////////////////////////////////////////////////////////////////////////////////
// The following FIT Protocol software provided may be used with FIT protocol
// devices only and remains the copyrighted property of Garmin Canada Inc.
// The software is being provided on an "as-is" basis and as an accommodation,
// and therefore all warranties, representations, or guarantees of any kind
// (whether express, implied or statutory) including, without limitation,
// warranties of merchantability, non-infringement, or fitness for a particular
// purpose, are specifically disclaimed.
//
// Copyright 2015 Garmin Canada Inc.
////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 16.25Garmin
// Tag = development-akw-16.25.00-4
////////////////////////////////////////////////////////////////////////////////

#if !defined(FIT_HR_TO_RECORD_MESSAGE_PLUGIN_HPP)
#define FIT_HR_TO_RECORD_MESSAGE_PLUGIN_HPP

#include "fit.hpp"
#include "fit_date_time.hpp"
#include "fit_mesg_broadcast_plugin.hpp"
#include <vector>

namespace fit
{

class HRToRecordMesgBroadcastPlugin : public fit::MesgBroadcastPlugin
{
   public:
      HRToRecordMesgBroadcastPlugin();
      ~HRToRecordMesgBroadcastPlugin();
      void OnBroadcast(std::vector<Mesg>& mesgs);
      void OnIncomingMesg(const Mesg& mesg);
      // Plugins are not designed to be copied
      HRToRecordMesgBroadcastPlugin &operator=(const HRToRecordMesgBroadcastPlugin&) = delete;
      HRToRecordMesgBroadcastPlugin(const HRToRecordMesgBroadcastPlugin&) = delete;

      FIT_UINT32 GetHRMesgs() { return hr_mesgs; };
      FIT_UINT32 GetRecordMesgs() { return record_mesgs; };

   private:
      DateTime *record_range_start_time;
      FIT_SINT32 hr_start_index;
      FIT_SINT32 hr_start_sub_index;
      FIT_BOOL isActivityFile;
      FIT_UINT32 mesg_count;
      const FIT_SINT32 INVALID_INDEX = -1;
      FIT_UINT32 hr_mesgs;
      FIT_UINT32 record_mesgs;
};

} // namespace fit

#endif // defined(FIT_HR_TO_RECORD_MESSAGE_PLUGIN_HPP)
