# FIT SDK Cookbook

The FIT SDK Cookbook contains examples of using the FIT SDK to solve real-world problems. There are recipes for encoding and decoding Activity, Workout, and Course files; and recipes that provide tips for working with the FIT SDK.

The example projects provided in the cookbook are C# console apps written with .NET Core 3.1. All example projects in the cookbook use Visual Studio Code and can be compiled and executed on Windows, Mac, and Linux systems. The source code for the recipes is included with the FIT SDK and is located at /path/to/fit/sdk/cs/cookbook. The recipes are written in C#, but the concepts can be applied to the Java and C++ versions of the FIT SDK.

The Cookbook projects reference the precompiled Dynastream.Fit.Portable.dll that is included with the FIT SDK. If needed, the C# FIT SDK source files can be directly included in the projects.

## Prerequisites

The following prerequisites are required for working with the example projects found in the cookbook.

1. [Visual Studio Code](https://code.visualstudio.com/) with the [C# extension](https://marketplace.visualstudio.com/items?itemName=ms-dotnettools.csharp) installed.
2. The [NET Core SDK v3.1](https://dotnet.microsoft.com/download/dotnet-core) or later installed.

## Using the recipes

1. Open project folder in Visual Studio Code and install any extensions that are suggested for the project.
2. To start debugging press F5, or from the menu choose Run -> Start debugging.