/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2023 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.101Release
// Tag = production/release/21.101.00-0-gceb92d5
/////////////////////////////////////////////////////////////////////////////////////////////


#import <Foundation/Foundation.h>

#import "FITDate.h"
#import "FITMessage.h"
#import "FITTypes.h"

NS_ASSUME_NONNULL_BEGIN

@interface FITMonitoringMesg : FITMessage
- (id)init;
// Timestamp 
- (BOOL)isTimestampValid;
- (FITDate *)getTimestamp;
- (void)setTimestamp:(FITDate *)timestamp;
// DeviceIndex 
- (BOOL)isDeviceIndexValid;
- (FITDeviceIndex)getDeviceIndex;
- (void)setDeviceIndex:(FITDeviceIndex)deviceIndex;
// Calories 
- (BOOL)isCaloriesValid;
- (FITUInt16)getCalories;
- (void)setCalories:(FITUInt16)calories;
// Distance 
- (BOOL)isDistanceValid;
- (FITFloat32)getDistance;
- (void)setDistance:(FITFloat32)distance;
// Cycles 
- (BOOL)isCyclesValid;
- (FITFloat32)getCycles;
- (void)setCycles:(FITFloat32)cycles;
// Cycles Sub Fields
- (BOOL)isStepsValid;
- (FITUInt32) getSteps;
- (void)setSteps:(FITUInt32)steps;
- (BOOL)isStrokesValid;
- (FITFloat32) getStrokes;
- (void)setStrokes:(FITFloat32)strokes;
// ActiveTime 
- (BOOL)isActiveTimeValid;
- (FITFloat32)getActiveTime;
- (void)setActiveTime:(FITFloat32)activeTime;
// ActivityType 
- (BOOL)isActivityTypeValid;
- (FITActivityType)getActivityType;
- (void)setActivityType:(FITActivityType)activityType;
// ActivitySubtype 
- (BOOL)isActivitySubtypeValid;
- (FITActivitySubtype)getActivitySubtype;
- (void)setActivitySubtype:(FITActivitySubtype)activitySubtype;
// ActivityLevel 
- (BOOL)isActivityLevelValid;
- (FITActivityLevel)getActivityLevel;
- (void)setActivityLevel:(FITActivityLevel)activityLevel;
// Distance16 
- (BOOL)isDistance16Valid;
- (FITUInt16)getDistance16;
- (void)setDistance16:(FITUInt16)distance16;
// Cycles16 
- (BOOL)isCycles16Valid;
- (FITUInt16)getCycles16;
- (void)setCycles16:(FITUInt16)cycles16;
// ActiveTime16 
- (BOOL)isActiveTime16Valid;
- (FITUInt16)getActiveTime16;
- (void)setActiveTime16:(FITUInt16)activeTime16;
// LocalTimestamp 
- (BOOL)isLocalTimestampValid;
- (FITLocalDateTime)getLocalTimestamp;
- (void)setLocalTimestamp:(FITLocalDateTime)localTimestamp;
// Temperature 
- (BOOL)isTemperatureValid;
- (FITFloat32)getTemperature;
- (void)setTemperature:(FITFloat32)temperature;
// TemperatureMin 
- (BOOL)isTemperatureMinValid;
- (FITFloat32)getTemperatureMin;
- (void)setTemperatureMin:(FITFloat32)temperatureMin;
// TemperatureMax 
- (BOOL)isTemperatureMaxValid;
- (FITFloat32)getTemperatureMax;
- (void)setTemperatureMax:(FITFloat32)temperatureMax;
// ActivityTime 
@property(readonly,nonatomic) uint8_t numActivityTimeValues;
- (BOOL)isActivityTimeValidforIndex : (uint8_t)index;
- (FITUInt16)getActivityTimeforIndex : (uint8_t)index;
- (void)setActivityTime:(FITUInt16)activityTime forIndex:(uint8_t)index;
// ActiveCalories 
- (BOOL)isActiveCaloriesValid;
- (FITUInt16)getActiveCalories;
- (void)setActiveCalories:(FITUInt16)activeCalories;
// CurrentActivityTypeIntensity 
- (BOOL)isCurrentActivityTypeIntensityValid;
- (FITByte)getCurrentActivityTypeIntensity;
- (void)setCurrentActivityTypeIntensity:(FITByte)currentActivityTypeIntensity;
// TimestampMin8 
- (BOOL)isTimestampMin8Valid;
- (FITUInt8)getTimestampMin8;
- (void)setTimestampMin8:(FITUInt8)timestampMin8;
// Timestamp16 
- (BOOL)isTimestamp16Valid;
- (FITUInt16)getTimestamp16;
- (void)setTimestamp16:(FITUInt16)timestamp16;
// HeartRate 
- (BOOL)isHeartRateValid;
- (FITUInt8)getHeartRate;
- (void)setHeartRate:(FITUInt8)heartRate;
// Intensity 
- (BOOL)isIntensityValid;
- (FITFloat32)getIntensity;
- (void)setIntensity:(FITFloat32)intensity;
// DurationMin 
- (BOOL)isDurationMinValid;
- (FITUInt16)getDurationMin;
- (void)setDurationMin:(FITUInt16)durationMin;
// Duration 
- (BOOL)isDurationValid;
- (FITUInt32)getDuration;
- (void)setDuration:(FITUInt32)duration;
// Ascent 
- (BOOL)isAscentValid;
- (FITFloat32)getAscent;
- (void)setAscent:(FITFloat32)ascent;
// Descent 
- (BOOL)isDescentValid;
- (FITFloat32)getDescent;
- (void)setDescent:(FITFloat32)descent;
// ModerateActivityMinutes 
- (BOOL)isModerateActivityMinutesValid;
- (FITUInt16)getModerateActivityMinutes;
- (void)setModerateActivityMinutes:(FITUInt16)moderateActivityMinutes;
// VigorousActivityMinutes 
- (BOOL)isVigorousActivityMinutesValid;
- (FITUInt16)getVigorousActivityMinutes;
- (void)setVigorousActivityMinutes:(FITUInt16)vigorousActivityMinutes;

@end

NS_ASSUME_NONNULL_END
