/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2023 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.101Release
// Tag = production/release/21.101.00-0-gceb92d5
/////////////////////////////////////////////////////////////////////////////////////////////


// Base Types
typedef uint8_t FITEnum;
#define FITEnumInvalid          ((FITEnum)0xFF)
typedef int8_t FITSInt8;
#define FITSInt8Invalid         ((FITSInt8)0x7F)
typedef uint8_t FITUInt8;
#define FITUInt8Invalid         ((FITUInt8)0xFF)
typedef int16_t FITSInt16;
#define FITSInt16Invalid        ((FITSInt16)0x7FFF)
typedef uint16_t FITUInt16;
#define FITUInt16Invalid        ((FIT_UINT16)0xFFFF)
typedef int32_t FITSInt32;
#define FITSInt32Invalid        ((FITSInt32)0x7FFFFFFF)
typedef uint32_t FITUInt32;
#define FITUInt32Invalid        ((FITUInt32)0xFFFFFFFF)
typedef float FITFloat32;
#define FITFloat32Invalid       ((FITFloat32) 0xFFFFFFFFFFFFFFFF)
typedef double FITFloat64;
#define FITFloat64Invalid       ((FITFloat64) 0xFFFFFFFFFFFFFFFF)
typedef uint8_t FITUInt8z;
#define FITUInt8zInvalid        ((FITUInt8z)0x00)
typedef uint16_t FITUInt16z;
#define FITUInt16zInvalid       ((FITUInt16z)0x0000)
typedef uint32_t FITUInt32z;
#define FITUInt32zInvalid       ((FITUInt32z)0x00000000)
typedef uint8_t FITByte;
#define FITByteInvalid          ((FITByte)0xFF)
typedef int64_t FITSInt64;
#define FITSInt64Invalid        ((FITSInt64)0x7FFFFFFFFFFFFFFFL)
typedef uint64_t FITUInt64;
#define FITUInt64Invalid        ((FITUInt64)0xFFFFFFFFFFFFFFFFL)
typedef uint64_t FITUInt64z;
#define FITUInt64zInvalid       ((FITUInt64z)0x0000000000000000L)
typedef FITEnum FITBool;
#define FITBoolInvalid          FITEnumInvalid
#define FITBoolFalse            ((FITBool)0)
#define FITBoolTrue             ((FITBool)1)

// Profile Types

typedef FITEnum FITFile;
#define FITFileInvalid                                                           FITEnumInvalid
#define FITFileDevice                                                            ((FITFile)1) // Read only, single file. Must be in root directory.
#define FITFileSettings                                                          ((FITFile)2) // Read/write, single file. Directory=Settings
#define FITFileSport                                                             ((FITFile)3) // Read/write, multiple files, file number = sport type. Directory=Sports
#define FITFileActivity                                                          ((FITFile)4) // Read/erase, multiple files. Directory=Activities
#define FITFileWorkout                                                           ((FITFile)5) // Read/write/erase, multiple files. Directory=Workouts
#define FITFileCourse                                                            ((FITFile)6) // Read/write/erase, multiple files. Directory=Courses
#define FITFileSchedules                                                         ((FITFile)7) // Read/write, single file. Directory=Schedules
#define FITFileWeight                                                            ((FITFile)9) // Read only, single file. Circular buffer. All message definitions at start of file. Directory=Weight
#define FITFileTotals                                                            ((FITFile)10) // Read only, single file. Directory=Totals
#define FITFileGoals                                                             ((FITFile)11) // Read/write, single file. Directory=Goals
#define FITFileBloodPressure                                                     ((FITFile)14) // Read only. Directory=Blood Pressure
#define FITFileMonitoringA                                                       ((FITFile)15) // Read only. Directory=Monitoring. File number=sub type.
#define FITFileActivitySummary                                                   ((FITFile)20) // Read/erase, multiple files. Directory=Activities
#define FITFileMonitoringDaily                                                   ((FITFile)28)
#define FITFileMonitoringB                                                       ((FITFile)32) // Read only. Directory=Monitoring. File number=identifier
#define FITFileSegment                                                           ((FITFile)34) // Read/write/erase. Multiple Files. Directory=Segments
#define FITFileSegmentList                                                       ((FITFile)35) // Read/write/erase. Single File. Directory=Segments
#define FITFileExdConfiguration                                                  ((FITFile)40) // Read/write/erase. Single File. Directory=Settings
#define FITFileMfgRangeMin                                                       ((FITFile)0xF7) // 0xF7 - 0xFE reserved for manufacturer specific file types
#define FITFileMfgRangeMax                                                       ((FITFile)0xFE) // 0xF7 - 0xFE reserved for manufacturer specific file types
#define FITFileCount                                                             20

typedef FITUInt16 FITMesgNum;
#define FITMesgNumInvalid                                                        FITUInt16Invalid
#define FITMesgNumFileId                                                         ((FITMesgNum)0)
#define FITMesgNumCapabilities                                                   ((FITMesgNum)1)
#define FITMesgNumDeviceSettings                                                 ((FITMesgNum)2)
#define FITMesgNumUserProfile                                                    ((FITMesgNum)3)
#define FITMesgNumHrmProfile                                                     ((FITMesgNum)4)
#define FITMesgNumSdmProfile                                                     ((FITMesgNum)5)
#define FITMesgNumBikeProfile                                                    ((FITMesgNum)6)
#define FITMesgNumZonesTarget                                                    ((FITMesgNum)7)
#define FITMesgNumHrZone                                                         ((FITMesgNum)8)
#define FITMesgNumPowerZone                                                      ((FITMesgNum)9)
#define FITMesgNumMetZone                                                        ((FITMesgNum)10)
#define FITMesgNumSport                                                          ((FITMesgNum)12)
#define FITMesgNumGoal                                                           ((FITMesgNum)15)
#define FITMesgNumSession                                                        ((FITMesgNum)18)
#define FITMesgNumLap                                                            ((FITMesgNum)19)
#define FITMesgNumRecord                                                         ((FITMesgNum)20)
#define FITMesgNumEvent                                                          ((FITMesgNum)21)
#define FITMesgNumDeviceInfo                                                     ((FITMesgNum)23)
#define FITMesgNumWorkout                                                        ((FITMesgNum)26)
#define FITMesgNumWorkoutStep                                                    ((FITMesgNum)27)
#define FITMesgNumSchedule                                                       ((FITMesgNum)28)
#define FITMesgNumWeightScale                                                    ((FITMesgNum)30)
#define FITMesgNumCourse                                                         ((FITMesgNum)31)
#define FITMesgNumCoursePoint                                                    ((FITMesgNum)32)
#define FITMesgNumTotals                                                         ((FITMesgNum)33)
#define FITMesgNumActivity                                                       ((FITMesgNum)34)
#define FITMesgNumSoftware                                                       ((FITMesgNum)35)
#define FITMesgNumFileCapabilities                                               ((FITMesgNum)37)
#define FITMesgNumMesgCapabilities                                               ((FITMesgNum)38)
#define FITMesgNumFieldCapabilities                                              ((FITMesgNum)39)
#define FITMesgNumFileCreator                                                    ((FITMesgNum)49)
#define FITMesgNumBloodPressure                                                  ((FITMesgNum)51)
#define FITMesgNumSpeedZone                                                      ((FITMesgNum)53)
#define FITMesgNumMonitoring                                                     ((FITMesgNum)55)
#define FITMesgNumTrainingFile                                                   ((FITMesgNum)72)
#define FITMesgNumHrv                                                            ((FITMesgNum)78)
#define FITMesgNumAntRx                                                          ((FITMesgNum)80)
#define FITMesgNumAntTx                                                          ((FITMesgNum)81)
#define FITMesgNumAntChannelId                                                   ((FITMesgNum)82)
#define FITMesgNumLength                                                         ((FITMesgNum)101)
#define FITMesgNumMonitoringInfo                                                 ((FITMesgNum)103)
#define FITMesgNumPad                                                            ((FITMesgNum)105)
#define FITMesgNumSlaveDevice                                                    ((FITMesgNum)106)
#define FITMesgNumConnectivity                                                   ((FITMesgNum)127)
#define FITMesgNumWeatherConditions                                              ((FITMesgNum)128)
#define FITMesgNumWeatherAlert                                                   ((FITMesgNum)129)
#define FITMesgNumCadenceZone                                                    ((FITMesgNum)131)
#define FITMesgNumHr                                                             ((FITMesgNum)132)
#define FITMesgNumSegmentLap                                                     ((FITMesgNum)142)
#define FITMesgNumMemoGlob                                                       ((FITMesgNum)145)
#define FITMesgNumSegmentId                                                      ((FITMesgNum)148)
#define FITMesgNumSegmentLeaderboardEntry                                        ((FITMesgNum)149)
#define FITMesgNumSegmentPoint                                                   ((FITMesgNum)150)
#define FITMesgNumSegmentFile                                                    ((FITMesgNum)151)
#define FITMesgNumWorkoutSession                                                 ((FITMesgNum)158)
#define FITMesgNumWatchfaceSettings                                              ((FITMesgNum)159)
#define FITMesgNumGpsMetadata                                                    ((FITMesgNum)160)
#define FITMesgNumCameraEvent                                                    ((FITMesgNum)161)
#define FITMesgNumTimestampCorrelation                                           ((FITMesgNum)162)
#define FITMesgNumGyroscopeData                                                  ((FITMesgNum)164)
#define FITMesgNumAccelerometerData                                              ((FITMesgNum)165)
#define FITMesgNumThreeDSensorCalibration                                        ((FITMesgNum)167)
#define FITMesgNumVideoFrame                                                     ((FITMesgNum)169)
#define FITMesgNumObdiiData                                                      ((FITMesgNum)174)
#define FITMesgNumNmeaSentence                                                   ((FITMesgNum)177)
#define FITMesgNumAviationAttitude                                               ((FITMesgNum)178)
#define FITMesgNumVideo                                                          ((FITMesgNum)184)
#define FITMesgNumVideoTitle                                                     ((FITMesgNum)185)
#define FITMesgNumVideoDescription                                               ((FITMesgNum)186)
#define FITMesgNumVideoClip                                                      ((FITMesgNum)187)
#define FITMesgNumOhrSettings                                                    ((FITMesgNum)188)
#define FITMesgNumExdScreenConfiguration                                         ((FITMesgNum)200)
#define FITMesgNumExdDataFieldConfiguration                                      ((FITMesgNum)201)
#define FITMesgNumExdDataConceptConfiguration                                    ((FITMesgNum)202)
#define FITMesgNumFieldDescription                                               ((FITMesgNum)206)
#define FITMesgNumDeveloperDataId                                                ((FITMesgNum)207)
#define FITMesgNumMagnetometerData                                               ((FITMesgNum)208)
#define FITMesgNumBarometerData                                                  ((FITMesgNum)209)
#define FITMesgNumOneDSensorCalibration                                          ((FITMesgNum)210)
#define FITMesgNumTimeInZone                                                     ((FITMesgNum)216)
#define FITMesgNumSet                                                            ((FITMesgNum)225)
#define FITMesgNumStressLevel                                                    ((FITMesgNum)227)
#define FITMesgNumDiveSettings                                                   ((FITMesgNum)258)
#define FITMesgNumDiveGas                                                        ((FITMesgNum)259)
#define FITMesgNumDiveAlarm                                                      ((FITMesgNum)262)
#define FITMesgNumExerciseTitle                                                  ((FITMesgNum)264)
#define FITMesgNumDiveSummary                                                    ((FITMesgNum)268)
#define FITMesgNumJump                                                           ((FITMesgNum)285)
#define FITMesgNumSplit                                                          ((FITMesgNum)312)
#define FITMesgNumClimbPro                                                       ((FITMesgNum)317)
#define FITMesgNumDeviceAuxBatteryInfo                                           ((FITMesgNum)375)
#define FITMesgNumMfgRangeMin                                                    ((FITMesgNum)0xFF00) // 0xFF00 - 0xFFFE reserved for manufacturer specific messages
#define FITMesgNumMfgRangeMax                                                    ((FITMesgNum)0xFFFE) // 0xFF00 - 0xFFFE reserved for manufacturer specific messages
#define FITMesgNumCount                                                          93

typedef FITUInt8 FITChecksum;
#define FITChecksumInvalid                                                       FITUInt8Invalid
#define FITChecksumClear                                                         ((FITChecksum)0) // Allows clear of checksum for flash memory where can only write 1 to 0 without erasing sector.
#define FITChecksumOk                                                            ((FITChecksum)1) // Set to mark checksum as valid if computes to invalid values 0 or 0xFF. Checksum can also be set to ok to save encoding computation time.
#define FITChecksumCount                                                         2

typedef FITUInt8z FITFileFlags;
#define FITFileFlagsInvalid                                                      FITUInt8zInvalid
#define FITFileFlagsRead                                                         ((FITFileFlags)0x02)
#define FITFileFlagsWrite                                                        ((FITFileFlags)0x04)
#define FITFileFlagsErase                                                        ((FITFileFlags)0x08)
#define FITFileFlagsCount                                                        3

typedef FITEnum FITMesgCount;
#define FITMesgCountInvalid                                                      FITEnumInvalid
#define FITMesgCountNumPerFile                                                   ((FITMesgCount)0)
#define FITMesgCountMaxPerFile                                                   ((FITMesgCount)1)
#define FITMesgCountMaxPerFileType                                               ((FITMesgCount)2)
#define FITMesgCountCount                                                        3

typedef FITUInt32 FITDateTime; // seconds since UTC 00:00 Dec 31 1989
#define FITDateTimeInvalid                                                       FITUInt32Invalid
#define FITDateTimeMin                                                           ((FITDateTime)0x10000000) // if date_time is < 0x10000000 then it is system time (seconds from device power on)
#define FITDateTimeCount                                                         1

typedef FITUInt32 FITLocalDateTime; // seconds since 00:00 Dec 31 1989 in local time zone
#define FITLocalDateTimeInvalid                                                  FITUInt32Invalid
#define FITLocalDateTimeMin                                                      ((FITLocalDateTime)0x10000000) // if date_time is < 0x10000000 then it is system time (seconds from device power on)
#define FITLocalDateTimeCount                                                    1

typedef FITUInt16 FITMessageIndex;
#define FITMessageIndexInvalid                                                   FITUInt16Invalid
#define FITMessageIndexSelected                                                  ((FITMessageIndex)0x8000) // message is selected if set
#define FITMessageIndexReserved                                                  ((FITMessageIndex)0x7000) // reserved (default 0)
#define FITMessageIndexMask                                                      ((FITMessageIndex)0x0FFF) // index
#define FITMessageIndexCount                                                     3

typedef FITUInt8 FITDeviceIndex;
#define FITDeviceIndexInvalid                                                    FITUInt8Invalid
#define FITDeviceIndexCreator                                                    ((FITDeviceIndex)0) // Creator of the file is always device index 0.
#define FITDeviceIndexCount                                                      1

typedef FITEnum FITGender;
#define FITGenderInvalid                                                         FITEnumInvalid
#define FITGenderFemale                                                          ((FITGender)0)
#define FITGenderMale                                                            ((FITGender)1)
#define FITGenderCount                                                           2

typedef FITEnum FITLanguage;
#define FITLanguageInvalid                                                       FITEnumInvalid
#define FITLanguageEnglish                                                       ((FITLanguage)0)
#define FITLanguageFrench                                                        ((FITLanguage)1)
#define FITLanguageItalian                                                       ((FITLanguage)2)
#define FITLanguageGerman                                                        ((FITLanguage)3)
#define FITLanguageSpanish                                                       ((FITLanguage)4)
#define FITLanguageCroatian                                                      ((FITLanguage)5)
#define FITLanguageCzech                                                         ((FITLanguage)6)
#define FITLanguageDanish                                                        ((FITLanguage)7)
#define FITLanguageDutch                                                         ((FITLanguage)8)
#define FITLanguageFinnish                                                       ((FITLanguage)9)
#define FITLanguageGreek                                                         ((FITLanguage)10)
#define FITLanguageHungarian                                                     ((FITLanguage)11)
#define FITLanguageNorwegian                                                     ((FITLanguage)12)
#define FITLanguagePolish                                                        ((FITLanguage)13)
#define FITLanguagePortuguese                                                    ((FITLanguage)14)
#define FITLanguageSlovakian                                                     ((FITLanguage)15)
#define FITLanguageSlovenian                                                     ((FITLanguage)16)
#define FITLanguageSwedish                                                       ((FITLanguage)17)
#define FITLanguageRussian                                                       ((FITLanguage)18)
#define FITLanguageTurkish                                                       ((FITLanguage)19)
#define FITLanguageLatvian                                                       ((FITLanguage)20)
#define FITLanguageUkrainian                                                     ((FITLanguage)21)
#define FITLanguageArabic                                                        ((FITLanguage)22)
#define FITLanguageFarsi                                                         ((FITLanguage)23)
#define FITLanguageBulgarian                                                     ((FITLanguage)24)
#define FITLanguageRomanian                                                      ((FITLanguage)25)
#define FITLanguageChinese                                                       ((FITLanguage)26)
#define FITLanguageJapanese                                                      ((FITLanguage)27)
#define FITLanguageKorean                                                        ((FITLanguage)28)
#define FITLanguageTaiwanese                                                     ((FITLanguage)29)
#define FITLanguageThai                                                          ((FITLanguage)30)
#define FITLanguageHebrew                                                        ((FITLanguage)31)
#define FITLanguageBrazilianPortuguese                                           ((FITLanguage)32)
#define FITLanguageIndonesian                                                    ((FITLanguage)33)
#define FITLanguageMalaysian                                                     ((FITLanguage)34)
#define FITLanguageVietnamese                                                    ((FITLanguage)35)
#define FITLanguageBurmese                                                       ((FITLanguage)36)
#define FITLanguageMongolian                                                     ((FITLanguage)37)
#define FITLanguageCustom                                                        ((FITLanguage)254)
#define FITLanguageCount                                                         39

typedef FITUInt8z FITLanguageBits0; // Bit field corresponding to language enum type (1 << language).
#define FITLanguageBits0Invalid                                                  FITUInt8zInvalid
#define FITLanguageBits0English                                                  ((FITLanguageBits0)0x01)
#define FITLanguageBits0French                                                   ((FITLanguageBits0)0x02)
#define FITLanguageBits0Italian                                                  ((FITLanguageBits0)0x04)
#define FITLanguageBits0German                                                   ((FITLanguageBits0)0x08)
#define FITLanguageBits0Spanish                                                  ((FITLanguageBits0)0x10)
#define FITLanguageBits0Croatian                                                 ((FITLanguageBits0)0x20)
#define FITLanguageBits0Czech                                                    ((FITLanguageBits0)0x40)
#define FITLanguageBits0Danish                                                   ((FITLanguageBits0)0x80)
#define FITLanguageBits0Count                                                    8

typedef FITUInt8z FITLanguageBits1;
#define FITLanguageBits1Invalid                                                  FITUInt8zInvalid
#define FITLanguageBits1Dutch                                                    ((FITLanguageBits1)0x01)
#define FITLanguageBits1Finnish                                                  ((FITLanguageBits1)0x02)
#define FITLanguageBits1Greek                                                    ((FITLanguageBits1)0x04)
#define FITLanguageBits1Hungarian                                                ((FITLanguageBits1)0x08)
#define FITLanguageBits1Norwegian                                                ((FITLanguageBits1)0x10)
#define FITLanguageBits1Polish                                                   ((FITLanguageBits1)0x20)
#define FITLanguageBits1Portuguese                                               ((FITLanguageBits1)0x40)
#define FITLanguageBits1Slovakian                                                ((FITLanguageBits1)0x80)
#define FITLanguageBits1Count                                                    8

typedef FITUInt8z FITLanguageBits2;
#define FITLanguageBits2Invalid                                                  FITUInt8zInvalid
#define FITLanguageBits2Slovenian                                                ((FITLanguageBits2)0x01)
#define FITLanguageBits2Swedish                                                  ((FITLanguageBits2)0x02)
#define FITLanguageBits2Russian                                                  ((FITLanguageBits2)0x04)
#define FITLanguageBits2Turkish                                                  ((FITLanguageBits2)0x08)
#define FITLanguageBits2Latvian                                                  ((FITLanguageBits2)0x10)
#define FITLanguageBits2Ukrainian                                                ((FITLanguageBits2)0x20)
#define FITLanguageBits2Arabic                                                   ((FITLanguageBits2)0x40)
#define FITLanguageBits2Farsi                                                    ((FITLanguageBits2)0x80)
#define FITLanguageBits2Count                                                    8

typedef FITUInt8z FITLanguageBits3;
#define FITLanguageBits3Invalid                                                  FITUInt8zInvalid
#define FITLanguageBits3Bulgarian                                                ((FITLanguageBits3)0x01)
#define FITLanguageBits3Romanian                                                 ((FITLanguageBits3)0x02)
#define FITLanguageBits3Chinese                                                  ((FITLanguageBits3)0x04)
#define FITLanguageBits3Japanese                                                 ((FITLanguageBits3)0x08)
#define FITLanguageBits3Korean                                                   ((FITLanguageBits3)0x10)
#define FITLanguageBits3Taiwanese                                                ((FITLanguageBits3)0x20)
#define FITLanguageBits3Thai                                                     ((FITLanguageBits3)0x40)
#define FITLanguageBits3Hebrew                                                   ((FITLanguageBits3)0x80)
#define FITLanguageBits3Count                                                    8

typedef FITUInt8z FITLanguageBits4;
#define FITLanguageBits4Invalid                                                  FITUInt8zInvalid
#define FITLanguageBits4BrazilianPortuguese                                      ((FITLanguageBits4)0x01)
#define FITLanguageBits4Indonesian                                               ((FITLanguageBits4)0x02)
#define FITLanguageBits4Malaysian                                                ((FITLanguageBits4)0x04)
#define FITLanguageBits4Vietnamese                                               ((FITLanguageBits4)0x08)
#define FITLanguageBits4Burmese                                                  ((FITLanguageBits4)0x10)
#define FITLanguageBits4Mongolian                                                ((FITLanguageBits4)0x20)
#define FITLanguageBits4Count                                                    6

typedef FITEnum FITTimeZone;
#define FITTimeZoneInvalid                                                       FITEnumInvalid
#define FITTimeZoneAlmaty                                                        ((FITTimeZone)0)
#define FITTimeZoneBangkok                                                       ((FITTimeZone)1)
#define FITTimeZoneBombay                                                        ((FITTimeZone)2)
#define FITTimeZoneBrasilia                                                      ((FITTimeZone)3)
#define FITTimeZoneCairo                                                         ((FITTimeZone)4)
#define FITTimeZoneCapeVerdeIs                                                   ((FITTimeZone)5)
#define FITTimeZoneDarwin                                                        ((FITTimeZone)6)
#define FITTimeZoneEniwetok                                                      ((FITTimeZone)7)
#define FITTimeZoneFiji                                                          ((FITTimeZone)8)
#define FITTimeZoneHongKong                                                      ((FITTimeZone)9)
#define FITTimeZoneIslamabad                                                     ((FITTimeZone)10)
#define FITTimeZoneKabul                                                         ((FITTimeZone)11)
#define FITTimeZoneMagadan                                                       ((FITTimeZone)12)
#define FITTimeZoneMidAtlantic                                                   ((FITTimeZone)13)
#define FITTimeZoneMoscow                                                        ((FITTimeZone)14)
#define FITTimeZoneMuscat                                                        ((FITTimeZone)15)
#define FITTimeZoneNewfoundland                                                  ((FITTimeZone)16)
#define FITTimeZoneSamoa                                                         ((FITTimeZone)17)
#define FITTimeZoneSydney                                                        ((FITTimeZone)18)
#define FITTimeZoneTehran                                                        ((FITTimeZone)19)
#define FITTimeZoneTokyo                                                         ((FITTimeZone)20)
#define FITTimeZoneUsAlaska                                                      ((FITTimeZone)21)
#define FITTimeZoneUsAtlantic                                                    ((FITTimeZone)22)
#define FITTimeZoneUsCentral                                                     ((FITTimeZone)23)
#define FITTimeZoneUsEastern                                                     ((FITTimeZone)24)
#define FITTimeZoneUsHawaii                                                      ((FITTimeZone)25)
#define FITTimeZoneUsMountain                                                    ((FITTimeZone)26)
#define FITTimeZoneUsPacific                                                     ((FITTimeZone)27)
#define FITTimeZoneOther                                                         ((FITTimeZone)28)
#define FITTimeZoneAuckland                                                      ((FITTimeZone)29)
#define FITTimeZoneKathmandu                                                     ((FITTimeZone)30)
#define FITTimeZoneEuropeWesternWet                                              ((FITTimeZone)31)
#define FITTimeZoneEuropeCentralCet                                              ((FITTimeZone)32)
#define FITTimeZoneEuropeEasternEet                                              ((FITTimeZone)33)
#define FITTimeZoneJakarta                                                       ((FITTimeZone)34)
#define FITTimeZonePerth                                                         ((FITTimeZone)35)
#define FITTimeZoneAdelaide                                                      ((FITTimeZone)36)
#define FITTimeZoneBrisbane                                                      ((FITTimeZone)37)
#define FITTimeZoneTasmania                                                      ((FITTimeZone)38)
#define FITTimeZoneIceland                                                       ((FITTimeZone)39)
#define FITTimeZoneAmsterdam                                                     ((FITTimeZone)40)
#define FITTimeZoneAthens                                                        ((FITTimeZone)41)
#define FITTimeZoneBarcelona                                                     ((FITTimeZone)42)
#define FITTimeZoneBerlin                                                        ((FITTimeZone)43)
#define FITTimeZoneBrussels                                                      ((FITTimeZone)44)
#define FITTimeZoneBudapest                                                      ((FITTimeZone)45)
#define FITTimeZoneCopenhagen                                                    ((FITTimeZone)46)
#define FITTimeZoneDublin                                                        ((FITTimeZone)47)
#define FITTimeZoneHelsinki                                                      ((FITTimeZone)48)
#define FITTimeZoneLisbon                                                        ((FITTimeZone)49)
#define FITTimeZoneLondon                                                        ((FITTimeZone)50)
#define FITTimeZoneMadrid                                                        ((FITTimeZone)51)
#define FITTimeZoneMunich                                                        ((FITTimeZone)52)
#define FITTimeZoneOslo                                                          ((FITTimeZone)53)
#define FITTimeZoneParis                                                         ((FITTimeZone)54)
#define FITTimeZonePrague                                                        ((FITTimeZone)55)
#define FITTimeZoneReykjavik                                                     ((FITTimeZone)56)
#define FITTimeZoneRome                                                          ((FITTimeZone)57)
#define FITTimeZoneStockholm                                                     ((FITTimeZone)58)
#define FITTimeZoneVienna                                                        ((FITTimeZone)59)
#define FITTimeZoneWarsaw                                                        ((FITTimeZone)60)
#define FITTimeZoneZurich                                                        ((FITTimeZone)61)
#define FITTimeZoneQuebec                                                        ((FITTimeZone)62)
#define FITTimeZoneOntario                                                       ((FITTimeZone)63)
#define FITTimeZoneManitoba                                                      ((FITTimeZone)64)
#define FITTimeZoneSaskatchewan                                                  ((FITTimeZone)65)
#define FITTimeZoneAlberta                                                       ((FITTimeZone)66)
#define FITTimeZoneBritishColumbia                                               ((FITTimeZone)67)
#define FITTimeZoneBoise                                                         ((FITTimeZone)68)
#define FITTimeZoneBoston                                                        ((FITTimeZone)69)
#define FITTimeZoneChicago                                                       ((FITTimeZone)70)
#define FITTimeZoneDallas                                                        ((FITTimeZone)71)
#define FITTimeZoneDenver                                                        ((FITTimeZone)72)
#define FITTimeZoneKansasCity                                                    ((FITTimeZone)73)
#define FITTimeZoneLasVegas                                                      ((FITTimeZone)74)
#define FITTimeZoneLosAngeles                                                    ((FITTimeZone)75)
#define FITTimeZoneMiami                                                         ((FITTimeZone)76)
#define FITTimeZoneMinneapolis                                                   ((FITTimeZone)77)
#define FITTimeZoneNewYork                                                       ((FITTimeZone)78)
#define FITTimeZoneNewOrleans                                                    ((FITTimeZone)79)
#define FITTimeZonePhoenix                                                       ((FITTimeZone)80)
#define FITTimeZoneSantaFe                                                       ((FITTimeZone)81)
#define FITTimeZoneSeattle                                                       ((FITTimeZone)82)
#define FITTimeZoneWashingtonDc                                                  ((FITTimeZone)83)
#define FITTimeZoneUsArizona                                                     ((FITTimeZone)84)
#define FITTimeZoneChita                                                         ((FITTimeZone)85)
#define FITTimeZoneEkaterinburg                                                  ((FITTimeZone)86)
#define FITTimeZoneIrkutsk                                                       ((FITTimeZone)87)
#define FITTimeZoneKaliningrad                                                   ((FITTimeZone)88)
#define FITTimeZoneKrasnoyarsk                                                   ((FITTimeZone)89)
#define FITTimeZoneNovosibirsk                                                   ((FITTimeZone)90)
#define FITTimeZonePetropavlovskKamchatskiy                                      ((FITTimeZone)91)
#define FITTimeZoneSamara                                                        ((FITTimeZone)92)
#define FITTimeZoneVladivostok                                                   ((FITTimeZone)93)
#define FITTimeZoneMexicoCentral                                                 ((FITTimeZone)94)
#define FITTimeZoneMexicoMountain                                                ((FITTimeZone)95)
#define FITTimeZoneMexicoPacific                                                 ((FITTimeZone)96)
#define FITTimeZoneCapeTown                                                      ((FITTimeZone)97)
#define FITTimeZoneWinkhoek                                                      ((FITTimeZone)98)
#define FITTimeZoneLagos                                                         ((FITTimeZone)99)
#define FITTimeZoneRiyahd                                                        ((FITTimeZone)100)
#define FITTimeZoneVenezuela                                                     ((FITTimeZone)101)
#define FITTimeZoneAustraliaLh                                                   ((FITTimeZone)102)
#define FITTimeZoneSantiago                                                      ((FITTimeZone)103)
#define FITTimeZoneManual                                                        ((FITTimeZone)253)
#define FITTimeZoneAutomatic                                                     ((FITTimeZone)254)
#define FITTimeZoneCount                                                         106

typedef FITEnum FITDisplayMeasure;
#define FITDisplayMeasureInvalid                                                 FITEnumInvalid
#define FITDisplayMeasureMetric                                                  ((FITDisplayMeasure)0)
#define FITDisplayMeasureStatute                                                 ((FITDisplayMeasure)1)
#define FITDisplayMeasureNautical                                                ((FITDisplayMeasure)2)
#define FITDisplayMeasureCount                                                   3

typedef FITEnum FITDisplayHeart;
#define FITDisplayHeartInvalid                                                   FITEnumInvalid
#define FITDisplayHeartBpm                                                       ((FITDisplayHeart)0)
#define FITDisplayHeartMax                                                       ((FITDisplayHeart)1)
#define FITDisplayHeartReserve                                                   ((FITDisplayHeart)2)
#define FITDisplayHeartCount                                                     3

typedef FITEnum FITDisplayPower;
#define FITDisplayPowerInvalid                                                   FITEnumInvalid
#define FITDisplayPowerWatts                                                     ((FITDisplayPower)0)
#define FITDisplayPowerPercentFtp                                                ((FITDisplayPower)1)
#define FITDisplayPowerCount                                                     2

typedef FITEnum FITDisplayPosition;
#define FITDisplayPositionInvalid                                                FITEnumInvalid
#define FITDisplayPositionDegree                                                 ((FITDisplayPosition)0) // dd.dddddd
#define FITDisplayPositionDegreeMinute                                           ((FITDisplayPosition)1) // dddmm.mmm
#define FITDisplayPositionDegreeMinuteSecond                                     ((FITDisplayPosition)2) // dddmmss
#define FITDisplayPositionAustrianGrid                                           ((FITDisplayPosition)3) // Austrian Grid (BMN)
#define FITDisplayPositionBritishGrid                                            ((FITDisplayPosition)4) // British National Grid
#define FITDisplayPositionDutchGrid                                              ((FITDisplayPosition)5) // Dutch grid system
#define FITDisplayPositionHungarianGrid                                          ((FITDisplayPosition)6) // Hungarian grid system
#define FITDisplayPositionFinnishGrid                                            ((FITDisplayPosition)7) // Finnish grid system Zone3 KKJ27
#define FITDisplayPositionGermanGrid                                             ((FITDisplayPosition)8) // Gausss Krueger (German)
#define FITDisplayPositionIcelandicGrid                                          ((FITDisplayPosition)9) // Icelandic Grid
#define FITDisplayPositionIndonesianEquatorial                                   ((FITDisplayPosition)10) // Indonesian Equatorial LCO
#define FITDisplayPositionIndonesianIrian                                        ((FITDisplayPosition)11) // Indonesian Irian LCO
#define FITDisplayPositionIndonesianSouthern                                     ((FITDisplayPosition)12) // Indonesian Southern LCO
#define FITDisplayPositionIndiaZone0                                             ((FITDisplayPosition)13) // India zone 0
#define FITDisplayPositionIndiaZoneIA                                            ((FITDisplayPosition)14) // India zone IA
#define FITDisplayPositionIndiaZoneIB                                            ((FITDisplayPosition)15) // India zone IB
#define FITDisplayPositionIndiaZoneIIA                                           ((FITDisplayPosition)16) // India zone IIA
#define FITDisplayPositionIndiaZoneIIB                                           ((FITDisplayPosition)17) // India zone IIB
#define FITDisplayPositionIndiaZoneIIIA                                          ((FITDisplayPosition)18) // India zone IIIA
#define FITDisplayPositionIndiaZoneIIIB                                          ((FITDisplayPosition)19) // India zone IIIB
#define FITDisplayPositionIndiaZoneIVA                                           ((FITDisplayPosition)20) // India zone IVA
#define FITDisplayPositionIndiaZoneIVB                                           ((FITDisplayPosition)21) // India zone IVB
#define FITDisplayPositionIrishTransverse                                        ((FITDisplayPosition)22) // Irish Transverse Mercator
#define FITDisplayPositionIrishGrid                                              ((FITDisplayPosition)23) // Irish Grid
#define FITDisplayPositionLoran                                                  ((FITDisplayPosition)24) // Loran TD
#define FITDisplayPositionMaidenheadGrid                                         ((FITDisplayPosition)25) // Maidenhead grid system
#define FITDisplayPositionMgrsGrid                                               ((FITDisplayPosition)26) // MGRS grid system
#define FITDisplayPositionNewZealandGrid                                         ((FITDisplayPosition)27) // New Zealand grid system
#define FITDisplayPositionNewZealandTransverse                                   ((FITDisplayPosition)28) // New Zealand Transverse Mercator
#define FITDisplayPositionQatarGrid                                              ((FITDisplayPosition)29) // Qatar National Grid
#define FITDisplayPositionModifiedSwedishGrid                                    ((FITDisplayPosition)30) // Modified RT-90 (Sweden)
#define FITDisplayPositionSwedishGrid                                            ((FITDisplayPosition)31) // RT-90 (Sweden)
#define FITDisplayPositionSouthAfricanGrid                                       ((FITDisplayPosition)32) // South African Grid
#define FITDisplayPositionSwissGrid                                              ((FITDisplayPosition)33) // Swiss CH-1903 grid
#define FITDisplayPositionTaiwanGrid                                             ((FITDisplayPosition)34) // Taiwan Grid
#define FITDisplayPositionUnitedStatesGrid                                       ((FITDisplayPosition)35) // United States National Grid
#define FITDisplayPositionUtmUpsGrid                                             ((FITDisplayPosition)36) // UTM/UPS grid system
#define FITDisplayPositionWestMalayan                                            ((FITDisplayPosition)37) // West Malayan RSO
#define FITDisplayPositionBorneoRso                                              ((FITDisplayPosition)38) // Borneo RSO
#define FITDisplayPositionEstonianGrid                                           ((FITDisplayPosition)39) // Estonian grid system
#define FITDisplayPositionLatvianGrid                                            ((FITDisplayPosition)40) // Latvian Transverse Mercator
#define FITDisplayPositionSwedishRef99Grid                                       ((FITDisplayPosition)41) // Reference Grid 99 TM (Swedish)
#define FITDisplayPositionCount                                                  42

typedef FITEnum FITSwitch;
#define FITSwitchInvalid                                                         FITEnumInvalid
#define FITSwitchOff                                                             ((FITSwitch)0)
#define FITSwitchOn                                                              ((FITSwitch)1)
#define FITSwitchAuto                                                            ((FITSwitch)2)
#define FITSwitchCount                                                           3

typedef FITEnum FITSport;
#define FITSportInvalid                                                          FITEnumInvalid
#define FITSportGeneric                                                          ((FITSport)0)
#define FITSportRunning                                                          ((FITSport)1)
#define FITSportCycling                                                          ((FITSport)2)
#define FITSportTransition                                                       ((FITSport)3) // Mulitsport transition
#define FITSportFitnessEquipment                                                 ((FITSport)4)
#define FITSportSwimming                                                         ((FITSport)5)
#define FITSportBasketball                                                       ((FITSport)6)
#define FITSportSoccer                                                           ((FITSport)7)
#define FITSportTennis                                                           ((FITSport)8)
#define FITSportAmericanFootball                                                 ((FITSport)9)
#define FITSportTraining                                                         ((FITSport)10)
#define FITSportWalking                                                          ((FITSport)11)
#define FITSportCrossCountrySkiing                                               ((FITSport)12)
#define FITSportAlpineSkiing                                                     ((FITSport)13)
#define FITSportSnowboarding                                                     ((FITSport)14)
#define FITSportRowing                                                           ((FITSport)15)
#define FITSportMountaineering                                                   ((FITSport)16)
#define FITSportHiking                                                           ((FITSport)17)
#define FITSportMultisport                                                       ((FITSport)18)
#define FITSportPaddling                                                         ((FITSport)19)
#define FITSportFlying                                                           ((FITSport)20)
#define FITSportEBiking                                                          ((FITSport)21)
#define FITSportMotorcycling                                                     ((FITSport)22)
#define FITSportBoating                                                          ((FITSport)23)
#define FITSportDriving                                                          ((FITSport)24)
#define FITSportGolf                                                             ((FITSport)25)
#define FITSportHangGliding                                                      ((FITSport)26)
#define FITSportHorsebackRiding                                                  ((FITSport)27)
#define FITSportHunting                                                          ((FITSport)28)
#define FITSportFishing                                                          ((FITSport)29)
#define FITSportInlineSkating                                                    ((FITSport)30)
#define FITSportRockClimbing                                                     ((FITSport)31)
#define FITSportSailing                                                          ((FITSport)32)
#define FITSportIceSkating                                                       ((FITSport)33)
#define FITSportSkyDiving                                                        ((FITSport)34)
#define FITSportSnowshoeing                                                      ((FITSport)35)
#define FITSportSnowmobiling                                                     ((FITSport)36)
#define FITSportStandUpPaddleboarding                                            ((FITSport)37)
#define FITSportSurfing                                                          ((FITSport)38)
#define FITSportWakeboarding                                                     ((FITSport)39)
#define FITSportWaterSkiing                                                      ((FITSport)40)
#define FITSportKayaking                                                         ((FITSport)41)
#define FITSportRafting                                                          ((FITSport)42)
#define FITSportWindsurfing                                                      ((FITSport)43)
#define FITSportKitesurfing                                                      ((FITSport)44)
#define FITSportTactical                                                         ((FITSport)45)
#define FITSportJumpmaster                                                       ((FITSport)46)
#define FITSportBoxing                                                           ((FITSport)47)
#define FITSportFloorClimbing                                                    ((FITSport)48)
#define FITSportDiving                                                           ((FITSport)53)
#define FITSportRacket                                                           ((FITSport)64)
#define FITSportWaterTubing                                                      ((FITSport)76)
#define FITSportWakesurfing                                                      ((FITSport)77)
#define FITSportAll                                                              ((FITSport)254) // All is for goals only to include all sports.
#define FITSportCount                                                            54

typedef FITUInt8z FITSportBits0; // Bit field corresponding to sport enum type (1 << sport).
#define FITSportBits0Invalid                                                     FITUInt8zInvalid
#define FITSportBits0Generic                                                     ((FITSportBits0)0x01)
#define FITSportBits0Running                                                     ((FITSportBits0)0x02)
#define FITSportBits0Cycling                                                     ((FITSportBits0)0x04)
#define FITSportBits0Transition                                                  ((FITSportBits0)0x08) // Mulitsport transition
#define FITSportBits0FitnessEquipment                                            ((FITSportBits0)0x10)
#define FITSportBits0Swimming                                                    ((FITSportBits0)0x20)
#define FITSportBits0Basketball                                                  ((FITSportBits0)0x40)
#define FITSportBits0Soccer                                                      ((FITSportBits0)0x80)
#define FITSportBits0Count                                                       8

typedef FITUInt8z FITSportBits1; // Bit field corresponding to sport enum type (1 << (sport-8)).
#define FITSportBits1Invalid                                                     FITUInt8zInvalid
#define FITSportBits1Tennis                                                      ((FITSportBits1)0x01)
#define FITSportBits1AmericanFootball                                            ((FITSportBits1)0x02)
#define FITSportBits1Training                                                    ((FITSportBits1)0x04)
#define FITSportBits1Walking                                                     ((FITSportBits1)0x08)
#define FITSportBits1CrossCountrySkiing                                          ((FITSportBits1)0x10)
#define FITSportBits1AlpineSkiing                                                ((FITSportBits1)0x20)
#define FITSportBits1Snowboarding                                                ((FITSportBits1)0x40)
#define FITSportBits1Rowing                                                      ((FITSportBits1)0x80)
#define FITSportBits1Count                                                       8

typedef FITUInt8z FITSportBits2; // Bit field corresponding to sport enum type (1 << (sport-16)).
#define FITSportBits2Invalid                                                     FITUInt8zInvalid
#define FITSportBits2Mountaineering                                              ((FITSportBits2)0x01)
#define FITSportBits2Hiking                                                      ((FITSportBits2)0x02)
#define FITSportBits2Multisport                                                  ((FITSportBits2)0x04)
#define FITSportBits2Paddling                                                    ((FITSportBits2)0x08)
#define FITSportBits2Flying                                                      ((FITSportBits2)0x10)
#define FITSportBits2EBiking                                                     ((FITSportBits2)0x20)
#define FITSportBits2Motorcycling                                                ((FITSportBits2)0x40)
#define FITSportBits2Boating                                                     ((FITSportBits2)0x80)
#define FITSportBits2Count                                                       8

typedef FITUInt8z FITSportBits3; // Bit field corresponding to sport enum type (1 << (sport-24)).
#define FITSportBits3Invalid                                                     FITUInt8zInvalid
#define FITSportBits3Driving                                                     ((FITSportBits3)0x01)
#define FITSportBits3Golf                                                        ((FITSportBits3)0x02)
#define FITSportBits3HangGliding                                                 ((FITSportBits3)0x04)
#define FITSportBits3HorsebackRiding                                             ((FITSportBits3)0x08)
#define FITSportBits3Hunting                                                     ((FITSportBits3)0x10)
#define FITSportBits3Fishing                                                     ((FITSportBits3)0x20)
#define FITSportBits3InlineSkating                                               ((FITSportBits3)0x40)
#define FITSportBits3RockClimbing                                                ((FITSportBits3)0x80)
#define FITSportBits3Count                                                       8

typedef FITUInt8z FITSportBits4; // Bit field corresponding to sport enum type (1 << (sport-32)).
#define FITSportBits4Invalid                                                     FITUInt8zInvalid
#define FITSportBits4Sailing                                                     ((FITSportBits4)0x01)
#define FITSportBits4IceSkating                                                  ((FITSportBits4)0x02)
#define FITSportBits4SkyDiving                                                   ((FITSportBits4)0x04)
#define FITSportBits4Snowshoeing                                                 ((FITSportBits4)0x08)
#define FITSportBits4Snowmobiling                                                ((FITSportBits4)0x10)
#define FITSportBits4StandUpPaddleboarding                                       ((FITSportBits4)0x20)
#define FITSportBits4Surfing                                                     ((FITSportBits4)0x40)
#define FITSportBits4Wakeboarding                                                ((FITSportBits4)0x80)
#define FITSportBits4Count                                                       8

typedef FITUInt8z FITSportBits5; // Bit field corresponding to sport enum type (1 << (sport-40)).
#define FITSportBits5Invalid                                                     FITUInt8zInvalid
#define FITSportBits5WaterSkiing                                                 ((FITSportBits5)0x01)
#define FITSportBits5Kayaking                                                    ((FITSportBits5)0x02)
#define FITSportBits5Rafting                                                     ((FITSportBits5)0x04)
#define FITSportBits5Windsurfing                                                 ((FITSportBits5)0x08)
#define FITSportBits5Kitesurfing                                                 ((FITSportBits5)0x10)
#define FITSportBits5Tactical                                                    ((FITSportBits5)0x20)
#define FITSportBits5Jumpmaster                                                  ((FITSportBits5)0x40)
#define FITSportBits5Boxing                                                      ((FITSportBits5)0x80)
#define FITSportBits5Count                                                       8

typedef FITUInt8z FITSportBits6; // Bit field corresponding to sport enum type (1 << (sport-48)).
#define FITSportBits6Invalid                                                     FITUInt8zInvalid
#define FITSportBits6FloorClimbing                                               ((FITSportBits6)0x01)
#define FITSportBits6Count                                                       1

typedef FITEnum FITSubSport;
#define FITSubSportInvalid                                                       FITEnumInvalid
#define FITSubSportGeneric                                                       ((FITSubSport)0)
#define FITSubSportTreadmill                                                     ((FITSubSport)1) // Run/Fitness Equipment
#define FITSubSportStreet                                                        ((FITSubSport)2) // Run
#define FITSubSportTrail                                                         ((FITSubSport)3) // Run
#define FITSubSportTrack                                                         ((FITSubSport)4) // Run
#define FITSubSportSpin                                                          ((FITSubSport)5) // Cycling
#define FITSubSportIndoorCycling                                                 ((FITSubSport)6) // Cycling/Fitness Equipment
#define FITSubSportRoad                                                          ((FITSubSport)7) // Cycling
#define FITSubSportMountain                                                      ((FITSubSport)8) // Cycling
#define FITSubSportDownhill                                                      ((FITSubSport)9) // Cycling
#define FITSubSportRecumbent                                                     ((FITSubSport)10) // Cycling
#define FITSubSportCyclocross                                                    ((FITSubSport)11) // Cycling
#define FITSubSportHandCycling                                                   ((FITSubSport)12) // Cycling
#define FITSubSportTrackCycling                                                  ((FITSubSport)13) // Cycling
#define FITSubSportIndoorRowing                                                  ((FITSubSport)14) // Fitness Equipment
#define FITSubSportElliptical                                                    ((FITSubSport)15) // Fitness Equipment
#define FITSubSportStairClimbing                                                 ((FITSubSport)16) // Fitness Equipment
#define FITSubSportLapSwimming                                                   ((FITSubSport)17) // Swimming
#define FITSubSportOpenWater                                                     ((FITSubSport)18) // Swimming
#define FITSubSportFlexibilityTraining                                           ((FITSubSport)19) // Training
#define FITSubSportStrengthTraining                                              ((FITSubSport)20) // Training
#define FITSubSportWarmUp                                                        ((FITSubSport)21) // Tennis
#define FITSubSportMatch                                                         ((FITSubSport)22) // Tennis
#define FITSubSportExercise                                                      ((FITSubSport)23) // Tennis
#define FITSubSportChallenge                                                     ((FITSubSport)24)
#define FITSubSportIndoorSkiing                                                  ((FITSubSport)25) // Fitness Equipment
#define FITSubSportCardioTraining                                                ((FITSubSport)26) // Training
#define FITSubSportIndoorWalking                                                 ((FITSubSport)27) // Walking/Fitness Equipment
#define FITSubSportEBikeFitness                                                  ((FITSubSport)28) // E-Biking
#define FITSubSportBmx                                                           ((FITSubSport)29) // Cycling
#define FITSubSportCasualWalking                                                 ((FITSubSport)30) // Walking
#define FITSubSportSpeedWalking                                                  ((FITSubSport)31) // Walking
#define FITSubSportBikeToRunTransition                                           ((FITSubSport)32) // Transition
#define FITSubSportRunToBikeTransition                                           ((FITSubSport)33) // Transition
#define FITSubSportSwimToBikeTransition                                          ((FITSubSport)34) // Transition
#define FITSubSportAtv                                                           ((FITSubSport)35) // Motorcycling
#define FITSubSportMotocross                                                     ((FITSubSport)36) // Motorcycling
#define FITSubSportBackcountry                                                   ((FITSubSport)37) // Alpine Skiing/Snowboarding
#define FITSubSportResort                                                        ((FITSubSport)38) // Alpine Skiing/Snowboarding
#define FITSubSportRcDrone                                                       ((FITSubSport)39) // Flying
#define FITSubSportWingsuit                                                      ((FITSubSport)40) // Flying
#define FITSubSportWhitewater                                                    ((FITSubSport)41) // Kayaking/Rafting
#define FITSubSportSkateSkiing                                                   ((FITSubSport)42) // Cross Country Skiing
#define FITSubSportYoga                                                          ((FITSubSport)43) // Training
#define FITSubSportPilates                                                       ((FITSubSport)44) // Fitness Equipment
#define FITSubSportIndoorRunning                                                 ((FITSubSport)45) // Run
#define FITSubSportGravelCycling                                                 ((FITSubSport)46) // Cycling
#define FITSubSportEBikeMountain                                                 ((FITSubSport)47) // Cycling
#define FITSubSportCommuting                                                     ((FITSubSport)48) // Cycling
#define FITSubSportMixedSurface                                                  ((FITSubSport)49) // Cycling
#define FITSubSportNavigate                                                      ((FITSubSport)50)
#define FITSubSportTrackMe                                                       ((FITSubSport)51)
#define FITSubSportMap                                                           ((FITSubSport)52)
#define FITSubSportSingleGasDiving                                               ((FITSubSport)53) // Diving
#define FITSubSportMultiGasDiving                                                ((FITSubSport)54) // Diving
#define FITSubSportGaugeDiving                                                   ((FITSubSport)55) // Diving
#define FITSubSportApneaDiving                                                   ((FITSubSport)56) // Diving
#define FITSubSportApneaHunting                                                  ((FITSubSport)57) // Diving
#define FITSubSportVirtualActivity                                               ((FITSubSport)58)
#define FITSubSportObstacle                                                      ((FITSubSport)59) // Used for events where participants run, crawl through mud, climb over walls, etc.
#define FITSubSportBreathing                                                     ((FITSubSport)62)
#define FITSubSportSailRace                                                      ((FITSubSport)65) // Sailing
#define FITSubSportUltra                                                         ((FITSubSport)67) // Ultramarathon
#define FITSubSportIndoorClimbing                                                ((FITSubSport)68) // Climbing
#define FITSubSportBouldering                                                    ((FITSubSport)69) // Climbing
#define FITSubSportPickleball                                                    ((FITSubSport)84) // Racket
#define FITSubSportPadel                                                         ((FITSubSport)85) // Racket
#define FITSubSportAll                                                           ((FITSubSport)254)
#define FITSubSportCount                                                         68

typedef FITEnum FITSportEvent;
#define FITSportEventInvalid                                                     FITEnumInvalid
#define FITSportEventUncategorized                                               ((FITSportEvent)0)
#define FITSportEventGeocaching                                                  ((FITSportEvent)1)
#define FITSportEventFitness                                                     ((FITSportEvent)2)
#define FITSportEventRecreation                                                  ((FITSportEvent)3)
#define FITSportEventRace                                                        ((FITSportEvent)4)
#define FITSportEventSpecialEvent                                                ((FITSportEvent)5)
#define FITSportEventTraining                                                    ((FITSportEvent)6)
#define FITSportEventTransportation                                              ((FITSportEvent)7)
#define FITSportEventTouring                                                     ((FITSportEvent)8)
#define FITSportEventCount                                                       9

typedef FITEnum FITActivity;
#define FITActivityInvalid                                                       FITEnumInvalid
#define FITActivityManual                                                        ((FITActivity)0)
#define FITActivityAutoMultiSport                                                ((FITActivity)1)
#define FITActivityCount                                                         2

typedef FITEnum FITIntensity;
#define FITIntensityInvalid                                                      FITEnumInvalid
#define FITIntensityActive                                                       ((FITIntensity)0)
#define FITIntensityRest                                                         ((FITIntensity)1)
#define FITIntensityWarmup                                                       ((FITIntensity)2)
#define FITIntensityCooldown                                                     ((FITIntensity)3)
#define FITIntensityRecovery                                                     ((FITIntensity)4)
#define FITIntensityInterval                                                     ((FITIntensity)5)
#define FITIntensityOther                                                        ((FITIntensity)6)
#define FITIntensityCount                                                        7

typedef FITEnum FITSessionTrigger;
#define FITSessionTriggerInvalid                                                 FITEnumInvalid
#define FITSessionTriggerActivityEnd                                             ((FITSessionTrigger)0)
#define FITSessionTriggerManual                                                  ((FITSessionTrigger)1) // User changed sport.
#define FITSessionTriggerAutoMultiSport                                          ((FITSessionTrigger)2) // Auto multi-sport feature is enabled and user pressed lap button to advance session.
#define FITSessionTriggerFitnessEquipment                                        ((FITSessionTrigger)3) // Auto sport change caused by user linking to fitness equipment.
#define FITSessionTriggerCount                                                   4

typedef FITEnum FITAutolapTrigger;
#define FITAutolapTriggerInvalid                                                 FITEnumInvalid
#define FITAutolapTriggerTime                                                    ((FITAutolapTrigger)0)
#define FITAutolapTriggerDistance                                                ((FITAutolapTrigger)1)
#define FITAutolapTriggerPositionStart                                           ((FITAutolapTrigger)2)
#define FITAutolapTriggerPositionLap                                             ((FITAutolapTrigger)3)
#define FITAutolapTriggerPositionWaypoint                                        ((FITAutolapTrigger)4)
#define FITAutolapTriggerPositionMarked                                          ((FITAutolapTrigger)5)
#define FITAutolapTriggerOff                                                     ((FITAutolapTrigger)6)
#define FITAutolapTriggerCount                                                   7

typedef FITEnum FITLapTrigger;
#define FITLapTriggerInvalid                                                     FITEnumInvalid
#define FITLapTriggerManual                                                      ((FITLapTrigger)0)
#define FITLapTriggerTime                                                        ((FITLapTrigger)1)
#define FITLapTriggerDistance                                                    ((FITLapTrigger)2)
#define FITLapTriggerPositionStart                                               ((FITLapTrigger)3)
#define FITLapTriggerPositionLap                                                 ((FITLapTrigger)4)
#define FITLapTriggerPositionWaypoint                                            ((FITLapTrigger)5)
#define FITLapTriggerPositionMarked                                              ((FITLapTrigger)6)
#define FITLapTriggerSessionEnd                                                  ((FITLapTrigger)7)
#define FITLapTriggerFitnessEquipment                                            ((FITLapTrigger)8)
#define FITLapTriggerCount                                                       9

typedef FITEnum FITTimeMode;
#define FITTimeModeInvalid                                                       FITEnumInvalid
#define FITTimeModeHour12                                                        ((FITTimeMode)0)
#define FITTimeModeHour24                                                        ((FITTimeMode)1) // Does not use a leading zero and has a colon
#define FITTimeModeMilitary                                                      ((FITTimeMode)2) // Uses a leading zero and does not have a colon
#define FITTimeModeHour12WithSeconds                                             ((FITTimeMode)3)
#define FITTimeModeHour24WithSeconds                                             ((FITTimeMode)4)
#define FITTimeModeUtc                                                           ((FITTimeMode)5)
#define FITTimeModeCount                                                         6

typedef FITEnum FITBacklightMode;
#define FITBacklightModeInvalid                                                  FITEnumInvalid
#define FITBacklightModeOff                                                      ((FITBacklightMode)0)
#define FITBacklightModeManual                                                   ((FITBacklightMode)1)
#define FITBacklightModeKeyAndMessages                                           ((FITBacklightMode)2)
#define FITBacklightModeAutoBrightness                                           ((FITBacklightMode)3)
#define FITBacklightModeSmartNotifications                                       ((FITBacklightMode)4)
#define FITBacklightModeKeyAndMessagesNight                                      ((FITBacklightMode)5)
#define FITBacklightModeKeyAndMessagesAndSmartNotifications                      ((FITBacklightMode)6)
#define FITBacklightModeCount                                                    7

typedef FITEnum FITDateMode;
#define FITDateModeInvalid                                                       FITEnumInvalid
#define FITDateModeDayMonth                                                      ((FITDateMode)0)
#define FITDateModeMonthDay                                                      ((FITDateMode)1)
#define FITDateModeCount                                                         2

typedef FITUInt8 FITBacklightTimeout; // Timeout in seconds.
#define FITBacklightTimeoutInvalid                                               FITUInt8Invalid
#define FITBacklightTimeoutInfinite                                              ((FITBacklightTimeout)0) // Backlight stays on forever.
#define FITBacklightTimeoutCount                                                 1

typedef FITEnum FITEvent;
#define FITEventInvalid                                                          FITEnumInvalid
#define FITEventTimer                                                            ((FITEvent)0) // Group 0. Start / stop_all
#define FITEventWorkout                                                          ((FITEvent)3) // start / stop
#define FITEventWorkoutStep                                                      ((FITEvent)4) // Start at beginning of workout. Stop at end of each step.
#define FITEventPowerDown                                                        ((FITEvent)5) // stop_all group 0
#define FITEventPowerUp                                                          ((FITEvent)6) // stop_all group 0
#define FITEventOffCourse                                                        ((FITEvent)7) // start / stop group 0
#define FITEventSession                                                          ((FITEvent)8) // Stop at end of each session.
#define FITEventLap                                                              ((FITEvent)9) // Stop at end of each lap.
#define FITEventCoursePoint                                                      ((FITEvent)10) // marker
#define FITEventBattery                                                          ((FITEvent)11) // marker
#define FITEventVirtualPartnerPace                                               ((FITEvent)12) // Group 1. Start at beginning of activity if VP enabled, when VP pace is changed during activity or VP enabled mid activity. stop_disable when VP disabled.
#define FITEventHrHighAlert                                                      ((FITEvent)13) // Group 0. Start / stop when in alert condition.
#define FITEventHrLowAlert                                                       ((FITEvent)14) // Group 0. Start / stop when in alert condition.
#define FITEventSpeedHighAlert                                                   ((FITEvent)15) // Group 0. Start / stop when in alert condition.
#define FITEventSpeedLowAlert                                                    ((FITEvent)16) // Group 0. Start / stop when in alert condition.
#define FITEventCadHighAlert                                                     ((FITEvent)17) // Group 0. Start / stop when in alert condition.
#define FITEventCadLowAlert                                                      ((FITEvent)18) // Group 0. Start / stop when in alert condition.
#define FITEventPowerHighAlert                                                   ((FITEvent)19) // Group 0. Start / stop when in alert condition.
#define FITEventPowerLowAlert                                                    ((FITEvent)20) // Group 0. Start / stop when in alert condition.
#define FITEventRecoveryHr                                                       ((FITEvent)21) // marker
#define FITEventBatteryLow                                                       ((FITEvent)22) // marker
#define FITEventTimeDurationAlert                                                ((FITEvent)23) // Group 1. Start if enabled mid activity (not required at start of activity). Stop when duration is reached. stop_disable if disabled.
#define FITEventDistanceDurationAlert                                            ((FITEvent)24) // Group 1. Start if enabled mid activity (not required at start of activity). Stop when duration is reached. stop_disable if disabled.
#define FITEventCalorieDurationAlert                                             ((FITEvent)25) // Group 1. Start if enabled mid activity (not required at start of activity). Stop when duration is reached. stop_disable if disabled.
#define FITEventActivity                                                         ((FITEvent)26) // Group 1.. Stop at end of activity.
#define FITEventFitnessEquipment                                                 ((FITEvent)27) // marker
#define FITEventLength                                                           ((FITEvent)28) // Stop at end of each length.
#define FITEventUserMarker                                                       ((FITEvent)32) // marker
#define FITEventSportPoint                                                       ((FITEvent)33) // marker
#define FITEventCalibration                                                      ((FITEvent)36) // start/stop/marker
#define FITEventFrontGearChange                                                  ((FITEvent)42) // marker
#define FITEventRearGearChange                                                   ((FITEvent)43) // marker
#define FITEventRiderPositionChange                                              ((FITEvent)44) // marker
#define FITEventElevHighAlert                                                    ((FITEvent)45) // Group 0. Start / stop when in alert condition.
#define FITEventElevLowAlert                                                     ((FITEvent)46) // Group 0. Start / stop when in alert condition.
#define FITEventCommTimeout                                                      ((FITEvent)47) // marker
#define FITEventRadarThreatAlert                                                 ((FITEvent)75) // start/stop/marker
#define FITEventCount                                                            37

typedef FITEnum FITEventType;
#define FITEventTypeInvalid                                                      FITEnumInvalid
#define FITEventTypeStart                                                        ((FITEventType)0)
#define FITEventTypeStop                                                         ((FITEventType)1)
#define FITEventTypeConsecutiveDepreciated                                       ((FITEventType)2)
#define FITEventTypeMarker                                                       ((FITEventType)3)
#define FITEventTypeStopAll                                                      ((FITEventType)4)
#define FITEventTypeBeginDepreciated                                             ((FITEventType)5)
#define FITEventTypeEndDepreciated                                               ((FITEventType)6)
#define FITEventTypeEndAllDepreciated                                            ((FITEventType)7)
#define FITEventTypeStopDisable                                                  ((FITEventType)8)
#define FITEventTypeStopDisableAll                                               ((FITEventType)9)
#define FITEventTypeCount                                                        10

typedef FITEnum FITTimerTrigger; // timer event data
#define FITTimerTriggerInvalid                                                   FITEnumInvalid
#define FITTimerTriggerManual                                                    ((FITTimerTrigger)0)
#define FITTimerTriggerAuto                                                      ((FITTimerTrigger)1)
#define FITTimerTriggerFitnessEquipment                                          ((FITTimerTrigger)2)
#define FITTimerTriggerCount                                                     3

typedef FITEnum FITFitnessEquipmentState; // fitness equipment event data
#define FITFitnessEquipmentStateInvalid                                          FITEnumInvalid
#define FITFitnessEquipmentStateReady                                            ((FITFitnessEquipmentState)0)
#define FITFitnessEquipmentStateInUse                                            ((FITFitnessEquipmentState)1)
#define FITFitnessEquipmentStatePaused                                           ((FITFitnessEquipmentState)2)
#define FITFitnessEquipmentStateUnknown                                          ((FITFitnessEquipmentState)3) // lost connection to fitness equipment
#define FITFitnessEquipmentStateCount                                            4

typedef FITEnum FITTone;
#define FITToneInvalid                                                           FITEnumInvalid
#define FITToneOff                                                               ((FITTone)0)
#define FITToneTone                                                              ((FITTone)1)
#define FITToneVibrate                                                           ((FITTone)2)
#define FITToneToneAndVibrate                                                    ((FITTone)3)
#define FITToneCount                                                             4

typedef FITEnum FITAutoscroll;
#define FITAutoscrollInvalid                                                     FITEnumInvalid
#define FITAutoscrollNone                                                        ((FITAutoscroll)0)
#define FITAutoscrollSlow                                                        ((FITAutoscroll)1)
#define FITAutoscrollMedium                                                      ((FITAutoscroll)2)
#define FITAutoscrollFast                                                        ((FITAutoscroll)3)
#define FITAutoscrollCount                                                       4

typedef FITEnum FITActivityClass;
#define FITActivityClassInvalid                                                  FITEnumInvalid
#define FITActivityClassLevel                                                    ((FITActivityClass)0x7F) // 0 to 100
#define FITActivityClassLevelMax                                                 ((FITActivityClass)100)
#define FITActivityClassAthlete                                                  ((FITActivityClass)0x80)
#define FITActivityClassCount                                                    3

typedef FITEnum FITHrZoneCalc;
#define FITHrZoneCalcInvalid                                                     FITEnumInvalid
#define FITHrZoneCalcCustom                                                      ((FITHrZoneCalc)0)
#define FITHrZoneCalcPercentMaxHr                                                ((FITHrZoneCalc)1)
#define FITHrZoneCalcPercentHrr                                                  ((FITHrZoneCalc)2)
#define FITHrZoneCalcPercentLthr                                                 ((FITHrZoneCalc)3)
#define FITHrZoneCalcCount                                                       4

typedef FITEnum FITPwrZoneCalc;
#define FITPwrZoneCalcInvalid                                                    FITEnumInvalid
#define FITPwrZoneCalcCustom                                                     ((FITPwrZoneCalc)0)
#define FITPwrZoneCalcPercentFtp                                                 ((FITPwrZoneCalc)1)
#define FITPwrZoneCalcCount                                                      2

typedef FITEnum FITWktStepDuration;
#define FITWktStepDurationInvalid                                                FITEnumInvalid
#define FITWktStepDurationTime                                                   ((FITWktStepDuration)0)
#define FITWktStepDurationDistance                                               ((FITWktStepDuration)1)
#define FITWktStepDurationHrLessThan                                             ((FITWktStepDuration)2)
#define FITWktStepDurationHrGreaterThan                                          ((FITWktStepDuration)3)
#define FITWktStepDurationCalories                                               ((FITWktStepDuration)4)
#define FITWktStepDurationOpen                                                   ((FITWktStepDuration)5)
#define FITWktStepDurationRepeatUntilStepsCmplt                                  ((FITWktStepDuration)6)
#define FITWktStepDurationRepeatUntilTime                                        ((FITWktStepDuration)7)
#define FITWktStepDurationRepeatUntilDistance                                    ((FITWktStepDuration)8)
#define FITWktStepDurationRepeatUntilCalories                                    ((FITWktStepDuration)9)
#define FITWktStepDurationRepeatUntilHrLessThan                                  ((FITWktStepDuration)10)
#define FITWktStepDurationRepeatUntilHrGreaterThan                               ((FITWktStepDuration)11)
#define FITWktStepDurationRepeatUntilPowerLessThan                               ((FITWktStepDuration)12)
#define FITWktStepDurationRepeatUntilPowerGreaterThan                            ((FITWktStepDuration)13)
#define FITWktStepDurationPowerLessThan                                          ((FITWktStepDuration)14)
#define FITWktStepDurationPowerGreaterThan                                       ((FITWktStepDuration)15)
#define FITWktStepDurationTrainingPeaksTss                                       ((FITWktStepDuration)16)
#define FITWktStepDurationRepeatUntilPowerLastLapLessThan                        ((FITWktStepDuration)17)
#define FITWktStepDurationRepeatUntilMaxPowerLastLapLessThan                     ((FITWktStepDuration)18)
#define FITWktStepDurationPower3sLessThan                                        ((FITWktStepDuration)19)
#define FITWktStepDurationPower10sLessThan                                       ((FITWktStepDuration)20)
#define FITWktStepDurationPower30sLessThan                                       ((FITWktStepDuration)21)
#define FITWktStepDurationPower3sGreaterThan                                     ((FITWktStepDuration)22)
#define FITWktStepDurationPower10sGreaterThan                                    ((FITWktStepDuration)23)
#define FITWktStepDurationPower30sGreaterThan                                    ((FITWktStepDuration)24)
#define FITWktStepDurationPowerLapLessThan                                       ((FITWktStepDuration)25)
#define FITWktStepDurationPowerLapGreaterThan                                    ((FITWktStepDuration)26)
#define FITWktStepDurationRepeatUntilTrainingPeaksTss                            ((FITWktStepDuration)27)
#define FITWktStepDurationRepetitionTime                                         ((FITWktStepDuration)28)
#define FITWktStepDurationReps                                                   ((FITWktStepDuration)29)
#define FITWktStepDurationTimeOnly                                               ((FITWktStepDuration)31)
#define FITWktStepDurationCount                                                  31

typedef FITEnum FITWktStepTarget;
#define FITWktStepTargetInvalid                                                  FITEnumInvalid
#define FITWktStepTargetSpeed                                                    ((FITWktStepTarget)0)
#define FITWktStepTargetHeartRate                                                ((FITWktStepTarget)1)
#define FITWktStepTargetOpen                                                     ((FITWktStepTarget)2)
#define FITWktStepTargetCadence                                                  ((FITWktStepTarget)3)
#define FITWktStepTargetPower                                                    ((FITWktStepTarget)4)
#define FITWktStepTargetGrade                                                    ((FITWktStepTarget)5)
#define FITWktStepTargetResistance                                               ((FITWktStepTarget)6)
#define FITWktStepTargetPower3s                                                  ((FITWktStepTarget)7)
#define FITWktStepTargetPower10s                                                 ((FITWktStepTarget)8)
#define FITWktStepTargetPower30s                                                 ((FITWktStepTarget)9)
#define FITWktStepTargetPowerLap                                                 ((FITWktStepTarget)10)
#define FITWktStepTargetSwimStroke                                               ((FITWktStepTarget)11)
#define FITWktStepTargetSpeedLap                                                 ((FITWktStepTarget)12)
#define FITWktStepTargetHeartRateLap                                             ((FITWktStepTarget)13)
#define FITWktStepTargetCount                                                    14

typedef FITEnum FITGoal;
#define FITGoalInvalid                                                           FITEnumInvalid
#define FITGoalTime                                                              ((FITGoal)0)
#define FITGoalDistance                                                          ((FITGoal)1)
#define FITGoalCalories                                                          ((FITGoal)2)
#define FITGoalFrequency                                                         ((FITGoal)3)
#define FITGoalSteps                                                             ((FITGoal)4)
#define FITGoalAscent                                                            ((FITGoal)5)
#define FITGoalActiveMinutes                                                     ((FITGoal)6)
#define FITGoalCount                                                             7

typedef FITEnum FITGoalRecurrence;
#define FITGoalRecurrenceInvalid                                                 FITEnumInvalid
#define FITGoalRecurrenceOff                                                     ((FITGoalRecurrence)0)
#define FITGoalRecurrenceDaily                                                   ((FITGoalRecurrence)1)
#define FITGoalRecurrenceWeekly                                                  ((FITGoalRecurrence)2)
#define FITGoalRecurrenceMonthly                                                 ((FITGoalRecurrence)3)
#define FITGoalRecurrenceYearly                                                  ((FITGoalRecurrence)4)
#define FITGoalRecurrenceCustom                                                  ((FITGoalRecurrence)5)
#define FITGoalRecurrenceCount                                                   6

typedef FITEnum FITGoalSource;
#define FITGoalSourceInvalid                                                     FITEnumInvalid
#define FITGoalSourceAuto                                                        ((FITGoalSource)0) // Device generated
#define FITGoalSourceCommunity                                                   ((FITGoalSource)1) // Social network sourced goal
#define FITGoalSourceUser                                                        ((FITGoalSource)2) // Manually generated
#define FITGoalSourceCount                                                       3

typedef FITEnum FITSchedule;
#define FITScheduleInvalid                                                       FITEnumInvalid
#define FITScheduleWorkout                                                       ((FITSchedule)0)
#define FITScheduleCourse                                                        ((FITSchedule)1)
#define FITScheduleCount                                                         2

typedef FITEnum FITCoursePoint;
#define FITCoursePointInvalid                                                    FITEnumInvalid
#define FITCoursePointGeneric                                                    ((FITCoursePoint)0)
#define FITCoursePointSummit                                                     ((FITCoursePoint)1)
#define FITCoursePointValley                                                     ((FITCoursePoint)2)
#define FITCoursePointWater                                                      ((FITCoursePoint)3)
#define FITCoursePointFood                                                       ((FITCoursePoint)4)
#define FITCoursePointDanger                                                     ((FITCoursePoint)5)
#define FITCoursePointLeft                                                       ((FITCoursePoint)6)
#define FITCoursePointRight                                                      ((FITCoursePoint)7)
#define FITCoursePointStraight                                                   ((FITCoursePoint)8)
#define FITCoursePointFirstAid                                                   ((FITCoursePoint)9)
#define FITCoursePointFourthCategory                                             ((FITCoursePoint)10)
#define FITCoursePointThirdCategory                                              ((FITCoursePoint)11)
#define FITCoursePointSecondCategory                                             ((FITCoursePoint)12)
#define FITCoursePointFirstCategory                                              ((FITCoursePoint)13)
#define FITCoursePointHorsCategory                                               ((FITCoursePoint)14)
#define FITCoursePointSprint                                                     ((FITCoursePoint)15)
#define FITCoursePointLeftFork                                                   ((FITCoursePoint)16)
#define FITCoursePointRightFork                                                  ((FITCoursePoint)17)
#define FITCoursePointMiddleFork                                                 ((FITCoursePoint)18)
#define FITCoursePointSlightLeft                                                 ((FITCoursePoint)19)
#define FITCoursePointSharpLeft                                                  ((FITCoursePoint)20)
#define FITCoursePointSlightRight                                                ((FITCoursePoint)21)
#define FITCoursePointSharpRight                                                 ((FITCoursePoint)22)
#define FITCoursePointUTurn                                                      ((FITCoursePoint)23)
#define FITCoursePointSegmentStart                                               ((FITCoursePoint)24)
#define FITCoursePointSegmentEnd                                                 ((FITCoursePoint)25)
#define FITCoursePointCampsite                                                   ((FITCoursePoint)27)
#define FITCoursePointAidStation                                                 ((FITCoursePoint)28)
#define FITCoursePointRestArea                                                   ((FITCoursePoint)29)
#define FITCoursePointGeneralDistance                                            ((FITCoursePoint)30) // Used with UpAhead
#define FITCoursePointService                                                    ((FITCoursePoint)31)
#define FITCoursePointEnergyGel                                                  ((FITCoursePoint)32)
#define FITCoursePointSportsDrink                                                ((FITCoursePoint)33)
#define FITCoursePointMileMarker                                                 ((FITCoursePoint)34)
#define FITCoursePointCheckpoint                                                 ((FITCoursePoint)35)
#define FITCoursePointShelter                                                    ((FITCoursePoint)36)
#define FITCoursePointMeetingSpot                                                ((FITCoursePoint)37)
#define FITCoursePointOverlook                                                   ((FITCoursePoint)38)
#define FITCoursePointToilet                                                     ((FITCoursePoint)39)
#define FITCoursePointShower                                                     ((FITCoursePoint)40)
#define FITCoursePointGear                                                       ((FITCoursePoint)41)
#define FITCoursePointSharpCurve                                                 ((FITCoursePoint)42)
#define FITCoursePointSteepIncline                                               ((FITCoursePoint)43)
#define FITCoursePointTunnel                                                     ((FITCoursePoint)44)
#define FITCoursePointBridge                                                     ((FITCoursePoint)45)
#define FITCoursePointObstacle                                                   ((FITCoursePoint)46)
#define FITCoursePointCrossing                                                   ((FITCoursePoint)47)
#define FITCoursePointStore                                                      ((FITCoursePoint)48)
#define FITCoursePointTransition                                                 ((FITCoursePoint)49)
#define FITCoursePointNavaid                                                     ((FITCoursePoint)50)
#define FITCoursePointTransport                                                  ((FITCoursePoint)51)
#define FITCoursePointAlert                                                      ((FITCoursePoint)52)
#define FITCoursePointInfo                                                       ((FITCoursePoint)53)
#define FITCoursePointCount                                                      53

typedef FITUInt16 FITManufacturer;
#define FITManufacturerInvalid                                                   FITUInt16Invalid
#define FITManufacturerGarmin                                                    ((FITManufacturer)1)
#define FITManufacturerGarminFr405Antfs                                          ((FITManufacturer)2) // Do not use. Used by FR405 for ANTFS man id.
#define FITManufacturerZephyr                                                    ((FITManufacturer)3)
#define FITManufacturerDayton                                                    ((FITManufacturer)4)
#define FITManufacturerIdt                                                       ((FITManufacturer)5)
#define FITManufacturerSrm                                                       ((FITManufacturer)6)
#define FITManufacturerQuarq                                                     ((FITManufacturer)7)
#define FITManufacturerIbike                                                     ((FITManufacturer)8)
#define FITManufacturerSaris                                                     ((FITManufacturer)9)
#define FITManufacturerSparkHk                                                   ((FITManufacturer)10)
#define FITManufacturerTanita                                                    ((FITManufacturer)11)
#define FITManufacturerEchowell                                                  ((FITManufacturer)12)
#define FITManufacturerDynastreamOem                                             ((FITManufacturer)13)
#define FITManufacturerNautilus                                                  ((FITManufacturer)14)
#define FITManufacturerDynastream                                                ((FITManufacturer)15)
#define FITManufacturerTimex                                                     ((FITManufacturer)16)
#define FITManufacturerMetrigear                                                 ((FITManufacturer)17)
#define FITManufacturerXelic                                                     ((FITManufacturer)18)
#define FITManufacturerBeurer                                                    ((FITManufacturer)19)
#define FITManufacturerCardiosport                                               ((FITManufacturer)20)
#define FITManufacturerAAndD                                                     ((FITManufacturer)21)
#define FITManufacturerHmm                                                       ((FITManufacturer)22)
#define FITManufacturerSuunto                                                    ((FITManufacturer)23)
#define FITManufacturerThitaElektronik                                           ((FITManufacturer)24)
#define FITManufacturerGpulse                                                    ((FITManufacturer)25)
#define FITManufacturerCleanMobile                                               ((FITManufacturer)26)
#define FITManufacturerPedalBrain                                                ((FITManufacturer)27)
#define FITManufacturerPeaksware                                                 ((FITManufacturer)28)
#define FITManufacturerSaxonar                                                   ((FITManufacturer)29)
#define FITManufacturerLemondFitness                                             ((FITManufacturer)30)
#define FITManufacturerDexcom                                                    ((FITManufacturer)31)
#define FITManufacturerWahooFitness                                              ((FITManufacturer)32)
#define FITManufacturerOctaneFitness                                             ((FITManufacturer)33)
#define FITManufacturerArchinoetics                                              ((FITManufacturer)34)
#define FITManufacturerTheHurtBox                                                ((FITManufacturer)35)
#define FITManufacturerCitizenSystems                                            ((FITManufacturer)36)
#define FITManufacturerMagellan                                                  ((FITManufacturer)37)
#define FITManufacturerOsynce                                                    ((FITManufacturer)38)
#define FITManufacturerHolux                                                     ((FITManufacturer)39)
#define FITManufacturerConcept2                                                  ((FITManufacturer)40)
#define FITManufacturerShimano                                                   ((FITManufacturer)41)
#define FITManufacturerOneGiantLeap                                              ((FITManufacturer)42)
#define FITManufacturerAceSensor                                                 ((FITManufacturer)43)
#define FITManufacturerBrimBrothers                                              ((FITManufacturer)44)
#define FITManufacturerXplova                                                    ((FITManufacturer)45)
#define FITManufacturerPerceptionDigital                                         ((FITManufacturer)46)
#define FITManufacturerBf1systems                                                ((FITManufacturer)47)
#define FITManufacturerPioneer                                                   ((FITManufacturer)48)
#define FITManufacturerSpantec                                                   ((FITManufacturer)49)
#define FITManufacturerMetalogics                                                ((FITManufacturer)50)
#define FITManufacturer4iiiis                                                    ((FITManufacturer)51)
#define FITManufacturerSeikoEpson                                                ((FITManufacturer)52)
#define FITManufacturerSeikoEpsonOem                                             ((FITManufacturer)53)
#define FITManufacturerIforPowell                                                ((FITManufacturer)54)
#define FITManufacturerMaxwellGuider                                             ((FITManufacturer)55)
#define FITManufacturerStarTrac                                                  ((FITManufacturer)56)
#define FITManufacturerBreakaway                                                 ((FITManufacturer)57)
#define FITManufacturerAlatechTechnologyLtd                                      ((FITManufacturer)58)
#define FITManufacturerMioTechnologyEurope                                       ((FITManufacturer)59)
#define FITManufacturerRotor                                                     ((FITManufacturer)60)
#define FITManufacturerGeonaute                                                  ((FITManufacturer)61)
#define FITManufacturerIdBike                                                    ((FITManufacturer)62)
#define FITManufacturerSpecialized                                               ((FITManufacturer)63)
#define FITManufacturerWtek                                                      ((FITManufacturer)64)
#define FITManufacturerPhysicalEnterprises                                       ((FITManufacturer)65)
#define FITManufacturerNorthPoleEngineering                                      ((FITManufacturer)66)
#define FITManufacturerBkool                                                     ((FITManufacturer)67)
#define FITManufacturerCateye                                                    ((FITManufacturer)68)
#define FITManufacturerStagesCycling                                             ((FITManufacturer)69)
#define FITManufacturerSigmasport                                                ((FITManufacturer)70)
#define FITManufacturerTomtom                                                    ((FITManufacturer)71)
#define FITManufacturerPeripedal                                                 ((FITManufacturer)72)
#define FITManufacturerWattbike                                                  ((FITManufacturer)73)
#define FITManufacturerMoxy                                                      ((FITManufacturer)76)
#define FITManufacturerCiclosport                                                ((FITManufacturer)77)
#define FITManufacturerPowerbahn                                                 ((FITManufacturer)78)
#define FITManufacturerAcornProjectsAps                                          ((FITManufacturer)79)
#define FITManufacturerLifebeam                                                  ((FITManufacturer)80)
#define FITManufacturerBontrager                                                 ((FITManufacturer)81)
#define FITManufacturerWellgo                                                    ((FITManufacturer)82)
#define FITManufacturerScosche                                                   ((FITManufacturer)83)
#define FITManufacturerMagura                                                    ((FITManufacturer)84)
#define FITManufacturerWoodway                                                   ((FITManufacturer)85)
#define FITManufacturerElite                                                     ((FITManufacturer)86)
#define FITManufacturerNielsenKellerman                                          ((FITManufacturer)87)
#define FITManufacturerDkCity                                                    ((FITManufacturer)88)
#define FITManufacturerTacx                                                      ((FITManufacturer)89)
#define FITManufacturerDirectionTechnology                                       ((FITManufacturer)90)
#define FITManufacturerMagtonic                                                  ((FITManufacturer)91)
#define FITManufacturer1partcarbon                                               ((FITManufacturer)92)
#define FITManufacturerInsideRideTechnologies                                    ((FITManufacturer)93)
#define FITManufacturerSoundOfMotion                                             ((FITManufacturer)94)
#define FITManufacturerStryd                                                     ((FITManufacturer)95)
#define FITManufacturerIcg                                                       ((FITManufacturer)96) // Indoorcycling Group
#define FITManufacturerMiPulse                                                   ((FITManufacturer)97)
#define FITManufacturerBsxAthletics                                              ((FITManufacturer)98)
#define FITManufacturerLook                                                      ((FITManufacturer)99)
#define FITManufacturerCampagnoloSrl                                             ((FITManufacturer)100)
#define FITManufacturerBodyBikeSmart                                             ((FITManufacturer)101)
#define FITManufacturerPraxisworks                                               ((FITManufacturer)102)
#define FITManufacturerLimitsTechnology                                          ((FITManufacturer)103) // Limits Technology Ltd.
#define FITManufacturerTopactionTechnology                                       ((FITManufacturer)104) // TopAction Technology Inc.
#define FITManufacturerCosinuss                                                  ((FITManufacturer)105)
#define FITManufacturerFitcare                                                   ((FITManufacturer)106)
#define FITManufacturerMagene                                                    ((FITManufacturer)107)
#define FITManufacturerGiantManufacturingCo                                      ((FITManufacturer)108)
#define FITManufacturerTigrasport                                                ((FITManufacturer)109) // Tigrasport
#define FITManufacturerSalutron                                                  ((FITManufacturer)110)
#define FITManufacturerTechnogym                                                 ((FITManufacturer)111)
#define FITManufacturerBrytonSensors                                             ((FITManufacturer)112)
#define FITManufacturerLatitudeLimited                                           ((FITManufacturer)113)
#define FITManufacturerSoaringTechnology                                         ((FITManufacturer)114)
#define FITManufacturerIgpsport                                                  ((FITManufacturer)115)
#define FITManufacturerThinkrider                                                ((FITManufacturer)116)
#define FITManufacturerGopherSport                                               ((FITManufacturer)117)
#define FITManufacturerWaterrower                                                ((FITManufacturer)118)
#define FITManufacturerOrangetheory                                              ((FITManufacturer)119)
#define FITManufacturerInpeak                                                    ((FITManufacturer)120)
#define FITManufacturerKinetic                                                   ((FITManufacturer)121)
#define FITManufacturerJohnsonHealthTech                                         ((FITManufacturer)122)
#define FITManufacturerPolarElectro                                              ((FITManufacturer)123)
#define FITManufacturerSeesense                                                  ((FITManufacturer)124)
#define FITManufacturerNciTechnology                                             ((FITManufacturer)125)
#define FITManufacturerIqsquare                                                  ((FITManufacturer)126)
#define FITManufacturerLeomo                                                     ((FITManufacturer)127)
#define FITManufacturerIfitCom                                                   ((FITManufacturer)128)
#define FITManufacturerCorosByte                                                 ((FITManufacturer)129)
#define FITManufacturerVersaDesign                                               ((FITManufacturer)130)
#define FITManufacturerChileaf                                                   ((FITManufacturer)131)
#define FITManufacturerCycplus                                                   ((FITManufacturer)132)
#define FITManufacturerGravaaByte                                                ((FITManufacturer)133)
#define FITManufacturerSigeyi                                                    ((FITManufacturer)134)
#define FITManufacturerCoospo                                                    ((FITManufacturer)135)
#define FITManufacturerGeoid                                                     ((FITManufacturer)136)
#define FITManufacturerBosch                                                     ((FITManufacturer)137)
#define FITManufacturerKyto                                                      ((FITManufacturer)138)
#define FITManufacturerKineticSports                                             ((FITManufacturer)139)
#define FITManufacturerDecathlonByte                                             ((FITManufacturer)140)
#define FITManufacturerTqSystems                                                 ((FITManufacturer)141)
#define FITManufacturerTagHeuer                                                  ((FITManufacturer)142)
#define FITManufacturerKeiserFitness                                             ((FITManufacturer)143)
#define FITManufacturerZwiftByte                                                 ((FITManufacturer)144)
#define FITManufacturerPorscheEp                                                 ((FITManufacturer)145)
#define FITManufacturerDevelopment                                               ((FITManufacturer)255)
#define FITManufacturerHealthandlife                                             ((FITManufacturer)257)
#define FITManufacturerLezyne                                                    ((FITManufacturer)258)
#define FITManufacturerScribeLabs                                                ((FITManufacturer)259)
#define FITManufacturerZwift                                                     ((FITManufacturer)260)
#define FITManufacturerWatteam                                                   ((FITManufacturer)261)
#define FITManufacturerRecon                                                     ((FITManufacturer)262)
#define FITManufacturerFaveroElectronics                                         ((FITManufacturer)263)
#define FITManufacturerDynovelo                                                  ((FITManufacturer)264)
#define FITManufacturerStrava                                                    ((FITManufacturer)265)
#define FITManufacturerPrecor                                                    ((FITManufacturer)266) // Amer Sports
#define FITManufacturerBryton                                                    ((FITManufacturer)267)
#define FITManufacturerSram                                                      ((FITManufacturer)268)
#define FITManufacturerNavman                                                    ((FITManufacturer)269) // MiTAC Global Corporation (Mio Technology)
#define FITManufacturerCobi                                                      ((FITManufacturer)270) // COBI GmbH
#define FITManufacturerSpivi                                                     ((FITManufacturer)271)
#define FITManufacturerMioMagellan                                               ((FITManufacturer)272)
#define FITManufacturerEvesports                                                 ((FITManufacturer)273)
#define FITManufacturerSensitivusGauge                                           ((FITManufacturer)274)
#define FITManufacturerPodoon                                                    ((FITManufacturer)275)
#define FITManufacturerLifeTimeFitness                                           ((FITManufacturer)276)
#define FITManufacturerFalcoEMotors                                              ((FITManufacturer)277) // Falco eMotors Inc.
#define FITManufacturerMinoura                                                   ((FITManufacturer)278)
#define FITManufacturerCycliq                                                    ((FITManufacturer)279)
#define FITManufacturerLuxottica                                                 ((FITManufacturer)280)
#define FITManufacturerTrainerRoad                                               ((FITManufacturer)281)
#define FITManufacturerTheSufferfest                                             ((FITManufacturer)282)
#define FITManufacturerFullspeedahead                                            ((FITManufacturer)283)
#define FITManufacturerVirtualtraining                                           ((FITManufacturer)284)
#define FITManufacturerFeedbacksports                                            ((FITManufacturer)285)
#define FITManufacturerOmata                                                     ((FITManufacturer)286)
#define FITManufacturerVdo                                                       ((FITManufacturer)287)
#define FITManufacturerMagneticdays                                              ((FITManufacturer)288)
#define FITManufacturerHammerhead                                                ((FITManufacturer)289)
#define FITManufacturerKineticByKurt                                             ((FITManufacturer)290)
#define FITManufacturerShapelog                                                  ((FITManufacturer)291)
#define FITManufacturerDabuziduo                                                 ((FITManufacturer)292)
#define FITManufacturerJetblack                                                  ((FITManufacturer)293)
#define FITManufacturerCoros                                                     ((FITManufacturer)294)
#define FITManufacturerVirtugo                                                   ((FITManufacturer)295)
#define FITManufacturerVelosense                                                 ((FITManufacturer)296)
#define FITManufacturerCycligentinc                                              ((FITManufacturer)297)
#define FITManufacturerTrailforks                                                ((FITManufacturer)298)
#define FITManufacturerMahleEbikemotion                                          ((FITManufacturer)299)
#define FITManufacturerNurvv                                                     ((FITManufacturer)300)
#define FITManufacturerMicroprogram                                              ((FITManufacturer)301)
#define FITManufacturerZone5cloud                                                ((FITManufacturer)302)
#define FITManufacturerGreenteg                                                  ((FITManufacturer)303)
#define FITManufacturerYamahaMotors                                              ((FITManufacturer)304)
#define FITManufacturerWhoop                                                     ((FITManufacturer)305)
#define FITManufacturerGravaa                                                    ((FITManufacturer)306)
#define FITManufacturerOnelap                                                    ((FITManufacturer)307)
#define FITManufacturerMonarkExercise                                            ((FITManufacturer)308)
#define FITManufacturerForm                                                      ((FITManufacturer)309)
#define FITManufacturerDecathlon                                                 ((FITManufacturer)310)
#define FITManufacturerSyncros                                                   ((FITManufacturer)311)
#define FITManufacturerHeatup                                                    ((FITManufacturer)312)
#define FITManufacturerCannondale                                                ((FITManufacturer)313)
#define FITManufacturerTrueFitness                                               ((FITManufacturer)314)
#define FITManufacturerRGTCycling                                                ((FITManufacturer)315)
#define FITManufacturerVasa                                                      ((FITManufacturer)316)
#define FITManufacturerRaceRepublic                                              ((FITManufacturer)317)
#define FITManufacturerFazua                                                     ((FITManufacturer)318)
#define FITManufacturerOrekaTraining                                             ((FITManufacturer)319)
#define FITManufacturerLsec                                                      ((FITManufacturer)320) // Lishun Electric & Communication
#define FITManufacturerLululemonStudio                                           ((FITManufacturer)321)
#define FITManufacturerShanyue                                                   ((FITManufacturer)322)
#define FITManufacturerActigraphcorp                                             ((FITManufacturer)5759)
#define FITManufacturerCount                                                     211

typedef FITUInt16 FITGarminProduct;
#define FITGarminProductInvalid                                                  FITUInt16Invalid
#define FITGarminProductHrm1                                                     ((FITGarminProduct)1)
#define FITGarminProductAxh01                                                    ((FITGarminProduct)2) // AXH01 HRM chipset
#define FITGarminProductAxb01                                                    ((FITGarminProduct)3)
#define FITGarminProductAxb02                                                    ((FITGarminProduct)4)
#define FITGarminProductHrm2ss                                                   ((FITGarminProduct)5)
#define FITGarminProductDsiAlf02                                                 ((FITGarminProduct)6)
#define FITGarminProductHrm3ss                                                   ((FITGarminProduct)7)
#define FITGarminProductHrmRunSingleByteProductId                                ((FITGarminProduct)8) // hrm_run model for HRM ANT+ messaging
#define FITGarminProductBsm                                                      ((FITGarminProduct)9) // BSM model for ANT+ messaging
#define FITGarminProductBcm                                                      ((FITGarminProduct)10) // BCM model for ANT+ messaging
#define FITGarminProductAxs01                                                    ((FITGarminProduct)11) // AXS01 HRM Bike Chipset model for ANT+ messaging
#define FITGarminProductHrmTriSingleByteProductId                                ((FITGarminProduct)12) // hrm_tri model for HRM ANT+ messaging
#define FITGarminProductHrm4RunSingleByteProductId                               ((FITGarminProduct)13) // hrm4 run model for HRM ANT+ messaging
#define FITGarminProductFr225SingleByteProductId                                 ((FITGarminProduct)14) // fr225 model for HRM ANT+ messaging
#define FITGarminProductGen3BsmSingleByteProductId                               ((FITGarminProduct)15) // gen3_bsm model for Bike Speed ANT+ messaging
#define FITGarminProductGen3BcmSingleByteProductId                               ((FITGarminProduct)16) // gen3_bcm model for Bike Cadence ANT+ messaging
#define FITGarminProductOHR                                                      ((FITGarminProduct)255) // Garmin Wearable Optical Heart Rate Sensor for ANT+ HR Profile Broadcasting
#define FITGarminProductFr301China                                               ((FITGarminProduct)473)
#define FITGarminProductFr301Japan                                               ((FITGarminProduct)474)
#define FITGarminProductFr301Korea                                               ((FITGarminProduct)475)
#define FITGarminProductFr301Taiwan                                              ((FITGarminProduct)494)
#define FITGarminProductFr405                                                    ((FITGarminProduct)717) // Forerunner 405
#define FITGarminProductFr50                                                     ((FITGarminProduct)782) // Forerunner 50
#define FITGarminProductFr405Japan                                               ((FITGarminProduct)987)
#define FITGarminProductFr60                                                     ((FITGarminProduct)988) // Forerunner 60
#define FITGarminProductDsiAlf01                                                 ((FITGarminProduct)1011)
#define FITGarminProductFr310xt                                                  ((FITGarminProduct)1018) // Forerunner 310
#define FITGarminProductEdge500                                                  ((FITGarminProduct)1036)
#define FITGarminProductFr110                                                    ((FITGarminProduct)1124) // Forerunner 110
#define FITGarminProductEdge800                                                  ((FITGarminProduct)1169)
#define FITGarminProductEdge500Taiwan                                            ((FITGarminProduct)1199)
#define FITGarminProductEdge500Japan                                             ((FITGarminProduct)1213)
#define FITGarminProductChirp                                                    ((FITGarminProduct)1253)
#define FITGarminProductFr110Japan                                               ((FITGarminProduct)1274)
#define FITGarminProductEdge200                                                  ((FITGarminProduct)1325)
#define FITGarminProductFr910xt                                                  ((FITGarminProduct)1328)
#define FITGarminProductEdge800Taiwan                                            ((FITGarminProduct)1333)
#define FITGarminProductEdge800Japan                                             ((FITGarminProduct)1334)
#define FITGarminProductAlf04                                                    ((FITGarminProduct)1341)
#define FITGarminProductFr610                                                    ((FITGarminProduct)1345)
#define FITGarminProductFr210Japan                                               ((FITGarminProduct)1360)
#define FITGarminProductVectorSs                                                 ((FITGarminProduct)1380)
#define FITGarminProductVectorCp                                                 ((FITGarminProduct)1381)
#define FITGarminProductEdge800China                                             ((FITGarminProduct)1386)
#define FITGarminProductEdge500China                                             ((FITGarminProduct)1387)
#define FITGarminProductApproachG10                                              ((FITGarminProduct)1405)
#define FITGarminProductFr610Japan                                               ((FITGarminProduct)1410)
#define FITGarminProductEdge500Korea                                             ((FITGarminProduct)1422)
#define FITGarminProductFr70                                                     ((FITGarminProduct)1436)
#define FITGarminProductFr310xt4t                                                ((FITGarminProduct)1446)
#define FITGarminProductAmx                                                      ((FITGarminProduct)1461)
#define FITGarminProductFr10                                                     ((FITGarminProduct)1482)
#define FITGarminProductEdge800Korea                                             ((FITGarminProduct)1497)
#define FITGarminProductSwim                                                     ((FITGarminProduct)1499)
#define FITGarminProductFr910xtChina                                             ((FITGarminProduct)1537)
#define FITGarminProductFenix                                                    ((FITGarminProduct)1551)
#define FITGarminProductEdge200Taiwan                                            ((FITGarminProduct)1555)
#define FITGarminProductEdge510                                                  ((FITGarminProduct)1561)
#define FITGarminProductEdge810                                                  ((FITGarminProduct)1567)
#define FITGarminProductTempe                                                    ((FITGarminProduct)1570)
#define FITGarminProductFr910xtJapan                                             ((FITGarminProduct)1600)
#define FITGarminProductFr620                                                    ((FITGarminProduct)1623)
#define FITGarminProductFr220                                                    ((FITGarminProduct)1632)
#define FITGarminProductFr910xtKorea                                             ((FITGarminProduct)1664)
#define FITGarminProductFr10Japan                                                ((FITGarminProduct)1688)
#define FITGarminProductEdge810Japan                                             ((FITGarminProduct)1721)
#define FITGarminProductVirbElite                                                ((FITGarminProduct)1735)
#define FITGarminProductEdgeTouring                                              ((FITGarminProduct)1736) // Also Edge Touring Plus
#define FITGarminProductEdge510Japan                                             ((FITGarminProduct)1742)
#define FITGarminProductHrmTri                                                   ((FITGarminProduct)1743) // Also HRM-Swim
#define FITGarminProductHrmRun                                                   ((FITGarminProduct)1752)
#define FITGarminProductFr920xt                                                  ((FITGarminProduct)1765)
#define FITGarminProductEdge510Asia                                              ((FITGarminProduct)1821)
#define FITGarminProductEdge810China                                             ((FITGarminProduct)1822)
#define FITGarminProductEdge810Taiwan                                            ((FITGarminProduct)1823)
#define FITGarminProductEdge1000                                                 ((FITGarminProduct)1836)
#define FITGarminProductVivoFit                                                  ((FITGarminProduct)1837)
#define FITGarminProductVirbRemote                                               ((FITGarminProduct)1853)
#define FITGarminProductVivoKi                                                   ((FITGarminProduct)1885)
#define FITGarminProductFr15                                                     ((FITGarminProduct)1903)
#define FITGarminProductVivoActive                                               ((FITGarminProduct)1907)
#define FITGarminProductEdge510Korea                                             ((FITGarminProduct)1918)
#define FITGarminProductFr620Japan                                               ((FITGarminProduct)1928)
#define FITGarminProductFr620China                                               ((FITGarminProduct)1929)
#define FITGarminProductFr220Japan                                               ((FITGarminProduct)1930)
#define FITGarminProductFr220China                                               ((FITGarminProduct)1931)
#define FITGarminProductApproachS6                                               ((FITGarminProduct)1936)
#define FITGarminProductVivoSmart                                                ((FITGarminProduct)1956)
#define FITGarminProductFenix2                                                   ((FITGarminProduct)1967)
#define FITGarminProductEpix                                                     ((FITGarminProduct)1988)
#define FITGarminProductFenix3                                                   ((FITGarminProduct)2050)
#define FITGarminProductEdge1000Taiwan                                           ((FITGarminProduct)2052)
#define FITGarminProductEdge1000Japan                                            ((FITGarminProduct)2053)
#define FITGarminProductFr15Japan                                                ((FITGarminProduct)2061)
#define FITGarminProductEdge520                                                  ((FITGarminProduct)2067)
#define FITGarminProductEdge1000China                                            ((FITGarminProduct)2070)
#define FITGarminProductFr620Russia                                              ((FITGarminProduct)2072)
#define FITGarminProductFr220Russia                                              ((FITGarminProduct)2073)
#define FITGarminProductVectorS                                                  ((FITGarminProduct)2079)
#define FITGarminProductEdge1000Korea                                            ((FITGarminProduct)2100)
#define FITGarminProductFr920xtTaiwan                                            ((FITGarminProduct)2130)
#define FITGarminProductFr920xtChina                                             ((FITGarminProduct)2131)
#define FITGarminProductFr920xtJapan                                             ((FITGarminProduct)2132)
#define FITGarminProductVirbx                                                    ((FITGarminProduct)2134)
#define FITGarminProductVivoSmartApac                                            ((FITGarminProduct)2135)
#define FITGarminProductEtrexTouch                                               ((FITGarminProduct)2140)
#define FITGarminProductEdge25                                                   ((FITGarminProduct)2147)
#define FITGarminProductFr25                                                     ((FITGarminProduct)2148)
#define FITGarminProductVivoFit2                                                 ((FITGarminProduct)2150)
#define FITGarminProductFr225                                                    ((FITGarminProduct)2153)
#define FITGarminProductFr630                                                    ((FITGarminProduct)2156)
#define FITGarminProductFr230                                                    ((FITGarminProduct)2157)
#define FITGarminProductFr735xt                                                  ((FITGarminProduct)2158)
#define FITGarminProductVivoActiveApac                                           ((FITGarminProduct)2160)
#define FITGarminProductVector2                                                  ((FITGarminProduct)2161)
#define FITGarminProductVector2s                                                 ((FITGarminProduct)2162)
#define FITGarminProductVirbxe                                                   ((FITGarminProduct)2172)
#define FITGarminProductFr620Taiwan                                              ((FITGarminProduct)2173)
#define FITGarminProductFr220Taiwan                                              ((FITGarminProduct)2174)
#define FITGarminProductTruswing                                                 ((FITGarminProduct)2175)
#define FITGarminProductD2airvenu                                                ((FITGarminProduct)2187)
#define FITGarminProductFenix3China                                              ((FITGarminProduct)2188)
#define FITGarminProductFenix3Twn                                                ((FITGarminProduct)2189)
#define FITGarminProductVariaHeadlight                                           ((FITGarminProduct)2192)
#define FITGarminProductVariaTaillightOld                                        ((FITGarminProduct)2193)
#define FITGarminProductEdgeExplore1000                                          ((FITGarminProduct)2204)
#define FITGarminProductFr225Asia                                                ((FITGarminProduct)2219)
#define FITGarminProductVariaRadarTaillight                                      ((FITGarminProduct)2225)
#define FITGarminProductVariaRadarDisplay                                        ((FITGarminProduct)2226)
#define FITGarminProductEdge20                                                   ((FITGarminProduct)2238)
#define FITGarminProductEdge520Asia                                              ((FITGarminProduct)2260)
#define FITGarminProductEdge520Japan                                             ((FITGarminProduct)2261)
#define FITGarminProductD2Bravo                                                  ((FITGarminProduct)2262)
#define FITGarminProductApproachS20                                              ((FITGarminProduct)2266)
#define FITGarminProductVivoSmart2                                               ((FITGarminProduct)2271)
#define FITGarminProductEdge1000Thai                                             ((FITGarminProduct)2274)
#define FITGarminProductVariaRemote                                              ((FITGarminProduct)2276)
#define FITGarminProductEdge25Asia                                               ((FITGarminProduct)2288)
#define FITGarminProductEdge25Jpn                                                ((FITGarminProduct)2289)
#define FITGarminProductEdge20Asia                                               ((FITGarminProduct)2290)
#define FITGarminProductApproachX40                                              ((FITGarminProduct)2292)
#define FITGarminProductFenix3Japan                                              ((FITGarminProduct)2293)
#define FITGarminProductVivoSmartEmea                                            ((FITGarminProduct)2294)
#define FITGarminProductFr630Asia                                                ((FITGarminProduct)2310)
#define FITGarminProductFr630Jpn                                                 ((FITGarminProduct)2311)
#define FITGarminProductFr230Jpn                                                 ((FITGarminProduct)2313)
#define FITGarminProductHrm4Run                                                  ((FITGarminProduct)2327)
#define FITGarminProductEpixJapan                                                ((FITGarminProduct)2332)
#define FITGarminProductVivoActiveHr                                             ((FITGarminProduct)2337)
#define FITGarminProductVivoSmartGpsHr                                           ((FITGarminProduct)2347)
#define FITGarminProductVivoSmartHr                                              ((FITGarminProduct)2348)
#define FITGarminProductVivoSmartHrAsia                                          ((FITGarminProduct)2361)
#define FITGarminProductVivoSmartGpsHrAsia                                       ((FITGarminProduct)2362)
#define FITGarminProductVivoMove                                                 ((FITGarminProduct)2368)
#define FITGarminProductVariaTaillight                                           ((FITGarminProduct)2379)
#define FITGarminProductFr235Asia                                                ((FITGarminProduct)2396)
#define FITGarminProductFr235Japan                                               ((FITGarminProduct)2397)
#define FITGarminProductVariaVision                                              ((FITGarminProduct)2398)
#define FITGarminProductVivoFit3                                                 ((FITGarminProduct)2406)
#define FITGarminProductFenix3Korea                                              ((FITGarminProduct)2407)
#define FITGarminProductFenix3Sea                                                ((FITGarminProduct)2408)
#define FITGarminProductFenix3Hr                                                 ((FITGarminProduct)2413)
#define FITGarminProductVirbUltra30                                              ((FITGarminProduct)2417)
#define FITGarminProductIndexSmartScale                                          ((FITGarminProduct)2429)
#define FITGarminProductFr235                                                    ((FITGarminProduct)2431)
#define FITGarminProductFenix3Chronos                                            ((FITGarminProduct)2432)
#define FITGarminProductOregon7xx                                                ((FITGarminProduct)2441)
#define FITGarminProductRino7xx                                                  ((FITGarminProduct)2444)
#define FITGarminProductEpixKorea                                                ((FITGarminProduct)2457)
#define FITGarminProductFenix3HrChn                                              ((FITGarminProduct)2473)
#define FITGarminProductFenix3HrTwn                                              ((FITGarminProduct)2474)
#define FITGarminProductFenix3HrJpn                                              ((FITGarminProduct)2475)
#define FITGarminProductFenix3HrSea                                              ((FITGarminProduct)2476)
#define FITGarminProductFenix3HrKor                                              ((FITGarminProduct)2477)
#define FITGarminProductNautix                                                   ((FITGarminProduct)2496)
#define FITGarminProductVivoActiveHrApac                                         ((FITGarminProduct)2497)
#define FITGarminProductOregon7xxWw                                              ((FITGarminProduct)2512)
#define FITGarminProductEdge820                                                  ((FITGarminProduct)2530)
#define FITGarminProductEdgeExplore820                                           ((FITGarminProduct)2531)
#define FITGarminProductFr735xtApac                                              ((FITGarminProduct)2533)
#define FITGarminProductFr735xtJapan                                             ((FITGarminProduct)2534)
#define FITGarminProductFenix5s                                                  ((FITGarminProduct)2544)
#define FITGarminProductD2BravoTitanium                                          ((FITGarminProduct)2547)
#define FITGarminProductVariaUt800                                               ((FITGarminProduct)2567) // Varia UT 800 SW
#define FITGarminProductRunningDynamicsPod                                       ((FITGarminProduct)2593)
#define FITGarminProductEdge820China                                             ((FITGarminProduct)2599)
#define FITGarminProductEdge820Japan                                             ((FITGarminProduct)2600)
#define FITGarminProductFenix5x                                                  ((FITGarminProduct)2604)
#define FITGarminProductVivoFitJr                                                ((FITGarminProduct)2606)
#define FITGarminProductVivoSmart3                                               ((FITGarminProduct)2622)
#define FITGarminProductVivoSport                                                ((FITGarminProduct)2623)
#define FITGarminProductEdge820Taiwan                                            ((FITGarminProduct)2628)
#define FITGarminProductEdge820Korea                                             ((FITGarminProduct)2629)
#define FITGarminProductEdge820Sea                                               ((FITGarminProduct)2630)
#define FITGarminProductFr35Hebrew                                               ((FITGarminProduct)2650)
#define FITGarminProductApproachS60                                              ((FITGarminProduct)2656)
#define FITGarminProductFr35Apac                                                 ((FITGarminProduct)2667)
#define FITGarminProductFr35Japan                                                ((FITGarminProduct)2668)
#define FITGarminProductFenix3ChronosAsia                                        ((FITGarminProduct)2675)
#define FITGarminProductVirb360                                                  ((FITGarminProduct)2687)
#define FITGarminProductFr935                                                    ((FITGarminProduct)2691)
#define FITGarminProductFenix5                                                   ((FITGarminProduct)2697)
#define FITGarminProductVivoactive3                                              ((FITGarminProduct)2700)
#define FITGarminProductFr235ChinaNfc                                            ((FITGarminProduct)2733)
#define FITGarminProductForetrex601_701                                          ((FITGarminProduct)2769)
#define FITGarminProductVivoMoveHr                                               ((FITGarminProduct)2772)
#define FITGarminProductEdge1030                                                 ((FITGarminProduct)2713)
#define FITGarminProductFr35Sea                                                  ((FITGarminProduct)2727)
#define FITGarminProductVector3                                                  ((FITGarminProduct)2787)
#define FITGarminProductFenix5Asia                                               ((FITGarminProduct)2796)
#define FITGarminProductFenix5sAsia                                              ((FITGarminProduct)2797)
#define FITGarminProductFenix5xAsia                                              ((FITGarminProduct)2798)
#define FITGarminProductApproachZ80                                              ((FITGarminProduct)2806)
#define FITGarminProductFr35Korea                                                ((FITGarminProduct)2814)
#define FITGarminProductD2charlie                                                ((FITGarminProduct)2819)
#define FITGarminProductVivoSmart3Apac                                           ((FITGarminProduct)2831)
#define FITGarminProductVivoSportApac                                            ((FITGarminProduct)2832)
#define FITGarminProductFr935Asia                                                ((FITGarminProduct)2833)
#define FITGarminProductDescent                                                  ((FITGarminProduct)2859)
#define FITGarminProductVivoFit4                                                 ((FITGarminProduct)2878)
#define FITGarminProductFr645                                                    ((FITGarminProduct)2886)
#define FITGarminProductFr645m                                                   ((FITGarminProduct)2888)
#define FITGarminProductFr30                                                     ((FITGarminProduct)2891)
#define FITGarminProductFenix5sPlus                                              ((FITGarminProduct)2900)
#define FITGarminProductEdge130                                                  ((FITGarminProduct)2909)
#define FITGarminProductEdge1030Asia                                             ((FITGarminProduct)2924)
#define FITGarminProductVivosmart4                                               ((FITGarminProduct)2927)
#define FITGarminProductVivoMoveHrAsia                                           ((FITGarminProduct)2945)
#define FITGarminProductApproachX10                                              ((FITGarminProduct)2962)
#define FITGarminProductFr30Asia                                                 ((FITGarminProduct)2977)
#define FITGarminProductVivoactive3mW                                            ((FITGarminProduct)2988)
#define FITGarminProductFr645Asia                                                ((FITGarminProduct)3003)
#define FITGarminProductFr645mAsia                                               ((FITGarminProduct)3004)
#define FITGarminProductEdgeExplore                                              ((FITGarminProduct)3011)
#define FITGarminProductGpsmap66                                                 ((FITGarminProduct)3028)
#define FITGarminProductApproachS10                                              ((FITGarminProduct)3049)
#define FITGarminProductVivoactive3mL                                            ((FITGarminProduct)3066)
#define FITGarminProductApproachG80                                              ((FITGarminProduct)3085)
#define FITGarminProductEdge130Asia                                              ((FITGarminProduct)3092)
#define FITGarminProductEdge1030Bontrager                                        ((FITGarminProduct)3095)
#define FITGarminProductFenix5Plus                                               ((FITGarminProduct)3110)
#define FITGarminProductFenix5xPlus                                              ((FITGarminProduct)3111)
#define FITGarminProductEdge520Plus                                              ((FITGarminProduct)3112)
#define FITGarminProductFr945                                                    ((FITGarminProduct)3113)
#define FITGarminProductEdge530                                                  ((FITGarminProduct)3121)
#define FITGarminProductEdge830                                                  ((FITGarminProduct)3122)
#define FITGarminProductInstinctEsports                                          ((FITGarminProduct)3126)
#define FITGarminProductFenix5sPlusApac                                          ((FITGarminProduct)3134)
#define FITGarminProductFenix5xPlusApac                                          ((FITGarminProduct)3135)
#define FITGarminProductEdge520PlusApac                                          ((FITGarminProduct)3142)
#define FITGarminProductFr235lAsia                                               ((FITGarminProduct)3144)
#define FITGarminProductFr245Asia                                                ((FITGarminProduct)3145)
#define FITGarminProductVivoActive3mApac                                         ((FITGarminProduct)3163)
#define FITGarminProductGen3Bsm                                                  ((FITGarminProduct)3192) // gen3 bike speed sensor
#define FITGarminProductGen3Bcm                                                  ((FITGarminProduct)3193) // gen3 bike cadence sensor
#define FITGarminProductVivoSmart4Asia                                           ((FITGarminProduct)3218)
#define FITGarminProductVivoactive4Small                                         ((FITGarminProduct)3224)
#define FITGarminProductVivoactive4Large                                         ((FITGarminProduct)3225)
#define FITGarminProductVenu                                                     ((FITGarminProduct)3226)
#define FITGarminProductMarqDriver                                               ((FITGarminProduct)3246)
#define FITGarminProductMarqAviator                                              ((FITGarminProduct)3247)
#define FITGarminProductMarqCaptain                                              ((FITGarminProduct)3248)
#define FITGarminProductMarqCommander                                            ((FITGarminProduct)3249)
#define FITGarminProductMarqExpedition                                           ((FITGarminProduct)3250)
#define FITGarminProductMarqAthlete                                              ((FITGarminProduct)3251)
#define FITGarminProductDescentMk2                                               ((FITGarminProduct)3258)
#define FITGarminProductGpsmap66i                                                ((FITGarminProduct)3284)
#define FITGarminProductFenix6SSport                                             ((FITGarminProduct)3287)
#define FITGarminProductFenix6S                                                  ((FITGarminProduct)3288)
#define FITGarminProductFenix6Sport                                              ((FITGarminProduct)3289)
#define FITGarminProductFenix6                                                   ((FITGarminProduct)3290)
#define FITGarminProductFenix6x                                                  ((FITGarminProduct)3291)
#define FITGarminProductHrmDual                                                  ((FITGarminProduct)3299) // HRM-Dual
#define FITGarminProductHrmPro                                                   ((FITGarminProduct)3300) // HRM-Pro
#define FITGarminProductVivoMove3Premium                                         ((FITGarminProduct)3308)
#define FITGarminProductApproachS40                                              ((FITGarminProduct)3314)
#define FITGarminProductFr245mAsia                                               ((FITGarminProduct)3321)
#define FITGarminProductEdge530Apac                                              ((FITGarminProduct)3349)
#define FITGarminProductEdge830Apac                                              ((FITGarminProduct)3350)
#define FITGarminProductVivoMove3                                                ((FITGarminProduct)3378)
#define FITGarminProductVivoActive4SmallAsia                                     ((FITGarminProduct)3387)
#define FITGarminProductVivoActive4LargeAsia                                     ((FITGarminProduct)3388)
#define FITGarminProductVivoActive4OledAsia                                      ((FITGarminProduct)3389)
#define FITGarminProductSwim2                                                    ((FITGarminProduct)3405)
#define FITGarminProductMarqDriverAsia                                           ((FITGarminProduct)3420)
#define FITGarminProductMarqAviatorAsia                                          ((FITGarminProduct)3421)
#define FITGarminProductVivoMove3Asia                                            ((FITGarminProduct)3422)
#define FITGarminProductFr945Asia                                                ((FITGarminProduct)3441)
#define FITGarminProductVivoActive3tChn                                          ((FITGarminProduct)3446)
#define FITGarminProductMarqCaptainAsia                                          ((FITGarminProduct)3448)
#define FITGarminProductMarqCommanderAsia                                        ((FITGarminProduct)3449)
#define FITGarminProductMarqExpeditionAsia                                       ((FITGarminProduct)3450)
#define FITGarminProductMarqAthleteAsia                                          ((FITGarminProduct)3451)
#define FITGarminProductInstinctSolar                                            ((FITGarminProduct)3466)
#define FITGarminProductFr45Asia                                                 ((FITGarminProduct)3469)
#define FITGarminProductVivoactive3Daimler                                       ((FITGarminProduct)3473)
#define FITGarminProductLegacyRey                                                ((FITGarminProduct)3498)
#define FITGarminProductLegacyDarthVader                                         ((FITGarminProduct)3499)
#define FITGarminProductLegacyCaptainMarvel                                      ((FITGarminProduct)3500)
#define FITGarminProductLegacyFirstAvenger                                       ((FITGarminProduct)3501)
#define FITGarminProductFenix6sSportAsia                                         ((FITGarminProduct)3512)
#define FITGarminProductFenix6sAsia                                              ((FITGarminProduct)3513)
#define FITGarminProductFenix6SportAsia                                          ((FITGarminProduct)3514)
#define FITGarminProductFenix6Asia                                               ((FITGarminProduct)3515)
#define FITGarminProductFenix6xAsia                                              ((FITGarminProduct)3516)
#define FITGarminProductLegacyCaptainMarvelAsia                                  ((FITGarminProduct)3535)
#define FITGarminProductLegacyFirstAvengerAsia                                   ((FITGarminProduct)3536)
#define FITGarminProductLegacyReyAsia                                            ((FITGarminProduct)3537)
#define FITGarminProductLegacyDarthVaderAsia                                     ((FITGarminProduct)3538)
#define FITGarminProductDescentMk2s                                              ((FITGarminProduct)3542)
#define FITGarminProductEdge130Plus                                              ((FITGarminProduct)3558)
#define FITGarminProductEdge1030Plus                                             ((FITGarminProduct)3570)
#define FITGarminProductRally200                                                 ((FITGarminProduct)3578) // Rally 100/200 Power Meter Series
#define FITGarminProductFr745                                                    ((FITGarminProduct)3589)
#define FITGarminProductVenusq                                                   ((FITGarminProduct)3600)
#define FITGarminProductLily                                                     ((FITGarminProduct)3615)
#define FITGarminProductMarqAdventurer                                           ((FITGarminProduct)3624)
#define FITGarminProductEnduro                                                   ((FITGarminProduct)3638)
#define FITGarminProductSwim2Apac                                                ((FITGarminProduct)3639)
#define FITGarminProductMarqAdventurerAsia                                       ((FITGarminProduct)3648)
#define FITGarminProductFr945Lte                                                 ((FITGarminProduct)3652)
#define FITGarminProductDescentMk2Asia                                           ((FITGarminProduct)3702) // Mk2 and Mk2i
#define FITGarminProductVenu2                                                    ((FITGarminProduct)3703)
#define FITGarminProductVenu2s                                                   ((FITGarminProduct)3704)
#define FITGarminProductVenuDaimlerAsia                                          ((FITGarminProduct)3737)
#define FITGarminProductMarqGolfer                                               ((FITGarminProduct)3739)
#define FITGarminProductVenuDaimler                                              ((FITGarminProduct)3740)
#define FITGarminProductFr745Asia                                                ((FITGarminProduct)3794)
#define FITGarminProductLilyAsia                                                 ((FITGarminProduct)3809)
#define FITGarminProductEdge1030PlusAsia                                         ((FITGarminProduct)3812)
#define FITGarminProductEdge130PlusAsia                                          ((FITGarminProduct)3813)
#define FITGarminProductApproachS12                                              ((FITGarminProduct)3823)
#define FITGarminProductEnduroAsia                                               ((FITGarminProduct)3872)
#define FITGarminProductVenusqAsia                                               ((FITGarminProduct)3837)
#define FITGarminProductEdge1040                                                 ((FITGarminProduct)3843)
#define FITGarminProductMarqGolferAsia                                           ((FITGarminProduct)3850)
#define FITGarminProductVenu2Plus                                                ((FITGarminProduct)3851)
#define FITGarminProductFr55                                                     ((FITGarminProduct)3869)
#define FITGarminProductInstinct2                                                ((FITGarminProduct)3888)
#define FITGarminProductFenix7s                                                  ((FITGarminProduct)3905)
#define FITGarminProductFenix7                                                   ((FITGarminProduct)3906)
#define FITGarminProductFenix7x                                                  ((FITGarminProduct)3907)
#define FITGarminProductFenix7sApac                                              ((FITGarminProduct)3908)
#define FITGarminProductFenix7Apac                                               ((FITGarminProduct)3909)
#define FITGarminProductFenix7xApac                                              ((FITGarminProduct)3910)
#define FITGarminProductApproachG12                                              ((FITGarminProduct) 3927)
#define FITGarminProductDescentMk2sAsia                                          ((FITGarminProduct)3930)
#define FITGarminProductApproachS42                                              ((FITGarminProduct)3934)
#define FITGarminProductEpixGen2                                                 ((FITGarminProduct)3943)
#define FITGarminProductEpixGen2Apac                                             ((FITGarminProduct)3944)
#define FITGarminProductVenu2sAsia                                               ((FITGarminProduct)3949)
#define FITGarminProductVenu2Asia                                                ((FITGarminProduct)3950)
#define FITGarminProductFr945LteAsia                                             ((FITGarminProduct)3978)
#define FITGarminProductVivoMoveSport                                            ((FITGarminProduct)3982)
#define FITGarminProductApproachS12Asia                                          ((FITGarminProduct)3986)
#define FITGarminProductFr255Music                                               ((FITGarminProduct)3990)
#define FITGarminProductFr255SmallMusic                                          ((FITGarminProduct)3991)
#define FITGarminProductFr255                                                    ((FITGarminProduct)3992)
#define FITGarminProductFr255Small                                               ((FITGarminProduct)3993)
#define FITGarminProductApproachG12Asia                                          ((FITGarminProduct) 4001)
#define FITGarminProductApproachS42Asia                                          ((FITGarminProduct)4002)
#define FITGarminProductDescentG1                                                ((FITGarminProduct)4005)
#define FITGarminProductVenu2PlusAsia                                            ((FITGarminProduct)4017)
#define FITGarminProductFr955                                                    ((FITGarminProduct)4024)
#define FITGarminProductFr55Asia                                                 ((FITGarminProduct)4033)
#define FITGarminProductVivosmart5                                               ((FITGarminProduct)4063)
#define FITGarminProductInstinct2Asia                                            ((FITGarminProduct)4071)
#define FITGarminProductMarqGen2                                                 ((FITGarminProduct)4105) // Adventurer, Athlete, Captain, Golfer
#define FITGarminProductVenusq2                                                  ((FITGarminProduct)4115)
#define FITGarminProductVenusq2music                                             ((FITGarminProduct)4116)
#define FITGarminProductMarqGen2Aviator                                          ((FITGarminProduct)4124)
#define FITGarminProductD2AirX10                                                 ((FITGarminProduct)4125)
#define FITGarminProductHrmProPlus                                               ((FITGarminProduct)4130)
#define FITGarminProductDescentG1Asia                                            ((FITGarminProduct)4132)
#define FITGarminProductTactix7                                                  ((FITGarminProduct)4135)
#define FITGarminProductInstinctCrossover                                        ((FITGarminProduct)4155)
#define FITGarminProductEdgeExplore2                                             ((FITGarminProduct)4169)
#define FITGarminProductTacxNeoSmart                                             ((FITGarminProduct)4265) // Neo Smart, Tacx
#define FITGarminProductTacxNeo2Smart                                            ((FITGarminProduct)4266) // Neo 2 Smart, Tacx
#define FITGarminProductTacxNeo2TSmart                                           ((FITGarminProduct)4267) // Neo 2T Smart, Tacx
#define FITGarminProductTacxNeoSmartBike                                         ((FITGarminProduct)4268) // Neo Smart Bike, Tacx
#define FITGarminProductTacxSatoriSmart                                          ((FITGarminProduct)4269) // Satori Smart, Tacx
#define FITGarminProductTacxFlowSmart                                            ((FITGarminProduct)4270) // Flow Smart, Tacx
#define FITGarminProductTacxVortexSmart                                          ((FITGarminProduct)4271) // Vortex Smart, Tacx
#define FITGarminProductTacxBushidoSmart                                         ((FITGarminProduct)4272) // Bushido Smart, Tacx
#define FITGarminProductTacxGeniusSmart                                          ((FITGarminProduct)4273) // Genius Smart, Tacx
#define FITGarminProductTacxFluxFluxSSmart                                       ((FITGarminProduct)4274) // Flux/Flux S Smart, Tacx
#define FITGarminProductTacxFlux2Smart                                           ((FITGarminProduct)4275) // Flux 2 Smart, Tacx
#define FITGarminProductTacxMagnum                                               ((FITGarminProduct)4276) // Magnum, Tacx
#define FITGarminProductEdge1040Asia                                             ((FITGarminProduct)4305)
#define FITGarminProductEnduro2                                                  ((FITGarminProduct)4341)
#define FITGarminProductSdm4                                                     ((FITGarminProduct)10007) // SDM4 footpod
#define FITGarminProductEdgeRemote                                               ((FITGarminProduct)10014)
#define FITGarminProductTacxTrainingAppWin                                       ((FITGarminProduct)20533)
#define FITGarminProductTacxTrainingAppMac                                       ((FITGarminProduct)20534)
#define FITGarminProductTacxTrainingAppMacCatalyst                               ((FITGarminProduct)20565)
#define FITGarminProductTrainingCenter                                           ((FITGarminProduct)20119)
#define FITGarminProductTacxTrainingAppAndroid                                   ((FITGarminProduct)30045)
#define FITGarminProductTacxTrainingAppIos                                       ((FITGarminProduct)30046)
#define FITGarminProductTacxTrainingAppLegacy                                    ((FITGarminProduct)30047)
#define FITGarminProductConnectiqSimulator                                       ((FITGarminProduct)65531)
#define FITGarminProductAndroidAntplusPlugin                                     ((FITGarminProduct)65532)
#define FITGarminProductConnect                                                  ((FITGarminProduct)65534) // Garmin Connect website
#define FITGarminProductCount                                                    403

typedef FITUInt8 FITAntplusDeviceType;
#define FITAntplusDeviceTypeInvalid                                              FITUInt8Invalid
#define FITAntplusDeviceTypeAntfs                                                ((FITAntplusDeviceType)1)
#define FITAntplusDeviceTypeBikePower                                            ((FITAntplusDeviceType)11)
#define FITAntplusDeviceTypeEnvironmentSensorLegacy                              ((FITAntplusDeviceType)12)
#define FITAntplusDeviceTypeMultiSportSpeedDistance                              ((FITAntplusDeviceType)15)
#define FITAntplusDeviceTypeControl                                              ((FITAntplusDeviceType)16)
#define FITAntplusDeviceTypeFitnessEquipment                                     ((FITAntplusDeviceType)17)
#define FITAntplusDeviceTypeBloodPressure                                        ((FITAntplusDeviceType)18)
#define FITAntplusDeviceTypeGeocacheNode                                         ((FITAntplusDeviceType)19)
#define FITAntplusDeviceTypeLightElectricVehicle                                 ((FITAntplusDeviceType)20)
#define FITAntplusDeviceTypeEnvSensor                                            ((FITAntplusDeviceType)25)
#define FITAntplusDeviceTypeRacquet                                              ((FITAntplusDeviceType)26)
#define FITAntplusDeviceTypeControlHub                                           ((FITAntplusDeviceType)27)
#define FITAntplusDeviceTypeMuscleOxygen                                         ((FITAntplusDeviceType)31)
#define FITAntplusDeviceTypeShifting                                             ((FITAntplusDeviceType)34)
#define FITAntplusDeviceTypeBikeLightMain                                        ((FITAntplusDeviceType)35)
#define FITAntplusDeviceTypeBikeLightShared                                      ((FITAntplusDeviceType)36)
#define FITAntplusDeviceTypeExd                                                  ((FITAntplusDeviceType)38)
#define FITAntplusDeviceTypeBikeRadar                                            ((FITAntplusDeviceType)40)
#define FITAntplusDeviceTypeBikeAero                                             ((FITAntplusDeviceType)46)
#define FITAntplusDeviceTypeWeightScale                                          ((FITAntplusDeviceType)119)
#define FITAntplusDeviceTypeHeartRate                                            ((FITAntplusDeviceType)120)
#define FITAntplusDeviceTypeBikeSpeedCadence                                     ((FITAntplusDeviceType)121)
#define FITAntplusDeviceTypeBikeCadence                                          ((FITAntplusDeviceType)122)
#define FITAntplusDeviceTypeBikeSpeed                                            ((FITAntplusDeviceType)123)
#define FITAntplusDeviceTypeStrideSpeedDistance                                  ((FITAntplusDeviceType)124)
#define FITAntplusDeviceTypeCount                                                25

typedef FITEnum FITAntNetwork;
#define FITAntNetworkInvalid                                                     FITEnumInvalid
#define FITAntNetworkPublic                                                      ((FITAntNetwork)0)
#define FITAntNetworkAntplus                                                     ((FITAntNetwork)1)
#define FITAntNetworkAntfs                                                       ((FITAntNetwork)2)
#define FITAntNetworkPrivate                                                     ((FITAntNetwork)3)
#define FITAntNetworkCount                                                       4

typedef FITUInt32z FITWorkoutCapabilities;
#define FITWorkoutCapabilitiesInvalid                                            FITUInt32zInvalid
#define FITWorkoutCapabilitiesInterval                                           ((FITWorkoutCapabilities)0x00000001)
#define FITWorkoutCapabilitiesCustom                                             ((FITWorkoutCapabilities)0x00000002)
#define FITWorkoutCapabilitiesFitnessEquipment                                   ((FITWorkoutCapabilities)0x00000004)
#define FITWorkoutCapabilitiesFirstbeat                                          ((FITWorkoutCapabilities)0x00000008)
#define FITWorkoutCapabilitiesNewLeaf                                            ((FITWorkoutCapabilities)0x00000010)
#define FITWorkoutCapabilitiesTcx                                                ((FITWorkoutCapabilities)0x00000020) // For backwards compatibility. Watch should add missing id fields then clear flag.
#define FITWorkoutCapabilitiesSpeed                                              ((FITWorkoutCapabilities)0x00000080) // Speed source required for workout step.
#define FITWorkoutCapabilitiesHeartRate                                          ((FITWorkoutCapabilities)0x00000100) // Heart rate source required for workout step.
#define FITWorkoutCapabilitiesDistance                                           ((FITWorkoutCapabilities)0x00000200) // Distance source required for workout step.
#define FITWorkoutCapabilitiesCadence                                            ((FITWorkoutCapabilities)0x00000400) // Cadence source required for workout step.
#define FITWorkoutCapabilitiesPower                                              ((FITWorkoutCapabilities)0x00000800) // Power source required for workout step.
#define FITWorkoutCapabilitiesGrade                                              ((FITWorkoutCapabilities)0x00001000) // Grade source required for workout step.
#define FITWorkoutCapabilitiesResistance                                         ((FITWorkoutCapabilities)0x00002000) // Resistance source required for workout step.
#define FITWorkoutCapabilitiesProtected                                          ((FITWorkoutCapabilities)0x00004000)
#define FITWorkoutCapabilitiesCount                                              14

typedef FITUInt8 FITBatteryStatus;
#define FITBatteryStatusInvalid                                                  FITUInt8Invalid
#define FITBatteryStatusNew                                                      ((FITBatteryStatus)1)
#define FITBatteryStatusGood                                                     ((FITBatteryStatus)2)
#define FITBatteryStatusOk                                                       ((FITBatteryStatus)3)
#define FITBatteryStatusLow                                                      ((FITBatteryStatus)4)
#define FITBatteryStatusCritical                                                 ((FITBatteryStatus)5)
#define FITBatteryStatusCharging                                                 ((FITBatteryStatus)6)
#define FITBatteryStatusUnknown                                                  ((FITBatteryStatus)7)
#define FITBatteryStatusCount                                                    7

typedef FITEnum FITHrType;
#define FITHrTypeInvalid                                                         FITEnumInvalid
#define FITHrTypeNormal                                                          ((FITHrType)0)
#define FITHrTypeIrregular                                                       ((FITHrType)1)
#define FITHrTypeCount                                                           2

typedef FITUInt32z FITCourseCapabilities;
#define FITCourseCapabilitiesInvalid                                             FITUInt32zInvalid
#define FITCourseCapabilitiesProcessed                                           ((FITCourseCapabilities)0x00000001)
#define FITCourseCapabilitiesValid                                               ((FITCourseCapabilities)0x00000002)
#define FITCourseCapabilitiesTime                                                ((FITCourseCapabilities)0x00000004)
#define FITCourseCapabilitiesDistance                                            ((FITCourseCapabilities)0x00000008)
#define FITCourseCapabilitiesPosition                                            ((FITCourseCapabilities)0x00000010)
#define FITCourseCapabilitiesHeartRate                                           ((FITCourseCapabilities)0x00000020)
#define FITCourseCapabilitiesPower                                               ((FITCourseCapabilities)0x00000040)
#define FITCourseCapabilitiesCadence                                             ((FITCourseCapabilities)0x00000080)
#define FITCourseCapabilitiesTraining                                            ((FITCourseCapabilities)0x00000100)
#define FITCourseCapabilitiesNavigation                                          ((FITCourseCapabilities)0x00000200)
#define FITCourseCapabilitiesBikeway                                             ((FITCourseCapabilities)0x00000400)
#define FITCourseCapabilitiesAviation                                            ((FITCourseCapabilities)0x00001000) // Denote course files to be used as flight plans
#define FITCourseCapabilitiesCount                                               12

typedef FITUInt16 FITWeight;
#define FITWeightInvalid                                                         FITUInt16Invalid
#define FITWeightCalculating                                                     ((FITWeight)0xFFFE)
#define FITWeightCount                                                           1

typedef FITUInt32 FITWorkoutHr; // 0 - 100 indicates% of max hr; >100 indicates bpm (255 max) plus 100
#define FITWorkoutHrInvalid                                                      FITUInt32Invalid
#define FITWorkoutHrBpmOffset                                                    ((FITWorkoutHr)100)
#define FITWorkoutHrCount                                                        1

typedef FITUInt32 FITWorkoutPower; // 0 - 1000 indicates % of functional threshold power; >1000 indicates watts plus 1000.
#define FITWorkoutPowerInvalid                                                   FITUInt32Invalid
#define FITWorkoutPowerWattsOffset                                               ((FITWorkoutPower)1000)
#define FITWorkoutPowerCount                                                     1

typedef FITEnum FITBpStatus;
#define FITBpStatusInvalid                                                       FITEnumInvalid
#define FITBpStatusNoError                                                       ((FITBpStatus)0)
#define FITBpStatusErrorIncompleteData                                           ((FITBpStatus)1)
#define FITBpStatusErrorNoMeasurement                                            ((FITBpStatus)2)
#define FITBpStatusErrorDataOutOfRange                                           ((FITBpStatus)3)
#define FITBpStatusErrorIrregularHeartRate                                       ((FITBpStatus)4)
#define FITBpStatusCount                                                         5

typedef FITUInt16 FITUserLocalId;
#define FITUserLocalIdInvalid                                                    FITUInt16Invalid
#define FITUserLocalIdLocalMin                                                   ((FITUserLocalId)0x0000)
#define FITUserLocalIdLocalMax                                                   ((FITUserLocalId)0x000F)
#define FITUserLocalIdStationaryMin                                              ((FITUserLocalId)0x0010)
#define FITUserLocalIdStationaryMax                                              ((FITUserLocalId)0x00FF)
#define FITUserLocalIdPortableMin                                                ((FITUserLocalId)0x0100)
#define FITUserLocalIdPortableMax                                                ((FITUserLocalId)0xFFFE)
#define FITUserLocalIdCount                                                      6

typedef FITEnum FITSwimStroke;
#define FITSwimStrokeInvalid                                                     FITEnumInvalid
#define FITSwimStrokeFreestyle                                                   ((FITSwimStroke)0)
#define FITSwimStrokeBackstroke                                                  ((FITSwimStroke)1)
#define FITSwimStrokeBreaststroke                                                ((FITSwimStroke)2)
#define FITSwimStrokeButterfly                                                   ((FITSwimStroke)3)
#define FITSwimStrokeDrill                                                       ((FITSwimStroke)4)
#define FITSwimStrokeMixed                                                       ((FITSwimStroke)5)
#define FITSwimStrokeIm                                                          ((FITSwimStroke)6) // IM is a mixed interval containing the same number of lengths for each of: Butterfly, Backstroke, Breaststroke, Freestyle, swam in that order.
#define FITSwimStrokeCount                                                       7

typedef FITEnum FITActivityType;
#define FITActivityTypeInvalid                                                   FITEnumInvalid
#define FITActivityTypeGeneric                                                   ((FITActivityType)0)
#define FITActivityTypeRunning                                                   ((FITActivityType)1)
#define FITActivityTypeCycling                                                   ((FITActivityType)2)
#define FITActivityTypeTransition                                                ((FITActivityType)3) // Mulitsport transition
#define FITActivityTypeFitnessEquipment                                          ((FITActivityType)4)
#define FITActivityTypeSwimming                                                  ((FITActivityType)5)
#define FITActivityTypeWalking                                                   ((FITActivityType)6)
#define FITActivityTypeSedentary                                                 ((FITActivityType)8)
#define FITActivityTypeAll                                                       ((FITActivityType)254) // All is for goals only to include all sports.
#define FITActivityTypeCount                                                     9

typedef FITEnum FITActivitySubtype;
#define FITActivitySubtypeInvalid                                                FITEnumInvalid
#define FITActivitySubtypeGeneric                                                ((FITActivitySubtype)0)
#define FITActivitySubtypeTreadmill                                              ((FITActivitySubtype)1) // Run
#define FITActivitySubtypeStreet                                                 ((FITActivitySubtype)2) // Run
#define FITActivitySubtypeTrail                                                  ((FITActivitySubtype)3) // Run
#define FITActivitySubtypeTrack                                                  ((FITActivitySubtype)4) // Run
#define FITActivitySubtypeSpin                                                   ((FITActivitySubtype)5) // Cycling
#define FITActivitySubtypeIndoorCycling                                          ((FITActivitySubtype)6) // Cycling
#define FITActivitySubtypeRoad                                                   ((FITActivitySubtype)7) // Cycling
#define FITActivitySubtypeMountain                                               ((FITActivitySubtype)8) // Cycling
#define FITActivitySubtypeDownhill                                               ((FITActivitySubtype)9) // Cycling
#define FITActivitySubtypeRecumbent                                              ((FITActivitySubtype)10) // Cycling
#define FITActivitySubtypeCyclocross                                             ((FITActivitySubtype)11) // Cycling
#define FITActivitySubtypeHandCycling                                            ((FITActivitySubtype)12) // Cycling
#define FITActivitySubtypeTrackCycling                                           ((FITActivitySubtype)13) // Cycling
#define FITActivitySubtypeIndoorRowing                                           ((FITActivitySubtype)14) // Fitness Equipment
#define FITActivitySubtypeElliptical                                             ((FITActivitySubtype)15) // Fitness Equipment
#define FITActivitySubtypeStairClimbing                                          ((FITActivitySubtype)16) // Fitness Equipment
#define FITActivitySubtypeLapSwimming                                            ((FITActivitySubtype)17) // Swimming
#define FITActivitySubtypeOpenWater                                              ((FITActivitySubtype)18) // Swimming
#define FITActivitySubtypeAll                                                    ((FITActivitySubtype)254)
#define FITActivitySubtypeCount                                                  20

typedef FITEnum FITActivityLevel;
#define FITActivityLevelInvalid                                                  FITEnumInvalid
#define FITActivityLevelLow                                                      ((FITActivityLevel)0)
#define FITActivityLevelMedium                                                   ((FITActivityLevel)1)
#define FITActivityLevelHigh                                                     ((FITActivityLevel)2)
#define FITActivityLevelCount                                                    3

typedef FITEnum FITSide;
#define FITSideInvalid                                                           FITEnumInvalid
#define FITSideRight                                                             ((FITSide)0)
#define FITSideLeft                                                              ((FITSide)1)
#define FITSideCount                                                             2

typedef FITUInt8 FITLeftRightBalance;
#define FITLeftRightBalanceInvalid                                               FITUInt8Invalid
#define FITLeftRightBalanceMask                                                  ((FITLeftRightBalance)0x7F) // % contribution
#define FITLeftRightBalanceRight                                                 ((FITLeftRightBalance)0x80) // data corresponds to right if set, otherwise unknown
#define FITLeftRightBalanceCount                                                 2

typedef FITUInt16 FITLeftRightBalance100;
#define FITLeftRightBalance100Invalid                                            FITUInt16Invalid
#define FITLeftRightBalance100Mask                                               ((FITLeftRightBalance100)0x3FFF) // % contribution scaled by 100
#define FITLeftRightBalance100Right                                              ((FITLeftRightBalance100)0x8000) // data corresponds to right if set, otherwise unknown
#define FITLeftRightBalance100Count                                              2

typedef FITEnum FITLengthType;
#define FITLengthTypeInvalid                                                     FITEnumInvalid
#define FITLengthTypeIdle                                                        ((FITLengthType)0) // Rest period. Length with no strokes
#define FITLengthTypeActive                                                      ((FITLengthType)1) // Length with strokes.
#define FITLengthTypeCount                                                       2

typedef FITEnum FITDayOfWeek;
#define FITDayOfWeekInvalid                                                      FITEnumInvalid
#define FITDayOfWeekSunday                                                       ((FITDayOfWeek)0)
#define FITDayOfWeekMonday                                                       ((FITDayOfWeek)1)
#define FITDayOfWeekTuesday                                                      ((FITDayOfWeek)2)
#define FITDayOfWeekWednesday                                                    ((FITDayOfWeek)3)
#define FITDayOfWeekThursday                                                     ((FITDayOfWeek)4)
#define FITDayOfWeekFriday                                                       ((FITDayOfWeek)5)
#define FITDayOfWeekSaturday                                                     ((FITDayOfWeek)6)
#define FITDayOfWeekCount                                                        7

typedef FITUInt32z FITConnectivityCapabilities;
#define FITConnectivityCapabilitiesInvalid                                       FITUInt32zInvalid
#define FITConnectivityCapabilitiesBluetooth                                     ((FITConnectivityCapabilities)0x00000001)
#define FITConnectivityCapabilitiesBluetoothLe                                   ((FITConnectivityCapabilities)0x00000002)
#define FITConnectivityCapabilitiesAnt                                           ((FITConnectivityCapabilities)0x00000004)
#define FITConnectivityCapabilitiesActivityUpload                                ((FITConnectivityCapabilities)0x00000008)
#define FITConnectivityCapabilitiesCourseDownload                                ((FITConnectivityCapabilities)0x00000010)
#define FITConnectivityCapabilitiesWorkoutDownload                               ((FITConnectivityCapabilities)0x00000020)
#define FITConnectivityCapabilitiesLiveTrack                                     ((FITConnectivityCapabilities)0x00000040)
#define FITConnectivityCapabilitiesWeatherConditions                             ((FITConnectivityCapabilities)0x00000080)
#define FITConnectivityCapabilitiesWeatherAlerts                                 ((FITConnectivityCapabilities)0x00000100)
#define FITConnectivityCapabilitiesGpsEphemerisDownload                          ((FITConnectivityCapabilities)0x00000200)
#define FITConnectivityCapabilitiesExplicitArchive                               ((FITConnectivityCapabilities)0x00000400)
#define FITConnectivityCapabilitiesSetupIncomplete                               ((FITConnectivityCapabilities)0x00000800)
#define FITConnectivityCapabilitiesContinueSyncAfterSoftwareUpdate               ((FITConnectivityCapabilities)0x00001000)
#define FITConnectivityCapabilitiesConnectIqAppDownload                          ((FITConnectivityCapabilities)0x00002000)
#define FITConnectivityCapabilitiesGolfCourseDownload                            ((FITConnectivityCapabilities)0x00004000)
#define FITConnectivityCapabilitiesDeviceInitiatesSync                           ((FITConnectivityCapabilities)0x00008000) // Indicates device is in control of initiating all syncs
#define FITConnectivityCapabilitiesConnectIqWatchAppDownload                     ((FITConnectivityCapabilities)0x00010000)
#define FITConnectivityCapabilitiesConnectIqWidgetDownload                       ((FITConnectivityCapabilities)0x00020000)
#define FITConnectivityCapabilitiesConnectIqWatchFaceDownload                    ((FITConnectivityCapabilities)0x00040000)
#define FITConnectivityCapabilitiesConnectIqDataFieldDownload                    ((FITConnectivityCapabilities)0x00080000)
#define FITConnectivityCapabilitiesConnectIqAppManagment                         ((FITConnectivityCapabilities)0x00100000) // Device supports delete and reorder of apps via GCM
#define FITConnectivityCapabilitiesSwingSensor                                   ((FITConnectivityCapabilities)0x00200000)
#define FITConnectivityCapabilitiesSwingSensorRemote                             ((FITConnectivityCapabilities)0x00400000)
#define FITConnectivityCapabilitiesIncidentDetection                             ((FITConnectivityCapabilities)0x00800000) // Device supports incident detection
#define FITConnectivityCapabilitiesAudioPrompts                                  ((FITConnectivityCapabilities)0x01000000)
#define FITConnectivityCapabilitiesWifiVerification                              ((FITConnectivityCapabilities)0x02000000) // Device supports reporting wifi verification via GCM
#define FITConnectivityCapabilitiesTrueUp                                        ((FITConnectivityCapabilities)0x04000000) // Device supports True Up
#define FITConnectivityCapabilitiesFindMyWatch                                   ((FITConnectivityCapabilities)0x08000000) // Device supports Find My Watch
#define FITConnectivityCapabilitiesRemoteManualSync                              ((FITConnectivityCapabilities)0x10000000)
#define FITConnectivityCapabilitiesLiveTrackAutoStart                            ((FITConnectivityCapabilities)0x20000000) // Device supports LiveTrack auto start
#define FITConnectivityCapabilitiesLiveTrackMessaging                            ((FITConnectivityCapabilities)0x40000000) // Device supports LiveTrack Messaging
#define FITConnectivityCapabilitiesInstantInput                                  ((FITConnectivityCapabilities)0x80000000) // Device supports instant input feature
#define FITConnectivityCapabilitiesCount                                         32

typedef FITEnum FITWeatherReport;
#define FITWeatherReportInvalid                                                  FITEnumInvalid
#define FITWeatherReportCurrent                                                  ((FITWeatherReport)0)
#define FITWeatherReportForecast                                                 ((FITWeatherReport)1) // Deprecated use hourly_forecast instead
#define FITWeatherReportHourlyForecast                                           ((FITWeatherReport)1)
#define FITWeatherReportDailyForecast                                            ((FITWeatherReport)2)
#define FITWeatherReportCount                                                    4

typedef FITEnum FITWeatherStatus;
#define FITWeatherStatusInvalid                                                  FITEnumInvalid
#define FITWeatherStatusClear                                                    ((FITWeatherStatus)0)
#define FITWeatherStatusPartlyCloudy                                             ((FITWeatherStatus)1)
#define FITWeatherStatusMostlyCloudy                                             ((FITWeatherStatus)2)
#define FITWeatherStatusRain                                                     ((FITWeatherStatus)3)
#define FITWeatherStatusSnow                                                     ((FITWeatherStatus)4)
#define FITWeatherStatusWindy                                                    ((FITWeatherStatus)5)
#define FITWeatherStatusThunderstorms                                            ((FITWeatherStatus)6)
#define FITWeatherStatusWintryMix                                                ((FITWeatherStatus)7)
#define FITWeatherStatusFog                                                      ((FITWeatherStatus)8)
#define FITWeatherStatusHazy                                                     ((FITWeatherStatus)11)
#define FITWeatherStatusHail                                                     ((FITWeatherStatus)12)
#define FITWeatherStatusScatteredShowers                                         ((FITWeatherStatus)13)
#define FITWeatherStatusScatteredThunderstorms                                   ((FITWeatherStatus)14)
#define FITWeatherStatusUnknownPrecipitation                                     ((FITWeatherStatus)15)
#define FITWeatherStatusLightRain                                                ((FITWeatherStatus)16)
#define FITWeatherStatusHeavyRain                                                ((FITWeatherStatus)17)
#define FITWeatherStatusLightSnow                                                ((FITWeatherStatus)18)
#define FITWeatherStatusHeavySnow                                                ((FITWeatherStatus)19)
#define FITWeatherStatusLightRainSnow                                            ((FITWeatherStatus)20)
#define FITWeatherStatusHeavyRainSnow                                            ((FITWeatherStatus)21)
#define FITWeatherStatusCloudy                                                   ((FITWeatherStatus)22)
#define FITWeatherStatusCount                                                    21

typedef FITEnum FITWeatherSeverity;
#define FITWeatherSeverityInvalid                                                FITEnumInvalid
#define FITWeatherSeverityUnknown                                                ((FITWeatherSeverity)0)
#define FITWeatherSeverityWarning                                                ((FITWeatherSeverity)1)
#define FITWeatherSeverityWatch                                                  ((FITWeatherSeverity)2)
#define FITWeatherSeverityAdvisory                                               ((FITWeatherSeverity)3)
#define FITWeatherSeverityStatement                                              ((FITWeatherSeverity)4)
#define FITWeatherSeverityCount                                                  5

typedef FITEnum FITWeatherSevereType;
#define FITWeatherSevereTypeInvalid                                              FITEnumInvalid
#define FITWeatherSevereTypeUnspecified                                          ((FITWeatherSevereType)0)
#define FITWeatherSevereTypeTornado                                              ((FITWeatherSevereType)1)
#define FITWeatherSevereTypeTsunami                                              ((FITWeatherSevereType)2)
#define FITWeatherSevereTypeHurricane                                            ((FITWeatherSevereType)3)
#define FITWeatherSevereTypeExtremeWind                                          ((FITWeatherSevereType)4)
#define FITWeatherSevereTypeTyphoon                                              ((FITWeatherSevereType)5)
#define FITWeatherSevereTypeInlandHurricane                                      ((FITWeatherSevereType)6)
#define FITWeatherSevereTypeHurricaneForceWind                                   ((FITWeatherSevereType)7)
#define FITWeatherSevereTypeWaterspout                                           ((FITWeatherSevereType)8)
#define FITWeatherSevereTypeSevereThunderstorm                                   ((FITWeatherSevereType)9)
#define FITWeatherSevereTypeWreckhouseWinds                                      ((FITWeatherSevereType)10)
#define FITWeatherSevereTypeLesSuetesWind                                        ((FITWeatherSevereType)11)
#define FITWeatherSevereTypeAvalanche                                            ((FITWeatherSevereType)12)
#define FITWeatherSevereTypeFlashFlood                                           ((FITWeatherSevereType)13)
#define FITWeatherSevereTypeTropicalStorm                                        ((FITWeatherSevereType)14)
#define FITWeatherSevereTypeInlandTropicalStorm                                  ((FITWeatherSevereType)15)
#define FITWeatherSevereTypeBlizzard                                             ((FITWeatherSevereType)16)
#define FITWeatherSevereTypeIceStorm                                             ((FITWeatherSevereType)17)
#define FITWeatherSevereTypeFreezingRain                                         ((FITWeatherSevereType)18)
#define FITWeatherSevereTypeDebrisFlow                                           ((FITWeatherSevereType)19)
#define FITWeatherSevereTypeFlashFreeze                                          ((FITWeatherSevereType)20)
#define FITWeatherSevereTypeDustStorm                                            ((FITWeatherSevereType)21)
#define FITWeatherSevereTypeHighWind                                             ((FITWeatherSevereType)22)
#define FITWeatherSevereTypeWinterStorm                                          ((FITWeatherSevereType)23)
#define FITWeatherSevereTypeHeavyFreezingSpray                                   ((FITWeatherSevereType)24)
#define FITWeatherSevereTypeExtremeCold                                          ((FITWeatherSevereType)25)
#define FITWeatherSevereTypeWindChill                                            ((FITWeatherSevereType)26)
#define FITWeatherSevereTypeColdWave                                             ((FITWeatherSevereType)27)
#define FITWeatherSevereTypeHeavySnowAlert                                       ((FITWeatherSevereType)28)
#define FITWeatherSevereTypeLakeEffectBlowingSnow                                ((FITWeatherSevereType)29)
#define FITWeatherSevereTypeSnowSquall                                           ((FITWeatherSevereType)30)
#define FITWeatherSevereTypeLakeEffectSnow                                       ((FITWeatherSevereType)31)
#define FITWeatherSevereTypeWinterWeather                                        ((FITWeatherSevereType)32)
#define FITWeatherSevereTypeSleet                                                ((FITWeatherSevereType)33)
#define FITWeatherSevereTypeSnowfall                                             ((FITWeatherSevereType)34)
#define FITWeatherSevereTypeSnowAndBlowingSnow                                   ((FITWeatherSevereType)35)
#define FITWeatherSevereTypeBlowingSnow                                          ((FITWeatherSevereType)36)
#define FITWeatherSevereTypeSnowAlert                                            ((FITWeatherSevereType)37)
#define FITWeatherSevereTypeArcticOutflow                                        ((FITWeatherSevereType)38)
#define FITWeatherSevereTypeFreezingDrizzle                                      ((FITWeatherSevereType)39)
#define FITWeatherSevereTypeStorm                                                ((FITWeatherSevereType)40)
#define FITWeatherSevereTypeStormSurge                                           ((FITWeatherSevereType)41)
#define FITWeatherSevereTypeRainfall                                             ((FITWeatherSevereType)42)
#define FITWeatherSevereTypeArealFlood                                           ((FITWeatherSevereType)43)
#define FITWeatherSevereTypeCoastalFlood                                         ((FITWeatherSevereType)44)
#define FITWeatherSevereTypeLakeshoreFlood                                       ((FITWeatherSevereType)45)
#define FITWeatherSevereTypeExcessiveHeat                                        ((FITWeatherSevereType)46)
#define FITWeatherSevereTypeHeat                                                 ((FITWeatherSevereType)47)
#define FITWeatherSevereTypeWeather                                              ((FITWeatherSevereType)48)
#define FITWeatherSevereTypeHighHeatAndHumidity                                  ((FITWeatherSevereType)49)
#define FITWeatherSevereTypeHumidexAndHealth                                     ((FITWeatherSevereType)50)
#define FITWeatherSevereTypeHumidex                                              ((FITWeatherSevereType)51)
#define FITWeatherSevereTypeGale                                                 ((FITWeatherSevereType)52)
#define FITWeatherSevereTypeFreezingSpray                                        ((FITWeatherSevereType)53)
#define FITWeatherSevereTypeSpecialMarine                                        ((FITWeatherSevereType)54)
#define FITWeatherSevereTypeSquall                                               ((FITWeatherSevereType)55)
#define FITWeatherSevereTypeStrongWind                                           ((FITWeatherSevereType)56)
#define FITWeatherSevereTypeLakeWind                                             ((FITWeatherSevereType)57)
#define FITWeatherSevereTypeMarineWeather                                        ((FITWeatherSevereType)58)
#define FITWeatherSevereTypeWind                                                 ((FITWeatherSevereType)59)
#define FITWeatherSevereTypeSmallCraftHazardousSeas                              ((FITWeatherSevereType)60)
#define FITWeatherSevereTypeHazardousSeas                                        ((FITWeatherSevereType)61)
#define FITWeatherSevereTypeSmallCraft                                           ((FITWeatherSevereType)62)
#define FITWeatherSevereTypeSmallCraftWinds                                      ((FITWeatherSevereType)63)
#define FITWeatherSevereTypeSmallCraftRoughBar                                   ((FITWeatherSevereType)64)
#define FITWeatherSevereTypeHighWaterLevel                                       ((FITWeatherSevereType)65)
#define FITWeatherSevereTypeAshfall                                              ((FITWeatherSevereType)66)
#define FITWeatherSevereTypeFreezingFog                                          ((FITWeatherSevereType)67)
#define FITWeatherSevereTypeDenseFog                                             ((FITWeatherSevereType)68)
#define FITWeatherSevereTypeDenseSmoke                                           ((FITWeatherSevereType)69)
#define FITWeatherSevereTypeBlowingDust                                          ((FITWeatherSevereType)70)
#define FITWeatherSevereTypeHardFreeze                                           ((FITWeatherSevereType)71)
#define FITWeatherSevereTypeFreeze                                               ((FITWeatherSevereType)72)
#define FITWeatherSevereTypeFrost                                                ((FITWeatherSevereType)73)
#define FITWeatherSevereTypeFireWeather                                          ((FITWeatherSevereType)74)
#define FITWeatherSevereTypeFlood                                                ((FITWeatherSevereType)75)
#define FITWeatherSevereTypeRipTide                                              ((FITWeatherSevereType)76)
#define FITWeatherSevereTypeHighSurf                                             ((FITWeatherSevereType)77)
#define FITWeatherSevereTypeSmog                                                 ((FITWeatherSevereType)78)
#define FITWeatherSevereTypeAirQuality                                           ((FITWeatherSevereType)79)
#define FITWeatherSevereTypeBriskWind                                            ((FITWeatherSevereType)80)
#define FITWeatherSevereTypeAirStagnation                                        ((FITWeatherSevereType)81)
#define FITWeatherSevereTypeLowWater                                             ((FITWeatherSevereType)82)
#define FITWeatherSevereTypeHydrological                                         ((FITWeatherSevereType)83)
#define FITWeatherSevereTypeSpecialWeather                                       ((FITWeatherSevereType)84)
#define FITWeatherSevereTypeCount                                                85

typedef FITUInt32 FITTimeIntoDay; // number of seconds into the day since 00:00:00 UTC
#define FITTimeIntoDayInvalid                                                    FITUInt32Invalid
#define FITTimeIntoDayCount                                                      0

typedef FITUInt32 FITLocaltimeIntoDay; // number of seconds into the day since local 00:00:00
#define FITLocaltimeIntoDayInvalid                                               FITUInt32Invalid
#define FITLocaltimeIntoDayCount                                                 0

typedef FITEnum FITStrokeType;
#define FITStrokeTypeInvalid                                                     FITEnumInvalid
#define FITStrokeTypeNoEvent                                                     ((FITStrokeType)0)
#define FITStrokeTypeOther                                                       ((FITStrokeType)1) // stroke was detected but cannot be identified
#define FITStrokeTypeServe                                                       ((FITStrokeType)2)
#define FITStrokeTypeForehand                                                    ((FITStrokeType)3)
#define FITStrokeTypeBackhand                                                    ((FITStrokeType)4)
#define FITStrokeTypeSmash                                                       ((FITStrokeType)5)
#define FITStrokeTypeCount                                                       6

typedef FITEnum FITBodyLocation;
#define FITBodyLocationInvalid                                                   FITEnumInvalid
#define FITBodyLocationLeftLeg                                                   ((FITBodyLocation)0)
#define FITBodyLocationLeftCalf                                                  ((FITBodyLocation)1)
#define FITBodyLocationLeftShin                                                  ((FITBodyLocation)2)
#define FITBodyLocationLeftHamstring                                             ((FITBodyLocation)3)
#define FITBodyLocationLeftQuad                                                  ((FITBodyLocation)4)
#define FITBodyLocationLeftGlute                                                 ((FITBodyLocation)5)
#define FITBodyLocationRightLeg                                                  ((FITBodyLocation)6)
#define FITBodyLocationRightCalf                                                 ((FITBodyLocation)7)
#define FITBodyLocationRightShin                                                 ((FITBodyLocation)8)
#define FITBodyLocationRightHamstring                                            ((FITBodyLocation)9)
#define FITBodyLocationRightQuad                                                 ((FITBodyLocation)10)
#define FITBodyLocationRightGlute                                                ((FITBodyLocation)11)
#define FITBodyLocationTorsoBack                                                 ((FITBodyLocation)12)
#define FITBodyLocationLeftLowerBack                                             ((FITBodyLocation)13)
#define FITBodyLocationLeftUpperBack                                             ((FITBodyLocation)14)
#define FITBodyLocationRightLowerBack                                            ((FITBodyLocation)15)
#define FITBodyLocationRightUpperBack                                            ((FITBodyLocation)16)
#define FITBodyLocationTorsoFront                                                ((FITBodyLocation)17)
#define FITBodyLocationLeftAbdomen                                               ((FITBodyLocation)18)
#define FITBodyLocationLeftChest                                                 ((FITBodyLocation)19)
#define FITBodyLocationRightAbdomen                                              ((FITBodyLocation)20)
#define FITBodyLocationRightChest                                                ((FITBodyLocation)21)
#define FITBodyLocationLeftArm                                                   ((FITBodyLocation)22)
#define FITBodyLocationLeftShoulder                                              ((FITBodyLocation)23)
#define FITBodyLocationLeftBicep                                                 ((FITBodyLocation)24)
#define FITBodyLocationLeftTricep                                                ((FITBodyLocation)25)
#define FITBodyLocationLeftBrachioradialis                                       ((FITBodyLocation)26) // Left anterior forearm
#define FITBodyLocationLeftForearmExtensors                                      ((FITBodyLocation)27) // Left posterior forearm
#define FITBodyLocationRightArm                                                  ((FITBodyLocation)28)
#define FITBodyLocationRightShoulder                                             ((FITBodyLocation)29)
#define FITBodyLocationRightBicep                                                ((FITBodyLocation)30)
#define FITBodyLocationRightTricep                                               ((FITBodyLocation)31)
#define FITBodyLocationRightBrachioradialis                                      ((FITBodyLocation)32) // Right anterior forearm
#define FITBodyLocationRightForearmExtensors                                     ((FITBodyLocation)33) // Right posterior forearm
#define FITBodyLocationNeck                                                      ((FITBodyLocation)34)
#define FITBodyLocationThroat                                                    ((FITBodyLocation)35)
#define FITBodyLocationWaistMidBack                                              ((FITBodyLocation)36)
#define FITBodyLocationWaistFront                                                ((FITBodyLocation)37)
#define FITBodyLocationWaistLeft                                                 ((FITBodyLocation)38)
#define FITBodyLocationWaistRight                                                ((FITBodyLocation)39)
#define FITBodyLocationCount                                                     40

typedef FITEnum FITSegmentLapStatus;
#define FITSegmentLapStatusInvalid                                               FITEnumInvalid
#define FITSegmentLapStatusEnd                                                   ((FITSegmentLapStatus)0)
#define FITSegmentLapStatusFail                                                  ((FITSegmentLapStatus)1)
#define FITSegmentLapStatusCount                                                 2

typedef FITEnum FITSegmentLeaderboardType;
#define FITSegmentLeaderboardTypeInvalid                                         FITEnumInvalid
#define FITSegmentLeaderboardTypeOverall                                         ((FITSegmentLeaderboardType)0)
#define FITSegmentLeaderboardTypePersonalBest                                    ((FITSegmentLeaderboardType)1)
#define FITSegmentLeaderboardTypeConnections                                     ((FITSegmentLeaderboardType)2)
#define FITSegmentLeaderboardTypeGroup                                           ((FITSegmentLeaderboardType)3)
#define FITSegmentLeaderboardTypeChallenger                                      ((FITSegmentLeaderboardType)4)
#define FITSegmentLeaderboardTypeKom                                             ((FITSegmentLeaderboardType)5)
#define FITSegmentLeaderboardTypeQom                                             ((FITSegmentLeaderboardType)6)
#define FITSegmentLeaderboardTypePr                                              ((FITSegmentLeaderboardType)7)
#define FITSegmentLeaderboardTypeGoal                                            ((FITSegmentLeaderboardType)8)
#define FITSegmentLeaderboardTypeRival                                           ((FITSegmentLeaderboardType)9)
#define FITSegmentLeaderboardTypeClubLeader                                      ((FITSegmentLeaderboardType)10)
#define FITSegmentLeaderboardTypeCount                                           11

typedef FITEnum FITSegmentDeleteStatus;
#define FITSegmentDeleteStatusInvalid                                            FITEnumInvalid
#define FITSegmentDeleteStatusDoNotDelete                                        ((FITSegmentDeleteStatus)0)
#define FITSegmentDeleteStatusDeleteOne                                          ((FITSegmentDeleteStatus)1)
#define FITSegmentDeleteStatusDeleteAll                                          ((FITSegmentDeleteStatus)2)
#define FITSegmentDeleteStatusCount                                              3

typedef FITEnum FITSegmentSelectionType;
#define FITSegmentSelectionTypeInvalid                                           FITEnumInvalid
#define FITSegmentSelectionTypeStarred                                           ((FITSegmentSelectionType)0)
#define FITSegmentSelectionTypeSuggested                                         ((FITSegmentSelectionType)1)
#define FITSegmentSelectionTypeCount                                             2

typedef FITEnum FITSourceType;
#define FITSourceTypeInvalid                                                     FITEnumInvalid
#define FITSourceTypeAnt                                                         ((FITSourceType)0) // External device connected with ANT
#define FITSourceTypeAntplus                                                     ((FITSourceType)1) // External device connected with ANT+
#define FITSourceTypeBluetooth                                                   ((FITSourceType)2) // External device connected with BT
#define FITSourceTypeBluetoothLowEnergy                                          ((FITSourceType)3) // External device connected with BLE
#define FITSourceTypeWifi                                                        ((FITSourceType)4) // External device connected with Wifi
#define FITSourceTypeLocal                                                       ((FITSourceType)5) // Onboard device
#define FITSourceTypeCount                                                       6

typedef FITUInt8 FITLocalDeviceType;
#define FITLocalDeviceTypeInvalid                                                FITUInt8Invalid
#define FITLocalDeviceTypeGps                                                    ((FITLocalDeviceType)0) // Onboard gps receiver
#define FITLocalDeviceTypeGlonass                                                ((FITLocalDeviceType)1) // Onboard glonass receiver
#define FITLocalDeviceTypeGpsGlonass                                             ((FITLocalDeviceType)2) // Onboard gps glonass receiver
#define FITLocalDeviceTypeAccelerometer                                          ((FITLocalDeviceType)3) // Onboard sensor
#define FITLocalDeviceTypeBarometer                                              ((FITLocalDeviceType)4) // Onboard sensor
#define FITLocalDeviceTypeTemperature                                            ((FITLocalDeviceType)5) // Onboard sensor
#define FITLocalDeviceTypeWhr                                                    ((FITLocalDeviceType)10) // Onboard wrist HR sensor
#define FITLocalDeviceTypeSensorHub                                              ((FITLocalDeviceType)12) // Onboard software package
#define FITLocalDeviceTypeCount                                                  8

typedef FITUInt8 FITBleDeviceType;
#define FITBleDeviceTypeInvalid                                                  FITUInt8Invalid
#define FITBleDeviceTypeConnectedGps                                             ((FITBleDeviceType)0) // GPS that is provided over a proprietary bluetooth service
#define FITBleDeviceTypeHeartRate                                                ((FITBleDeviceType)1)
#define FITBleDeviceTypeBikePower                                                ((FITBleDeviceType)2)
#define FITBleDeviceTypeBikeSpeedCadence                                         ((FITBleDeviceType)3)
#define FITBleDeviceTypeBikeSpeed                                                ((FITBleDeviceType)4)
#define FITBleDeviceTypeBikeCadence                                              ((FITBleDeviceType)5)
#define FITBleDeviceTypeFootpod                                                  ((FITBleDeviceType)6)
#define FITBleDeviceTypeBikeTrainer                                              ((FITBleDeviceType)7) // Indoor-Bike FTMS protocol
#define FITBleDeviceTypeCount                                                    8

typedef FITEnum FITDisplayOrientation;
#define FITDisplayOrientationInvalid                                             FITEnumInvalid
#define FITDisplayOrientationAuto                                                ((FITDisplayOrientation)0) // automatic if the device supports it
#define FITDisplayOrientationPortrait                                            ((FITDisplayOrientation)1)
#define FITDisplayOrientationLandscape                                           ((FITDisplayOrientation)2)
#define FITDisplayOrientationPortraitFlipped                                     ((FITDisplayOrientation)3) // portrait mode but rotated 180 degrees
#define FITDisplayOrientationLandscapeFlipped                                    ((FITDisplayOrientation)4) // landscape mode but rotated 180 degrees
#define FITDisplayOrientationCount                                               5

typedef FITEnum FITWorkoutEquipment;
#define FITWorkoutEquipmentInvalid                                               FITEnumInvalid
#define FITWorkoutEquipmentNone                                                  ((FITWorkoutEquipment)0)
#define FITWorkoutEquipmentSwimFins                                              ((FITWorkoutEquipment)1)
#define FITWorkoutEquipmentSwimKickboard                                         ((FITWorkoutEquipment)2)
#define FITWorkoutEquipmentSwimPaddles                                           ((FITWorkoutEquipment)3)
#define FITWorkoutEquipmentSwimPullBuoy                                          ((FITWorkoutEquipment)4)
#define FITWorkoutEquipmentSwimSnorkel                                           ((FITWorkoutEquipment)5)
#define FITWorkoutEquipmentCount                                                 6

typedef FITEnum FITWatchfaceMode;
#define FITWatchfaceModeInvalid                                                  FITEnumInvalid
#define FITWatchfaceModeDigital                                                  ((FITWatchfaceMode)0)
#define FITWatchfaceModeAnalog                                                   ((FITWatchfaceMode)1)
#define FITWatchfaceModeConnectIq                                                ((FITWatchfaceMode)2)
#define FITWatchfaceModeDisabled                                                 ((FITWatchfaceMode)3)
#define FITWatchfaceModeCount                                                    4

typedef FITEnum FITDigitalWatchfaceLayout;
#define FITDigitalWatchfaceLayoutInvalid                                         FITEnumInvalid
#define FITDigitalWatchfaceLayoutTraditional                                     ((FITDigitalWatchfaceLayout)0)
#define FITDigitalWatchfaceLayoutModern                                          ((FITDigitalWatchfaceLayout)1)
#define FITDigitalWatchfaceLayoutBold                                            ((FITDigitalWatchfaceLayout)2)
#define FITDigitalWatchfaceLayoutCount                                           3

typedef FITEnum FITAnalogWatchfaceLayout;
#define FITAnalogWatchfaceLayoutInvalid                                          FITEnumInvalid
#define FITAnalogWatchfaceLayoutMinimal                                          ((FITAnalogWatchfaceLayout)0)
#define FITAnalogWatchfaceLayoutTraditional                                      ((FITAnalogWatchfaceLayout)1)
#define FITAnalogWatchfaceLayoutModern                                           ((FITAnalogWatchfaceLayout)2)
#define FITAnalogWatchfaceLayoutCount                                            3

typedef FITEnum FITRiderPositionType;
#define FITRiderPositionTypeInvalid                                              FITEnumInvalid
#define FITRiderPositionTypeSeated                                               ((FITRiderPositionType)0)
#define FITRiderPositionTypeStanding                                             ((FITRiderPositionType)1)
#define FITRiderPositionTypeTransitionToSeated                                   ((FITRiderPositionType)2)
#define FITRiderPositionTypeTransitionToStanding                                 ((FITRiderPositionType)3)
#define FITRiderPositionTypeCount                                                4

typedef FITEnum FITPowerPhaseType;
#define FITPowerPhaseTypeInvalid                                                 FITEnumInvalid
#define FITPowerPhaseTypePowerPhaseStartAngle                                    ((FITPowerPhaseType)0)
#define FITPowerPhaseTypePowerPhaseEndAngle                                      ((FITPowerPhaseType)1)
#define FITPowerPhaseTypePowerPhaseArcLength                                     ((FITPowerPhaseType)2)
#define FITPowerPhaseTypePowerPhaseCenter                                        ((FITPowerPhaseType)3)
#define FITPowerPhaseTypeCount                                                   4

typedef FITEnum FITCameraEventType;
#define FITCameraEventTypeInvalid                                                FITEnumInvalid
#define FITCameraEventTypeVideoStart                                             ((FITCameraEventType)0) // Start of video recording
#define FITCameraEventTypeVideoSplit                                             ((FITCameraEventType)1) // Mark of video file split (end of one file, beginning of the other)
#define FITCameraEventTypeVideoEnd                                               ((FITCameraEventType)2) // End of video recording
#define FITCameraEventTypePhotoTaken                                             ((FITCameraEventType)3) // Still photo taken
#define FITCameraEventTypeVideoSecondStreamStart                                 ((FITCameraEventType)4)
#define FITCameraEventTypeVideoSecondStreamSplit                                 ((FITCameraEventType)5)
#define FITCameraEventTypeVideoSecondStreamEnd                                   ((FITCameraEventType)6)
#define FITCameraEventTypeVideoSplitStart                                        ((FITCameraEventType)7) // Mark of video file split start
#define FITCameraEventTypeVideoSecondStreamSplitStart                            ((FITCameraEventType)8)
#define FITCameraEventTypeVideoPause                                             ((FITCameraEventType)11) // Mark when a video recording has been paused
#define FITCameraEventTypeVideoSecondStreamPause                                 ((FITCameraEventType)12)
#define FITCameraEventTypeVideoResume                                            ((FITCameraEventType)13) // Mark when a video recording has been resumed
#define FITCameraEventTypeVideoSecondStreamResume                                ((FITCameraEventType)14)
#define FITCameraEventTypeCount                                                  13

typedef FITEnum FITSensorType;
#define FITSensorTypeInvalid                                                     FITEnumInvalid
#define FITSensorTypeAccelerometer                                               ((FITSensorType)0)
#define FITSensorTypeGyroscope                                                   ((FITSensorType)1)
#define FITSensorTypeCompass                                                     ((FITSensorType)2) // Magnetometer
#define FITSensorTypeBarometer                                                   ((FITSensorType)3)
#define FITSensorTypeCount                                                       4

typedef FITEnum FITBikeLightNetworkConfigType;
#define FITBikeLightNetworkConfigTypeInvalid                                     FITEnumInvalid
#define FITBikeLightNetworkConfigTypeAuto                                        ((FITBikeLightNetworkConfigType)0)
#define FITBikeLightNetworkConfigTypeIndividual                                  ((FITBikeLightNetworkConfigType)4)
#define FITBikeLightNetworkConfigTypeHighVisibility                              ((FITBikeLightNetworkConfigType)5)
#define FITBikeLightNetworkConfigTypeTrail                                       ((FITBikeLightNetworkConfigType)6)
#define FITBikeLightNetworkConfigTypeCount                                       4

typedef FITUInt16 FITCommTimeoutType;
#define FITCommTimeoutTypeInvalid                                                FITUInt16Invalid
#define FITCommTimeoutTypeWildcardPairingTimeout                                 ((FITCommTimeoutType)0) // Timeout pairing to any device
#define FITCommTimeoutTypePairingTimeout                                         ((FITCommTimeoutType)1) // Timeout pairing to previously paired device
#define FITCommTimeoutTypeConnectionLost                                         ((FITCommTimeoutType)2) // Temporary loss of communications
#define FITCommTimeoutTypeConnectionTimeout                                      ((FITCommTimeoutType)3) // Connection closed due to extended bad communications
#define FITCommTimeoutTypeCount                                                  4

typedef FITEnum FITCameraOrientationType;
#define FITCameraOrientationTypeInvalid                                          FITEnumInvalid
#define FITCameraOrientationTypeCameraOrientation0                               ((FITCameraOrientationType)0)
#define FITCameraOrientationTypeCameraOrientation90                              ((FITCameraOrientationType)1)
#define FITCameraOrientationTypeCameraOrientation180                             ((FITCameraOrientationType)2)
#define FITCameraOrientationTypeCameraOrientation270                             ((FITCameraOrientationType)3)
#define FITCameraOrientationTypeCount                                            4

typedef FITEnum FITAttitudeStage;
#define FITAttitudeStageInvalid                                                  FITEnumInvalid
#define FITAttitudeStageFailed                                                   ((FITAttitudeStage)0)
#define FITAttitudeStageAligning                                                 ((FITAttitudeStage)1)
#define FITAttitudeStageDegraded                                                 ((FITAttitudeStage)2)
#define FITAttitudeStageValid                                                    ((FITAttitudeStage)3)
#define FITAttitudeStageCount                                                    4

typedef FITUInt16 FITAttitudeValidity;
#define FITAttitudeValidityInvalid                                               FITUInt16Invalid
#define FITAttitudeValidityTrackAngleHeadingValid                                ((FITAttitudeValidity)0x0001)
#define FITAttitudeValidityPitchValid                                            ((FITAttitudeValidity)0x0002)
#define FITAttitudeValidityRollValid                                             ((FITAttitudeValidity)0x0004)
#define FITAttitudeValidityLateralBodyAccelValid                                 ((FITAttitudeValidity)0x0008)
#define FITAttitudeValidityNormalBodyAccelValid                                  ((FITAttitudeValidity)0x0010)
#define FITAttitudeValidityTurnRateValid                                         ((FITAttitudeValidity)0x0020)
#define FITAttitudeValidityHwFail                                                ((FITAttitudeValidity)0x0040)
#define FITAttitudeValidityMagInvalid                                            ((FITAttitudeValidity)0x0080)
#define FITAttitudeValidityNoGps                                                 ((FITAttitudeValidity)0x0100)
#define FITAttitudeValidityGpsInvalid                                            ((FITAttitudeValidity)0x0200)
#define FITAttitudeValiditySolutionCoasting                                      ((FITAttitudeValidity)0x0400)
#define FITAttitudeValidityTrueTrackAngle                                        ((FITAttitudeValidity)0x0800)
#define FITAttitudeValidityMagneticHeading                                       ((FITAttitudeValidity)0x1000)
#define FITAttitudeValidityCount                                                 13

typedef FITEnum FITAutoSyncFrequency;
#define FITAutoSyncFrequencyInvalid                                              FITEnumInvalid
#define FITAutoSyncFrequencyNever                                                ((FITAutoSyncFrequency)0)
#define FITAutoSyncFrequencyOccasionally                                         ((FITAutoSyncFrequency)1)
#define FITAutoSyncFrequencyFrequent                                             ((FITAutoSyncFrequency)2)
#define FITAutoSyncFrequencyOnceADay                                             ((FITAutoSyncFrequency)3)
#define FITAutoSyncFrequencyRemote                                               ((FITAutoSyncFrequency)4)
#define FITAutoSyncFrequencyCount                                                5

typedef FITEnum FITExdLayout;
#define FITExdLayoutInvalid                                                      FITEnumInvalid
#define FITExdLayoutFullScreen                                                   ((FITExdLayout)0)
#define FITExdLayoutHalfVertical                                                 ((FITExdLayout)1)
#define FITExdLayoutHalfHorizontal                                               ((FITExdLayout)2)
#define FITExdLayoutHalfVerticalRightSplit                                       ((FITExdLayout)3)
#define FITExdLayoutHalfHorizontalBottomSplit                                    ((FITExdLayout)4)
#define FITExdLayoutFullQuarterSplit                                             ((FITExdLayout)5)
#define FITExdLayoutHalfVerticalLeftSplit                                        ((FITExdLayout)6)
#define FITExdLayoutHalfHorizontalTopSplit                                       ((FITExdLayout)7)
#define FITExdLayoutDynamic                                                      ((FITExdLayout)8) // The EXD may display the configured concepts in any layout it sees fit.
#define FITExdLayoutCount                                                        9

typedef FITEnum FITExdDisplayType;
#define FITExdDisplayTypeInvalid                                                 FITEnumInvalid
#define FITExdDisplayTypeNumerical                                               ((FITExdDisplayType)0)
#define FITExdDisplayTypeSimple                                                  ((FITExdDisplayType)1)
#define FITExdDisplayTypeGraph                                                   ((FITExdDisplayType)2)
#define FITExdDisplayTypeBar                                                     ((FITExdDisplayType)3)
#define FITExdDisplayTypeCircleGraph                                             ((FITExdDisplayType)4)
#define FITExdDisplayTypeVirtualPartner                                          ((FITExdDisplayType)5)
#define FITExdDisplayTypeBalance                                                 ((FITExdDisplayType)6)
#define FITExdDisplayTypeStringList                                              ((FITExdDisplayType)7)
#define FITExdDisplayTypeString                                                  ((FITExdDisplayType)8)
#define FITExdDisplayTypeSimpleDynamicIcon                                       ((FITExdDisplayType)9)
#define FITExdDisplayTypeGauge                                                   ((FITExdDisplayType)10)
#define FITExdDisplayTypeCount                                                   11

typedef FITEnum FITExdDataUnits;
#define FITExdDataUnitsInvalid                                                   FITEnumInvalid
#define FITExdDataUnitsNoUnits                                                   ((FITExdDataUnits)0)
#define FITExdDataUnitsLaps                                                      ((FITExdDataUnits)1)
#define FITExdDataUnitsMilesPerHour                                              ((FITExdDataUnits)2)
#define FITExdDataUnitsKilometersPerHour                                         ((FITExdDataUnits)3)
#define FITExdDataUnitsFeetPerHour                                               ((FITExdDataUnits)4)
#define FITExdDataUnitsMetersPerHour                                             ((FITExdDataUnits)5)
#define FITExdDataUnitsDegreesCelsius                                            ((FITExdDataUnits)6)
#define FITExdDataUnitsDegreesFarenheit                                          ((FITExdDataUnits)7)
#define FITExdDataUnitsZone                                                      ((FITExdDataUnits)8)
#define FITExdDataUnitsGear                                                      ((FITExdDataUnits)9)
#define FITExdDataUnitsRpm                                                       ((FITExdDataUnits)10)
#define FITExdDataUnitsBpm                                                       ((FITExdDataUnits)11)
#define FITExdDataUnitsDegrees                                                   ((FITExdDataUnits)12)
#define FITExdDataUnitsMillimeters                                               ((FITExdDataUnits)13)
#define FITExdDataUnitsMeters                                                    ((FITExdDataUnits)14)
#define FITExdDataUnitsKilometers                                                ((FITExdDataUnits)15)
#define FITExdDataUnitsFeet                                                      ((FITExdDataUnits)16)
#define FITExdDataUnitsYards                                                     ((FITExdDataUnits)17)
#define FITExdDataUnitsKilofeet                                                  ((FITExdDataUnits)18)
#define FITExdDataUnitsMiles                                                     ((FITExdDataUnits)19)
#define FITExdDataUnitsTime                                                      ((FITExdDataUnits)20)
#define FITExdDataUnitsEnumTurnType                                              ((FITExdDataUnits)21)
#define FITExdDataUnitsPercent                                                   ((FITExdDataUnits)22)
#define FITExdDataUnitsWatts                                                     ((FITExdDataUnits)23)
#define FITExdDataUnitsWattsPerKilogram                                          ((FITExdDataUnits)24)
#define FITExdDataUnitsEnumBatteryStatus                                         ((FITExdDataUnits)25)
#define FITExdDataUnitsEnumBikeLightBeamAngleMode                                ((FITExdDataUnits)26)
#define FITExdDataUnitsEnumBikeLightBatteryStatus                                ((FITExdDataUnits)27)
#define FITExdDataUnitsEnumBikeLightNetworkConfigType                            ((FITExdDataUnits)28)
#define FITExdDataUnitsLights                                                    ((FITExdDataUnits)29)
#define FITExdDataUnitsSeconds                                                   ((FITExdDataUnits)30)
#define FITExdDataUnitsMinutes                                                   ((FITExdDataUnits)31)
#define FITExdDataUnitsHours                                                     ((FITExdDataUnits)32)
#define FITExdDataUnitsCalories                                                  ((FITExdDataUnits)33)
#define FITExdDataUnitsKilojoules                                                ((FITExdDataUnits)34)
#define FITExdDataUnitsMilliseconds                                              ((FITExdDataUnits)35)
#define FITExdDataUnitsSecondPerMile                                             ((FITExdDataUnits)36)
#define FITExdDataUnitsSecondPerKilometer                                        ((FITExdDataUnits)37)
#define FITExdDataUnitsCentimeter                                                ((FITExdDataUnits)38)
#define FITExdDataUnitsEnumCoursePoint                                           ((FITExdDataUnits)39)
#define FITExdDataUnitsBradians                                                  ((FITExdDataUnits)40)
#define FITExdDataUnitsEnumSport                                                 ((FITExdDataUnits)41)
#define FITExdDataUnitsInchesHg                                                  ((FITExdDataUnits)42)
#define FITExdDataUnitsMmHg                                                      ((FITExdDataUnits)43)
#define FITExdDataUnitsMbars                                                     ((FITExdDataUnits)44)
#define FITExdDataUnitsHectoPascals                                              ((FITExdDataUnits)45)
#define FITExdDataUnitsFeetPerMin                                                ((FITExdDataUnits)46)
#define FITExdDataUnitsMetersPerMin                                              ((FITExdDataUnits)47)
#define FITExdDataUnitsMetersPerSec                                              ((FITExdDataUnits)48)
#define FITExdDataUnitsEightCardinal                                             ((FITExdDataUnits)49)
#define FITExdDataUnitsCount                                                     50

typedef FITEnum FITExdQualifiers;
#define FITExdQualifiersInvalid                                                  FITEnumInvalid
#define FITExdQualifiersNoQualifier                                              ((FITExdQualifiers)0)
#define FITExdQualifiersInstantaneous                                            ((FITExdQualifiers)1)
#define FITExdQualifiersAverage                                                  ((FITExdQualifiers)2)
#define FITExdQualifiersLap                                                      ((FITExdQualifiers)3)
#define FITExdQualifiersMaximum                                                  ((FITExdQualifiers)4)
#define FITExdQualifiersMaximumAverage                                           ((FITExdQualifiers)5)
#define FITExdQualifiersMaximumLap                                               ((FITExdQualifiers)6)
#define FITExdQualifiersLastLap                                                  ((FITExdQualifiers)7)
#define FITExdQualifiersAverageLap                                               ((FITExdQualifiers)8)
#define FITExdQualifiersToDestination                                            ((FITExdQualifiers)9)
#define FITExdQualifiersToGo                                                     ((FITExdQualifiers)10)
#define FITExdQualifiersToNext                                                   ((FITExdQualifiers)11)
#define FITExdQualifiersNextCoursePoint                                          ((FITExdQualifiers)12)
#define FITExdQualifiersTotal                                                    ((FITExdQualifiers)13)
#define FITExdQualifiersThreeSecondAverage                                       ((FITExdQualifiers)14)
#define FITExdQualifiersTenSecondAverage                                         ((FITExdQualifiers)15)
#define FITExdQualifiersThirtySecondAverage                                      ((FITExdQualifiers)16)
#define FITExdQualifiersPercentMaximum                                           ((FITExdQualifiers)17)
#define FITExdQualifiersPercentMaximumAverage                                    ((FITExdQualifiers)18)
#define FITExdQualifiersLapPercentMaximum                                        ((FITExdQualifiers)19)
#define FITExdQualifiersElapsed                                                  ((FITExdQualifiers)20)
#define FITExdQualifiersSunrise                                                  ((FITExdQualifiers)21)
#define FITExdQualifiersSunset                                                   ((FITExdQualifiers)22)
#define FITExdQualifiersComparedToVirtualPartner                                 ((FITExdQualifiers)23)
#define FITExdQualifiersMaximum24h                                               ((FITExdQualifiers)24)
#define FITExdQualifiersMinimum24h                                               ((FITExdQualifiers)25)
#define FITExdQualifiersMinimum                                                  ((FITExdQualifiers)26)
#define FITExdQualifiersFirst                                                    ((FITExdQualifiers)27)
#define FITExdQualifiersSecond                                                   ((FITExdQualifiers)28)
#define FITExdQualifiersThird                                                    ((FITExdQualifiers)29)
#define FITExdQualifiersShifter                                                  ((FITExdQualifiers)30)
#define FITExdQualifiersLastSport                                                ((FITExdQualifiers)31)
#define FITExdQualifiersMoving                                                   ((FITExdQualifiers)32)
#define FITExdQualifiersStopped                                                  ((FITExdQualifiers)33)
#define FITExdQualifiersEstimatedTotal                                           ((FITExdQualifiers)34)
#define FITExdQualifiersZone9                                                    ((FITExdQualifiers)242)
#define FITExdQualifiersZone8                                                    ((FITExdQualifiers)243)
#define FITExdQualifiersZone7                                                    ((FITExdQualifiers)244)
#define FITExdQualifiersZone6                                                    ((FITExdQualifiers)245)
#define FITExdQualifiersZone5                                                    ((FITExdQualifiers)246)
#define FITExdQualifiersZone4                                                    ((FITExdQualifiers)247)
#define FITExdQualifiersZone3                                                    ((FITExdQualifiers)248)
#define FITExdQualifiersZone2                                                    ((FITExdQualifiers)249)
#define FITExdQualifiersZone1                                                    ((FITExdQualifiers)250)
#define FITExdQualifiersCount                                                    44

typedef FITEnum FITExdDescriptors;
#define FITExdDescriptorsInvalid                                                 FITEnumInvalid
#define FITExdDescriptorsBikeLightBatteryStatus                                  ((FITExdDescriptors)0)
#define FITExdDescriptorsBeamAngleStatus                                         ((FITExdDescriptors)1)
#define FITExdDescriptorsBateryLevel                                             ((FITExdDescriptors)2)
#define FITExdDescriptorsLightNetworkMode                                        ((FITExdDescriptors)3)
#define FITExdDescriptorsNumberLightsConnected                                   ((FITExdDescriptors)4)
#define FITExdDescriptorsCadence                                                 ((FITExdDescriptors)5)
#define FITExdDescriptorsDistance                                                ((FITExdDescriptors)6)
#define FITExdDescriptorsEstimatedTimeOfArrival                                  ((FITExdDescriptors)7)
#define FITExdDescriptorsHeading                                                 ((FITExdDescriptors)8)
#define FITExdDescriptorsTime                                                    ((FITExdDescriptors)9)
#define FITExdDescriptorsBatteryLevel                                            ((FITExdDescriptors)10)
#define FITExdDescriptorsTrainerResistance                                       ((FITExdDescriptors)11)
#define FITExdDescriptorsTrainerTargetPower                                      ((FITExdDescriptors)12)
#define FITExdDescriptorsTimeSeated                                              ((FITExdDescriptors)13)
#define FITExdDescriptorsTimeStanding                                            ((FITExdDescriptors)14)
#define FITExdDescriptorsElevation                                               ((FITExdDescriptors)15)
#define FITExdDescriptorsGrade                                                   ((FITExdDescriptors)16)
#define FITExdDescriptorsAscent                                                  ((FITExdDescriptors)17)
#define FITExdDescriptorsDescent                                                 ((FITExdDescriptors)18)
#define FITExdDescriptorsVerticalSpeed                                           ((FITExdDescriptors)19)
#define FITExdDescriptorsDi2BatteryLevel                                         ((FITExdDescriptors)20)
#define FITExdDescriptorsFrontGear                                               ((FITExdDescriptors)21)
#define FITExdDescriptorsRearGear                                                ((FITExdDescriptors)22)
#define FITExdDescriptorsGearRatio                                               ((FITExdDescriptors)23)
#define FITExdDescriptorsHeartRate                                               ((FITExdDescriptors)24)
#define FITExdDescriptorsHeartRateZone                                           ((FITExdDescriptors)25)
#define FITExdDescriptorsTimeInHeartRateZone                                     ((FITExdDescriptors)26)
#define FITExdDescriptorsHeartRateReserve                                        ((FITExdDescriptors)27)
#define FITExdDescriptorsCalories                                                ((FITExdDescriptors)28)
#define FITExdDescriptorsGpsAccuracy                                             ((FITExdDescriptors)29)
#define FITExdDescriptorsGpsSignalStrength                                       ((FITExdDescriptors)30)
#define FITExdDescriptorsTemperature                                             ((FITExdDescriptors)31)
#define FITExdDescriptorsTimeOfDay                                               ((FITExdDescriptors)32)
#define FITExdDescriptorsBalance                                                 ((FITExdDescriptors)33)
#define FITExdDescriptorsPedalSmoothness                                         ((FITExdDescriptors)34)
#define FITExdDescriptorsPower                                                   ((FITExdDescriptors)35)
#define FITExdDescriptorsFunctionalThresholdPower                                ((FITExdDescriptors)36)
#define FITExdDescriptorsIntensityFactor                                         ((FITExdDescriptors)37)
#define FITExdDescriptorsWork                                                    ((FITExdDescriptors)38)
#define FITExdDescriptorsPowerRatio                                              ((FITExdDescriptors)39)
#define FITExdDescriptorsNormalizedPower                                         ((FITExdDescriptors)40)
#define FITExdDescriptorsTrainingStressScore                                     ((FITExdDescriptors)41)
#define FITExdDescriptorsTimeOnZone                                              ((FITExdDescriptors)42)
#define FITExdDescriptorsSpeed                                                   ((FITExdDescriptors)43)
#define FITExdDescriptorsLaps                                                    ((FITExdDescriptors)44)
#define FITExdDescriptorsReps                                                    ((FITExdDescriptors)45)
#define FITExdDescriptorsWorkoutStep                                             ((FITExdDescriptors)46)
#define FITExdDescriptorsCourseDistance                                          ((FITExdDescriptors)47)
#define FITExdDescriptorsNavigationDistance                                      ((FITExdDescriptors)48)
#define FITExdDescriptorsCourseEstimatedTimeOfArrival                            ((FITExdDescriptors)49)
#define FITExdDescriptorsNavigationEstimatedTimeOfArrival                        ((FITExdDescriptors)50)
#define FITExdDescriptorsCourseTime                                              ((FITExdDescriptors)51)
#define FITExdDescriptorsNavigationTime                                          ((FITExdDescriptors)52)
#define FITExdDescriptorsCourseHeading                                           ((FITExdDescriptors)53)
#define FITExdDescriptorsNavigationHeading                                       ((FITExdDescriptors)54)
#define FITExdDescriptorsPowerZone                                               ((FITExdDescriptors)55)
#define FITExdDescriptorsTorqueEffectiveness                                     ((FITExdDescriptors)56)
#define FITExdDescriptorsTimerTime                                               ((FITExdDescriptors)57)
#define FITExdDescriptorsPowerWeightRatio                                        ((FITExdDescriptors)58)
#define FITExdDescriptorsLeftPlatformCenterOffset                                ((FITExdDescriptors)59)
#define FITExdDescriptorsRightPlatformCenterOffset                               ((FITExdDescriptors)60)
#define FITExdDescriptorsLeftPowerPhaseStartAngle                                ((FITExdDescriptors)61)
#define FITExdDescriptorsRightPowerPhaseStartAngle                               ((FITExdDescriptors)62)
#define FITExdDescriptorsLeftPowerPhaseFinishAngle                               ((FITExdDescriptors)63)
#define FITExdDescriptorsRightPowerPhaseFinishAngle                              ((FITExdDescriptors)64)
#define FITExdDescriptorsGears                                                   ((FITExdDescriptors)65) // Combined gear information
#define FITExdDescriptorsPace                                                    ((FITExdDescriptors)66)
#define FITExdDescriptorsTrainingEffect                                          ((FITExdDescriptors)67)
#define FITExdDescriptorsVerticalOscillation                                     ((FITExdDescriptors)68)
#define FITExdDescriptorsVerticalRatio                                           ((FITExdDescriptors)69)
#define FITExdDescriptorsGroundContactTime                                       ((FITExdDescriptors)70)
#define FITExdDescriptorsLeftGroundContactTimeBalance                            ((FITExdDescriptors)71)
#define FITExdDescriptorsRightGroundContactTimeBalance                           ((FITExdDescriptors)72)
#define FITExdDescriptorsStrideLength                                            ((FITExdDescriptors)73)
#define FITExdDescriptorsRunningCadence                                          ((FITExdDescriptors)74)
#define FITExdDescriptorsPerformanceCondition                                    ((FITExdDescriptors)75)
#define FITExdDescriptorsCourseType                                              ((FITExdDescriptors)76)
#define FITExdDescriptorsTimeInPowerZone                                         ((FITExdDescriptors)77)
#define FITExdDescriptorsNavigationTurn                                          ((FITExdDescriptors)78)
#define FITExdDescriptorsCourseLocation                                          ((FITExdDescriptors)79)
#define FITExdDescriptorsNavigationLocation                                      ((FITExdDescriptors)80)
#define FITExdDescriptorsCompass                                                 ((FITExdDescriptors)81)
#define FITExdDescriptorsGearCombo                                               ((FITExdDescriptors)82)
#define FITExdDescriptorsMuscleOxygen                                            ((FITExdDescriptors)83)
#define FITExdDescriptorsIcon                                                    ((FITExdDescriptors)84)
#define FITExdDescriptorsCompassHeading                                          ((FITExdDescriptors)85)
#define FITExdDescriptorsGpsHeading                                              ((FITExdDescriptors)86)
#define FITExdDescriptorsGpsElevation                                            ((FITExdDescriptors)87)
#define FITExdDescriptorsAnaerobicTrainingEffect                                 ((FITExdDescriptors)88)
#define FITExdDescriptorsCourse                                                  ((FITExdDescriptors)89)
#define FITExdDescriptorsOffCourse                                               ((FITExdDescriptors)90)
#define FITExdDescriptorsGlideRatio                                              ((FITExdDescriptors)91)
#define FITExdDescriptorsVerticalDistance                                        ((FITExdDescriptors)92)
#define FITExdDescriptorsVmg                                                     ((FITExdDescriptors)93)
#define FITExdDescriptorsAmbientPressure                                         ((FITExdDescriptors)94)
#define FITExdDescriptorsPressure                                                ((FITExdDescriptors)95)
#define FITExdDescriptorsVam                                                     ((FITExdDescriptors)96)
#define FITExdDescriptorsCount                                                   97

typedef FITUInt32 FITAutoActivityDetect;
#define FITAutoActivityDetectInvalid                                             FITUInt32Invalid
#define FITAutoActivityDetectNone                                                ((FITAutoActivityDetect)0x00000000)
#define FITAutoActivityDetectRunning                                             ((FITAutoActivityDetect)0x00000001)
#define FITAutoActivityDetectCycling                                             ((FITAutoActivityDetect)0x00000002)
#define FITAutoActivityDetectSwimming                                            ((FITAutoActivityDetect)0x00000004)
#define FITAutoActivityDetectWalking                                             ((FITAutoActivityDetect)0x00000008)
#define FITAutoActivityDetectElliptical                                          ((FITAutoActivityDetect)0x00000020)
#define FITAutoActivityDetectSedentary                                           ((FITAutoActivityDetect)0x00000400)
#define FITAutoActivityDetectCount                                               7

typedef FITUInt32z FITSupportedExdScreenLayouts;
#define FITSupportedExdScreenLayoutsInvalid                                      FITUInt32zInvalid
#define FITSupportedExdScreenLayoutsFullScreen                                   ((FITSupportedExdScreenLayouts)0x00000001)
#define FITSupportedExdScreenLayoutsHalfVertical                                 ((FITSupportedExdScreenLayouts)0x00000002)
#define FITSupportedExdScreenLayoutsHalfHorizontal                               ((FITSupportedExdScreenLayouts)0x00000004)
#define FITSupportedExdScreenLayoutsHalfVerticalRightSplit                       ((FITSupportedExdScreenLayouts)0x00000008)
#define FITSupportedExdScreenLayoutsHalfHorizontalBottomSplit                    ((FITSupportedExdScreenLayouts)0x00000010)
#define FITSupportedExdScreenLayoutsFullQuarterSplit                             ((FITSupportedExdScreenLayouts)0x00000020)
#define FITSupportedExdScreenLayoutsHalfVerticalLeftSplit                        ((FITSupportedExdScreenLayouts)0x00000040)
#define FITSupportedExdScreenLayoutsHalfHorizontalTopSplit                       ((FITSupportedExdScreenLayouts)0x00000080)
#define FITSupportedExdScreenLayoutsCount                                        8

typedef FITUInt8 FITFitBaseType;
#define FITFitBaseTypeInvalid                                                    FITUInt8Invalid
#define FITFitBaseTypeEnum                                                       ((FITFitBaseType)0)
#define FITFitBaseTypeSint8                                                      ((FITFitBaseType)1)
#define FITFitBaseTypeUint8                                                      ((FITFitBaseType)2)
#define FITFitBaseTypeSint16                                                     ((FITFitBaseType)131)
#define FITFitBaseTypeUint16                                                     ((FITFitBaseType)132)
#define FITFitBaseTypeSint32                                                     ((FITFitBaseType)133)
#define FITFitBaseTypeUint32                                                     ((FITFitBaseType)134)
#define FITFitBaseTypeString                                                     ((FITFitBaseType)7)
#define FITFitBaseTypeFloat32                                                    ((FITFitBaseType)136)
#define FITFitBaseTypeFloat64                                                    ((FITFitBaseType)137)
#define FITFitBaseTypeUint8z                                                     ((FITFitBaseType)10)
#define FITFitBaseTypeUint16z                                                    ((FITFitBaseType)139)
#define FITFitBaseTypeUint32z                                                    ((FITFitBaseType)140)
#define FITFitBaseTypeByte                                                       ((FITFitBaseType)13)
#define FITFitBaseTypeSint64                                                     ((FITFitBaseType)142)
#define FITFitBaseTypeUint64                                                     ((FITFitBaseType)143)
#define FITFitBaseTypeUint64z                                                    ((FITFitBaseType)144)
#define FITFitBaseTypeCount                                                      17

typedef FITEnum FITTurnType;
#define FITTurnTypeInvalid                                                       FITEnumInvalid
#define FITTurnTypeArrivingIdx                                                   ((FITTurnType)0)
#define FITTurnTypeArrivingLeftIdx                                               ((FITTurnType)1)
#define FITTurnTypeArrivingRightIdx                                              ((FITTurnType)2)
#define FITTurnTypeArrivingViaIdx                                                ((FITTurnType)3)
#define FITTurnTypeArrivingViaLeftIdx                                            ((FITTurnType)4)
#define FITTurnTypeArrivingViaRightIdx                                           ((FITTurnType)5)
#define FITTurnTypeBearKeepLeftIdx                                               ((FITTurnType)6)
#define FITTurnTypeBearKeepRightIdx                                              ((FITTurnType)7)
#define FITTurnTypeContinueIdx                                                   ((FITTurnType)8)
#define FITTurnTypeExitLeftIdx                                                   ((FITTurnType)9)
#define FITTurnTypeExitRightIdx                                                  ((FITTurnType)10)
#define FITTurnTypeFerryIdx                                                      ((FITTurnType)11)
#define FITTurnTypeRoundabout45Idx                                               ((FITTurnType)12)
#define FITTurnTypeRoundabout90Idx                                               ((FITTurnType)13)
#define FITTurnTypeRoundabout135Idx                                              ((FITTurnType)14)
#define FITTurnTypeRoundabout180Idx                                              ((FITTurnType)15)
#define FITTurnTypeRoundabout225Idx                                              ((FITTurnType)16)
#define FITTurnTypeRoundabout270Idx                                              ((FITTurnType)17)
#define FITTurnTypeRoundabout315Idx                                              ((FITTurnType)18)
#define FITTurnTypeRoundabout360Idx                                              ((FITTurnType)19)
#define FITTurnTypeRoundaboutNeg45Idx                                            ((FITTurnType)20)
#define FITTurnTypeRoundaboutNeg90Idx                                            ((FITTurnType)21)
#define FITTurnTypeRoundaboutNeg135Idx                                           ((FITTurnType)22)
#define FITTurnTypeRoundaboutNeg180Idx                                           ((FITTurnType)23)
#define FITTurnTypeRoundaboutNeg225Idx                                           ((FITTurnType)24)
#define FITTurnTypeRoundaboutNeg270Idx                                           ((FITTurnType)25)
#define FITTurnTypeRoundaboutNeg315Idx                                           ((FITTurnType)26)
#define FITTurnTypeRoundaboutNeg360Idx                                           ((FITTurnType)27)
#define FITTurnTypeRoundaboutGenericIdx                                          ((FITTurnType)28)
#define FITTurnTypeRoundaboutNegGenericIdx                                       ((FITTurnType)29)
#define FITTurnTypeSharpTurnLeftIdx                                              ((FITTurnType)30)
#define FITTurnTypeSharpTurnRightIdx                                             ((FITTurnType)31)
#define FITTurnTypeTurnLeftIdx                                                   ((FITTurnType)32)
#define FITTurnTypeTurnRightIdx                                                  ((FITTurnType)33)
#define FITTurnTypeUturnLeftIdx                                                  ((FITTurnType)34)
#define FITTurnTypeUturnRightIdx                                                 ((FITTurnType)35)
#define FITTurnTypeIconInvIdx                                                    ((FITTurnType)36)
#define FITTurnTypeIconIdxCnt                                                    ((FITTurnType)37)
#define FITTurnTypeCount                                                         38

typedef FITUInt8 FITBikeLightBeamAngleMode;
#define FITBikeLightBeamAngleModeInvalid                                         FITUInt8Invalid
#define FITBikeLightBeamAngleModeManual                                          ((FITBikeLightBeamAngleMode)0)
#define FITBikeLightBeamAngleModeAuto                                            ((FITBikeLightBeamAngleMode)1)
#define FITBikeLightBeamAngleModeCount                                           2

typedef FITUInt16 FITFitBaseUnit;
#define FITFitBaseUnitInvalid                                                    FITUInt16Invalid
#define FITFitBaseUnitOther                                                      ((FITFitBaseUnit)0)
#define FITFitBaseUnitKilogram                                                   ((FITFitBaseUnit)1)
#define FITFitBaseUnitPound                                                      ((FITFitBaseUnit)2)
#define FITFitBaseUnitCount                                                      3

typedef FITUInt8 FITSetType;
#define FITSetTypeInvalid                                                        FITUInt8Invalid
#define FITSetTypeRest                                                           ((FITSetType)0)
#define FITSetTypeActive                                                         ((FITSetType)1)
#define FITSetTypeCount                                                          2

typedef FITUInt16 FITExerciseCategory;
#define FITExerciseCategoryInvalid                                               FITUInt16Invalid
#define FITExerciseCategoryBenchPress                                            ((FITExerciseCategory)0)
#define FITExerciseCategoryCalfRaise                                             ((FITExerciseCategory)1)
#define FITExerciseCategoryCardio                                                ((FITExerciseCategory)2)
#define FITExerciseCategoryCarry                                                 ((FITExerciseCategory)3)
#define FITExerciseCategoryChop                                                  ((FITExerciseCategory)4)
#define FITExerciseCategoryCore                                                  ((FITExerciseCategory)5)
#define FITExerciseCategoryCrunch                                                ((FITExerciseCategory)6)
#define FITExerciseCategoryCurl                                                  ((FITExerciseCategory)7)
#define FITExerciseCategoryDeadlift                                              ((FITExerciseCategory)8)
#define FITExerciseCategoryFlye                                                  ((FITExerciseCategory)9)
#define FITExerciseCategoryHipRaise                                              ((FITExerciseCategory)10)
#define FITExerciseCategoryHipStability                                          ((FITExerciseCategory)11)
#define FITExerciseCategoryHipSwing                                              ((FITExerciseCategory)12)
#define FITExerciseCategoryHyperextension                                        ((FITExerciseCategory)13)
#define FITExerciseCategoryLateralRaise                                          ((FITExerciseCategory)14)
#define FITExerciseCategoryLegCurl                                               ((FITExerciseCategory)15)
#define FITExerciseCategoryLegRaise                                              ((FITExerciseCategory)16)
#define FITExerciseCategoryLunge                                                 ((FITExerciseCategory)17)
#define FITExerciseCategoryOlympicLift                                           ((FITExerciseCategory)18)
#define FITExerciseCategoryPlank                                                 ((FITExerciseCategory)19)
#define FITExerciseCategoryPlyo                                                  ((FITExerciseCategory)20)
#define FITExerciseCategoryPullUp                                                ((FITExerciseCategory)21)
#define FITExerciseCategoryPushUp                                                ((FITExerciseCategory)22)
#define FITExerciseCategoryRow                                                   ((FITExerciseCategory)23)
#define FITExerciseCategoryShoulderPress                                         ((FITExerciseCategory)24)
#define FITExerciseCategoryShoulderStability                                     ((FITExerciseCategory)25)
#define FITExerciseCategoryShrug                                                 ((FITExerciseCategory)26)
#define FITExerciseCategorySitUp                                                 ((FITExerciseCategory)27)
#define FITExerciseCategorySquat                                                 ((FITExerciseCategory)28)
#define FITExerciseCategoryTotalBody                                             ((FITExerciseCategory)29)
#define FITExerciseCategoryTricepsExtension                                      ((FITExerciseCategory)30)
#define FITExerciseCategoryWarmUp                                                ((FITExerciseCategory)31)
#define FITExerciseCategoryRun                                                   ((FITExerciseCategory)32)
#define FITExerciseCategoryUnknown                                               ((FITExerciseCategory)65534)
#define FITExerciseCategoryCount                                                 34

typedef FITUInt16 FITBenchPressExerciseName;
#define FITBenchPressExerciseNameInvalid                                         FITUInt16Invalid
#define FITBenchPressExerciseNameAlternatingDumbbellChestPressOnSwissBall        ((FITBenchPressExerciseName)0)
#define FITBenchPressExerciseNameBarbellBenchPress                               ((FITBenchPressExerciseName)1)
#define FITBenchPressExerciseNameBarbellBoardBenchPress                          ((FITBenchPressExerciseName)2)
#define FITBenchPressExerciseNameBarbellFloorPress                               ((FITBenchPressExerciseName)3)
#define FITBenchPressExerciseNameCloseGripBarbellBenchPress                      ((FITBenchPressExerciseName)4)
#define FITBenchPressExerciseNameDeclineDumbbellBenchPress                       ((FITBenchPressExerciseName)5)
#define FITBenchPressExerciseNameDumbbellBenchPress                              ((FITBenchPressExerciseName)6)
#define FITBenchPressExerciseNameDumbbellFloorPress                              ((FITBenchPressExerciseName)7)
#define FITBenchPressExerciseNameInclineBarbellBenchPress                        ((FITBenchPressExerciseName)8)
#define FITBenchPressExerciseNameInclineDumbbellBenchPress                       ((FITBenchPressExerciseName)9)
#define FITBenchPressExerciseNameInclineSmithMachineBenchPress                   ((FITBenchPressExerciseName)10)
#define FITBenchPressExerciseNameIsometricBarbellBenchPress                      ((FITBenchPressExerciseName)11)
#define FITBenchPressExerciseNameKettlebellChestPress                            ((FITBenchPressExerciseName)12)
#define FITBenchPressExerciseNameNeutralGripDumbbellBenchPress                   ((FITBenchPressExerciseName)13)
#define FITBenchPressExerciseNameNeutralGripDumbbellInclineBenchPress            ((FITBenchPressExerciseName)14)
#define FITBenchPressExerciseNameOneArmFloorPress                                ((FITBenchPressExerciseName)15)
#define FITBenchPressExerciseNameWeightedOneArmFloorPress                        ((FITBenchPressExerciseName)16)
#define FITBenchPressExerciseNamePartialLockout                                  ((FITBenchPressExerciseName)17)
#define FITBenchPressExerciseNameReverseGripBarbellBenchPress                    ((FITBenchPressExerciseName)18)
#define FITBenchPressExerciseNameReverseGripInclineBenchPress                    ((FITBenchPressExerciseName)19)
#define FITBenchPressExerciseNameSingleArmCableChestPress                        ((FITBenchPressExerciseName)20)
#define FITBenchPressExerciseNameSingleArmDumbbellBenchPress                     ((FITBenchPressExerciseName)21)
#define FITBenchPressExerciseNameSmithMachineBenchPress                          ((FITBenchPressExerciseName)22)
#define FITBenchPressExerciseNameSwissBallDumbbellChestPress                     ((FITBenchPressExerciseName)23)
#define FITBenchPressExerciseNameTripleStopBarbellBenchPress                     ((FITBenchPressExerciseName)24)
#define FITBenchPressExerciseNameWideGripBarbellBenchPress                       ((FITBenchPressExerciseName)25)
#define FITBenchPressExerciseNameAlternatingDumbbellChestPress                   ((FITBenchPressExerciseName)26)
#define FITBenchPressExerciseNameCount                                           27

typedef FITUInt16 FITCalfRaiseExerciseName;
#define FITCalfRaiseExerciseNameInvalid                                          FITUInt16Invalid
#define FITCalfRaiseExerciseName3WayCalfRaise                                    ((FITCalfRaiseExerciseName)0)
#define FITCalfRaiseExerciseName3WayWeightedCalfRaise                            ((FITCalfRaiseExerciseName)1)
#define FITCalfRaiseExerciseName3WaySingleLegCalfRaise                           ((FITCalfRaiseExerciseName)2)
#define FITCalfRaiseExerciseName3WayWeightedSingleLegCalfRaise                   ((FITCalfRaiseExerciseName)3)
#define FITCalfRaiseExerciseNameDonkeyCalfRaise                                  ((FITCalfRaiseExerciseName)4)
#define FITCalfRaiseExerciseNameWeightedDonkeyCalfRaise                          ((FITCalfRaiseExerciseName)5)
#define FITCalfRaiseExerciseNameSeatedCalfRaise                                  ((FITCalfRaiseExerciseName)6)
#define FITCalfRaiseExerciseNameWeightedSeatedCalfRaise                          ((FITCalfRaiseExerciseName)7)
#define FITCalfRaiseExerciseNameSeatedDumbbellToeRaise                           ((FITCalfRaiseExerciseName)8)
#define FITCalfRaiseExerciseNameSingleLegBentKneeCalfRaise                       ((FITCalfRaiseExerciseName)9)
#define FITCalfRaiseExerciseNameWeightedSingleLegBentKneeCalfRaise               ((FITCalfRaiseExerciseName)10)
#define FITCalfRaiseExerciseNameSingleLegDeclinePushUp                           ((FITCalfRaiseExerciseName)11)
#define FITCalfRaiseExerciseNameSingleLegDonkeyCalfRaise                         ((FITCalfRaiseExerciseName)12)
#define FITCalfRaiseExerciseNameWeightedSingleLegDonkeyCalfRaise                 ((FITCalfRaiseExerciseName)13)
#define FITCalfRaiseExerciseNameSingleLegHipRaiseWithKneeHold                    ((FITCalfRaiseExerciseName)14)
#define FITCalfRaiseExerciseNameSingleLegStandingCalfRaise                       ((FITCalfRaiseExerciseName)15)
#define FITCalfRaiseExerciseNameSingleLegStandingDumbbellCalfRaise               ((FITCalfRaiseExerciseName)16)
#define FITCalfRaiseExerciseNameStandingBarbellCalfRaise                         ((FITCalfRaiseExerciseName)17)
#define FITCalfRaiseExerciseNameStandingCalfRaise                                ((FITCalfRaiseExerciseName)18)
#define FITCalfRaiseExerciseNameWeightedStandingCalfRaise                        ((FITCalfRaiseExerciseName)19)
#define FITCalfRaiseExerciseNameStandingDumbbellCalfRaise                        ((FITCalfRaiseExerciseName)20)
#define FITCalfRaiseExerciseNameCount                                            21

typedef FITUInt16 FITCardioExerciseName;
#define FITCardioExerciseNameInvalid                                             FITUInt16Invalid
#define FITCardioExerciseNameBobAndWeaveCircle                                   ((FITCardioExerciseName)0)
#define FITCardioExerciseNameWeightedBobAndWeaveCircle                           ((FITCardioExerciseName)1)
#define FITCardioExerciseNameCardioCoreCrawl                                     ((FITCardioExerciseName)2)
#define FITCardioExerciseNameWeightedCardioCoreCrawl                             ((FITCardioExerciseName)3)
#define FITCardioExerciseNameDoubleUnder                                         ((FITCardioExerciseName)4)
#define FITCardioExerciseNameWeightedDoubleUnder                                 ((FITCardioExerciseName)5)
#define FITCardioExerciseNameJumpRope                                            ((FITCardioExerciseName)6)
#define FITCardioExerciseNameWeightedJumpRope                                    ((FITCardioExerciseName)7)
#define FITCardioExerciseNameJumpRopeCrossover                                   ((FITCardioExerciseName)8)
#define FITCardioExerciseNameWeightedJumpRopeCrossover                           ((FITCardioExerciseName)9)
#define FITCardioExerciseNameJumpRopeJog                                         ((FITCardioExerciseName)10)
#define FITCardioExerciseNameWeightedJumpRopeJog                                 ((FITCardioExerciseName)11)
#define FITCardioExerciseNameJumpingJacks                                        ((FITCardioExerciseName)12)
#define FITCardioExerciseNameWeightedJumpingJacks                                ((FITCardioExerciseName)13)
#define FITCardioExerciseNameSkiMoguls                                           ((FITCardioExerciseName)14)
#define FITCardioExerciseNameWeightedSkiMoguls                                   ((FITCardioExerciseName)15)
#define FITCardioExerciseNameSplitJacks                                          ((FITCardioExerciseName)16)
#define FITCardioExerciseNameWeightedSplitJacks                                  ((FITCardioExerciseName)17)
#define FITCardioExerciseNameSquatJacks                                          ((FITCardioExerciseName)18)
#define FITCardioExerciseNameWeightedSquatJacks                                  ((FITCardioExerciseName)19)
#define FITCardioExerciseNameTripleUnder                                         ((FITCardioExerciseName)20)
#define FITCardioExerciseNameWeightedTripleUnder                                 ((FITCardioExerciseName)21)
#define FITCardioExerciseNameCount                                               22

typedef FITUInt16 FITCarryExerciseName;
#define FITCarryExerciseNameInvalid                                              FITUInt16Invalid
#define FITCarryExerciseNameBarHolds                                             ((FITCarryExerciseName)0)
#define FITCarryExerciseNameFarmersWalk                                          ((FITCarryExerciseName)1)
#define FITCarryExerciseNameFarmersWalkOnToes                                    ((FITCarryExerciseName)2)
#define FITCarryExerciseNameHexDumbbellHold                                      ((FITCarryExerciseName)3)
#define FITCarryExerciseNameOverheadCarry                                        ((FITCarryExerciseName)4)
#define FITCarryExerciseNameCount                                                5

typedef FITUInt16 FITChopExerciseName;
#define FITChopExerciseNameInvalid                                               FITUInt16Invalid
#define FITChopExerciseNameCablePullThrough                                      ((FITChopExerciseName)0)
#define FITChopExerciseNameCableRotationalLift                                   ((FITChopExerciseName)1)
#define FITChopExerciseNameCableWoodchop                                         ((FITChopExerciseName)2)
#define FITChopExerciseNameCrossChopToKnee                                       ((FITChopExerciseName)3)
#define FITChopExerciseNameWeightedCrossChopToKnee                               ((FITChopExerciseName)4)
#define FITChopExerciseNameDumbbellChop                                          ((FITChopExerciseName)5)
#define FITChopExerciseNameHalfKneelingRotation                                  ((FITChopExerciseName)6)
#define FITChopExerciseNameWeightedHalfKneelingRotation                          ((FITChopExerciseName)7)
#define FITChopExerciseNameHalfKneelingRotationalChop                            ((FITChopExerciseName)8)
#define FITChopExerciseNameHalfKneelingRotationalReverseChop                     ((FITChopExerciseName)9)
#define FITChopExerciseNameHalfKneelingStabilityChop                             ((FITChopExerciseName)10)
#define FITChopExerciseNameHalfKneelingStabilityReverseChop                      ((FITChopExerciseName)11)
#define FITChopExerciseNameKneelingRotationalChop                                ((FITChopExerciseName)12)
#define FITChopExerciseNameKneelingRotationalReverseChop                         ((FITChopExerciseName)13)
#define FITChopExerciseNameKneelingStabilityChop                                 ((FITChopExerciseName)14)
#define FITChopExerciseNameKneelingWoodchopper                                   ((FITChopExerciseName)15)
#define FITChopExerciseNameMedicineBallWoodChops                                 ((FITChopExerciseName)16)
#define FITChopExerciseNamePowerSquatChops                                       ((FITChopExerciseName)17)
#define FITChopExerciseNameWeightedPowerSquatChops                               ((FITChopExerciseName)18)
#define FITChopExerciseNameStandingRotationalChop                                ((FITChopExerciseName)19)
#define FITChopExerciseNameStandingSplitRotationalChop                           ((FITChopExerciseName)20)
#define FITChopExerciseNameStandingSplitRotationalReverseChop                    ((FITChopExerciseName)21)
#define FITChopExerciseNameStandingStabilityReverseChop                          ((FITChopExerciseName)22)
#define FITChopExerciseNameCount                                                 23

typedef FITUInt16 FITCoreExerciseName;
#define FITCoreExerciseNameInvalid                                               FITUInt16Invalid
#define FITCoreExerciseNameAbsJabs                                               ((FITCoreExerciseName)0)
#define FITCoreExerciseNameWeightedAbsJabs                                       ((FITCoreExerciseName)1)
#define FITCoreExerciseNameAlternatingPlateReach                                 ((FITCoreExerciseName)2)
#define FITCoreExerciseNameBarbellRollout                                        ((FITCoreExerciseName)3)
#define FITCoreExerciseNameWeightedBarbellRollout                                ((FITCoreExerciseName)4)
#define FITCoreExerciseNameBodyBarObliqueTwist                                   ((FITCoreExerciseName)5)
#define FITCoreExerciseNameCableCorePress                                        ((FITCoreExerciseName)6)
#define FITCoreExerciseNameCableSideBend                                         ((FITCoreExerciseName)7)
#define FITCoreExerciseNameSideBend                                              ((FITCoreExerciseName)8)
#define FITCoreExerciseNameWeightedSideBend                                      ((FITCoreExerciseName)9)
#define FITCoreExerciseNameCrescentCircle                                        ((FITCoreExerciseName)10)
#define FITCoreExerciseNameWeightedCrescentCircle                                ((FITCoreExerciseName)11)
#define FITCoreExerciseNameCyclingRussianTwist                                   ((FITCoreExerciseName)12)
#define FITCoreExerciseNameWeightedCyclingRussianTwist                           ((FITCoreExerciseName)13)
#define FITCoreExerciseNameElevatedFeetRussianTwist                              ((FITCoreExerciseName)14)
#define FITCoreExerciseNameWeightedElevatedFeetRussianTwist                      ((FITCoreExerciseName)15)
#define FITCoreExerciseNameHalfTurkishGetUp                                      ((FITCoreExerciseName)16)
#define FITCoreExerciseNameKettlebellWindmill                                    ((FITCoreExerciseName)17)
#define FITCoreExerciseNameKneelingAbWheel                                       ((FITCoreExerciseName)18)
#define FITCoreExerciseNameWeightedKneelingAbWheel                               ((FITCoreExerciseName)19)
#define FITCoreExerciseNameModifiedFrontLever                                    ((FITCoreExerciseName)20)
#define FITCoreExerciseNameOpenKneeTucks                                         ((FITCoreExerciseName)21)
#define FITCoreExerciseNameWeightedOpenKneeTucks                                 ((FITCoreExerciseName)22)
#define FITCoreExerciseNameSideAbsLegLift                                        ((FITCoreExerciseName)23)
#define FITCoreExerciseNameWeightedSideAbsLegLift                                ((FITCoreExerciseName)24)
#define FITCoreExerciseNameSwissBallJackknife                                    ((FITCoreExerciseName)25)
#define FITCoreExerciseNameWeightedSwissBallJackknife                            ((FITCoreExerciseName)26)
#define FITCoreExerciseNameSwissBallPike                                         ((FITCoreExerciseName)27)
#define FITCoreExerciseNameWeightedSwissBallPike                                 ((FITCoreExerciseName)28)
#define FITCoreExerciseNameSwissBallRollout                                      ((FITCoreExerciseName)29)
#define FITCoreExerciseNameWeightedSwissBallRollout                              ((FITCoreExerciseName)30)
#define FITCoreExerciseNameTriangleHipPress                                      ((FITCoreExerciseName)31)
#define FITCoreExerciseNameWeightedTriangleHipPress                              ((FITCoreExerciseName)32)
#define FITCoreExerciseNameTrxSuspendedJackknife                                 ((FITCoreExerciseName)33)
#define FITCoreExerciseNameWeightedTrxSuspendedJackknife                         ((FITCoreExerciseName)34)
#define FITCoreExerciseNameUBoat                                                 ((FITCoreExerciseName)35)
#define FITCoreExerciseNameWeightedUBoat                                         ((FITCoreExerciseName)36)
#define FITCoreExerciseNameWindmillSwitches                                      ((FITCoreExerciseName)37)
#define FITCoreExerciseNameWeightedWindmillSwitches                              ((FITCoreExerciseName)38)
#define FITCoreExerciseNameAlternatingSlideOut                                   ((FITCoreExerciseName)39)
#define FITCoreExerciseNameWeightedAlternatingSlideOut                           ((FITCoreExerciseName)40)
#define FITCoreExerciseNameGhdBackExtensions                                     ((FITCoreExerciseName)41)
#define FITCoreExerciseNameWeightedGhdBackExtensions                             ((FITCoreExerciseName)42)
#define FITCoreExerciseNameOverheadWalk                                          ((FITCoreExerciseName)43)
#define FITCoreExerciseNameInchworm                                              ((FITCoreExerciseName)44)
#define FITCoreExerciseNameWeightedModifiedFrontLever                            ((FITCoreExerciseName)45)
#define FITCoreExerciseNameRussianTwist                                          ((FITCoreExerciseName)46)
#define FITCoreExerciseNameAbdominalLegRotations                                 ((FITCoreExerciseName)47) // Deprecated do not use
#define FITCoreExerciseNameArmAndLegExtensionOnKnees                             ((FITCoreExerciseName)48)
#define FITCoreExerciseNameBicycle                                               ((FITCoreExerciseName)49)
#define FITCoreExerciseNameBicepCurlWithLegExtension                             ((FITCoreExerciseName)50)
#define FITCoreExerciseNameCatCow                                                ((FITCoreExerciseName)51)
#define FITCoreExerciseNameCorkscrew                                             ((FITCoreExerciseName)52)
#define FITCoreExerciseNameCrissCross                                            ((FITCoreExerciseName)53)
#define FITCoreExerciseNameCrissCrossWithBall                                    ((FITCoreExerciseName)54) // Deprecated do not use
#define FITCoreExerciseNameDoubleLegStretch                                      ((FITCoreExerciseName)55)
#define FITCoreExerciseNameKneeFolds                                             ((FITCoreExerciseName)56)
#define FITCoreExerciseNameLowerLift                                             ((FITCoreExerciseName)57)
#define FITCoreExerciseNameNeckPull                                              ((FITCoreExerciseName)58)
#define FITCoreExerciseNamePelvicClocks                                          ((FITCoreExerciseName)59)
#define FITCoreExerciseNameRollOver                                              ((FITCoreExerciseName)60)
#define FITCoreExerciseNameRollUp                                                ((FITCoreExerciseName)61)
#define FITCoreExerciseNameRolling                                               ((FITCoreExerciseName)62)
#define FITCoreExerciseNameRowing1                                               ((FITCoreExerciseName)63)
#define FITCoreExerciseNameRowing2                                               ((FITCoreExerciseName)64)
#define FITCoreExerciseNameScissors                                              ((FITCoreExerciseName)65)
#define FITCoreExerciseNameSingleLegCircles                                      ((FITCoreExerciseName)66)
#define FITCoreExerciseNameSingleLegStretch                                      ((FITCoreExerciseName)67)
#define FITCoreExerciseNameSnakeTwist1And2                                       ((FITCoreExerciseName)68) // Deprecated do not use
#define FITCoreExerciseNameSwan                                                  ((FITCoreExerciseName)69)
#define FITCoreExerciseNameSwimming                                              ((FITCoreExerciseName)70)
#define FITCoreExerciseNameTeaser                                                ((FITCoreExerciseName)71)
#define FITCoreExerciseNameTheHundred                                            ((FITCoreExerciseName)72)
#define FITCoreExerciseNameCount                                                 73

typedef FITUInt16 FITCrunchExerciseName;
#define FITCrunchExerciseNameInvalid                                             FITUInt16Invalid
#define FITCrunchExerciseNameBicycleCrunch                                       ((FITCrunchExerciseName)0)
#define FITCrunchExerciseNameCableCrunch                                         ((FITCrunchExerciseName)1)
#define FITCrunchExerciseNameCircularArmCrunch                                   ((FITCrunchExerciseName)2)
#define FITCrunchExerciseNameCrossedArmsCrunch                                   ((FITCrunchExerciseName)3)
#define FITCrunchExerciseNameWeightedCrossedArmsCrunch                           ((FITCrunchExerciseName)4)
#define FITCrunchExerciseNameCrossLegReverseCrunch                               ((FITCrunchExerciseName)5)
#define FITCrunchExerciseNameWeightedCrossLegReverseCrunch                       ((FITCrunchExerciseName)6)
#define FITCrunchExerciseNameCrunchChop                                          ((FITCrunchExerciseName)7)
#define FITCrunchExerciseNameWeightedCrunchChop                                  ((FITCrunchExerciseName)8)
#define FITCrunchExerciseNameDoubleCrunch                                        ((FITCrunchExerciseName)9)
#define FITCrunchExerciseNameWeightedDoubleCrunch                                ((FITCrunchExerciseName)10)
#define FITCrunchExerciseNameElbowToKneeCrunch                                   ((FITCrunchExerciseName)11)
#define FITCrunchExerciseNameWeightedElbowToKneeCrunch                           ((FITCrunchExerciseName)12)
#define FITCrunchExerciseNameFlutterKicks                                        ((FITCrunchExerciseName)13)
#define FITCrunchExerciseNameWeightedFlutterKicks                                ((FITCrunchExerciseName)14)
#define FITCrunchExerciseNameFoamRollerReverseCrunchOnBench                      ((FITCrunchExerciseName)15)
#define FITCrunchExerciseNameWeightedFoamRollerReverseCrunchOnBench              ((FITCrunchExerciseName)16)
#define FITCrunchExerciseNameFoamRollerReverseCrunchWithDumbbell                 ((FITCrunchExerciseName)17)
#define FITCrunchExerciseNameFoamRollerReverseCrunchWithMedicineBall             ((FITCrunchExerciseName)18)
#define FITCrunchExerciseNameFrogPress                                           ((FITCrunchExerciseName)19)
#define FITCrunchExerciseNameHangingKneeRaiseObliqueCrunch                       ((FITCrunchExerciseName)20)
#define FITCrunchExerciseNameWeightedHangingKneeRaiseObliqueCrunch               ((FITCrunchExerciseName)21)
#define FITCrunchExerciseNameHipCrossover                                        ((FITCrunchExerciseName)22)
#define FITCrunchExerciseNameWeightedHipCrossover                                ((FITCrunchExerciseName)23)
#define FITCrunchExerciseNameHollowRock                                          ((FITCrunchExerciseName)24)
#define FITCrunchExerciseNameWeightedHollowRock                                  ((FITCrunchExerciseName)25)
#define FITCrunchExerciseNameInclineReverseCrunch                                ((FITCrunchExerciseName)26)
#define FITCrunchExerciseNameWeightedInclineReverseCrunch                        ((FITCrunchExerciseName)27)
#define FITCrunchExerciseNameKneelingCableCrunch                                 ((FITCrunchExerciseName)28)
#define FITCrunchExerciseNameKneelingCrossCrunch                                 ((FITCrunchExerciseName)29)
#define FITCrunchExerciseNameWeightedKneelingCrossCrunch                         ((FITCrunchExerciseName)30)
#define FITCrunchExerciseNameKneelingObliqueCableCrunch                          ((FITCrunchExerciseName)31)
#define FITCrunchExerciseNameKneesToElbow                                        ((FITCrunchExerciseName)32)
#define FITCrunchExerciseNameLegExtensions                                       ((FITCrunchExerciseName)33)
#define FITCrunchExerciseNameWeightedLegExtensions                               ((FITCrunchExerciseName)34)
#define FITCrunchExerciseNameLegLevers                                           ((FITCrunchExerciseName)35)
#define FITCrunchExerciseNameMcgillCurlUp                                        ((FITCrunchExerciseName)36)
#define FITCrunchExerciseNameWeightedMcgillCurlUp                                ((FITCrunchExerciseName)37)
#define FITCrunchExerciseNameModifiedPilatesRollUpWithBall                       ((FITCrunchExerciseName)38)
#define FITCrunchExerciseNameWeightedModifiedPilatesRollUpWithBall               ((FITCrunchExerciseName)39)
#define FITCrunchExerciseNamePilatesCrunch                                       ((FITCrunchExerciseName)40)
#define FITCrunchExerciseNameWeightedPilatesCrunch                               ((FITCrunchExerciseName)41)
#define FITCrunchExerciseNamePilatesRollUpWithBall                               ((FITCrunchExerciseName)42)
#define FITCrunchExerciseNameWeightedPilatesRollUpWithBall                       ((FITCrunchExerciseName)43)
#define FITCrunchExerciseNameRaisedLegsCrunch                                    ((FITCrunchExerciseName)44)
#define FITCrunchExerciseNameWeightedRaisedLegsCrunch                            ((FITCrunchExerciseName)45)
#define FITCrunchExerciseNameReverseCrunch                                       ((FITCrunchExerciseName)46)
#define FITCrunchExerciseNameWeightedReverseCrunch                               ((FITCrunchExerciseName)47)
#define FITCrunchExerciseNameReverseCrunchOnABench                               ((FITCrunchExerciseName)48)
#define FITCrunchExerciseNameWeightedReverseCrunchOnABench                       ((FITCrunchExerciseName)49)
#define FITCrunchExerciseNameReverseCurlAndLift                                  ((FITCrunchExerciseName)50)
#define FITCrunchExerciseNameWeightedReverseCurlAndLift                          ((FITCrunchExerciseName)51)
#define FITCrunchExerciseNameRotationalLift                                      ((FITCrunchExerciseName)52)
#define FITCrunchExerciseNameWeightedRotationalLift                              ((FITCrunchExerciseName)53)
#define FITCrunchExerciseNameSeatedAlternatingReverseCrunch                      ((FITCrunchExerciseName)54)
#define FITCrunchExerciseNameWeightedSeatedAlternatingReverseCrunch              ((FITCrunchExerciseName)55)
#define FITCrunchExerciseNameSeatedLegU                                          ((FITCrunchExerciseName)56)
#define FITCrunchExerciseNameWeightedSeatedLegU                                  ((FITCrunchExerciseName)57)
#define FITCrunchExerciseNameSideToSideCrunchAndWeave                            ((FITCrunchExerciseName)58)
#define FITCrunchExerciseNameWeightedSideToSideCrunchAndWeave                    ((FITCrunchExerciseName)59)
#define FITCrunchExerciseNameSingleLegReverseCrunch                              ((FITCrunchExerciseName)60)
#define FITCrunchExerciseNameWeightedSingleLegReverseCrunch                      ((FITCrunchExerciseName)61)
#define FITCrunchExerciseNameSkaterCrunchCross                                   ((FITCrunchExerciseName)62)
#define FITCrunchExerciseNameWeightedSkaterCrunchCross                           ((FITCrunchExerciseName)63)
#define FITCrunchExerciseNameStandingCableCrunch                                 ((FITCrunchExerciseName)64)
#define FITCrunchExerciseNameStandingSideCrunch                                  ((FITCrunchExerciseName)65)
#define FITCrunchExerciseNameStepClimb                                           ((FITCrunchExerciseName)66)
#define FITCrunchExerciseNameWeightedStepClimb                                   ((FITCrunchExerciseName)67)
#define FITCrunchExerciseNameSwissBallCrunch                                     ((FITCrunchExerciseName)68)
#define FITCrunchExerciseNameSwissBallReverseCrunch                              ((FITCrunchExerciseName)69)
#define FITCrunchExerciseNameWeightedSwissBallReverseCrunch                      ((FITCrunchExerciseName)70)
#define FITCrunchExerciseNameSwissBallRussianTwist                               ((FITCrunchExerciseName)71)
#define FITCrunchExerciseNameWeightedSwissBallRussianTwist                       ((FITCrunchExerciseName)72)
#define FITCrunchExerciseNameSwissBallSideCrunch                                 ((FITCrunchExerciseName)73)
#define FITCrunchExerciseNameWeightedSwissBallSideCrunch                         ((FITCrunchExerciseName)74)
#define FITCrunchExerciseNameThoracicCrunchesOnFoamRoller                        ((FITCrunchExerciseName)75)
#define FITCrunchExerciseNameWeightedThoracicCrunchesOnFoamRoller                ((FITCrunchExerciseName)76)
#define FITCrunchExerciseNameTricepsCrunch                                       ((FITCrunchExerciseName)77)
#define FITCrunchExerciseNameWeightedBicycleCrunch                               ((FITCrunchExerciseName)78)
#define FITCrunchExerciseNameWeightedCrunch                                      ((FITCrunchExerciseName)79)
#define FITCrunchExerciseNameWeightedSwissBallCrunch                             ((FITCrunchExerciseName)80)
#define FITCrunchExerciseNameToesToBar                                           ((FITCrunchExerciseName)81)
#define FITCrunchExerciseNameWeightedToesToBar                                   ((FITCrunchExerciseName)82)
#define FITCrunchExerciseNameCrunch                                              ((FITCrunchExerciseName)83)
#define FITCrunchExerciseNameStraightLegCrunchWithBall                           ((FITCrunchExerciseName)84)
#define FITCrunchExerciseNameCount                                               85

typedef FITUInt16 FITCurlExerciseName;
#define FITCurlExerciseNameInvalid                                               FITUInt16Invalid
#define FITCurlExerciseNameAlternatingDumbbellBicepsCurl                         ((FITCurlExerciseName)0)
#define FITCurlExerciseNameAlternatingDumbbellBicepsCurlOnSwissBall              ((FITCurlExerciseName)1)
#define FITCurlExerciseNameAlternatingInclineDumbbellBicepsCurl                  ((FITCurlExerciseName)2)
#define FITCurlExerciseNameBarbellBicepsCurl                                     ((FITCurlExerciseName)3)
#define FITCurlExerciseNameBarbellReverseWristCurl                               ((FITCurlExerciseName)4)
#define FITCurlExerciseNameBarbellWristCurl                                      ((FITCurlExerciseName)5)
#define FITCurlExerciseNameBehindTheBackBarbellReverseWristCurl                  ((FITCurlExerciseName)6)
#define FITCurlExerciseNameBehindTheBackOneArmCableCurl                          ((FITCurlExerciseName)7)
#define FITCurlExerciseNameCableBicepsCurl                                       ((FITCurlExerciseName)8)
#define FITCurlExerciseNameCableHammerCurl                                       ((FITCurlExerciseName)9)
#define FITCurlExerciseNameCheatingBarbellBicepsCurl                             ((FITCurlExerciseName)10)
#define FITCurlExerciseNameCloseGripEzBarBicepsCurl                              ((FITCurlExerciseName)11)
#define FITCurlExerciseNameCrossBodyDumbbellHammerCurl                           ((FITCurlExerciseName)12)
#define FITCurlExerciseNameDeadHangBicepsCurl                                    ((FITCurlExerciseName)13)
#define FITCurlExerciseNameDeclineHammerCurl                                     ((FITCurlExerciseName)14)
#define FITCurlExerciseNameDumbbellBicepsCurlWithStaticHold                      ((FITCurlExerciseName)15)
#define FITCurlExerciseNameDumbbellHammerCurl                                    ((FITCurlExerciseName)16)
#define FITCurlExerciseNameDumbbellReverseWristCurl                              ((FITCurlExerciseName)17)
#define FITCurlExerciseNameDumbbellWristCurl                                     ((FITCurlExerciseName)18)
#define FITCurlExerciseNameEzBarPreacherCurl                                     ((FITCurlExerciseName)19)
#define FITCurlExerciseNameForwardBendBicepsCurl                                 ((FITCurlExerciseName)20)
#define FITCurlExerciseNameHammerCurlToPress                                     ((FITCurlExerciseName)21)
#define FITCurlExerciseNameInclineDumbbellBicepsCurl                             ((FITCurlExerciseName)22)
#define FITCurlExerciseNameInclineOffsetThumbDumbbellCurl                        ((FITCurlExerciseName)23)
#define FITCurlExerciseNameKettlebellBicepsCurl                                  ((FITCurlExerciseName)24)
#define FITCurlExerciseNameLyingConcentrationCableCurl                           ((FITCurlExerciseName)25)
#define FITCurlExerciseNameOneArmPreacherCurl                                    ((FITCurlExerciseName)26)
#define FITCurlExerciseNamePlatePinchCurl                                        ((FITCurlExerciseName)27)
#define FITCurlExerciseNamePreacherCurlWithCable                                 ((FITCurlExerciseName)28)
#define FITCurlExerciseNameReverseEzBarCurl                                      ((FITCurlExerciseName)29)
#define FITCurlExerciseNameReverseGripWristCurl                                  ((FITCurlExerciseName)30)
#define FITCurlExerciseNameReverseGripBarbellBicepsCurl                          ((FITCurlExerciseName)31)
#define FITCurlExerciseNameSeatedAlternatingDumbbellBicepsCurl                   ((FITCurlExerciseName)32)
#define FITCurlExerciseNameSeatedDumbbellBicepsCurl                              ((FITCurlExerciseName)33)
#define FITCurlExerciseNameSeatedReverseDumbbellCurl                             ((FITCurlExerciseName)34)
#define FITCurlExerciseNameSplitStanceOffsetPinkyDumbbellCurl                    ((FITCurlExerciseName)35)
#define FITCurlExerciseNameStandingAlternatingDumbbellCurls                      ((FITCurlExerciseName)36)
#define FITCurlExerciseNameStandingDumbbellBicepsCurl                            ((FITCurlExerciseName)37)
#define FITCurlExerciseNameStandingEzBarBicepsCurl                               ((FITCurlExerciseName)38)
#define FITCurlExerciseNameStaticCurl                                            ((FITCurlExerciseName)39)
#define FITCurlExerciseNameSwissBallDumbbellOverheadTricepsExtension             ((FITCurlExerciseName)40)
#define FITCurlExerciseNameSwissBallEzBarPreacherCurl                            ((FITCurlExerciseName)41)
#define FITCurlExerciseNameTwistingStandingDumbbellBicepsCurl                    ((FITCurlExerciseName)42)
#define FITCurlExerciseNameWideGripEzBarBicepsCurl                               ((FITCurlExerciseName)43)
#define FITCurlExerciseNameCount                                                 44

typedef FITUInt16 FITDeadliftExerciseName;
#define FITDeadliftExerciseNameInvalid                                           FITUInt16Invalid
#define FITDeadliftExerciseNameBarbellDeadlift                                   ((FITDeadliftExerciseName)0)
#define FITDeadliftExerciseNameBarbellStraightLegDeadlift                        ((FITDeadliftExerciseName)1)
#define FITDeadliftExerciseNameDumbbellDeadlift                                  ((FITDeadliftExerciseName)2)
#define FITDeadliftExerciseNameDumbbellSingleLegDeadliftToRow                    ((FITDeadliftExerciseName)3)
#define FITDeadliftExerciseNameDumbbellStraightLegDeadlift                       ((FITDeadliftExerciseName)4)
#define FITDeadliftExerciseNameKettlebellFloorToShelf                            ((FITDeadliftExerciseName)5)
#define FITDeadliftExerciseNameOneArmOneLegDeadlift                              ((FITDeadliftExerciseName)6)
#define FITDeadliftExerciseNameRackPull                                          ((FITDeadliftExerciseName)7)
#define FITDeadliftExerciseNameRotationalDumbbellStraightLegDeadlift             ((FITDeadliftExerciseName)8)
#define FITDeadliftExerciseNameSingleArmDeadlift                                 ((FITDeadliftExerciseName)9)
#define FITDeadliftExerciseNameSingleLegBarbellDeadlift                          ((FITDeadliftExerciseName)10)
#define FITDeadliftExerciseNameSingleLegBarbellStraightLegDeadlift               ((FITDeadliftExerciseName)11)
#define FITDeadliftExerciseNameSingleLegDeadliftWithBarbell                      ((FITDeadliftExerciseName)12)
#define FITDeadliftExerciseNameSingleLegRdlCircuit                               ((FITDeadliftExerciseName)13)
#define FITDeadliftExerciseNameSingleLegRomanianDeadliftWithDumbbell             ((FITDeadliftExerciseName)14)
#define FITDeadliftExerciseNameSumoDeadlift                                      ((FITDeadliftExerciseName)15)
#define FITDeadliftExerciseNameSumoDeadliftHighPull                              ((FITDeadliftExerciseName)16)
#define FITDeadliftExerciseNameTrapBarDeadlift                                   ((FITDeadliftExerciseName)17)
#define FITDeadliftExerciseNameWideGripBarbellDeadlift                           ((FITDeadliftExerciseName)18)
#define FITDeadliftExerciseNameCount                                             19

typedef FITUInt16 FITFlyeExerciseName;
#define FITFlyeExerciseNameInvalid                                               FITUInt16Invalid
#define FITFlyeExerciseNameCableCrossover                                        ((FITFlyeExerciseName)0)
#define FITFlyeExerciseNameDeclineDumbbellFlye                                   ((FITFlyeExerciseName)1)
#define FITFlyeExerciseNameDumbbellFlye                                          ((FITFlyeExerciseName)2)
#define FITFlyeExerciseNameInclineDumbbellFlye                                   ((FITFlyeExerciseName)3)
#define FITFlyeExerciseNameKettlebellFlye                                        ((FITFlyeExerciseName)4)
#define FITFlyeExerciseNameKneelingRearFlye                                      ((FITFlyeExerciseName)5)
#define FITFlyeExerciseNameSingleArmStandingCableReverseFlye                     ((FITFlyeExerciseName)6)
#define FITFlyeExerciseNameSwissBallDumbbellFlye                                 ((FITFlyeExerciseName)7)
#define FITFlyeExerciseNameArmRotations                                          ((FITFlyeExerciseName)8)
#define FITFlyeExerciseNameHugATree                                              ((FITFlyeExerciseName)9)
#define FITFlyeExerciseNameCount                                                 10

typedef FITUInt16 FITHipRaiseExerciseName;
#define FITHipRaiseExerciseNameInvalid                                           FITUInt16Invalid
#define FITHipRaiseExerciseNameBarbellHipThrustOnFloor                           ((FITHipRaiseExerciseName)0)
#define FITHipRaiseExerciseNameBarbellHipThrustWithBench                         ((FITHipRaiseExerciseName)1)
#define FITHipRaiseExerciseNameBentKneeSwissBallReverseHipRaise                  ((FITHipRaiseExerciseName)2)
#define FITHipRaiseExerciseNameWeightedBentKneeSwissBallReverseHipRaise          ((FITHipRaiseExerciseName)3)
#define FITHipRaiseExerciseNameBridgeWithLegExtension                            ((FITHipRaiseExerciseName)4)
#define FITHipRaiseExerciseNameWeightedBridgeWithLegExtension                    ((FITHipRaiseExerciseName)5)
#define FITHipRaiseExerciseNameClamBridge                                        ((FITHipRaiseExerciseName)6)
#define FITHipRaiseExerciseNameFrontKickTabletop                                 ((FITHipRaiseExerciseName)7)
#define FITHipRaiseExerciseNameWeightedFrontKickTabletop                         ((FITHipRaiseExerciseName)8)
#define FITHipRaiseExerciseNameHipExtensionAndCross                              ((FITHipRaiseExerciseName)9)
#define FITHipRaiseExerciseNameWeightedHipExtensionAndCross                      ((FITHipRaiseExerciseName)10)
#define FITHipRaiseExerciseNameHipRaise                                          ((FITHipRaiseExerciseName)11)
#define FITHipRaiseExerciseNameWeightedHipRaise                                  ((FITHipRaiseExerciseName)12)
#define FITHipRaiseExerciseNameHipRaiseWithFeetOnSwissBall                       ((FITHipRaiseExerciseName)13)
#define FITHipRaiseExerciseNameWeightedHipRaiseWithFeetOnSwissBall               ((FITHipRaiseExerciseName)14)
#define FITHipRaiseExerciseNameHipRaiseWithHeadOnBosuBall                        ((FITHipRaiseExerciseName)15)
#define FITHipRaiseExerciseNameWeightedHipRaiseWithHeadOnBosuBall                ((FITHipRaiseExerciseName)16)
#define FITHipRaiseExerciseNameHipRaiseWithHeadOnSwissBall                       ((FITHipRaiseExerciseName)17)
#define FITHipRaiseExerciseNameWeightedHipRaiseWithHeadOnSwissBall               ((FITHipRaiseExerciseName)18)
#define FITHipRaiseExerciseNameHipRaiseWithKneeSqueeze                           ((FITHipRaiseExerciseName)19)
#define FITHipRaiseExerciseNameWeightedHipRaiseWithKneeSqueeze                   ((FITHipRaiseExerciseName)20)
#define FITHipRaiseExerciseNameInclineRearLegExtension                           ((FITHipRaiseExerciseName)21)
#define FITHipRaiseExerciseNameWeightedInclineRearLegExtension                   ((FITHipRaiseExerciseName)22)
#define FITHipRaiseExerciseNameKettlebellSwing                                   ((FITHipRaiseExerciseName)23)
#define FITHipRaiseExerciseNameMarchingHipRaise                                  ((FITHipRaiseExerciseName)24)
#define FITHipRaiseExerciseNameWeightedMarchingHipRaise                          ((FITHipRaiseExerciseName)25)
#define FITHipRaiseExerciseNameMarchingHipRaiseWithFeetOnASwissBall              ((FITHipRaiseExerciseName)26)
#define FITHipRaiseExerciseNameWeightedMarchingHipRaiseWithFeetOnASwissBall      ((FITHipRaiseExerciseName)27)
#define FITHipRaiseExerciseNameReverseHipRaise                                   ((FITHipRaiseExerciseName)28)
#define FITHipRaiseExerciseNameWeightedReverseHipRaise                           ((FITHipRaiseExerciseName)29)
#define FITHipRaiseExerciseNameSingleLegHipRaise                                 ((FITHipRaiseExerciseName)30)
#define FITHipRaiseExerciseNameWeightedSingleLegHipRaise                         ((FITHipRaiseExerciseName)31)
#define FITHipRaiseExerciseNameSingleLegHipRaiseWithFootOnBench                  ((FITHipRaiseExerciseName)32)
#define FITHipRaiseExerciseNameWeightedSingleLegHipRaiseWithFootOnBench          ((FITHipRaiseExerciseName)33)
#define FITHipRaiseExerciseNameSingleLegHipRaiseWithFootOnBosuBall               ((FITHipRaiseExerciseName)34)
#define FITHipRaiseExerciseNameWeightedSingleLegHipRaiseWithFootOnBosuBall       ((FITHipRaiseExerciseName)35)
#define FITHipRaiseExerciseNameSingleLegHipRaiseWithFootOnFoamRoller             ((FITHipRaiseExerciseName)36)
#define FITHipRaiseExerciseNameWeightedSingleLegHipRaiseWithFootOnFoamRoller     ((FITHipRaiseExerciseName)37)
#define FITHipRaiseExerciseNameSingleLegHipRaiseWithFootOnMedicineBall           ((FITHipRaiseExerciseName)38)
#define FITHipRaiseExerciseNameWeightedSingleLegHipRaiseWithFootOnMedicineBall   ((FITHipRaiseExerciseName)39)
#define FITHipRaiseExerciseNameSingleLegHipRaiseWithHeadOnBosuBall               ((FITHipRaiseExerciseName)40)
#define FITHipRaiseExerciseNameWeightedSingleLegHipRaiseWithHeadOnBosuBall       ((FITHipRaiseExerciseName)41)
#define FITHipRaiseExerciseNameWeightedClamBridge                                ((FITHipRaiseExerciseName)42)
#define FITHipRaiseExerciseNameSingleLegSwissBallHipRaiseAndLegCurl              ((FITHipRaiseExerciseName)43)
#define FITHipRaiseExerciseNameClams                                             ((FITHipRaiseExerciseName)44)
#define FITHipRaiseExerciseNameInnerThighCircles                                 ((FITHipRaiseExerciseName)45) // Deprecated do not use
#define FITHipRaiseExerciseNameInnerThighSideLift                                ((FITHipRaiseExerciseName)46) // Deprecated do not use
#define FITHipRaiseExerciseNameLegCircles                                        ((FITHipRaiseExerciseName)47)
#define FITHipRaiseExerciseNameLegLift                                           ((FITHipRaiseExerciseName)48)
#define FITHipRaiseExerciseNameLegLiftInExternalRotation                         ((FITHipRaiseExerciseName)49)
#define FITHipRaiseExerciseNameCount                                             50

typedef FITUInt16 FITHipStabilityExerciseName;
#define FITHipStabilityExerciseNameInvalid                                       FITUInt16Invalid
#define FITHipStabilityExerciseNameBandSideLyingLegRaise                         ((FITHipStabilityExerciseName)0)
#define FITHipStabilityExerciseNameDeadBug                                       ((FITHipStabilityExerciseName)1)
#define FITHipStabilityExerciseNameWeightedDeadBug                               ((FITHipStabilityExerciseName)2)
#define FITHipStabilityExerciseNameExternalHipRaise                              ((FITHipStabilityExerciseName)3)
#define FITHipStabilityExerciseNameWeightedExternalHipRaise                      ((FITHipStabilityExerciseName)4)
#define FITHipStabilityExerciseNameFireHydrantKicks                              ((FITHipStabilityExerciseName)5)
#define FITHipStabilityExerciseNameWeightedFireHydrantKicks                      ((FITHipStabilityExerciseName)6)
#define FITHipStabilityExerciseNameHipCircles                                    ((FITHipStabilityExerciseName)7)
#define FITHipStabilityExerciseNameWeightedHipCircles                            ((FITHipStabilityExerciseName)8)
#define FITHipStabilityExerciseNameInnerThighLift                                ((FITHipStabilityExerciseName)9)
#define FITHipStabilityExerciseNameWeightedInnerThighLift                        ((FITHipStabilityExerciseName)10)
#define FITHipStabilityExerciseNameLateralWalksWithBandAtAnkles                  ((FITHipStabilityExerciseName)11)
#define FITHipStabilityExerciseNamePretzelSideKick                               ((FITHipStabilityExerciseName)12)
#define FITHipStabilityExerciseNameWeightedPretzelSideKick                       ((FITHipStabilityExerciseName)13)
#define FITHipStabilityExerciseNameProneHipInternalRotation                      ((FITHipStabilityExerciseName)14)
#define FITHipStabilityExerciseNameWeightedProneHipInternalRotation              ((FITHipStabilityExerciseName)15)
#define FITHipStabilityExerciseNameQuadruped                                     ((FITHipStabilityExerciseName)16)
#define FITHipStabilityExerciseNameQuadrupedHipExtension                         ((FITHipStabilityExerciseName)17)
#define FITHipStabilityExerciseNameWeightedQuadrupedHipExtension                 ((FITHipStabilityExerciseName)18)
#define FITHipStabilityExerciseNameQuadrupedWithLegLift                          ((FITHipStabilityExerciseName)19)
#define FITHipStabilityExerciseNameWeightedQuadrupedWithLegLift                  ((FITHipStabilityExerciseName)20)
#define FITHipStabilityExerciseNameSideLyingLegRaise                             ((FITHipStabilityExerciseName)21)
#define FITHipStabilityExerciseNameWeightedSideLyingLegRaise                     ((FITHipStabilityExerciseName)22)
#define FITHipStabilityExerciseNameSlidingHipAdduction                           ((FITHipStabilityExerciseName)23)
#define FITHipStabilityExerciseNameWeightedSlidingHipAdduction                   ((FITHipStabilityExerciseName)24)
#define FITHipStabilityExerciseNameStandingAdduction                             ((FITHipStabilityExerciseName)25)
#define FITHipStabilityExerciseNameWeightedStandingAdduction                     ((FITHipStabilityExerciseName)26)
#define FITHipStabilityExerciseNameStandingCableHipAbduction                     ((FITHipStabilityExerciseName)27)
#define FITHipStabilityExerciseNameStandingHipAbduction                          ((FITHipStabilityExerciseName)28)
#define FITHipStabilityExerciseNameWeightedStandingHipAbduction                  ((FITHipStabilityExerciseName)29)
#define FITHipStabilityExerciseNameStandingRearLegRaise                          ((FITHipStabilityExerciseName)30)
#define FITHipStabilityExerciseNameWeightedStandingRearLegRaise                  ((FITHipStabilityExerciseName)31)
#define FITHipStabilityExerciseNameSupineHipInternalRotation                     ((FITHipStabilityExerciseName)32)
#define FITHipStabilityExerciseNameWeightedSupineHipInternalRotation             ((FITHipStabilityExerciseName)33)
#define FITHipStabilityExerciseNameCount                                         34

typedef FITUInt16 FITHipSwingExerciseName;
#define FITHipSwingExerciseNameInvalid                                           FITUInt16Invalid
#define FITHipSwingExerciseNameSingleArmKettlebellSwing                          ((FITHipSwingExerciseName)0)
#define FITHipSwingExerciseNameSingleArmDumbbellSwing                            ((FITHipSwingExerciseName)1)
#define FITHipSwingExerciseNameStepOutSwing                                      ((FITHipSwingExerciseName)2)
#define FITHipSwingExerciseNameCount                                             3

typedef FITUInt16 FITHyperextensionExerciseName;
#define FITHyperextensionExerciseNameInvalid                                     FITUInt16Invalid
#define FITHyperextensionExerciseNameBackExtensionWithOppositeArmAndLegReach     ((FITHyperextensionExerciseName)0)
#define FITHyperextensionExerciseNameWeightedBackExtensionWithOppositeArmAndLegReach ((FITHyperextensionExerciseName)1)
#define FITHyperextensionExerciseNameBaseRotations                               ((FITHyperextensionExerciseName)2)
#define FITHyperextensionExerciseNameWeightedBaseRotations                       ((FITHyperextensionExerciseName)3)
#define FITHyperextensionExerciseNameBentKneeReverseHyperextension               ((FITHyperextensionExerciseName)4)
#define FITHyperextensionExerciseNameWeightedBentKneeReverseHyperextension       ((FITHyperextensionExerciseName)5)
#define FITHyperextensionExerciseNameHollowHoldAndRoll                           ((FITHyperextensionExerciseName)6)
#define FITHyperextensionExerciseNameWeightedHollowHoldAndRoll                   ((FITHyperextensionExerciseName)7)
#define FITHyperextensionExerciseNameKicks                                       ((FITHyperextensionExerciseName)8)
#define FITHyperextensionExerciseNameWeightedKicks                               ((FITHyperextensionExerciseName)9)
#define FITHyperextensionExerciseNameKneeRaises                                  ((FITHyperextensionExerciseName)10)
#define FITHyperextensionExerciseNameWeightedKneeRaises                          ((FITHyperextensionExerciseName)11)
#define FITHyperextensionExerciseNameKneelingSuperman                            ((FITHyperextensionExerciseName)12)
#define FITHyperextensionExerciseNameWeightedKneelingSuperman                    ((FITHyperextensionExerciseName)13)
#define FITHyperextensionExerciseNameLatPullDownWithRow                          ((FITHyperextensionExerciseName)14)
#define FITHyperextensionExerciseNameMedicineBallDeadliftToReach                 ((FITHyperextensionExerciseName)15)
#define FITHyperextensionExerciseNameOneArmOneLegRow                             ((FITHyperextensionExerciseName)16)
#define FITHyperextensionExerciseNameOneArmRowWithBand                           ((FITHyperextensionExerciseName)17)
#define FITHyperextensionExerciseNameOverheadLungeWithMedicineBall               ((FITHyperextensionExerciseName)18)
#define FITHyperextensionExerciseNamePlankKneeTucks                              ((FITHyperextensionExerciseName)19)
#define FITHyperextensionExerciseNameWeightedPlankKneeTucks                      ((FITHyperextensionExerciseName)20)
#define FITHyperextensionExerciseNameSideStep                                    ((FITHyperextensionExerciseName)21)
#define FITHyperextensionExerciseNameWeightedSideStep                            ((FITHyperextensionExerciseName)22)
#define FITHyperextensionExerciseNameSingleLegBackExtension                      ((FITHyperextensionExerciseName)23)
#define FITHyperextensionExerciseNameWeightedSingleLegBackExtension              ((FITHyperextensionExerciseName)24)
#define FITHyperextensionExerciseNameSpineExtension                              ((FITHyperextensionExerciseName)25)
#define FITHyperextensionExerciseNameWeightedSpineExtension                      ((FITHyperextensionExerciseName)26)
#define FITHyperextensionExerciseNameStaticBackExtension                         ((FITHyperextensionExerciseName)27)
#define FITHyperextensionExerciseNameWeightedStaticBackExtension                 ((FITHyperextensionExerciseName)28)
#define FITHyperextensionExerciseNameSupermanFromFloor                           ((FITHyperextensionExerciseName)29)
#define FITHyperextensionExerciseNameWeightedSupermanFromFloor                   ((FITHyperextensionExerciseName)30)
#define FITHyperextensionExerciseNameSwissBallBackExtension                      ((FITHyperextensionExerciseName)31)
#define FITHyperextensionExerciseNameWeightedSwissBallBackExtension              ((FITHyperextensionExerciseName)32)
#define FITHyperextensionExerciseNameSwissBallHyperextension                     ((FITHyperextensionExerciseName)33)
#define FITHyperextensionExerciseNameWeightedSwissBallHyperextension             ((FITHyperextensionExerciseName)34)
#define FITHyperextensionExerciseNameSwissBallOppositeArmAndLegLift              ((FITHyperextensionExerciseName)35)
#define FITHyperextensionExerciseNameWeightedSwissBallOppositeArmAndLegLift      ((FITHyperextensionExerciseName)36)
#define FITHyperextensionExerciseNameSupermanOnSwissBall                         ((FITHyperextensionExerciseName)37)
#define FITHyperextensionExerciseNameCobra                                       ((FITHyperextensionExerciseName)38)
#define FITHyperextensionExerciseNameSupineFloorBarre                            ((FITHyperextensionExerciseName)39) // Deprecated do not use
#define FITHyperextensionExerciseNameCount                                       40

typedef FITUInt16 FITLateralRaiseExerciseName;
#define FITLateralRaiseExerciseNameInvalid                                       FITUInt16Invalid
#define FITLateralRaiseExerciseName45DegreeCableExternalRotation                 ((FITLateralRaiseExerciseName)0)
#define FITLateralRaiseExerciseNameAlternatingLateralRaiseWithStaticHold         ((FITLateralRaiseExerciseName)1)
#define FITLateralRaiseExerciseNameBarMuscleUp                                   ((FITLateralRaiseExerciseName)2)
#define FITLateralRaiseExerciseNameBentOverLateralRaise                          ((FITLateralRaiseExerciseName)3)
#define FITLateralRaiseExerciseNameCableDiagonalRaise                            ((FITLateralRaiseExerciseName)4)
#define FITLateralRaiseExerciseNameCableFrontRaise                               ((FITLateralRaiseExerciseName)5)
#define FITLateralRaiseExerciseNameCalorieRow                                    ((FITLateralRaiseExerciseName)6)
#define FITLateralRaiseExerciseNameComboShoulderRaise                            ((FITLateralRaiseExerciseName)7)
#define FITLateralRaiseExerciseNameDumbbellDiagonalRaise                         ((FITLateralRaiseExerciseName)8)
#define FITLateralRaiseExerciseNameDumbbellVRaise                                ((FITLateralRaiseExerciseName)9)
#define FITLateralRaiseExerciseNameFrontRaise                                    ((FITLateralRaiseExerciseName)10)
#define FITLateralRaiseExerciseNameLeaningDumbbellLateralRaise                   ((FITLateralRaiseExerciseName)11)
#define FITLateralRaiseExerciseNameLyingDumbbellRaise                            ((FITLateralRaiseExerciseName)12)
#define FITLateralRaiseExerciseNameMuscleUp                                      ((FITLateralRaiseExerciseName)13)
#define FITLateralRaiseExerciseNameOneArmCableLateralRaise                       ((FITLateralRaiseExerciseName)14)
#define FITLateralRaiseExerciseNameOverhandGripRearLateralRaise                  ((FITLateralRaiseExerciseName)15)
#define FITLateralRaiseExerciseNamePlateRaises                                   ((FITLateralRaiseExerciseName)16)
#define FITLateralRaiseExerciseNameRingDip                                       ((FITLateralRaiseExerciseName)17)
#define FITLateralRaiseExerciseNameWeightedRingDip                               ((FITLateralRaiseExerciseName)18)
#define FITLateralRaiseExerciseNameRingMuscleUp                                  ((FITLateralRaiseExerciseName)19)
#define FITLateralRaiseExerciseNameWeightedRingMuscleUp                          ((FITLateralRaiseExerciseName)20)
#define FITLateralRaiseExerciseNameRopeClimb                                     ((FITLateralRaiseExerciseName)21)
#define FITLateralRaiseExerciseNameWeightedRopeClimb                             ((FITLateralRaiseExerciseName)22)
#define FITLateralRaiseExerciseNameScaption                                      ((FITLateralRaiseExerciseName)23)
#define FITLateralRaiseExerciseNameSeatedLateralRaise                            ((FITLateralRaiseExerciseName)24)
#define FITLateralRaiseExerciseNameSeatedRearLateralRaise                        ((FITLateralRaiseExerciseName)25)
#define FITLateralRaiseExerciseNameSideLyingLateralRaise                         ((FITLateralRaiseExerciseName)26)
#define FITLateralRaiseExerciseNameStandingLift                                  ((FITLateralRaiseExerciseName)27)
#define FITLateralRaiseExerciseNameSuspendedRow                                  ((FITLateralRaiseExerciseName)28)
#define FITLateralRaiseExerciseNameUnderhandGripRearLateralRaise                 ((FITLateralRaiseExerciseName)29)
#define FITLateralRaiseExerciseNameWallSlide                                     ((FITLateralRaiseExerciseName)30)
#define FITLateralRaiseExerciseNameWeightedWallSlide                             ((FITLateralRaiseExerciseName)31)
#define FITLateralRaiseExerciseNameArmCircles                                    ((FITLateralRaiseExerciseName)32)
#define FITLateralRaiseExerciseNameShavingTheHead                                ((FITLateralRaiseExerciseName)33)
#define FITLateralRaiseExerciseNameCount                                         34

typedef FITUInt16 FITLegCurlExerciseName;
#define FITLegCurlExerciseNameInvalid                                            FITUInt16Invalid
#define FITLegCurlExerciseNameLegCurl                                            ((FITLegCurlExerciseName)0)
#define FITLegCurlExerciseNameWeightedLegCurl                                    ((FITLegCurlExerciseName)1)
#define FITLegCurlExerciseNameGoodMorning                                        ((FITLegCurlExerciseName)2)
#define FITLegCurlExerciseNameSeatedBarbellGoodMorning                           ((FITLegCurlExerciseName)3)
#define FITLegCurlExerciseNameSingleLegBarbellGoodMorning                        ((FITLegCurlExerciseName)4)
#define FITLegCurlExerciseNameSingleLegSlidingLegCurl                            ((FITLegCurlExerciseName)5)
#define FITLegCurlExerciseNameSlidingLegCurl                                     ((FITLegCurlExerciseName)6)
#define FITLegCurlExerciseNameSplitBarbellGoodMorning                            ((FITLegCurlExerciseName)7)
#define FITLegCurlExerciseNameSplitStanceExtension                               ((FITLegCurlExerciseName)8)
#define FITLegCurlExerciseNameStaggeredStanceGoodMorning                         ((FITLegCurlExerciseName)9)
#define FITLegCurlExerciseNameSwissBallHipRaiseAndLegCurl                        ((FITLegCurlExerciseName)10)
#define FITLegCurlExerciseNameZercherGoodMorning                                 ((FITLegCurlExerciseName)11)
#define FITLegCurlExerciseNameCount                                              12

typedef FITUInt16 FITLegRaiseExerciseName;
#define FITLegRaiseExerciseNameInvalid                                           FITUInt16Invalid
#define FITLegRaiseExerciseNameHangingKneeRaise                                  ((FITLegRaiseExerciseName)0)
#define FITLegRaiseExerciseNameHangingLegRaise                                   ((FITLegRaiseExerciseName)1)
#define FITLegRaiseExerciseNameWeightedHangingLegRaise                           ((FITLegRaiseExerciseName)2)
#define FITLegRaiseExerciseNameHangingSingleLegRaise                             ((FITLegRaiseExerciseName)3)
#define FITLegRaiseExerciseNameWeightedHangingSingleLegRaise                     ((FITLegRaiseExerciseName)4)
#define FITLegRaiseExerciseNameKettlebellLegRaises                               ((FITLegRaiseExerciseName)5)
#define FITLegRaiseExerciseNameLegLoweringDrill                                  ((FITLegRaiseExerciseName)6)
#define FITLegRaiseExerciseNameWeightedLegLoweringDrill                          ((FITLegRaiseExerciseName)7)
#define FITLegRaiseExerciseNameLyingStraightLegRaise                             ((FITLegRaiseExerciseName)8)
#define FITLegRaiseExerciseNameWeightedLyingStraightLegRaise                     ((FITLegRaiseExerciseName)9)
#define FITLegRaiseExerciseNameMedicineBallLegDrops                              ((FITLegRaiseExerciseName)10)
#define FITLegRaiseExerciseNameQuadrupedLegRaise                                 ((FITLegRaiseExerciseName)11)
#define FITLegRaiseExerciseNameWeightedQuadrupedLegRaise                         ((FITLegRaiseExerciseName)12)
#define FITLegRaiseExerciseNameReverseLegRaise                                   ((FITLegRaiseExerciseName)13)
#define FITLegRaiseExerciseNameWeightedReverseLegRaise                           ((FITLegRaiseExerciseName)14)
#define FITLegRaiseExerciseNameReverseLegRaiseOnSwissBall                        ((FITLegRaiseExerciseName)15)
#define FITLegRaiseExerciseNameWeightedReverseLegRaiseOnSwissBall                ((FITLegRaiseExerciseName)16)
#define FITLegRaiseExerciseNameSingleLegLoweringDrill                            ((FITLegRaiseExerciseName)17)
#define FITLegRaiseExerciseNameWeightedSingleLegLoweringDrill                    ((FITLegRaiseExerciseName)18)
#define FITLegRaiseExerciseNameWeightedHangingKneeRaise                          ((FITLegRaiseExerciseName)19)
#define FITLegRaiseExerciseNameLateralStepover                                   ((FITLegRaiseExerciseName)20)
#define FITLegRaiseExerciseNameWeightedLateralStepover                           ((FITLegRaiseExerciseName)21)
#define FITLegRaiseExerciseNameCount                                             22

typedef FITUInt16 FITLungeExerciseName;
#define FITLungeExerciseNameInvalid                                              FITUInt16Invalid
#define FITLungeExerciseNameOverheadLunge                                        ((FITLungeExerciseName)0)
#define FITLungeExerciseNameLungeMatrix                                          ((FITLungeExerciseName)1)
#define FITLungeExerciseNameWeightedLungeMatrix                                  ((FITLungeExerciseName)2)
#define FITLungeExerciseNameAlternatingBarbellForwardLunge                       ((FITLungeExerciseName)3)
#define FITLungeExerciseNameAlternatingDumbbellLungeWithReach                    ((FITLungeExerciseName)4)
#define FITLungeExerciseNameBackFootElevatedDumbbellSplitSquat                   ((FITLungeExerciseName)5)
#define FITLungeExerciseNameBarbellBoxLunge                                      ((FITLungeExerciseName)6)
#define FITLungeExerciseNameBarbellBulgarianSplitSquat                           ((FITLungeExerciseName)7)
#define FITLungeExerciseNameBarbellCrossoverLunge                                ((FITLungeExerciseName)8)
#define FITLungeExerciseNameBarbellFrontSplitSquat                               ((FITLungeExerciseName)9)
#define FITLungeExerciseNameBarbellLunge                                         ((FITLungeExerciseName)10)
#define FITLungeExerciseNameBarbellReverseLunge                                  ((FITLungeExerciseName)11)
#define FITLungeExerciseNameBarbellSideLunge                                     ((FITLungeExerciseName)12)
#define FITLungeExerciseNameBarbellSplitSquat                                    ((FITLungeExerciseName)13)
#define FITLungeExerciseNameCoreControlRearLunge                                 ((FITLungeExerciseName)14)
#define FITLungeExerciseNameDiagonalLunge                                        ((FITLungeExerciseName)15)
#define FITLungeExerciseNameDropLunge                                            ((FITLungeExerciseName)16)
#define FITLungeExerciseNameDumbbellBoxLunge                                     ((FITLungeExerciseName)17)
#define FITLungeExerciseNameDumbbellBulgarianSplitSquat                          ((FITLungeExerciseName)18)
#define FITLungeExerciseNameDumbbellCrossoverLunge                               ((FITLungeExerciseName)19)
#define FITLungeExerciseNameDumbbellDiagonalLunge                                ((FITLungeExerciseName)20)
#define FITLungeExerciseNameDumbbellLunge                                        ((FITLungeExerciseName)21)
#define FITLungeExerciseNameDumbbellLungeAndRotation                             ((FITLungeExerciseName)22)
#define FITLungeExerciseNameDumbbellOverheadBulgarianSplitSquat                  ((FITLungeExerciseName)23)
#define FITLungeExerciseNameDumbbellReverseLungeToHighKneeAndPress               ((FITLungeExerciseName)24)
#define FITLungeExerciseNameDumbbellSideLunge                                    ((FITLungeExerciseName)25)
#define FITLungeExerciseNameElevatedFrontFootBarbellSplitSquat                   ((FITLungeExerciseName)26)
#define FITLungeExerciseNameFrontFootElevatedDumbbellSplitSquat                  ((FITLungeExerciseName)27)
#define FITLungeExerciseNameGunslingerLunge                                      ((FITLungeExerciseName)28)
#define FITLungeExerciseNameLawnmowerLunge                                       ((FITLungeExerciseName)29)
#define FITLungeExerciseNameLowLungeWithIsometricAdduction                       ((FITLungeExerciseName)30)
#define FITLungeExerciseNameLowSideToSideLunge                                   ((FITLungeExerciseName)31)
#define FITLungeExerciseNameLunge                                                ((FITLungeExerciseName)32)
#define FITLungeExerciseNameWeightedLunge                                        ((FITLungeExerciseName)33)
#define FITLungeExerciseNameLungeWithArmReach                                    ((FITLungeExerciseName)34)
#define FITLungeExerciseNameLungeWithDiagonalReach                               ((FITLungeExerciseName)35)
#define FITLungeExerciseNameLungeWithSideBend                                    ((FITLungeExerciseName)36)
#define FITLungeExerciseNameOffsetDumbbellLunge                                  ((FITLungeExerciseName)37)
#define FITLungeExerciseNameOffsetDumbbellReverseLunge                           ((FITLungeExerciseName)38)
#define FITLungeExerciseNameOverheadBulgarianSplitSquat                          ((FITLungeExerciseName)39)
#define FITLungeExerciseNameOverheadDumbbellReverseLunge                         ((FITLungeExerciseName)40)
#define FITLungeExerciseNameOverheadDumbbellSplitSquat                           ((FITLungeExerciseName)41)
#define FITLungeExerciseNameOverheadLungeWithRotation                            ((FITLungeExerciseName)42)
#define FITLungeExerciseNameReverseBarbellBoxLunge                               ((FITLungeExerciseName)43)
#define FITLungeExerciseNameReverseBoxLunge                                      ((FITLungeExerciseName)44)
#define FITLungeExerciseNameReverseDumbbellBoxLunge                              ((FITLungeExerciseName)45)
#define FITLungeExerciseNameReverseDumbbellCrossoverLunge                        ((FITLungeExerciseName)46)
#define FITLungeExerciseNameReverseDumbbellDiagonalLunge                         ((FITLungeExerciseName)47)
#define FITLungeExerciseNameReverseLungeWithReachBack                            ((FITLungeExerciseName)48)
#define FITLungeExerciseNameWeightedReverseLungeWithReachBack                    ((FITLungeExerciseName)49)
#define FITLungeExerciseNameReverseLungeWithTwistAndOverheadReach                ((FITLungeExerciseName)50)
#define FITLungeExerciseNameWeightedReverseLungeWithTwistAndOverheadReach        ((FITLungeExerciseName)51)
#define FITLungeExerciseNameReverseSlidingBoxLunge                               ((FITLungeExerciseName)52)
#define FITLungeExerciseNameWeightedReverseSlidingBoxLunge                       ((FITLungeExerciseName)53)
#define FITLungeExerciseNameReverseSlidingLunge                                  ((FITLungeExerciseName)54)
#define FITLungeExerciseNameWeightedReverseSlidingLunge                          ((FITLungeExerciseName)55)
#define FITLungeExerciseNameRunnersLungeToBalance                                ((FITLungeExerciseName)56)
#define FITLungeExerciseNameWeightedRunnersLungeToBalance                        ((FITLungeExerciseName)57)
#define FITLungeExerciseNameShiftingSideLunge                                    ((FITLungeExerciseName)58)
#define FITLungeExerciseNameSideAndCrossoverLunge                                ((FITLungeExerciseName)59)
#define FITLungeExerciseNameWeightedSideAndCrossoverLunge                        ((FITLungeExerciseName)60)
#define FITLungeExerciseNameSideLunge                                            ((FITLungeExerciseName)61)
#define FITLungeExerciseNameWeightedSideLunge                                    ((FITLungeExerciseName)62)
#define FITLungeExerciseNameSideLungeAndPress                                    ((FITLungeExerciseName)63)
#define FITLungeExerciseNameSideLungeJumpOff                                     ((FITLungeExerciseName)64)
#define FITLungeExerciseNameSideLungeSweep                                       ((FITLungeExerciseName)65)
#define FITLungeExerciseNameWeightedSideLungeSweep                               ((FITLungeExerciseName)66)
#define FITLungeExerciseNameSideLungeToCrossoverTap                              ((FITLungeExerciseName)67)
#define FITLungeExerciseNameWeightedSideLungeToCrossoverTap                      ((FITLungeExerciseName)68)
#define FITLungeExerciseNameSideToSideLungeChops                                 ((FITLungeExerciseName)69)
#define FITLungeExerciseNameWeightedSideToSideLungeChops                         ((FITLungeExerciseName)70)
#define FITLungeExerciseNameSiffJumpLunge                                        ((FITLungeExerciseName)71)
#define FITLungeExerciseNameWeightedSiffJumpLunge                                ((FITLungeExerciseName)72)
#define FITLungeExerciseNameSingleArmReverseLungeAndPress                        ((FITLungeExerciseName)73)
#define FITLungeExerciseNameSlidingLateralLunge                                  ((FITLungeExerciseName)74)
#define FITLungeExerciseNameWeightedSlidingLateralLunge                          ((FITLungeExerciseName)75)
#define FITLungeExerciseNameWalkingBarbellLunge                                  ((FITLungeExerciseName)76)
#define FITLungeExerciseNameWalkingDumbbellLunge                                 ((FITLungeExerciseName)77)
#define FITLungeExerciseNameWalkingLunge                                         ((FITLungeExerciseName)78)
#define FITLungeExerciseNameWeightedWalkingLunge                                 ((FITLungeExerciseName)79)
#define FITLungeExerciseNameWideGripOverheadBarbellSplitSquat                    ((FITLungeExerciseName)80)
#define FITLungeExerciseNameCount                                                81

typedef FITUInt16 FITOlympicLiftExerciseName;
#define FITOlympicLiftExerciseNameInvalid                                        FITUInt16Invalid
#define FITOlympicLiftExerciseNameBarbellHangPowerClean                          ((FITOlympicLiftExerciseName)0)
#define FITOlympicLiftExerciseNameBarbellHangSquatClean                          ((FITOlympicLiftExerciseName)1)
#define FITOlympicLiftExerciseNameBarbellPowerClean                              ((FITOlympicLiftExerciseName)2)
#define FITOlympicLiftExerciseNameBarbellPowerSnatch                             ((FITOlympicLiftExerciseName)3)
#define FITOlympicLiftExerciseNameBarbellSquatClean                              ((FITOlympicLiftExerciseName)4)
#define FITOlympicLiftExerciseNameCleanAndJerk                                   ((FITOlympicLiftExerciseName)5)
#define FITOlympicLiftExerciseNameBarbellHangPowerSnatch                         ((FITOlympicLiftExerciseName)6)
#define FITOlympicLiftExerciseNameBarbellHangPull                                ((FITOlympicLiftExerciseName)7)
#define FITOlympicLiftExerciseNameBarbellHighPull                                ((FITOlympicLiftExerciseName)8)
#define FITOlympicLiftExerciseNameBarbellSnatch                                  ((FITOlympicLiftExerciseName)9)
#define FITOlympicLiftExerciseNameBarbellSplitJerk                               ((FITOlympicLiftExerciseName)10)
#define FITOlympicLiftExerciseNameClean                                          ((FITOlympicLiftExerciseName)11)
#define FITOlympicLiftExerciseNameDumbbellClean                                  ((FITOlympicLiftExerciseName)12)
#define FITOlympicLiftExerciseNameDumbbellHangPull                               ((FITOlympicLiftExerciseName)13)
#define FITOlympicLiftExerciseNameOneHandDumbbellSplitSnatch                     ((FITOlympicLiftExerciseName)14)
#define FITOlympicLiftExerciseNamePushJerk                                       ((FITOlympicLiftExerciseName)15)
#define FITOlympicLiftExerciseNameSingleArmDumbbellSnatch                        ((FITOlympicLiftExerciseName)16)
#define FITOlympicLiftExerciseNameSingleArmHangSnatch                            ((FITOlympicLiftExerciseName)17)
#define FITOlympicLiftExerciseNameSingleArmKettlebellSnatch                      ((FITOlympicLiftExerciseName)18)
#define FITOlympicLiftExerciseNameSplitJerk                                      ((FITOlympicLiftExerciseName)19)
#define FITOlympicLiftExerciseNameSquatCleanAndJerk                              ((FITOlympicLiftExerciseName)20)
#define FITOlympicLiftExerciseNameCount                                          21

typedef FITUInt16 FITPlankExerciseName;
#define FITPlankExerciseNameInvalid                                              FITUInt16Invalid
#define FITPlankExerciseName45DegreePlank                                        ((FITPlankExerciseName)0)
#define FITPlankExerciseNameWeighted45DegreePlank                                ((FITPlankExerciseName)1)
#define FITPlankExerciseName90DegreeStaticHold                                   ((FITPlankExerciseName)2)
#define FITPlankExerciseNameWeighted90DegreeStaticHold                           ((FITPlankExerciseName)3)
#define FITPlankExerciseNameBearCrawl                                            ((FITPlankExerciseName)4)
#define FITPlankExerciseNameWeightedBearCrawl                                    ((FITPlankExerciseName)5)
#define FITPlankExerciseNameCrossBodyMountainClimber                             ((FITPlankExerciseName)6)
#define FITPlankExerciseNameWeightedCrossBodyMountainClimber                     ((FITPlankExerciseName)7)
#define FITPlankExerciseNameElbowPlankPikeJacks                                  ((FITPlankExerciseName)8)
#define FITPlankExerciseNameWeightedElbowPlankPikeJacks                          ((FITPlankExerciseName)9)
#define FITPlankExerciseNameElevatedFeetPlank                                    ((FITPlankExerciseName)10)
#define FITPlankExerciseNameWeightedElevatedFeetPlank                            ((FITPlankExerciseName)11)
#define FITPlankExerciseNameElevatorAbs                                          ((FITPlankExerciseName)12)
#define FITPlankExerciseNameWeightedElevatorAbs                                  ((FITPlankExerciseName)13)
#define FITPlankExerciseNameExtendedPlank                                        ((FITPlankExerciseName)14)
#define FITPlankExerciseNameWeightedExtendedPlank                                ((FITPlankExerciseName)15)
#define FITPlankExerciseNameFullPlankPasseTwist                                  ((FITPlankExerciseName)16)
#define FITPlankExerciseNameWeightedFullPlankPasseTwist                          ((FITPlankExerciseName)17)
#define FITPlankExerciseNameInchingElbowPlank                                    ((FITPlankExerciseName)18)
#define FITPlankExerciseNameWeightedInchingElbowPlank                            ((FITPlankExerciseName)19)
#define FITPlankExerciseNameInchwormToSidePlank                                  ((FITPlankExerciseName)20)
#define FITPlankExerciseNameWeightedInchwormToSidePlank                          ((FITPlankExerciseName)21)
#define FITPlankExerciseNameKneelingPlank                                        ((FITPlankExerciseName)22)
#define FITPlankExerciseNameWeightedKneelingPlank                                ((FITPlankExerciseName)23)
#define FITPlankExerciseNameKneelingSidePlankWithLegLift                         ((FITPlankExerciseName)24)
#define FITPlankExerciseNameWeightedKneelingSidePlankWithLegLift                 ((FITPlankExerciseName)25)
#define FITPlankExerciseNameLateralRoll                                          ((FITPlankExerciseName)26)
#define FITPlankExerciseNameWeightedLateralRoll                                  ((FITPlankExerciseName)27)
#define FITPlankExerciseNameLyingReversePlank                                    ((FITPlankExerciseName)28)
#define FITPlankExerciseNameWeightedLyingReversePlank                            ((FITPlankExerciseName)29)
#define FITPlankExerciseNameMedicineBallMountainClimber                          ((FITPlankExerciseName)30)
#define FITPlankExerciseNameWeightedMedicineBallMountainClimber                  ((FITPlankExerciseName)31)
#define FITPlankExerciseNameModifiedMountainClimberAndExtension                  ((FITPlankExerciseName)32)
#define FITPlankExerciseNameWeightedModifiedMountainClimberAndExtension          ((FITPlankExerciseName)33)
#define FITPlankExerciseNameMountainClimber                                      ((FITPlankExerciseName)34)
#define FITPlankExerciseNameWeightedMountainClimber                              ((FITPlankExerciseName)35)
#define FITPlankExerciseNameMountainClimberOnSlidingDiscs                        ((FITPlankExerciseName)36)
#define FITPlankExerciseNameWeightedMountainClimberOnSlidingDiscs                ((FITPlankExerciseName)37)
#define FITPlankExerciseNameMountainClimberWithFeetOnBosuBall                    ((FITPlankExerciseName)38)
#define FITPlankExerciseNameWeightedMountainClimberWithFeetOnBosuBall            ((FITPlankExerciseName)39)
#define FITPlankExerciseNameMountainClimberWithHandsOnBench                      ((FITPlankExerciseName)40)
#define FITPlankExerciseNameMountainClimberWithHandsOnSwissBall                  ((FITPlankExerciseName)41)
#define FITPlankExerciseNameWeightedMountainClimberWithHandsOnSwissBall          ((FITPlankExerciseName)42)
#define FITPlankExerciseNamePlank                                                ((FITPlankExerciseName)43)
#define FITPlankExerciseNamePlankJacksWithFeetOnSlidingDiscs                     ((FITPlankExerciseName)44)
#define FITPlankExerciseNameWeightedPlankJacksWithFeetOnSlidingDiscs             ((FITPlankExerciseName)45)
#define FITPlankExerciseNamePlankKneeTwist                                       ((FITPlankExerciseName)46)
#define FITPlankExerciseNameWeightedPlankKneeTwist                               ((FITPlankExerciseName)47)
#define FITPlankExerciseNamePlankPikeJumps                                       ((FITPlankExerciseName)48)
#define FITPlankExerciseNameWeightedPlankPikeJumps                               ((FITPlankExerciseName)49)
#define FITPlankExerciseNamePlankPikes                                           ((FITPlankExerciseName)50)
#define FITPlankExerciseNameWeightedPlankPikes                                   ((FITPlankExerciseName)51)
#define FITPlankExerciseNamePlankToStandUp                                       ((FITPlankExerciseName)52)
#define FITPlankExerciseNameWeightedPlankToStandUp                               ((FITPlankExerciseName)53)
#define FITPlankExerciseNamePlankWithArmRaise                                    ((FITPlankExerciseName)54)
#define FITPlankExerciseNameWeightedPlankWithArmRaise                            ((FITPlankExerciseName)55)
#define FITPlankExerciseNamePlankWithKneeToElbow                                 ((FITPlankExerciseName)56)
#define FITPlankExerciseNameWeightedPlankWithKneeToElbow                         ((FITPlankExerciseName)57)
#define FITPlankExerciseNamePlankWithObliqueCrunch                               ((FITPlankExerciseName)58)
#define FITPlankExerciseNameWeightedPlankWithObliqueCrunch                       ((FITPlankExerciseName)59)
#define FITPlankExerciseNamePlyometricSidePlank                                  ((FITPlankExerciseName)60)
#define FITPlankExerciseNameWeightedPlyometricSidePlank                          ((FITPlankExerciseName)61)
#define FITPlankExerciseNameRollingSidePlank                                     ((FITPlankExerciseName)62)
#define FITPlankExerciseNameWeightedRollingSidePlank                             ((FITPlankExerciseName)63)
#define FITPlankExerciseNameSideKickPlank                                        ((FITPlankExerciseName)64)
#define FITPlankExerciseNameWeightedSideKickPlank                                ((FITPlankExerciseName)65)
#define FITPlankExerciseNameSidePlank                                            ((FITPlankExerciseName)66)
#define FITPlankExerciseNameWeightedSidePlank                                    ((FITPlankExerciseName)67)
#define FITPlankExerciseNameSidePlankAndRow                                      ((FITPlankExerciseName)68)
#define FITPlankExerciseNameWeightedSidePlankAndRow                              ((FITPlankExerciseName)69)
#define FITPlankExerciseNameSidePlankLift                                        ((FITPlankExerciseName)70)
#define FITPlankExerciseNameWeightedSidePlankLift                                ((FITPlankExerciseName)71)
#define FITPlankExerciseNameSidePlankWithElbowOnBosuBall                         ((FITPlankExerciseName)72)
#define FITPlankExerciseNameWeightedSidePlankWithElbowOnBosuBall                 ((FITPlankExerciseName)73)
#define FITPlankExerciseNameSidePlankWithFeetOnBench                             ((FITPlankExerciseName)74)
#define FITPlankExerciseNameWeightedSidePlankWithFeetOnBench                     ((FITPlankExerciseName)75)
#define FITPlankExerciseNameSidePlankWithKneeCircle                              ((FITPlankExerciseName)76)
#define FITPlankExerciseNameWeightedSidePlankWithKneeCircle                      ((FITPlankExerciseName)77)
#define FITPlankExerciseNameSidePlankWithKneeTuck                                ((FITPlankExerciseName)78)
#define FITPlankExerciseNameWeightedSidePlankWithKneeTuck                        ((FITPlankExerciseName)79)
#define FITPlankExerciseNameSidePlankWithLegLift                                 ((FITPlankExerciseName)80)
#define FITPlankExerciseNameWeightedSidePlankWithLegLift                         ((FITPlankExerciseName)81)
#define FITPlankExerciseNameSidePlankWithReachUnder                              ((FITPlankExerciseName)82)
#define FITPlankExerciseNameWeightedSidePlankWithReachUnder                      ((FITPlankExerciseName)83)
#define FITPlankExerciseNameSingleLegElevatedFeetPlank                           ((FITPlankExerciseName)84)
#define FITPlankExerciseNameWeightedSingleLegElevatedFeetPlank                   ((FITPlankExerciseName)85)
#define FITPlankExerciseNameSingleLegFlexAndExtend                               ((FITPlankExerciseName)86)
#define FITPlankExerciseNameWeightedSingleLegFlexAndExtend                       ((FITPlankExerciseName)87)
#define FITPlankExerciseNameSingleLegSidePlank                                   ((FITPlankExerciseName)88)
#define FITPlankExerciseNameWeightedSingleLegSidePlank                           ((FITPlankExerciseName)89)
#define FITPlankExerciseNameSpidermanPlank                                       ((FITPlankExerciseName)90)
#define FITPlankExerciseNameWeightedSpidermanPlank                               ((FITPlankExerciseName)91)
#define FITPlankExerciseNameStraightArmPlank                                     ((FITPlankExerciseName)92)
#define FITPlankExerciseNameWeightedStraightArmPlank                             ((FITPlankExerciseName)93)
#define FITPlankExerciseNameStraightArmPlankWithShoulderTouch                    ((FITPlankExerciseName)94)
#define FITPlankExerciseNameWeightedStraightArmPlankWithShoulderTouch            ((FITPlankExerciseName)95)
#define FITPlankExerciseNameSwissBallPlank                                       ((FITPlankExerciseName)96)
#define FITPlankExerciseNameWeightedSwissBallPlank                               ((FITPlankExerciseName)97)
#define FITPlankExerciseNameSwissBallPlankLegLift                                ((FITPlankExerciseName)98)
#define FITPlankExerciseNameWeightedSwissBallPlankLegLift                        ((FITPlankExerciseName)99)
#define FITPlankExerciseNameSwissBallPlankLegLiftAndHold                         ((FITPlankExerciseName)100)
#define FITPlankExerciseNameSwissBallPlankWithFeetOnBench                        ((FITPlankExerciseName)101)
#define FITPlankExerciseNameWeightedSwissBallPlankWithFeetOnBench                ((FITPlankExerciseName)102)
#define FITPlankExerciseNameSwissBallProneJackknife                              ((FITPlankExerciseName)103)
#define FITPlankExerciseNameWeightedSwissBallProneJackknife                      ((FITPlankExerciseName)104)
#define FITPlankExerciseNameSwissBallSidePlank                                   ((FITPlankExerciseName)105)
#define FITPlankExerciseNameWeightedSwissBallSidePlank                           ((FITPlankExerciseName)106)
#define FITPlankExerciseNameThreeWayPlank                                        ((FITPlankExerciseName)107)
#define FITPlankExerciseNameWeightedThreeWayPlank                                ((FITPlankExerciseName)108)
#define FITPlankExerciseNameTowelPlankAndKneeIn                                  ((FITPlankExerciseName)109)
#define FITPlankExerciseNameWeightedTowelPlankAndKneeIn                          ((FITPlankExerciseName)110)
#define FITPlankExerciseNameTStabilization                                       ((FITPlankExerciseName)111)
#define FITPlankExerciseNameWeightedTStabilization                               ((FITPlankExerciseName)112)
#define FITPlankExerciseNameTurkishGetUpToSidePlank                              ((FITPlankExerciseName)113)
#define FITPlankExerciseNameWeightedTurkishGetUpToSidePlank                      ((FITPlankExerciseName)114)
#define FITPlankExerciseNameTwoPointPlank                                        ((FITPlankExerciseName)115)
#define FITPlankExerciseNameWeightedTwoPointPlank                                ((FITPlankExerciseName)116)
#define FITPlankExerciseNameWeightedPlank                                        ((FITPlankExerciseName)117)
#define FITPlankExerciseNameWideStancePlankWithDiagonalArmLift                   ((FITPlankExerciseName)118)
#define FITPlankExerciseNameWeightedWideStancePlankWithDiagonalArmLift           ((FITPlankExerciseName)119)
#define FITPlankExerciseNameWideStancePlankWithDiagonalLegLift                   ((FITPlankExerciseName)120)
#define FITPlankExerciseNameWeightedWideStancePlankWithDiagonalLegLift           ((FITPlankExerciseName)121)
#define FITPlankExerciseNameWideStancePlankWithLegLift                           ((FITPlankExerciseName)122)
#define FITPlankExerciseNameWeightedWideStancePlankWithLegLift                   ((FITPlankExerciseName)123)
#define FITPlankExerciseNameWideStancePlankWithOppositeArmAndLegLift             ((FITPlankExerciseName)124)
#define FITPlankExerciseNameWeightedMountainClimberWithHandsOnBench              ((FITPlankExerciseName)125)
#define FITPlankExerciseNameWeightedSwissBallPlankLegLiftAndHold                 ((FITPlankExerciseName)126)
#define FITPlankExerciseNameWeightedWideStancePlankWithOppositeArmAndLegLift     ((FITPlankExerciseName)127)
#define FITPlankExerciseNamePlankWithFeetOnSwissBall                             ((FITPlankExerciseName)128)
#define FITPlankExerciseNameSidePlankToPlankWithReachUnder                       ((FITPlankExerciseName)129)
#define FITPlankExerciseNameBridgeWithGluteLowerLift                             ((FITPlankExerciseName)130)
#define FITPlankExerciseNameBridgeOneLegBridge                                   ((FITPlankExerciseName)131)
#define FITPlankExerciseNamePlankWithArmVariations                               ((FITPlankExerciseName)132)
#define FITPlankExerciseNamePlankWithLegLift                                     ((FITPlankExerciseName)133)
#define FITPlankExerciseNameReversePlankWithLegPull                              ((FITPlankExerciseName)134)
#define FITPlankExerciseNameCount                                                135

typedef FITUInt16 FITPlyoExerciseName;
#define FITPlyoExerciseNameInvalid                                               FITUInt16Invalid
#define FITPlyoExerciseNameAlternatingJumpLunge                                  ((FITPlyoExerciseName)0)
#define FITPlyoExerciseNameWeightedAlternatingJumpLunge                          ((FITPlyoExerciseName)1)
#define FITPlyoExerciseNameBarbellJumpSquat                                      ((FITPlyoExerciseName)2)
#define FITPlyoExerciseNameBodyWeightJumpSquat                                   ((FITPlyoExerciseName)3)
#define FITPlyoExerciseNameWeightedJumpSquat                                     ((FITPlyoExerciseName)4)
#define FITPlyoExerciseNameCrossKneeStrike                                       ((FITPlyoExerciseName)5)
#define FITPlyoExerciseNameWeightedCrossKneeStrike                               ((FITPlyoExerciseName)6)
#define FITPlyoExerciseNameDepthJump                                             ((FITPlyoExerciseName)7)
#define FITPlyoExerciseNameWeightedDepthJump                                     ((FITPlyoExerciseName)8)
#define FITPlyoExerciseNameDumbbellJumpSquat                                     ((FITPlyoExerciseName)9)
#define FITPlyoExerciseNameDumbbellSplitJump                                     ((FITPlyoExerciseName)10)
#define FITPlyoExerciseNameFrontKneeStrike                                       ((FITPlyoExerciseName)11)
#define FITPlyoExerciseNameWeightedFrontKneeStrike                               ((FITPlyoExerciseName)12)
#define FITPlyoExerciseNameHighBoxJump                                           ((FITPlyoExerciseName)13)
#define FITPlyoExerciseNameWeightedHighBoxJump                                   ((FITPlyoExerciseName)14)
#define FITPlyoExerciseNameIsometricExplosiveBodyWeightJumpSquat                 ((FITPlyoExerciseName)15)
#define FITPlyoExerciseNameWeightedIsometricExplosiveJumpSquat                   ((FITPlyoExerciseName)16)
#define FITPlyoExerciseNameLateralLeapAndHop                                     ((FITPlyoExerciseName)17)
#define FITPlyoExerciseNameWeightedLateralLeapAndHop                             ((FITPlyoExerciseName)18)
#define FITPlyoExerciseNameLateralPlyoSquats                                     ((FITPlyoExerciseName)19)
#define FITPlyoExerciseNameWeightedLateralPlyoSquats                             ((FITPlyoExerciseName)20)
#define FITPlyoExerciseNameLateralSlide                                          ((FITPlyoExerciseName)21)
#define FITPlyoExerciseNameWeightedLateralSlide                                  ((FITPlyoExerciseName)22)
#define FITPlyoExerciseNameMedicineBallOverheadThrows                            ((FITPlyoExerciseName)23)
#define FITPlyoExerciseNameMedicineBallSideThrow                                 ((FITPlyoExerciseName)24)
#define FITPlyoExerciseNameMedicineBallSlam                                      ((FITPlyoExerciseName)25)
#define FITPlyoExerciseNameSideToSideMedicineBallThrows                          ((FITPlyoExerciseName)26)
#define FITPlyoExerciseNameSideToSideShuffleJump                                 ((FITPlyoExerciseName)27)
#define FITPlyoExerciseNameWeightedSideToSideShuffleJump                         ((FITPlyoExerciseName)28)
#define FITPlyoExerciseNameSquatJumpOntoBox                                      ((FITPlyoExerciseName)29)
#define FITPlyoExerciseNameWeightedSquatJumpOntoBox                              ((FITPlyoExerciseName)30)
#define FITPlyoExerciseNameSquatJumpsInAndOut                                    ((FITPlyoExerciseName)31)
#define FITPlyoExerciseNameWeightedSquatJumpsInAndOut                            ((FITPlyoExerciseName)32)
#define FITPlyoExerciseNameCount                                                 33

typedef FITUInt16 FITPullUpExerciseName;
#define FITPullUpExerciseNameInvalid                                             FITUInt16Invalid
#define FITPullUpExerciseNameBandedPullUps                                       ((FITPullUpExerciseName)0)
#define FITPullUpExerciseName30DegreeLatPulldown                                 ((FITPullUpExerciseName)1)
#define FITPullUpExerciseNameBandAssistedChinUp                                  ((FITPullUpExerciseName)2)
#define FITPullUpExerciseNameCloseGripChinUp                                     ((FITPullUpExerciseName)3)
#define FITPullUpExerciseNameWeightedCloseGripChinUp                             ((FITPullUpExerciseName)4)
#define FITPullUpExerciseNameCloseGripLatPulldown                                ((FITPullUpExerciseName)5)
#define FITPullUpExerciseNameCrossoverChinUp                                     ((FITPullUpExerciseName)6)
#define FITPullUpExerciseNameWeightedCrossoverChinUp                             ((FITPullUpExerciseName)7)
#define FITPullUpExerciseNameEzBarPullover                                       ((FITPullUpExerciseName)8)
#define FITPullUpExerciseNameHangingHurdle                                       ((FITPullUpExerciseName)9)
#define FITPullUpExerciseNameWeightedHangingHurdle                               ((FITPullUpExerciseName)10)
#define FITPullUpExerciseNameKneelingLatPulldown                                 ((FITPullUpExerciseName)11)
#define FITPullUpExerciseNameKneelingUnderhandGripLatPulldown                    ((FITPullUpExerciseName)12)
#define FITPullUpExerciseNameLatPulldown                                         ((FITPullUpExerciseName)13)
#define FITPullUpExerciseNameMixedGripChinUp                                     ((FITPullUpExerciseName)14)
#define FITPullUpExerciseNameWeightedMixedGripChinUp                             ((FITPullUpExerciseName)15)
#define FITPullUpExerciseNameMixedGripPullUp                                     ((FITPullUpExerciseName)16)
#define FITPullUpExerciseNameWeightedMixedGripPullUp                             ((FITPullUpExerciseName)17)
#define FITPullUpExerciseNameReverseGripPulldown                                 ((FITPullUpExerciseName)18)
#define FITPullUpExerciseNameStandingCablePullover                               ((FITPullUpExerciseName)19)
#define FITPullUpExerciseNameStraightArmPulldown                                 ((FITPullUpExerciseName)20)
#define FITPullUpExerciseNameSwissBallEzBarPullover                              ((FITPullUpExerciseName)21)
#define FITPullUpExerciseNameTowelPullUp                                         ((FITPullUpExerciseName)22)
#define FITPullUpExerciseNameWeightedTowelPullUp                                 ((FITPullUpExerciseName)23)
#define FITPullUpExerciseNameWeightedPullUp                                      ((FITPullUpExerciseName)24)
#define FITPullUpExerciseNameWideGripLatPulldown                                 ((FITPullUpExerciseName)25)
#define FITPullUpExerciseNameWideGripPullUp                                      ((FITPullUpExerciseName)26)
#define FITPullUpExerciseNameWeightedWideGripPullUp                              ((FITPullUpExerciseName)27)
#define FITPullUpExerciseNameBurpeePullUp                                        ((FITPullUpExerciseName)28)
#define FITPullUpExerciseNameWeightedBurpeePullUp                                ((FITPullUpExerciseName)29)
#define FITPullUpExerciseNameJumpingPullUps                                      ((FITPullUpExerciseName)30)
#define FITPullUpExerciseNameWeightedJumpingPullUps                              ((FITPullUpExerciseName)31)
#define FITPullUpExerciseNameKippingPullUp                                       ((FITPullUpExerciseName)32)
#define FITPullUpExerciseNameWeightedKippingPullUp                               ((FITPullUpExerciseName)33)
#define FITPullUpExerciseNameLPullUp                                             ((FITPullUpExerciseName)34)
#define FITPullUpExerciseNameWeightedLPullUp                                     ((FITPullUpExerciseName)35)
#define FITPullUpExerciseNameSuspendedChinUp                                     ((FITPullUpExerciseName)36)
#define FITPullUpExerciseNameWeightedSuspendedChinUp                             ((FITPullUpExerciseName)37)
#define FITPullUpExerciseNamePullUp                                              ((FITPullUpExerciseName)38)
#define FITPullUpExerciseNameCount                                               39

typedef FITUInt16 FITPushUpExerciseName;
#define FITPushUpExerciseNameInvalid                                             FITUInt16Invalid
#define FITPushUpExerciseNameChestPressWithBand                                  ((FITPushUpExerciseName)0)
#define FITPushUpExerciseNameAlternatingStaggeredPushUp                          ((FITPushUpExerciseName)1)
#define FITPushUpExerciseNameWeightedAlternatingStaggeredPushUp                  ((FITPushUpExerciseName)2)
#define FITPushUpExerciseNameAlternatingHandsMedicineBallPushUp                  ((FITPushUpExerciseName)3)
#define FITPushUpExerciseNameWeightedAlternatingHandsMedicineBallPushUp          ((FITPushUpExerciseName)4)
#define FITPushUpExerciseNameBosuBallPushUp                                      ((FITPushUpExerciseName)5)
#define FITPushUpExerciseNameWeightedBosuBallPushUp                              ((FITPushUpExerciseName)6)
#define FITPushUpExerciseNameClappingPushUp                                      ((FITPushUpExerciseName)7)
#define FITPushUpExerciseNameWeightedClappingPushUp                              ((FITPushUpExerciseName)8)
#define FITPushUpExerciseNameCloseGripMedicineBallPushUp                         ((FITPushUpExerciseName)9)
#define FITPushUpExerciseNameWeightedCloseGripMedicineBallPushUp                 ((FITPushUpExerciseName)10)
#define FITPushUpExerciseNameCloseHandsPushUp                                    ((FITPushUpExerciseName)11)
#define FITPushUpExerciseNameWeightedCloseHandsPushUp                            ((FITPushUpExerciseName)12)
#define FITPushUpExerciseNameDeclinePushUp                                       ((FITPushUpExerciseName)13)
#define FITPushUpExerciseNameWeightedDeclinePushUp                               ((FITPushUpExerciseName)14)
#define FITPushUpExerciseNameDiamondPushUp                                       ((FITPushUpExerciseName)15)
#define FITPushUpExerciseNameWeightedDiamondPushUp                               ((FITPushUpExerciseName)16)
#define FITPushUpExerciseNameExplosiveCrossoverPushUp                            ((FITPushUpExerciseName)17)
#define FITPushUpExerciseNameWeightedExplosiveCrossoverPushUp                    ((FITPushUpExerciseName)18)
#define FITPushUpExerciseNameExplosivePushUp                                     ((FITPushUpExerciseName)19)
#define FITPushUpExerciseNameWeightedExplosivePushUp                             ((FITPushUpExerciseName)20)
#define FITPushUpExerciseNameFeetElevatedSideToSidePushUp                        ((FITPushUpExerciseName)21)
#define FITPushUpExerciseNameWeightedFeetElevatedSideToSidePushUp                ((FITPushUpExerciseName)22)
#define FITPushUpExerciseNameHandReleasePushUp                                   ((FITPushUpExerciseName)23)
#define FITPushUpExerciseNameWeightedHandReleasePushUp                           ((FITPushUpExerciseName)24)
#define FITPushUpExerciseNameHandstandPushUp                                     ((FITPushUpExerciseName)25)
#define FITPushUpExerciseNameWeightedHandstandPushUp                             ((FITPushUpExerciseName)26)
#define FITPushUpExerciseNameInclinePushUp                                       ((FITPushUpExerciseName)27)
#define FITPushUpExerciseNameWeightedInclinePushUp                               ((FITPushUpExerciseName)28)
#define FITPushUpExerciseNameIsometricExplosivePushUp                            ((FITPushUpExerciseName)29)
#define FITPushUpExerciseNameWeightedIsometricExplosivePushUp                    ((FITPushUpExerciseName)30)
#define FITPushUpExerciseNameJudoPushUp                                          ((FITPushUpExerciseName)31)
#define FITPushUpExerciseNameWeightedJudoPushUp                                  ((FITPushUpExerciseName)32)
#define FITPushUpExerciseNameKneelingPushUp                                      ((FITPushUpExerciseName)33)
#define FITPushUpExerciseNameWeightedKneelingPushUp                              ((FITPushUpExerciseName)34)
#define FITPushUpExerciseNameMedicineBallChestPass                               ((FITPushUpExerciseName)35)
#define FITPushUpExerciseNameMedicineBallPushUp                                  ((FITPushUpExerciseName)36)
#define FITPushUpExerciseNameWeightedMedicineBallPushUp                          ((FITPushUpExerciseName)37)
#define FITPushUpExerciseNameOneArmPushUp                                        ((FITPushUpExerciseName)38)
#define FITPushUpExerciseNameWeightedOneArmPushUp                                ((FITPushUpExerciseName)39)
#define FITPushUpExerciseNameWeightedPushUp                                      ((FITPushUpExerciseName)40)
#define FITPushUpExerciseNamePushUpAndRow                                        ((FITPushUpExerciseName)41)
#define FITPushUpExerciseNameWeightedPushUpAndRow                                ((FITPushUpExerciseName)42)
#define FITPushUpExerciseNamePushUpPlus                                          ((FITPushUpExerciseName)43)
#define FITPushUpExerciseNameWeightedPushUpPlus                                  ((FITPushUpExerciseName)44)
#define FITPushUpExerciseNamePushUpWithFeetOnSwissBall                           ((FITPushUpExerciseName)45)
#define FITPushUpExerciseNameWeightedPushUpWithFeetOnSwissBall                   ((FITPushUpExerciseName)46)
#define FITPushUpExerciseNamePushUpWithOneHandOnMedicineBall                     ((FITPushUpExerciseName)47)
#define FITPushUpExerciseNameWeightedPushUpWithOneHandOnMedicineBall             ((FITPushUpExerciseName)48)
#define FITPushUpExerciseNameShoulderPushUp                                      ((FITPushUpExerciseName)49)
#define FITPushUpExerciseNameWeightedShoulderPushUp                              ((FITPushUpExerciseName)50)
#define FITPushUpExerciseNameSingleArmMedicineBallPushUp                         ((FITPushUpExerciseName)51)
#define FITPushUpExerciseNameWeightedSingleArmMedicineBallPushUp                 ((FITPushUpExerciseName)52)
#define FITPushUpExerciseNameSpidermanPushUp                                     ((FITPushUpExerciseName)53)
#define FITPushUpExerciseNameWeightedSpidermanPushUp                             ((FITPushUpExerciseName)54)
#define FITPushUpExerciseNameStackedFeetPushUp                                   ((FITPushUpExerciseName)55)
#define FITPushUpExerciseNameWeightedStackedFeetPushUp                           ((FITPushUpExerciseName)56)
#define FITPushUpExerciseNameStaggeredHandsPushUp                                ((FITPushUpExerciseName)57)
#define FITPushUpExerciseNameWeightedStaggeredHandsPushUp                        ((FITPushUpExerciseName)58)
#define FITPushUpExerciseNameSuspendedPushUp                                     ((FITPushUpExerciseName)59)
#define FITPushUpExerciseNameWeightedSuspendedPushUp                             ((FITPushUpExerciseName)60)
#define FITPushUpExerciseNameSwissBallPushUp                                     ((FITPushUpExerciseName)61)
#define FITPushUpExerciseNameWeightedSwissBallPushUp                             ((FITPushUpExerciseName)62)
#define FITPushUpExerciseNameSwissBallPushUpPlus                                 ((FITPushUpExerciseName)63)
#define FITPushUpExerciseNameWeightedSwissBallPushUpPlus                         ((FITPushUpExerciseName)64)
#define FITPushUpExerciseNameTPushUp                                             ((FITPushUpExerciseName)65)
#define FITPushUpExerciseNameWeightedTPushUp                                     ((FITPushUpExerciseName)66)
#define FITPushUpExerciseNameTripleStopPushUp                                    ((FITPushUpExerciseName)67)
#define FITPushUpExerciseNameWeightedTripleStopPushUp                            ((FITPushUpExerciseName)68)
#define FITPushUpExerciseNameWideHandsPushUp                                     ((FITPushUpExerciseName)69)
#define FITPushUpExerciseNameWeightedWideHandsPushUp                             ((FITPushUpExerciseName)70)
#define FITPushUpExerciseNameParalletteHandstandPushUp                           ((FITPushUpExerciseName)71)
#define FITPushUpExerciseNameWeightedParalletteHandstandPushUp                   ((FITPushUpExerciseName)72)
#define FITPushUpExerciseNameRingHandstandPushUp                                 ((FITPushUpExerciseName)73)
#define FITPushUpExerciseNameWeightedRingHandstandPushUp                         ((FITPushUpExerciseName)74)
#define FITPushUpExerciseNameRingPushUp                                          ((FITPushUpExerciseName)75)
#define FITPushUpExerciseNameWeightedRingPushUp                                  ((FITPushUpExerciseName)76)
#define FITPushUpExerciseNamePushUp                                              ((FITPushUpExerciseName)77)
#define FITPushUpExerciseNamePilatesPushup                                       ((FITPushUpExerciseName)78)
#define FITPushUpExerciseNameCount                                               79

typedef FITUInt16 FITRowExerciseName;
#define FITRowExerciseNameInvalid                                                FITUInt16Invalid
#define FITRowExerciseNameBarbellStraightLegDeadliftToRow                        ((FITRowExerciseName)0)
#define FITRowExerciseNameCableRowStanding                                       ((FITRowExerciseName)1)
#define FITRowExerciseNameDumbbellRow                                            ((FITRowExerciseName)2)
#define FITRowExerciseNameElevatedFeetInvertedRow                                ((FITRowExerciseName)3)
#define FITRowExerciseNameWeightedElevatedFeetInvertedRow                        ((FITRowExerciseName)4)
#define FITRowExerciseNameFacePull                                               ((FITRowExerciseName)5)
#define FITRowExerciseNameFacePullWithExternalRotation                           ((FITRowExerciseName)6)
#define FITRowExerciseNameInvertedRowWithFeetOnSwissBall                         ((FITRowExerciseName)7)
#define FITRowExerciseNameWeightedInvertedRowWithFeetOnSwissBall                 ((FITRowExerciseName)8)
#define FITRowExerciseNameKettlebellRow                                          ((FITRowExerciseName)9)
#define FITRowExerciseNameModifiedInvertedRow                                    ((FITRowExerciseName)10)
#define FITRowExerciseNameWeightedModifiedInvertedRow                            ((FITRowExerciseName)11)
#define FITRowExerciseNameNeutralGripAlternatingDumbbellRow                      ((FITRowExerciseName)12)
#define FITRowExerciseNameOneArmBentOverRow                                      ((FITRowExerciseName)13)
#define FITRowExerciseNameOneLeggedDumbbellRow                                   ((FITRowExerciseName)14)
#define FITRowExerciseNameRenegadeRow                                            ((FITRowExerciseName)15)
#define FITRowExerciseNameReverseGripBarbellRow                                  ((FITRowExerciseName)16)
#define FITRowExerciseNameRopeHandleCableRow                                     ((FITRowExerciseName)17)
#define FITRowExerciseNameSeatedCableRow                                         ((FITRowExerciseName)18)
#define FITRowExerciseNameSeatedDumbbellRow                                      ((FITRowExerciseName)19)
#define FITRowExerciseNameSingleArmCableRow                                      ((FITRowExerciseName)20)
#define FITRowExerciseNameSingleArmCableRowAndRotation                           ((FITRowExerciseName)21)
#define FITRowExerciseNameSingleArmInvertedRow                                   ((FITRowExerciseName)22)
#define FITRowExerciseNameWeightedSingleArmInvertedRow                           ((FITRowExerciseName)23)
#define FITRowExerciseNameSingleArmNeutralGripDumbbellRow                        ((FITRowExerciseName)24)
#define FITRowExerciseNameSingleArmNeutralGripDumbbellRowAndRotation             ((FITRowExerciseName)25)
#define FITRowExerciseNameSuspendedInvertedRow                                   ((FITRowExerciseName)26)
#define FITRowExerciseNameWeightedSuspendedInvertedRow                           ((FITRowExerciseName)27)
#define FITRowExerciseNameTBarRow                                                ((FITRowExerciseName)28)
#define FITRowExerciseNameTowelGripInvertedRow                                   ((FITRowExerciseName)29)
#define FITRowExerciseNameWeightedTowelGripInvertedRow                           ((FITRowExerciseName)30)
#define FITRowExerciseNameUnderhandGripCableRow                                  ((FITRowExerciseName)31)
#define FITRowExerciseNameVGripCableRow                                          ((FITRowExerciseName)32)
#define FITRowExerciseNameWideGripSeatedCableRow                                 ((FITRowExerciseName)33)
#define FITRowExerciseNameCount                                                  34

typedef FITUInt16 FITShoulderPressExerciseName;
#define FITShoulderPressExerciseNameInvalid                                      FITUInt16Invalid
#define FITShoulderPressExerciseNameAlternatingDumbbellShoulderPress             ((FITShoulderPressExerciseName)0)
#define FITShoulderPressExerciseNameArnoldPress                                  ((FITShoulderPressExerciseName)1)
#define FITShoulderPressExerciseNameBarbellFrontSquatToPushPress                 ((FITShoulderPressExerciseName)2)
#define FITShoulderPressExerciseNameBarbellPushPress                             ((FITShoulderPressExerciseName)3)
#define FITShoulderPressExerciseNameBarbellShoulderPress                         ((FITShoulderPressExerciseName)4)
#define FITShoulderPressExerciseNameDeadCurlPress                                ((FITShoulderPressExerciseName)5)
#define FITShoulderPressExerciseNameDumbbellAlternatingShoulderPressAndTwist     ((FITShoulderPressExerciseName)6)
#define FITShoulderPressExerciseNameDumbbellHammerCurlToLungeToPress             ((FITShoulderPressExerciseName)7)
#define FITShoulderPressExerciseNameDumbbellPushPress                            ((FITShoulderPressExerciseName)8)
#define FITShoulderPressExerciseNameFloorInvertedShoulderPress                   ((FITShoulderPressExerciseName)9)
#define FITShoulderPressExerciseNameWeightedFloorInvertedShoulderPress           ((FITShoulderPressExerciseName)10)
#define FITShoulderPressExerciseNameInvertedShoulderPress                        ((FITShoulderPressExerciseName)11)
#define FITShoulderPressExerciseNameWeightedInvertedShoulderPress                ((FITShoulderPressExerciseName)12)
#define FITShoulderPressExerciseNameOneArmPushPress                              ((FITShoulderPressExerciseName)13)
#define FITShoulderPressExerciseNameOverheadBarbellPress                         ((FITShoulderPressExerciseName)14)
#define FITShoulderPressExerciseNameOverheadDumbbellPress                        ((FITShoulderPressExerciseName)15)
#define FITShoulderPressExerciseNameSeatedBarbellShoulderPress                   ((FITShoulderPressExerciseName)16)
#define FITShoulderPressExerciseNameSeatedDumbbellShoulderPress                  ((FITShoulderPressExerciseName)17)
#define FITShoulderPressExerciseNameSingleArmDumbbellShoulderPress               ((FITShoulderPressExerciseName)18)
#define FITShoulderPressExerciseNameSingleArmStepUpAndPress                      ((FITShoulderPressExerciseName)19)
#define FITShoulderPressExerciseNameSmithMachineOverheadPress                    ((FITShoulderPressExerciseName)20)
#define FITShoulderPressExerciseNameSplitStanceHammerCurlToPress                 ((FITShoulderPressExerciseName)21)
#define FITShoulderPressExerciseNameSwissBallDumbbellShoulderPress               ((FITShoulderPressExerciseName)22)
#define FITShoulderPressExerciseNameWeightPlateFrontRaise                        ((FITShoulderPressExerciseName)23)
#define FITShoulderPressExerciseNameCount                                        24

typedef FITUInt16 FITShoulderStabilityExerciseName;
#define FITShoulderStabilityExerciseNameInvalid                                  FITUInt16Invalid
#define FITShoulderStabilityExerciseName90DegreeCableExternalRotation            ((FITShoulderStabilityExerciseName)0)
#define FITShoulderStabilityExerciseNameBandExternalRotation                     ((FITShoulderStabilityExerciseName)1)
#define FITShoulderStabilityExerciseNameBandInternalRotation                     ((FITShoulderStabilityExerciseName)2)
#define FITShoulderStabilityExerciseNameBentArmLateralRaiseAndExternalRotation   ((FITShoulderStabilityExerciseName)3)
#define FITShoulderStabilityExerciseNameCableExternalRotation                    ((FITShoulderStabilityExerciseName)4)
#define FITShoulderStabilityExerciseNameDumbbellFacePullWithExternalRotation     ((FITShoulderStabilityExerciseName)5)
#define FITShoulderStabilityExerciseNameFloorIRaise                              ((FITShoulderStabilityExerciseName)6)
#define FITShoulderStabilityExerciseNameWeightedFloorIRaise                      ((FITShoulderStabilityExerciseName)7)
#define FITShoulderStabilityExerciseNameFloorTRaise                              ((FITShoulderStabilityExerciseName)8)
#define FITShoulderStabilityExerciseNameWeightedFloorTRaise                      ((FITShoulderStabilityExerciseName)9)
#define FITShoulderStabilityExerciseNameFloorYRaise                              ((FITShoulderStabilityExerciseName)10)
#define FITShoulderStabilityExerciseNameWeightedFloorYRaise                      ((FITShoulderStabilityExerciseName)11)
#define FITShoulderStabilityExerciseNameInclineIRaise                            ((FITShoulderStabilityExerciseName)12)
#define FITShoulderStabilityExerciseNameWeightedInclineIRaise                    ((FITShoulderStabilityExerciseName)13)
#define FITShoulderStabilityExerciseNameInclineLRaise                            ((FITShoulderStabilityExerciseName)14)
#define FITShoulderStabilityExerciseNameWeightedInclineLRaise                    ((FITShoulderStabilityExerciseName)15)
#define FITShoulderStabilityExerciseNameInclineTRaise                            ((FITShoulderStabilityExerciseName)16)
#define FITShoulderStabilityExerciseNameWeightedInclineTRaise                    ((FITShoulderStabilityExerciseName)17)
#define FITShoulderStabilityExerciseNameInclineWRaise                            ((FITShoulderStabilityExerciseName)18)
#define FITShoulderStabilityExerciseNameWeightedInclineWRaise                    ((FITShoulderStabilityExerciseName)19)
#define FITShoulderStabilityExerciseNameInclineYRaise                            ((FITShoulderStabilityExerciseName)20)
#define FITShoulderStabilityExerciseNameWeightedInclineYRaise                    ((FITShoulderStabilityExerciseName)21)
#define FITShoulderStabilityExerciseNameLyingExternalRotation                    ((FITShoulderStabilityExerciseName)22)
#define FITShoulderStabilityExerciseNameSeatedDumbbellExternalRotation           ((FITShoulderStabilityExerciseName)23)
#define FITShoulderStabilityExerciseNameStandingLRaise                           ((FITShoulderStabilityExerciseName)24)
#define FITShoulderStabilityExerciseNameSwissBallIRaise                          ((FITShoulderStabilityExerciseName)25)
#define FITShoulderStabilityExerciseNameWeightedSwissBallIRaise                  ((FITShoulderStabilityExerciseName)26)
#define FITShoulderStabilityExerciseNameSwissBallTRaise                          ((FITShoulderStabilityExerciseName)27)
#define FITShoulderStabilityExerciseNameWeightedSwissBallTRaise                  ((FITShoulderStabilityExerciseName)28)
#define FITShoulderStabilityExerciseNameSwissBallWRaise                          ((FITShoulderStabilityExerciseName)29)
#define FITShoulderStabilityExerciseNameWeightedSwissBallWRaise                  ((FITShoulderStabilityExerciseName)30)
#define FITShoulderStabilityExerciseNameSwissBallYRaise                          ((FITShoulderStabilityExerciseName)31)
#define FITShoulderStabilityExerciseNameWeightedSwissBallYRaise                  ((FITShoulderStabilityExerciseName)32)
#define FITShoulderStabilityExerciseNameCount                                    33

typedef FITUInt16 FITShrugExerciseName;
#define FITShrugExerciseNameInvalid                                              FITUInt16Invalid
#define FITShrugExerciseNameBarbellJumpShrug                                     ((FITShrugExerciseName)0)
#define FITShrugExerciseNameBarbellShrug                                         ((FITShrugExerciseName)1)
#define FITShrugExerciseNameBarbellUprightRow                                    ((FITShrugExerciseName)2)
#define FITShrugExerciseNameBehindTheBackSmithMachineShrug                       ((FITShrugExerciseName)3)
#define FITShrugExerciseNameDumbbellJumpShrug                                    ((FITShrugExerciseName)4)
#define FITShrugExerciseNameDumbbellShrug                                        ((FITShrugExerciseName)5)
#define FITShrugExerciseNameDumbbellUprightRow                                   ((FITShrugExerciseName)6)
#define FITShrugExerciseNameInclineDumbbellShrug                                 ((FITShrugExerciseName)7)
#define FITShrugExerciseNameOverheadBarbellShrug                                 ((FITShrugExerciseName)8)
#define FITShrugExerciseNameOverheadDumbbellShrug                                ((FITShrugExerciseName)9)
#define FITShrugExerciseNameScaptionAndShrug                                     ((FITShrugExerciseName)10)
#define FITShrugExerciseNameScapularRetraction                                   ((FITShrugExerciseName)11)
#define FITShrugExerciseNameSerratusChairShrug                                   ((FITShrugExerciseName)12)
#define FITShrugExerciseNameWeightedSerratusChairShrug                           ((FITShrugExerciseName)13)
#define FITShrugExerciseNameSerratusShrug                                        ((FITShrugExerciseName)14)
#define FITShrugExerciseNameWeightedSerratusShrug                                ((FITShrugExerciseName)15)
#define FITShrugExerciseNameWideGripJumpShrug                                    ((FITShrugExerciseName)16)
#define FITShrugExerciseNameCount                                                17

typedef FITUInt16 FITSitUpExerciseName;
#define FITSitUpExerciseNameInvalid                                              FITUInt16Invalid
#define FITSitUpExerciseNameAlternatingSitUp                                     ((FITSitUpExerciseName)0)
#define FITSitUpExerciseNameWeightedAlternatingSitUp                             ((FITSitUpExerciseName)1)
#define FITSitUpExerciseNameBentKneeVUp                                          ((FITSitUpExerciseName)2)
#define FITSitUpExerciseNameWeightedBentKneeVUp                                  ((FITSitUpExerciseName)3)
#define FITSitUpExerciseNameButterflySitUp                                       ((FITSitUpExerciseName)4)
#define FITSitUpExerciseNameWeightedButterflySitup                               ((FITSitUpExerciseName)5)
#define FITSitUpExerciseNameCrossPunchRollUp                                     ((FITSitUpExerciseName)6)
#define FITSitUpExerciseNameWeightedCrossPunchRollUp                             ((FITSitUpExerciseName)7)
#define FITSitUpExerciseNameCrossedArmsSitUp                                     ((FITSitUpExerciseName)8)
#define FITSitUpExerciseNameWeightedCrossedArmsSitUp                             ((FITSitUpExerciseName)9)
#define FITSitUpExerciseNameGetUpSitUp                                           ((FITSitUpExerciseName)10)
#define FITSitUpExerciseNameWeightedGetUpSitUp                                   ((FITSitUpExerciseName)11)
#define FITSitUpExerciseNameHoveringSitUp                                        ((FITSitUpExerciseName)12)
#define FITSitUpExerciseNameWeightedHoveringSitUp                                ((FITSitUpExerciseName)13)
#define FITSitUpExerciseNameKettlebellSitUp                                      ((FITSitUpExerciseName)14)
#define FITSitUpExerciseNameMedicineBallAlternatingVUp                           ((FITSitUpExerciseName)15)
#define FITSitUpExerciseNameMedicineBallSitUp                                    ((FITSitUpExerciseName)16)
#define FITSitUpExerciseNameMedicineBallVUp                                      ((FITSitUpExerciseName)17)
#define FITSitUpExerciseNameModifiedSitUp                                        ((FITSitUpExerciseName)18)
#define FITSitUpExerciseNameNegativeSitUp                                        ((FITSitUpExerciseName)19)
#define FITSitUpExerciseNameOneArmFullSitUp                                      ((FITSitUpExerciseName)20)
#define FITSitUpExerciseNameRecliningCircle                                      ((FITSitUpExerciseName)21)
#define FITSitUpExerciseNameWeightedRecliningCircle                              ((FITSitUpExerciseName)22)
#define FITSitUpExerciseNameReverseCurlUp                                        ((FITSitUpExerciseName)23)
#define FITSitUpExerciseNameWeightedReverseCurlUp                                ((FITSitUpExerciseName)24)
#define FITSitUpExerciseNameSingleLegSwissBallJackknife                          ((FITSitUpExerciseName)25)
#define FITSitUpExerciseNameWeightedSingleLegSwissBallJackknife                  ((FITSitUpExerciseName)26)
#define FITSitUpExerciseNameTheTeaser                                            ((FITSitUpExerciseName)27)
#define FITSitUpExerciseNameTheTeaserWeighted                                    ((FITSitUpExerciseName)28)
#define FITSitUpExerciseNameThreePartRollDown                                    ((FITSitUpExerciseName)29)
#define FITSitUpExerciseNameWeightedThreePartRollDown                            ((FITSitUpExerciseName)30)
#define FITSitUpExerciseNameVUp                                                  ((FITSitUpExerciseName)31)
#define FITSitUpExerciseNameWeightedVUp                                          ((FITSitUpExerciseName)32)
#define FITSitUpExerciseNameWeightedRussianTwistOnSwissBall                      ((FITSitUpExerciseName)33)
#define FITSitUpExerciseNameWeightedSitUp                                        ((FITSitUpExerciseName)34)
#define FITSitUpExerciseNameXAbs                                                 ((FITSitUpExerciseName)35)
#define FITSitUpExerciseNameWeightedXAbs                                         ((FITSitUpExerciseName)36)
#define FITSitUpExerciseNameSitUp                                                ((FITSitUpExerciseName)37)
#define FITSitUpExerciseNameCount                                                38

typedef FITUInt16 FITSquatExerciseName;
#define FITSquatExerciseNameInvalid                                              FITUInt16Invalid
#define FITSquatExerciseNameLegPress                                             ((FITSquatExerciseName)0)
#define FITSquatExerciseNameBackSquatWithBodyBar                                 ((FITSquatExerciseName)1)
#define FITSquatExerciseNameBackSquats                                           ((FITSquatExerciseName)2)
#define FITSquatExerciseNameWeightedBackSquats                                   ((FITSquatExerciseName)3)
#define FITSquatExerciseNameBalancingSquat                                       ((FITSquatExerciseName)4)
#define FITSquatExerciseNameWeightedBalancingSquat                               ((FITSquatExerciseName)5)
#define FITSquatExerciseNameBarbellBackSquat                                     ((FITSquatExerciseName)6)
#define FITSquatExerciseNameBarbellBoxSquat                                      ((FITSquatExerciseName)7)
#define FITSquatExerciseNameBarbellFrontSquat                                    ((FITSquatExerciseName)8)
#define FITSquatExerciseNameBarbellHackSquat                                     ((FITSquatExerciseName)9)
#define FITSquatExerciseNameBarbellHangSquatSnatch                               ((FITSquatExerciseName)10)
#define FITSquatExerciseNameBarbellLateralStepUp                                 ((FITSquatExerciseName)11)
#define FITSquatExerciseNameBarbellQuarterSquat                                  ((FITSquatExerciseName)12)
#define FITSquatExerciseNameBarbellSiffSquat                                     ((FITSquatExerciseName)13)
#define FITSquatExerciseNameBarbellSquatSnatch                                   ((FITSquatExerciseName)14)
#define FITSquatExerciseNameBarbellSquatWithHeelsRaised                          ((FITSquatExerciseName)15)
#define FITSquatExerciseNameBarbellStepover                                      ((FITSquatExerciseName)16)
#define FITSquatExerciseNameBarbellStepUp                                        ((FITSquatExerciseName)17)
#define FITSquatExerciseNameBenchSquatWithRotationalChop                         ((FITSquatExerciseName)18)
#define FITSquatExerciseNameWeightedBenchSquatWithRotationalChop                 ((FITSquatExerciseName)19)
#define FITSquatExerciseNameBodyWeightWallSquat                                  ((FITSquatExerciseName)20)
#define FITSquatExerciseNameWeightedWallSquat                                    ((FITSquatExerciseName)21)
#define FITSquatExerciseNameBoxStepSquat                                         ((FITSquatExerciseName)22)
#define FITSquatExerciseNameWeightedBoxStepSquat                                 ((FITSquatExerciseName)23)
#define FITSquatExerciseNameBracedSquat                                          ((FITSquatExerciseName)24)
#define FITSquatExerciseNameCrossedArmBarbellFrontSquat                          ((FITSquatExerciseName)25)
#define FITSquatExerciseNameCrossoverDumbbellStepUp                              ((FITSquatExerciseName)26)
#define FITSquatExerciseNameDumbbellFrontSquat                                   ((FITSquatExerciseName)27)
#define FITSquatExerciseNameDumbbellSplitSquat                                   ((FITSquatExerciseName)28)
#define FITSquatExerciseNameDumbbellSquat                                        ((FITSquatExerciseName)29)
#define FITSquatExerciseNameDumbbellSquatClean                                   ((FITSquatExerciseName)30)
#define FITSquatExerciseNameDumbbellStepover                                     ((FITSquatExerciseName)31)
#define FITSquatExerciseNameDumbbellStepUp                                       ((FITSquatExerciseName)32)
#define FITSquatExerciseNameElevatedSingleLegSquat                               ((FITSquatExerciseName)33)
#define FITSquatExerciseNameWeightedElevatedSingleLegSquat                       ((FITSquatExerciseName)34)
#define FITSquatExerciseNameFigureFourSquats                                     ((FITSquatExerciseName)35)
#define FITSquatExerciseNameWeightedFigureFourSquats                             ((FITSquatExerciseName)36)
#define FITSquatExerciseNameGobletSquat                                          ((FITSquatExerciseName)37)
#define FITSquatExerciseNameKettlebellSquat                                      ((FITSquatExerciseName)38)
#define FITSquatExerciseNameKettlebellSwingOverhead                              ((FITSquatExerciseName)39)
#define FITSquatExerciseNameKettlebellSwingWithFlipToSquat                       ((FITSquatExerciseName)40)
#define FITSquatExerciseNameLateralDumbbellStepUp                                ((FITSquatExerciseName)41)
#define FITSquatExerciseNameOneLeggedSquat                                       ((FITSquatExerciseName)42)
#define FITSquatExerciseNameOverheadDumbbellSquat                                ((FITSquatExerciseName)43)
#define FITSquatExerciseNameOverheadSquat                                        ((FITSquatExerciseName)44)
#define FITSquatExerciseNamePartialSingleLegSquat                                ((FITSquatExerciseName)45)
#define FITSquatExerciseNameWeightedPartialSingleLegSquat                        ((FITSquatExerciseName)46)
#define FITSquatExerciseNamePistolSquat                                          ((FITSquatExerciseName)47)
#define FITSquatExerciseNameWeightedPistolSquat                                  ((FITSquatExerciseName)48)
#define FITSquatExerciseNamePlieSlides                                           ((FITSquatExerciseName)49)
#define FITSquatExerciseNameWeightedPlieSlides                                   ((FITSquatExerciseName)50)
#define FITSquatExerciseNamePlieSquat                                            ((FITSquatExerciseName)51)
#define FITSquatExerciseNameWeightedPlieSquat                                    ((FITSquatExerciseName)52)
#define FITSquatExerciseNamePrisonerSquat                                        ((FITSquatExerciseName)53)
#define FITSquatExerciseNameWeightedPrisonerSquat                                ((FITSquatExerciseName)54)
#define FITSquatExerciseNameSingleLegBenchGetUp                                  ((FITSquatExerciseName)55)
#define FITSquatExerciseNameWeightedSingleLegBenchGetUp                          ((FITSquatExerciseName)56)
#define FITSquatExerciseNameSingleLegBenchSquat                                  ((FITSquatExerciseName)57)
#define FITSquatExerciseNameWeightedSingleLegBenchSquat                          ((FITSquatExerciseName)58)
#define FITSquatExerciseNameSingleLegSquatOnSwissBall                            ((FITSquatExerciseName)59)
#define FITSquatExerciseNameWeightedSingleLegSquatOnSwissBall                    ((FITSquatExerciseName)60)
#define FITSquatExerciseNameSquat                                                ((FITSquatExerciseName)61)
#define FITSquatExerciseNameWeightedSquat                                        ((FITSquatExerciseName)62)
#define FITSquatExerciseNameSquatsWithBand                                       ((FITSquatExerciseName)63)
#define FITSquatExerciseNameStaggeredSquat                                       ((FITSquatExerciseName)64)
#define FITSquatExerciseNameWeightedStaggeredSquat                               ((FITSquatExerciseName)65)
#define FITSquatExerciseNameStepUp                                               ((FITSquatExerciseName)66)
#define FITSquatExerciseNameWeightedStepUp                                       ((FITSquatExerciseName)67)
#define FITSquatExerciseNameSuitcaseSquats                                       ((FITSquatExerciseName)68)
#define FITSquatExerciseNameSumoSquat                                            ((FITSquatExerciseName)69)
#define FITSquatExerciseNameSumoSquatSlideIn                                     ((FITSquatExerciseName)70)
#define FITSquatExerciseNameWeightedSumoSquatSlideIn                             ((FITSquatExerciseName)71)
#define FITSquatExerciseNameSumoSquatToHighPull                                  ((FITSquatExerciseName)72)
#define FITSquatExerciseNameSumoSquatToStand                                     ((FITSquatExerciseName)73)
#define FITSquatExerciseNameWeightedSumoSquatToStand                             ((FITSquatExerciseName)74)
#define FITSquatExerciseNameSumoSquatWithRotation                                ((FITSquatExerciseName)75)
#define FITSquatExerciseNameWeightedSumoSquatWithRotation                        ((FITSquatExerciseName)76)
#define FITSquatExerciseNameSwissBallBodyWeightWallSquat                         ((FITSquatExerciseName)77)
#define FITSquatExerciseNameWeightedSwissBallWallSquat                           ((FITSquatExerciseName)78)
#define FITSquatExerciseNameThrusters                                            ((FITSquatExerciseName)79)
#define FITSquatExerciseNameUnevenSquat                                          ((FITSquatExerciseName)80)
#define FITSquatExerciseNameWeightedUnevenSquat                                  ((FITSquatExerciseName)81)
#define FITSquatExerciseNameWaistSlimmingSquat                                   ((FITSquatExerciseName)82)
#define FITSquatExerciseNameWallBall                                             ((FITSquatExerciseName)83)
#define FITSquatExerciseNameWideStanceBarbellSquat                               ((FITSquatExerciseName)84)
#define FITSquatExerciseNameWideStanceGobletSquat                                ((FITSquatExerciseName)85)
#define FITSquatExerciseNameZercherSquat                                         ((FITSquatExerciseName)86)
#define FITSquatExerciseNameKbsOverhead                                          ((FITSquatExerciseName)87) // Deprecated do not use
#define FITSquatExerciseNameSquatAndSideKick                                     ((FITSquatExerciseName)88)
#define FITSquatExerciseNameSquatJumpsInNOut                                     ((FITSquatExerciseName)89)
#define FITSquatExerciseNamePilatesPlieSquatsParallelTurnedOutFlatAndHeels       ((FITSquatExerciseName)90)
#define FITSquatExerciseNameReleveStraightLegAndKneeBentWithOneLegVariation      ((FITSquatExerciseName)91)
#define FITSquatExerciseNameCount                                                92

typedef FITUInt16 FITTotalBodyExerciseName;
#define FITTotalBodyExerciseNameInvalid                                          FITUInt16Invalid
#define FITTotalBodyExerciseNameBurpee                                           ((FITTotalBodyExerciseName)0)
#define FITTotalBodyExerciseNameWeightedBurpee                                   ((FITTotalBodyExerciseName)1)
#define FITTotalBodyExerciseNameBurpeeBoxJump                                    ((FITTotalBodyExerciseName)2)
#define FITTotalBodyExerciseNameWeightedBurpeeBoxJump                            ((FITTotalBodyExerciseName)3)
#define FITTotalBodyExerciseNameHighPullBurpee                                   ((FITTotalBodyExerciseName)4)
#define FITTotalBodyExerciseNameManMakers                                        ((FITTotalBodyExerciseName)5)
#define FITTotalBodyExerciseNameOneArmBurpee                                     ((FITTotalBodyExerciseName)6)
#define FITTotalBodyExerciseNameSquatThrusts                                     ((FITTotalBodyExerciseName)7)
#define FITTotalBodyExerciseNameWeightedSquatThrusts                             ((FITTotalBodyExerciseName)8)
#define FITTotalBodyExerciseNameSquatPlankPushUp                                 ((FITTotalBodyExerciseName)9)
#define FITTotalBodyExerciseNameWeightedSquatPlankPushUp                         ((FITTotalBodyExerciseName)10)
#define FITTotalBodyExerciseNameStandingTRotationBalance                         ((FITTotalBodyExerciseName)11)
#define FITTotalBodyExerciseNameWeightedStandingTRotationBalance                 ((FITTotalBodyExerciseName)12)
#define FITTotalBodyExerciseNameCount                                            13

typedef FITUInt16 FITTricepsExtensionExerciseName;
#define FITTricepsExtensionExerciseNameInvalid                                   FITUInt16Invalid
#define FITTricepsExtensionExerciseNameBenchDip                                  ((FITTricepsExtensionExerciseName)0)
#define FITTricepsExtensionExerciseNameWeightedBenchDip                          ((FITTricepsExtensionExerciseName)1)
#define FITTricepsExtensionExerciseNameBodyWeightDip                             ((FITTricepsExtensionExerciseName)2)
#define FITTricepsExtensionExerciseNameCableKickback                             ((FITTricepsExtensionExerciseName)3)
#define FITTricepsExtensionExerciseNameCableLyingTricepsExtension                ((FITTricepsExtensionExerciseName)4)
#define FITTricepsExtensionExerciseNameCableOverheadTricepsExtension             ((FITTricepsExtensionExerciseName)5)
#define FITTricepsExtensionExerciseNameDumbbellKickback                          ((FITTricepsExtensionExerciseName)6)
#define FITTricepsExtensionExerciseNameDumbbellLyingTricepsExtension             ((FITTricepsExtensionExerciseName)7)
#define FITTricepsExtensionExerciseNameEzBarOverheadTricepsExtension             ((FITTricepsExtensionExerciseName)8)
#define FITTricepsExtensionExerciseNameInclineDip                                ((FITTricepsExtensionExerciseName)9)
#define FITTricepsExtensionExerciseNameWeightedInclineDip                        ((FITTricepsExtensionExerciseName)10)
#define FITTricepsExtensionExerciseNameInclineEzBarLyingTricepsExtension         ((FITTricepsExtensionExerciseName)11)
#define FITTricepsExtensionExerciseNameLyingDumbbellPulloverToExtension          ((FITTricepsExtensionExerciseName)12)
#define FITTricepsExtensionExerciseNameLyingEzBarTricepsExtension                ((FITTricepsExtensionExerciseName)13)
#define FITTricepsExtensionExerciseNameLyingTricepsExtensionToCloseGripBenchPress ((FITTricepsExtensionExerciseName)14)
#define FITTricepsExtensionExerciseNameOverheadDumbbellTricepsExtension          ((FITTricepsExtensionExerciseName)15)
#define FITTricepsExtensionExerciseNameRecliningTricepsPress                     ((FITTricepsExtensionExerciseName)16)
#define FITTricepsExtensionExerciseNameReverseGripPressdown                      ((FITTricepsExtensionExerciseName)17)
#define FITTricepsExtensionExerciseNameReverseGripTricepsPressdown               ((FITTricepsExtensionExerciseName)18)
#define FITTricepsExtensionExerciseNameRopePressdown                             ((FITTricepsExtensionExerciseName)19)
#define FITTricepsExtensionExerciseNameSeatedBarbellOverheadTricepsExtension     ((FITTricepsExtensionExerciseName)20)
#define FITTricepsExtensionExerciseNameSeatedDumbbellOverheadTricepsExtension    ((FITTricepsExtensionExerciseName)21)
#define FITTricepsExtensionExerciseNameSeatedEzBarOverheadTricepsExtension       ((FITTricepsExtensionExerciseName)22)
#define FITTricepsExtensionExerciseNameSeatedSingleArmOverheadDumbbellExtension  ((FITTricepsExtensionExerciseName)23)
#define FITTricepsExtensionExerciseNameSingleArmDumbbellOverheadTricepsExtension ((FITTricepsExtensionExerciseName)24)
#define FITTricepsExtensionExerciseNameSingleDumbbellSeatedOverheadTricepsExtension ((FITTricepsExtensionExerciseName)25)
#define FITTricepsExtensionExerciseNameSingleLegBenchDipAndKick                  ((FITTricepsExtensionExerciseName)26)
#define FITTricepsExtensionExerciseNameWeightedSingleLegBenchDipAndKick          ((FITTricepsExtensionExerciseName)27)
#define FITTricepsExtensionExerciseNameSingleLegDip                              ((FITTricepsExtensionExerciseName)28)
#define FITTricepsExtensionExerciseNameWeightedSingleLegDip                      ((FITTricepsExtensionExerciseName)29)
#define FITTricepsExtensionExerciseNameStaticLyingTricepsExtension               ((FITTricepsExtensionExerciseName)30)
#define FITTricepsExtensionExerciseNameSuspendedDip                              ((FITTricepsExtensionExerciseName)31)
#define FITTricepsExtensionExerciseNameWeightedSuspendedDip                      ((FITTricepsExtensionExerciseName)32)
#define FITTricepsExtensionExerciseNameSwissBallDumbbellLyingTricepsExtension    ((FITTricepsExtensionExerciseName)33)
#define FITTricepsExtensionExerciseNameSwissBallEzBarLyingTricepsExtension       ((FITTricepsExtensionExerciseName)34)
#define FITTricepsExtensionExerciseNameSwissBallEzBarOverheadTricepsExtension    ((FITTricepsExtensionExerciseName)35)
#define FITTricepsExtensionExerciseNameTabletopDip                               ((FITTricepsExtensionExerciseName)36)
#define FITTricepsExtensionExerciseNameWeightedTabletopDip                       ((FITTricepsExtensionExerciseName)37)
#define FITTricepsExtensionExerciseNameTricepsExtensionOnFloor                   ((FITTricepsExtensionExerciseName)38)
#define FITTricepsExtensionExerciseNameTricepsPressdown                          ((FITTricepsExtensionExerciseName)39)
#define FITTricepsExtensionExerciseNameWeightedDip                               ((FITTricepsExtensionExerciseName)40)
#define FITTricepsExtensionExerciseNameCount                                     41

typedef FITUInt16 FITWarmUpExerciseName;
#define FITWarmUpExerciseNameInvalid                                             FITUInt16Invalid
#define FITWarmUpExerciseNameQuadrupedRocking                                    ((FITWarmUpExerciseName)0)
#define FITWarmUpExerciseNameNeckTilts                                           ((FITWarmUpExerciseName)1)
#define FITWarmUpExerciseNameAnkleCircles                                        ((FITWarmUpExerciseName)2)
#define FITWarmUpExerciseNameAnkleDorsiflexionWithBand                           ((FITWarmUpExerciseName)3)
#define FITWarmUpExerciseNameAnkleInternalRotation                               ((FITWarmUpExerciseName)4)
#define FITWarmUpExerciseNameArmCircles                                          ((FITWarmUpExerciseName)5)
#define FITWarmUpExerciseNameBentOverReachToSky                                  ((FITWarmUpExerciseName)6)
#define FITWarmUpExerciseNameCatCamel                                            ((FITWarmUpExerciseName)7)
#define FITWarmUpExerciseNameElbowToFootLunge                                    ((FITWarmUpExerciseName)8)
#define FITWarmUpExerciseNameForwardAndBackwardLegSwings                         ((FITWarmUpExerciseName)9)
#define FITWarmUpExerciseNameGroiners                                            ((FITWarmUpExerciseName)10)
#define FITWarmUpExerciseNameInvertedHamstringStretch                            ((FITWarmUpExerciseName)11)
#define FITWarmUpExerciseNameLateralDuckUnder                                    ((FITWarmUpExerciseName)12)
#define FITWarmUpExerciseNameNeckRotations                                       ((FITWarmUpExerciseName)13)
#define FITWarmUpExerciseNameOppositeArmAndLegBalance                            ((FITWarmUpExerciseName)14)
#define FITWarmUpExerciseNameReachRollAndLift                                    ((FITWarmUpExerciseName)15)
#define FITWarmUpExerciseNameScorpion                                            ((FITWarmUpExerciseName)16) // Deprecated do not use
#define FITWarmUpExerciseNameShoulderCircles                                     ((FITWarmUpExerciseName)17)
#define FITWarmUpExerciseNameSideToSideLegSwings                                 ((FITWarmUpExerciseName)18)
#define FITWarmUpExerciseNameSleeperStretch                                      ((FITWarmUpExerciseName)19)
#define FITWarmUpExerciseNameSlideOut                                            ((FITWarmUpExerciseName)20)
#define FITWarmUpExerciseNameSwissBallHipCrossover                               ((FITWarmUpExerciseName)21)
#define FITWarmUpExerciseNameSwissBallReachRollAndLift                           ((FITWarmUpExerciseName)22)
#define FITWarmUpExerciseNameSwissBallWindshieldWipers                           ((FITWarmUpExerciseName)23)
#define FITWarmUpExerciseNameThoracicRotation                                    ((FITWarmUpExerciseName)24)
#define FITWarmUpExerciseNameWalkingHighKicks                                    ((FITWarmUpExerciseName)25)
#define FITWarmUpExerciseNameWalkingHighKnees                                    ((FITWarmUpExerciseName)26)
#define FITWarmUpExerciseNameWalkingKneeHugs                                     ((FITWarmUpExerciseName)27)
#define FITWarmUpExerciseNameWalkingLegCradles                                   ((FITWarmUpExerciseName)28)
#define FITWarmUpExerciseNameWalkout                                             ((FITWarmUpExerciseName)29)
#define FITWarmUpExerciseNameWalkoutFromPushUpPosition                           ((FITWarmUpExerciseName)30)
#define FITWarmUpExerciseNameCount                                               31

typedef FITUInt16 FITRunExerciseName;
#define FITRunExerciseNameInvalid                                                FITUInt16Invalid
#define FITRunExerciseNameRun                                                    ((FITRunExerciseName)0)
#define FITRunExerciseNameWalk                                                   ((FITRunExerciseName)1)
#define FITRunExerciseNameJog                                                    ((FITRunExerciseName)2)
#define FITRunExerciseNameSprint                                                 ((FITRunExerciseName)3)
#define FITRunExerciseNameCount                                                  4

typedef FITEnum FITWaterType;
#define FITWaterTypeInvalid                                                      FITEnumInvalid
#define FITWaterTypeFresh                                                        ((FITWaterType)0)
#define FITWaterTypeSalt                                                         ((FITWaterType)1)
#define FITWaterTypeEn13319                                                      ((FITWaterType)2)
#define FITWaterTypeCustom                                                       ((FITWaterType)3)
#define FITWaterTypeCount                                                        4

typedef FITEnum FITTissueModelType;
#define FITTissueModelTypeInvalid                                                FITEnumInvalid
#define FITTissueModelTypeZhl16c                                                 ((FITTissueModelType)0) // Buhlmann's decompression algorithm, version C
#define FITTissueModelTypeCount                                                  1

typedef FITEnum FITDiveGasStatus;
#define FITDiveGasStatusInvalid                                                  FITEnumInvalid
#define FITDiveGasStatusDisabled                                                 ((FITDiveGasStatus)0)
#define FITDiveGasStatusEnabled                                                  ((FITDiveGasStatus)1)
#define FITDiveGasStatusBackupOnly                                               ((FITDiveGasStatus)2)
#define FITDiveGasStatusCount                                                    3

typedef FITEnum FITDiveAlarmType;
#define FITDiveAlarmTypeInvalid                                                  FITEnumInvalid
#define FITDiveAlarmTypeDepth                                                    ((FITDiveAlarmType)0) // Alarm when a certain depth is crossed
#define FITDiveAlarmTypeTime                                                     ((FITDiveAlarmType)1) // Alarm when a certain time has transpired
#define FITDiveAlarmTypeCount                                                    2

typedef FITEnum FITDiveBacklightMode;
#define FITDiveBacklightModeInvalid                                              FITEnumInvalid
#define FITDiveBacklightModeAtDepth                                              ((FITDiveBacklightMode)0)
#define FITDiveBacklightModeAlwaysOn                                             ((FITDiveBacklightMode)1)
#define FITDiveBacklightModeCount                                                2

typedef FITUInt16 FITFaveroProduct;
#define FITFaveroProductInvalid                                                  FITUInt16Invalid
#define FITFaveroProductAssiomaUno                                               ((FITFaveroProduct)10)
#define FITFaveroProductAssiomaDuo                                               ((FITFaveroProduct)12)
#define FITFaveroProductCount                                                    2

typedef FITEnum FITSplitType;
#define FITSplitTypeInvalid                                                      FITEnumInvalid
#define FITSplitTypeAscentSplit                                                  ((FITSplitType)1)
#define FITSplitTypeDescentSplit                                                 ((FITSplitType)2)
#define FITSplitTypeIntervalActive                                               ((FITSplitType)3)
#define FITSplitTypeIntervalRest                                                 ((FITSplitType)4)
#define FITSplitTypeIntervalWarmup                                               ((FITSplitType)5)
#define FITSplitTypeIntervalCooldown                                             ((FITSplitType)6)
#define FITSplitTypeIntervalRecovery                                             ((FITSplitType)7)
#define FITSplitTypeIntervalOther                                                ((FITSplitType)8)
#define FITSplitTypeClimbActive                                                  ((FITSplitType)9)
#define FITSplitTypeClimbRest                                                    ((FITSplitType)10)
#define FITSplitTypeSurfActive                                                   ((FITSplitType)11)
#define FITSplitTypeRunActive                                                    ((FITSplitType)12)
#define FITSplitTypeRunRest                                                      ((FITSplitType)13)
#define FITSplitTypeWorkoutRound                                                 ((FITSplitType)14)
#define FITSplitTypeRwdRun                                                       ((FITSplitType)17) // run/walk detection running
#define FITSplitTypeRwdWalk                                                      ((FITSplitType)18) // run/walk detection walking
#define FITSplitTypeWindsurfActive                                               ((FITSplitType)21)
#define FITSplitTypeRwdStand                                                     ((FITSplitType)22) // run/walk detection standing
#define FITSplitTypeTransition                                                   ((FITSplitType)23) // Marks the time going from ascent_split to descent_split/used in backcountry ski
#define FITSplitTypeSkiLiftSplit                                                 ((FITSplitType)28)
#define FITSplitTypeSkiRunSplit                                                  ((FITSplitType)29)
#define FITSplitTypeCount                                                        21

typedef FITEnum FITClimbProEvent;
#define FITClimbProEventInvalid                                                  FITEnumInvalid
#define FITClimbProEventApproach                                                 ((FITClimbProEvent)0)
#define FITClimbProEventStart                                                    ((FITClimbProEvent)1)
#define FITClimbProEventComplete                                                 ((FITClimbProEvent)2)
#define FITClimbProEventCount                                                    3

typedef FITEnum FITTapSensitivity;
#define FITTapSensitivityInvalid                                                 FITEnumInvalid
#define FITTapSensitivityHigh                                                    ((FITTapSensitivity)0)
#define FITTapSensitivityMedium                                                  ((FITTapSensitivity)1)
#define FITTapSensitivityLow                                                     ((FITTapSensitivity)2)
#define FITTapSensitivityCount                                                   3

typedef FITEnum FITRadarThreatLevelType;
#define FITRadarThreatLevelTypeInvalid                                           FITEnumInvalid
#define FITRadarThreatLevelTypeThreatUnknown                                     ((FITRadarThreatLevelType)0)
#define FITRadarThreatLevelTypeThreatNone                                        ((FITRadarThreatLevelType)1)
#define FITRadarThreatLevelTypeThreatApproaching                                 ((FITRadarThreatLevelType)2)
#define FITRadarThreatLevelTypeThreatApproachingFast                             ((FITRadarThreatLevelType)3)
#define FITRadarThreatLevelTypeCount                                             4


// Message Field Definition Numbers 
// FileIdMesg Field Definition Numbers
typedef enum FITFileIdMesgFieldDefNum : uint8_t {
    FITFileIdMesgFieldDefNumType = 0, 
    FITFileIdMesgFieldDefNumManufacturer = 1, 
    FITFileIdMesgFieldDefNumProduct = 2, 
    FITFileIdMesgFieldDefNumSerialNumber = 3, 
    FITFileIdMesgFieldDefNumTimeCreated = 4, 
    FITFileIdMesgFieldDefNumNumber = 5, 
    FITFileIdMesgFieldDefNumProductName = 8, 
} FITFileIdMesgFieldDefNum;

typedef enum FITFileIdMesgProductField : uint8_t {
    FITFileIdMesgProductFieldFaveroProductSubField,
    FITFileIdMesgProductFieldGarminProductSubField,
} FITFileIdMesgProductField;

// FileCreatorMesg Field Definition Numbers
typedef enum FITFileCreatorMesgFieldDefNum : uint8_t {
    FITFileCreatorMesgFieldDefNumSoftwareVersion = 0, 
    FITFileCreatorMesgFieldDefNumHardwareVersion = 1, 
} FITFileCreatorMesgFieldDefNum;

// TimestampCorrelationMesg Field Definition Numbers
typedef enum FITTimestampCorrelationMesgFieldDefNum : uint8_t {
    FITTimestampCorrelationMesgFieldDefNumTimestamp = 253, 
    FITTimestampCorrelationMesgFieldDefNumFractionalTimestamp = 0, 
    FITTimestampCorrelationMesgFieldDefNumSystemTimestamp = 1, 
    FITTimestampCorrelationMesgFieldDefNumFractionalSystemTimestamp = 2, 
    FITTimestampCorrelationMesgFieldDefNumLocalTimestamp = 3, 
    FITTimestampCorrelationMesgFieldDefNumTimestampMs = 4, 
    FITTimestampCorrelationMesgFieldDefNumSystemTimestampMs = 5, 
} FITTimestampCorrelationMesgFieldDefNum;

// SoftwareMesg Field Definition Numbers
typedef enum FITSoftwareMesgFieldDefNum : uint8_t {
    FITSoftwareMesgFieldDefNumMessageIndex = 254, 
    FITSoftwareMesgFieldDefNumVersion = 3, 
    FITSoftwareMesgFieldDefNumPartNumber = 5, 
} FITSoftwareMesgFieldDefNum;

// SlaveDeviceMesg Field Definition Numbers
typedef enum FITSlaveDeviceMesgFieldDefNum : uint8_t {
    FITSlaveDeviceMesgFieldDefNumManufacturer = 0, 
    FITSlaveDeviceMesgFieldDefNumProduct = 1, 
} FITSlaveDeviceMesgFieldDefNum;

typedef enum FITSlaveDeviceMesgProductField : uint8_t {
    FITSlaveDeviceMesgProductFieldFaveroProductSubField,
    FITSlaveDeviceMesgProductFieldGarminProductSubField,
} FITSlaveDeviceMesgProductField;

// CapabilitiesMesg Field Definition Numbers
typedef enum FITCapabilitiesMesgFieldDefNum : uint8_t {
    FITCapabilitiesMesgFieldDefNumLanguages = 0, 
    FITCapabilitiesMesgFieldDefNumSports = 1, 
    FITCapabilitiesMesgFieldDefNumWorkoutsSupported = 21, 
    FITCapabilitiesMesgFieldDefNumConnectivitySupported = 23, 
} FITCapabilitiesMesgFieldDefNum;

// FileCapabilitiesMesg Field Definition Numbers
typedef enum FITFileCapabilitiesMesgFieldDefNum : uint8_t {
    FITFileCapabilitiesMesgFieldDefNumMessageIndex = 254, 
    FITFileCapabilitiesMesgFieldDefNumType = 0, 
    FITFileCapabilitiesMesgFieldDefNumFlags = 1, 
    FITFileCapabilitiesMesgFieldDefNumDirectory = 2, 
    FITFileCapabilitiesMesgFieldDefNumMaxCount = 3, 
    FITFileCapabilitiesMesgFieldDefNumMaxSize = 4, 
} FITFileCapabilitiesMesgFieldDefNum;

// MesgCapabilitiesMesg Field Definition Numbers
typedef enum FITMesgCapabilitiesMesgFieldDefNum : uint8_t {
    FITMesgCapabilitiesMesgFieldDefNumMessageIndex = 254, 
    FITMesgCapabilitiesMesgFieldDefNumFile = 0, 
    FITMesgCapabilitiesMesgFieldDefNumMesgNum = 1, 
    FITMesgCapabilitiesMesgFieldDefNumCountType = 2, 
    FITMesgCapabilitiesMesgFieldDefNumCount = 3, 
} FITMesgCapabilitiesMesgFieldDefNum;

typedef enum FITMesgCapabilitiesMesgCountField : uint8_t {
    FITMesgCapabilitiesMesgCountFieldNumPerFileSubField,
    FITMesgCapabilitiesMesgCountFieldMaxPerFileSubField,
    FITMesgCapabilitiesMesgCountFieldMaxPerFileTypeSubField,
} FITMesgCapabilitiesMesgCountField;

// FieldCapabilitiesMesg Field Definition Numbers
typedef enum FITFieldCapabilitiesMesgFieldDefNum : uint8_t {
    FITFieldCapabilitiesMesgFieldDefNumMessageIndex = 254, 
    FITFieldCapabilitiesMesgFieldDefNumFile = 0, 
    FITFieldCapabilitiesMesgFieldDefNumMesgNum = 1, 
    FITFieldCapabilitiesMesgFieldDefNumFieldNum = 2, 
    FITFieldCapabilitiesMesgFieldDefNumCount = 3, 
} FITFieldCapabilitiesMesgFieldDefNum;

// DeviceSettingsMesg Field Definition Numbers
typedef enum FITDeviceSettingsMesgFieldDefNum : uint8_t {
    FITDeviceSettingsMesgFieldDefNumActiveTimeZone = 0, 
    FITDeviceSettingsMesgFieldDefNumUtcOffset = 1, 
    FITDeviceSettingsMesgFieldDefNumTimeOffset = 2, 
    FITDeviceSettingsMesgFieldDefNumTimeMode = 4, 
    FITDeviceSettingsMesgFieldDefNumTimeZoneOffset = 5, 
    FITDeviceSettingsMesgFieldDefNumBacklightMode = 12, 
    FITDeviceSettingsMesgFieldDefNumActivityTrackerEnabled = 36, 
    FITDeviceSettingsMesgFieldDefNumClockTime = 39, 
    FITDeviceSettingsMesgFieldDefNumPagesEnabled = 40, 
    FITDeviceSettingsMesgFieldDefNumMoveAlertEnabled = 46, 
    FITDeviceSettingsMesgFieldDefNumDateMode = 47, 
    FITDeviceSettingsMesgFieldDefNumDisplayOrientation = 55, 
    FITDeviceSettingsMesgFieldDefNumMountingSide = 56, 
    FITDeviceSettingsMesgFieldDefNumDefaultPage = 57, 
    FITDeviceSettingsMesgFieldDefNumAutosyncMinSteps = 58, 
    FITDeviceSettingsMesgFieldDefNumAutosyncMinTime = 59, 
    FITDeviceSettingsMesgFieldDefNumLactateThresholdAutodetectEnabled = 80, 
    FITDeviceSettingsMesgFieldDefNumBleAutoUploadEnabled = 86, 
    FITDeviceSettingsMesgFieldDefNumAutoSyncFrequency = 89, 
    FITDeviceSettingsMesgFieldDefNumAutoActivityDetect = 90, 
    FITDeviceSettingsMesgFieldDefNumNumberOfScreens = 94, 
    FITDeviceSettingsMesgFieldDefNumSmartNotificationDisplayOrientation = 95, 
    FITDeviceSettingsMesgFieldDefNumTapInterface = 134, 
    FITDeviceSettingsMesgFieldDefNumTapSensitivity = 174, 
} FITDeviceSettingsMesgFieldDefNum;

// UserProfileMesg Field Definition Numbers
typedef enum FITUserProfileMesgFieldDefNum : uint8_t {
    FITUserProfileMesgFieldDefNumMessageIndex = 254, 
    FITUserProfileMesgFieldDefNumFriendlyName = 0, 
    FITUserProfileMesgFieldDefNumGender = 1, 
    FITUserProfileMesgFieldDefNumAge = 2, 
    FITUserProfileMesgFieldDefNumHeight = 3, 
    FITUserProfileMesgFieldDefNumWeight = 4, 
    FITUserProfileMesgFieldDefNumLanguage = 5, 
    FITUserProfileMesgFieldDefNumElevSetting = 6, 
    FITUserProfileMesgFieldDefNumWeightSetting = 7, 
    FITUserProfileMesgFieldDefNumRestingHeartRate = 8, 
    FITUserProfileMesgFieldDefNumDefaultMaxRunningHeartRate = 9, 
    FITUserProfileMesgFieldDefNumDefaultMaxBikingHeartRate = 10, 
    FITUserProfileMesgFieldDefNumDefaultMaxHeartRate = 11, 
    FITUserProfileMesgFieldDefNumHrSetting = 12, 
    FITUserProfileMesgFieldDefNumSpeedSetting = 13, 
    FITUserProfileMesgFieldDefNumDistSetting = 14, 
    FITUserProfileMesgFieldDefNumPowerSetting = 16, 
    FITUserProfileMesgFieldDefNumActivityClass = 17, 
    FITUserProfileMesgFieldDefNumPositionSetting = 18, 
    FITUserProfileMesgFieldDefNumTemperatureSetting = 21, 
    FITUserProfileMesgFieldDefNumLocalId = 22, 
    FITUserProfileMesgFieldDefNumGlobalId = 23, 
    FITUserProfileMesgFieldDefNumWakeTime = 28, 
    FITUserProfileMesgFieldDefNumSleepTime = 29, 
    FITUserProfileMesgFieldDefNumHeightSetting = 30, 
    FITUserProfileMesgFieldDefNumUserRunningStepLength = 31, 
    FITUserProfileMesgFieldDefNumUserWalkingStepLength = 32, 
    FITUserProfileMesgFieldDefNumDepthSetting = 47, 
    FITUserProfileMesgFieldDefNumDiveCount = 49, 
} FITUserProfileMesgFieldDefNum;

// HrmProfileMesg Field Definition Numbers
typedef enum FITHrmProfileMesgFieldDefNum : uint8_t {
    FITHrmProfileMesgFieldDefNumMessageIndex = 254, 
    FITHrmProfileMesgFieldDefNumEnabled = 0, 
    FITHrmProfileMesgFieldDefNumHrmAntId = 1, 
    FITHrmProfileMesgFieldDefNumLogHrv = 2, 
    FITHrmProfileMesgFieldDefNumHrmAntIdTransType = 3, 
} FITHrmProfileMesgFieldDefNum;

// SdmProfileMesg Field Definition Numbers
typedef enum FITSdmProfileMesgFieldDefNum : uint8_t {
    FITSdmProfileMesgFieldDefNumMessageIndex = 254, 
    FITSdmProfileMesgFieldDefNumEnabled = 0, 
    FITSdmProfileMesgFieldDefNumSdmAntId = 1, 
    FITSdmProfileMesgFieldDefNumSdmCalFactor = 2, 
    FITSdmProfileMesgFieldDefNumOdometer = 3, 
    FITSdmProfileMesgFieldDefNumSpeedSource = 4, 
    FITSdmProfileMesgFieldDefNumSdmAntIdTransType = 5, 
    FITSdmProfileMesgFieldDefNumOdometerRollover = 7, 
} FITSdmProfileMesgFieldDefNum;

// BikeProfileMesg Field Definition Numbers
typedef enum FITBikeProfileMesgFieldDefNum : uint8_t {
    FITBikeProfileMesgFieldDefNumMessageIndex = 254, 
    FITBikeProfileMesgFieldDefNumName = 0, 
    FITBikeProfileMesgFieldDefNumSport = 1, 
    FITBikeProfileMesgFieldDefNumSubSport = 2, 
    FITBikeProfileMesgFieldDefNumOdometer = 3, 
    FITBikeProfileMesgFieldDefNumBikeSpdAntId = 4, 
    FITBikeProfileMesgFieldDefNumBikeCadAntId = 5, 
    FITBikeProfileMesgFieldDefNumBikeSpdcadAntId = 6, 
    FITBikeProfileMesgFieldDefNumBikePowerAntId = 7, 
    FITBikeProfileMesgFieldDefNumCustomWheelsize = 8, 
    FITBikeProfileMesgFieldDefNumAutoWheelsize = 9, 
    FITBikeProfileMesgFieldDefNumBikeWeight = 10, 
    FITBikeProfileMesgFieldDefNumPowerCalFactor = 11, 
    FITBikeProfileMesgFieldDefNumAutoWheelCal = 12, 
    FITBikeProfileMesgFieldDefNumAutoPowerZero = 13, 
    FITBikeProfileMesgFieldDefNumId = 14, 
    FITBikeProfileMesgFieldDefNumSpdEnabled = 15, 
    FITBikeProfileMesgFieldDefNumCadEnabled = 16, 
    FITBikeProfileMesgFieldDefNumSpdcadEnabled = 17, 
    FITBikeProfileMesgFieldDefNumPowerEnabled = 18, 
    FITBikeProfileMesgFieldDefNumCrankLength = 19, 
    FITBikeProfileMesgFieldDefNumEnabled = 20, 
    FITBikeProfileMesgFieldDefNumBikeSpdAntIdTransType = 21, 
    FITBikeProfileMesgFieldDefNumBikeCadAntIdTransType = 22, 
    FITBikeProfileMesgFieldDefNumBikeSpdcadAntIdTransType = 23, 
    FITBikeProfileMesgFieldDefNumBikePowerAntIdTransType = 24, 
    FITBikeProfileMesgFieldDefNumOdometerRollover = 37, 
    FITBikeProfileMesgFieldDefNumFrontGearNum = 38, 
    FITBikeProfileMesgFieldDefNumFrontGear = 39, 
    FITBikeProfileMesgFieldDefNumRearGearNum = 40, 
    FITBikeProfileMesgFieldDefNumRearGear = 41, 
    FITBikeProfileMesgFieldDefNumShimanoDi2Enabled = 44, 
} FITBikeProfileMesgFieldDefNum;

// ConnectivityMesg Field Definition Numbers
typedef enum FITConnectivityMesgFieldDefNum : uint8_t {
    FITConnectivityMesgFieldDefNumBluetoothEnabled = 0, 
    FITConnectivityMesgFieldDefNumBluetoothLeEnabled = 1, 
    FITConnectivityMesgFieldDefNumAntEnabled = 2, 
    FITConnectivityMesgFieldDefNumName = 3, 
    FITConnectivityMesgFieldDefNumLiveTrackingEnabled = 4, 
    FITConnectivityMesgFieldDefNumWeatherConditionsEnabled = 5, 
    FITConnectivityMesgFieldDefNumWeatherAlertsEnabled = 6, 
    FITConnectivityMesgFieldDefNumAutoActivityUploadEnabled = 7, 
    FITConnectivityMesgFieldDefNumCourseDownloadEnabled = 8, 
    FITConnectivityMesgFieldDefNumWorkoutDownloadEnabled = 9, 
    FITConnectivityMesgFieldDefNumGpsEphemerisDownloadEnabled = 10, 
    FITConnectivityMesgFieldDefNumIncidentDetectionEnabled = 11, 
    FITConnectivityMesgFieldDefNumGrouptrackEnabled = 12, 
} FITConnectivityMesgFieldDefNum;

// WatchfaceSettingsMesg Field Definition Numbers
typedef enum FITWatchfaceSettingsMesgFieldDefNum : uint8_t {
    FITWatchfaceSettingsMesgFieldDefNumMessageIndex = 254, 
    FITWatchfaceSettingsMesgFieldDefNumMode = 0, 
    FITWatchfaceSettingsMesgFieldDefNumLayout = 1, 
} FITWatchfaceSettingsMesgFieldDefNum;

typedef enum FITWatchfaceSettingsMesgLayoutField : uint8_t {
    FITWatchfaceSettingsMesgLayoutFieldDigitalLayoutSubField,
    FITWatchfaceSettingsMesgLayoutFieldAnalogLayoutSubField,
} FITWatchfaceSettingsMesgLayoutField;

// OhrSettingsMesg Field Definition Numbers
typedef enum FITOhrSettingsMesgFieldDefNum : uint8_t {
    FITOhrSettingsMesgFieldDefNumTimestamp = 253, 
    FITOhrSettingsMesgFieldDefNumEnabled = 0, 
} FITOhrSettingsMesgFieldDefNum;

// TimeInZoneMesg Field Definition Numbers
typedef enum FITTimeInZoneMesgFieldDefNum : uint8_t {
    FITTimeInZoneMesgFieldDefNumTimestamp = 253, 
    FITTimeInZoneMesgFieldDefNumReferenceMesg = 0, 
    FITTimeInZoneMesgFieldDefNumReferenceIndex = 1, 
    FITTimeInZoneMesgFieldDefNumTimeInHrZone = 2, 
    FITTimeInZoneMesgFieldDefNumTimeInSpeedZone = 3, 
    FITTimeInZoneMesgFieldDefNumTimeInCadenceZone = 4, 
    FITTimeInZoneMesgFieldDefNumTimeInPowerZone = 5, 
    FITTimeInZoneMesgFieldDefNumHrZoneHighBoundary = 6, 
    FITTimeInZoneMesgFieldDefNumSpeedZoneHighBoundary = 7, 
    FITTimeInZoneMesgFieldDefNumCadenceZoneHighBondary = 8, 
    FITTimeInZoneMesgFieldDefNumPowerZoneHighBoundary = 9, 
    FITTimeInZoneMesgFieldDefNumHrCalcType = 10, 
    FITTimeInZoneMesgFieldDefNumMaxHeartRate = 11, 
    FITTimeInZoneMesgFieldDefNumRestingHeartRate = 12, 
    FITTimeInZoneMesgFieldDefNumThresholdHeartRate = 13, 
    FITTimeInZoneMesgFieldDefNumPwrCalcType = 14, 
    FITTimeInZoneMesgFieldDefNumFunctionalThresholdPower = 15, 
} FITTimeInZoneMesgFieldDefNum;

// ZonesTargetMesg Field Definition Numbers
typedef enum FITZonesTargetMesgFieldDefNum : uint8_t {
    FITZonesTargetMesgFieldDefNumMaxHeartRate = 1, 
    FITZonesTargetMesgFieldDefNumThresholdHeartRate = 2, 
    FITZonesTargetMesgFieldDefNumFunctionalThresholdPower = 3, 
    FITZonesTargetMesgFieldDefNumHrCalcType = 5, 
    FITZonesTargetMesgFieldDefNumPwrCalcType = 7, 
} FITZonesTargetMesgFieldDefNum;

// SportMesg Field Definition Numbers
typedef enum FITSportMesgFieldDefNum : uint8_t {
    FITSportMesgFieldDefNumSport = 0, 
    FITSportMesgFieldDefNumSubSport = 1, 
    FITSportMesgFieldDefNumName = 3, 
} FITSportMesgFieldDefNum;

// HrZoneMesg Field Definition Numbers
typedef enum FITHrZoneMesgFieldDefNum : uint8_t {
    FITHrZoneMesgFieldDefNumMessageIndex = 254, 
    FITHrZoneMesgFieldDefNumHighBpm = 1, 
    FITHrZoneMesgFieldDefNumName = 2, 
} FITHrZoneMesgFieldDefNum;

// SpeedZoneMesg Field Definition Numbers
typedef enum FITSpeedZoneMesgFieldDefNum : uint8_t {
    FITSpeedZoneMesgFieldDefNumMessageIndex = 254, 
    FITSpeedZoneMesgFieldDefNumHighValue = 0, 
    FITSpeedZoneMesgFieldDefNumName = 1, 
} FITSpeedZoneMesgFieldDefNum;

// CadenceZoneMesg Field Definition Numbers
typedef enum FITCadenceZoneMesgFieldDefNum : uint8_t {
    FITCadenceZoneMesgFieldDefNumMessageIndex = 254, 
    FITCadenceZoneMesgFieldDefNumHighValue = 0, 
    FITCadenceZoneMesgFieldDefNumName = 1, 
} FITCadenceZoneMesgFieldDefNum;

// PowerZoneMesg Field Definition Numbers
typedef enum FITPowerZoneMesgFieldDefNum : uint8_t {
    FITPowerZoneMesgFieldDefNumMessageIndex = 254, 
    FITPowerZoneMesgFieldDefNumHighValue = 1, 
    FITPowerZoneMesgFieldDefNumName = 2, 
} FITPowerZoneMesgFieldDefNum;

// MetZoneMesg Field Definition Numbers
typedef enum FITMetZoneMesgFieldDefNum : uint8_t {
    FITMetZoneMesgFieldDefNumMessageIndex = 254, 
    FITMetZoneMesgFieldDefNumHighBpm = 1, 
    FITMetZoneMesgFieldDefNumCalories = 2, 
    FITMetZoneMesgFieldDefNumFatCalories = 3, 
} FITMetZoneMesgFieldDefNum;

// DiveSettingsMesg Field Definition Numbers
typedef enum FITDiveSettingsMesgFieldDefNum : uint8_t {
    FITDiveSettingsMesgFieldDefNumMessageIndex = 254, 
    FITDiveSettingsMesgFieldDefNumName = 0, 
    FITDiveSettingsMesgFieldDefNumModel = 1, 
    FITDiveSettingsMesgFieldDefNumGfLow = 2, 
    FITDiveSettingsMesgFieldDefNumGfHigh = 3, 
    FITDiveSettingsMesgFieldDefNumWaterType = 4, 
    FITDiveSettingsMesgFieldDefNumWaterDensity = 5, 
    FITDiveSettingsMesgFieldDefNumPo2Warn = 6, 
    FITDiveSettingsMesgFieldDefNumPo2Critical = 7, 
    FITDiveSettingsMesgFieldDefNumPo2Deco = 8, 
    FITDiveSettingsMesgFieldDefNumSafetyStopEnabled = 9, 
    FITDiveSettingsMesgFieldDefNumBottomDepth = 10, 
    FITDiveSettingsMesgFieldDefNumBottomTime = 11, 
    FITDiveSettingsMesgFieldDefNumApneaCountdownEnabled = 12, 
    FITDiveSettingsMesgFieldDefNumApneaCountdownTime = 13, 
    FITDiveSettingsMesgFieldDefNumBacklightMode = 14, 
    FITDiveSettingsMesgFieldDefNumBacklightBrightness = 15, 
    FITDiveSettingsMesgFieldDefNumBacklightTimeout = 16, 
    FITDiveSettingsMesgFieldDefNumRepeatDiveInterval = 17, 
    FITDiveSettingsMesgFieldDefNumSafetyStopTime = 18, 
    FITDiveSettingsMesgFieldDefNumHeartRateSourceType = 19, 
    FITDiveSettingsMesgFieldDefNumHeartRateSource = 20, 
} FITDiveSettingsMesgFieldDefNum;

typedef enum FITDiveSettingsMesgHeartRateSourceField : uint8_t {
    FITDiveSettingsMesgHeartRateSourceFieldHeartRateAntplusDeviceTypeSubField,
    FITDiveSettingsMesgHeartRateSourceFieldHeartRateLocalDeviceTypeSubField,
} FITDiveSettingsMesgHeartRateSourceField;

// DiveAlarmMesg Field Definition Numbers
typedef enum FITDiveAlarmMesgFieldDefNum : uint8_t {
    FITDiveAlarmMesgFieldDefNumMessageIndex = 254, 
    FITDiveAlarmMesgFieldDefNumDepth = 0, 
    FITDiveAlarmMesgFieldDefNumTime = 1, 
    FITDiveAlarmMesgFieldDefNumEnabled = 2, 
    FITDiveAlarmMesgFieldDefNumAlarmType = 3, 
    FITDiveAlarmMesgFieldDefNumSound = 4, 
    FITDiveAlarmMesgFieldDefNumDiveTypes = 5, 
} FITDiveAlarmMesgFieldDefNum;

// DiveGasMesg Field Definition Numbers
typedef enum FITDiveGasMesgFieldDefNum : uint8_t {
    FITDiveGasMesgFieldDefNumMessageIndex = 254, 
    FITDiveGasMesgFieldDefNumHeliumContent = 0, 
    FITDiveGasMesgFieldDefNumOxygenContent = 1, 
    FITDiveGasMesgFieldDefNumStatus = 2, 
} FITDiveGasMesgFieldDefNum;

// GoalMesg Field Definition Numbers
typedef enum FITGoalMesgFieldDefNum : uint8_t {
    FITGoalMesgFieldDefNumMessageIndex = 254, 
    FITGoalMesgFieldDefNumSport = 0, 
    FITGoalMesgFieldDefNumSubSport = 1, 
    FITGoalMesgFieldDefNumStartDate = 2, 
    FITGoalMesgFieldDefNumEndDate = 3, 
    FITGoalMesgFieldDefNumType = 4, 
    FITGoalMesgFieldDefNumValue = 5, 
    FITGoalMesgFieldDefNumRepeat = 6, 
    FITGoalMesgFieldDefNumTargetValue = 7, 
    FITGoalMesgFieldDefNumRecurrence = 8, 
    FITGoalMesgFieldDefNumRecurrenceValue = 9, 
    FITGoalMesgFieldDefNumEnabled = 10, 
    FITGoalMesgFieldDefNumSource = 11, 
} FITGoalMesgFieldDefNum;

// ActivityMesg Field Definition Numbers
typedef enum FITActivityMesgFieldDefNum : uint8_t {
    FITActivityMesgFieldDefNumTimestamp = 253, 
    FITActivityMesgFieldDefNumTotalTimerTime = 0, 
    FITActivityMesgFieldDefNumNumSessions = 1, 
    FITActivityMesgFieldDefNumType = 2, 
    FITActivityMesgFieldDefNumEvent = 3, 
    FITActivityMesgFieldDefNumEventType = 4, 
    FITActivityMesgFieldDefNumLocalTimestamp = 5, 
    FITActivityMesgFieldDefNumEventGroup = 6, 
} FITActivityMesgFieldDefNum;

// SessionMesg Field Definition Numbers
typedef enum FITSessionMesgFieldDefNum : uint8_t {
    FITSessionMesgFieldDefNumMessageIndex = 254, 
    FITSessionMesgFieldDefNumTimestamp = 253, 
    FITSessionMesgFieldDefNumEvent = 0, 
    FITSessionMesgFieldDefNumEventType = 1, 
    FITSessionMesgFieldDefNumStartTime = 2, 
    FITSessionMesgFieldDefNumStartPositionLat = 3, 
    FITSessionMesgFieldDefNumStartPositionLong = 4, 
    FITSessionMesgFieldDefNumSport = 5, 
    FITSessionMesgFieldDefNumSubSport = 6, 
    FITSessionMesgFieldDefNumTotalElapsedTime = 7, 
    FITSessionMesgFieldDefNumTotalTimerTime = 8, 
    FITSessionMesgFieldDefNumTotalDistance = 9, 
    FITSessionMesgFieldDefNumTotalCycles = 10, 
    FITSessionMesgFieldDefNumTotalCalories = 11, 
    FITSessionMesgFieldDefNumTotalFatCalories = 13, 
    FITSessionMesgFieldDefNumAvgSpeed = 14, 
    FITSessionMesgFieldDefNumMaxSpeed = 15, 
    FITSessionMesgFieldDefNumAvgHeartRate = 16, 
    FITSessionMesgFieldDefNumMaxHeartRate = 17, 
    FITSessionMesgFieldDefNumAvgCadence = 18, 
    FITSessionMesgFieldDefNumMaxCadence = 19, 
    FITSessionMesgFieldDefNumAvgPower = 20, 
    FITSessionMesgFieldDefNumMaxPower = 21, 
    FITSessionMesgFieldDefNumTotalAscent = 22, 
    FITSessionMesgFieldDefNumTotalDescent = 23, 
    FITSessionMesgFieldDefNumTotalTrainingEffect = 24, 
    FITSessionMesgFieldDefNumFirstLapIndex = 25, 
    FITSessionMesgFieldDefNumNumLaps = 26, 
    FITSessionMesgFieldDefNumEventGroup = 27, 
    FITSessionMesgFieldDefNumTrigger = 28, 
    FITSessionMesgFieldDefNumNecLat = 29, 
    FITSessionMesgFieldDefNumNecLong = 30, 
    FITSessionMesgFieldDefNumSwcLat = 31, 
    FITSessionMesgFieldDefNumSwcLong = 32, 
    FITSessionMesgFieldDefNumNumLengths = 33, 
    FITSessionMesgFieldDefNumNormalizedPower = 34, 
    FITSessionMesgFieldDefNumTrainingStressScore = 35, 
    FITSessionMesgFieldDefNumIntensityFactor = 36, 
    FITSessionMesgFieldDefNumLeftRightBalance = 37, 
    FITSessionMesgFieldDefNumAvgStrokeCount = 41, 
    FITSessionMesgFieldDefNumAvgStrokeDistance = 42, 
    FITSessionMesgFieldDefNumSwimStroke = 43, 
    FITSessionMesgFieldDefNumPoolLength = 44, 
    FITSessionMesgFieldDefNumThresholdPower = 45, 
    FITSessionMesgFieldDefNumPoolLengthUnit = 46, 
    FITSessionMesgFieldDefNumNumActiveLengths = 47, 
    FITSessionMesgFieldDefNumTotalWork = 48, 
    FITSessionMesgFieldDefNumAvgAltitude = 49, 
    FITSessionMesgFieldDefNumMaxAltitude = 50, 
    FITSessionMesgFieldDefNumGpsAccuracy = 51, 
    FITSessionMesgFieldDefNumAvgGrade = 52, 
    FITSessionMesgFieldDefNumAvgPosGrade = 53, 
    FITSessionMesgFieldDefNumAvgNegGrade = 54, 
    FITSessionMesgFieldDefNumMaxPosGrade = 55, 
    FITSessionMesgFieldDefNumMaxNegGrade = 56, 
    FITSessionMesgFieldDefNumAvgTemperature = 57, 
    FITSessionMesgFieldDefNumMaxTemperature = 58, 
    FITSessionMesgFieldDefNumTotalMovingTime = 59, 
    FITSessionMesgFieldDefNumAvgPosVerticalSpeed = 60, 
    FITSessionMesgFieldDefNumAvgNegVerticalSpeed = 61, 
    FITSessionMesgFieldDefNumMaxPosVerticalSpeed = 62, 
    FITSessionMesgFieldDefNumMaxNegVerticalSpeed = 63, 
    FITSessionMesgFieldDefNumMinHeartRate = 64, 
    FITSessionMesgFieldDefNumTimeInHrZone = 65, 
    FITSessionMesgFieldDefNumTimeInSpeedZone = 66, 
    FITSessionMesgFieldDefNumTimeInCadenceZone = 67, 
    FITSessionMesgFieldDefNumTimeInPowerZone = 68, 
    FITSessionMesgFieldDefNumAvgLapTime = 69, 
    FITSessionMesgFieldDefNumBestLapIndex = 70, 
    FITSessionMesgFieldDefNumMinAltitude = 71, 
    FITSessionMesgFieldDefNumPlayerScore = 82, 
    FITSessionMesgFieldDefNumOpponentScore = 83, 
    FITSessionMesgFieldDefNumOpponentName = 84, 
    FITSessionMesgFieldDefNumStrokeCount = 85, 
    FITSessionMesgFieldDefNumZoneCount = 86, 
    FITSessionMesgFieldDefNumMaxBallSpeed = 87, 
    FITSessionMesgFieldDefNumAvgBallSpeed = 88, 
    FITSessionMesgFieldDefNumAvgVerticalOscillation = 89, 
    FITSessionMesgFieldDefNumAvgStanceTimePercent = 90, 
    FITSessionMesgFieldDefNumAvgStanceTime = 91, 
    FITSessionMesgFieldDefNumAvgFractionalCadence = 92, 
    FITSessionMesgFieldDefNumMaxFractionalCadence = 93, 
    FITSessionMesgFieldDefNumTotalFractionalCycles = 94, 
    FITSessionMesgFieldDefNumAvgTotalHemoglobinConc = 95, 
    FITSessionMesgFieldDefNumMinTotalHemoglobinConc = 96, 
    FITSessionMesgFieldDefNumMaxTotalHemoglobinConc = 97, 
    FITSessionMesgFieldDefNumAvgSaturatedHemoglobinPercent = 98, 
    FITSessionMesgFieldDefNumMinSaturatedHemoglobinPercent = 99, 
    FITSessionMesgFieldDefNumMaxSaturatedHemoglobinPercent = 100, 
    FITSessionMesgFieldDefNumAvgLeftTorqueEffectiveness = 101, 
    FITSessionMesgFieldDefNumAvgRightTorqueEffectiveness = 102, 
    FITSessionMesgFieldDefNumAvgLeftPedalSmoothness = 103, 
    FITSessionMesgFieldDefNumAvgRightPedalSmoothness = 104, 
    FITSessionMesgFieldDefNumAvgCombinedPedalSmoothness = 105, 
    FITSessionMesgFieldDefNumSportIndex = 111, 
    FITSessionMesgFieldDefNumTimeStanding = 112, 
    FITSessionMesgFieldDefNumStandCount = 113, 
    FITSessionMesgFieldDefNumAvgLeftPco = 114, 
    FITSessionMesgFieldDefNumAvgRightPco = 115, 
    FITSessionMesgFieldDefNumAvgLeftPowerPhase = 116, 
    FITSessionMesgFieldDefNumAvgLeftPowerPhasePeak = 117, 
    FITSessionMesgFieldDefNumAvgRightPowerPhase = 118, 
    FITSessionMesgFieldDefNumAvgRightPowerPhasePeak = 119, 
    FITSessionMesgFieldDefNumAvgPowerPosition = 120, 
    FITSessionMesgFieldDefNumMaxPowerPosition = 121, 
    FITSessionMesgFieldDefNumAvgCadencePosition = 122, 
    FITSessionMesgFieldDefNumMaxCadencePosition = 123, 
    FITSessionMesgFieldDefNumEnhancedAvgSpeed = 124, 
    FITSessionMesgFieldDefNumEnhancedMaxSpeed = 125, 
    FITSessionMesgFieldDefNumEnhancedAvgAltitude = 126, 
    FITSessionMesgFieldDefNumEnhancedMinAltitude = 127, 
    FITSessionMesgFieldDefNumEnhancedMaxAltitude = 128, 
    FITSessionMesgFieldDefNumAvgLevMotorPower = 129, 
    FITSessionMesgFieldDefNumMaxLevMotorPower = 130, 
    FITSessionMesgFieldDefNumLevBatteryConsumption = 131, 
    FITSessionMesgFieldDefNumAvgVerticalRatio = 132, 
    FITSessionMesgFieldDefNumAvgStanceTimeBalance = 133, 
    FITSessionMesgFieldDefNumAvgStepLength = 134, 
    FITSessionMesgFieldDefNumTotalAnaerobicTrainingEffect = 137, 
    FITSessionMesgFieldDefNumAvgVam = 139, 
    FITSessionMesgFieldDefNumAvgRespirationRate = 147, 
    FITSessionMesgFieldDefNumMaxRespirationRate = 148, 
    FITSessionMesgFieldDefNumMinRespirationRate = 149, 
    FITSessionMesgFieldDefNumTrainingLoadPeak = 168, 
    FITSessionMesgFieldDefNumEnhancedAvgRespirationRate = 169, 
    FITSessionMesgFieldDefNumEnhancedMaxRespirationRate = 170, 
    FITSessionMesgFieldDefNumEnhancedMinRespirationRate = 180, 
    FITSessionMesgFieldDefNumTotalGrit = 181, 
    FITSessionMesgFieldDefNumTotalFlow = 182, 
    FITSessionMesgFieldDefNumJumpCount = 183, 
    FITSessionMesgFieldDefNumAvgGrit = 186, 
    FITSessionMesgFieldDefNumAvgFlow = 187, 
    FITSessionMesgFieldDefNumTotalFractionalAscent = 199, 
    FITSessionMesgFieldDefNumTotalFractionalDescent = 200, 
    FITSessionMesgFieldDefNumAvgCoreTemperature = 208, 
    FITSessionMesgFieldDefNumMinCoreTemperature = 209, 
    FITSessionMesgFieldDefNumMaxCoreTemperature = 210, 
} FITSessionMesgFieldDefNum;

typedef enum FITSessionMesgTotalCyclesField : uint8_t {
    FITSessionMesgTotalCyclesFieldTotalStridesSubField,
    FITSessionMesgTotalCyclesFieldTotalStrokesSubField,
} FITSessionMesgTotalCyclesField;

typedef enum FITSessionMesgAvgCadenceField : uint8_t {
    FITSessionMesgAvgCadenceFieldAvgRunningCadenceSubField,
} FITSessionMesgAvgCadenceField;

typedef enum FITSessionMesgMaxCadenceField : uint8_t {
    FITSessionMesgMaxCadenceFieldMaxRunningCadenceSubField,
} FITSessionMesgMaxCadenceField;

// LapMesg Field Definition Numbers
typedef enum FITLapMesgFieldDefNum : uint8_t {
    FITLapMesgFieldDefNumMessageIndex = 254, 
    FITLapMesgFieldDefNumTimestamp = 253, 
    FITLapMesgFieldDefNumEvent = 0, 
    FITLapMesgFieldDefNumEventType = 1, 
    FITLapMesgFieldDefNumStartTime = 2, 
    FITLapMesgFieldDefNumStartPositionLat = 3, 
    FITLapMesgFieldDefNumStartPositionLong = 4, 
    FITLapMesgFieldDefNumEndPositionLat = 5, 
    FITLapMesgFieldDefNumEndPositionLong = 6, 
    FITLapMesgFieldDefNumTotalElapsedTime = 7, 
    FITLapMesgFieldDefNumTotalTimerTime = 8, 
    FITLapMesgFieldDefNumTotalDistance = 9, 
    FITLapMesgFieldDefNumTotalCycles = 10, 
    FITLapMesgFieldDefNumTotalCalories = 11, 
    FITLapMesgFieldDefNumTotalFatCalories = 12, 
    FITLapMesgFieldDefNumAvgSpeed = 13, 
    FITLapMesgFieldDefNumMaxSpeed = 14, 
    FITLapMesgFieldDefNumAvgHeartRate = 15, 
    FITLapMesgFieldDefNumMaxHeartRate = 16, 
    FITLapMesgFieldDefNumAvgCadence = 17, 
    FITLapMesgFieldDefNumMaxCadence = 18, 
    FITLapMesgFieldDefNumAvgPower = 19, 
    FITLapMesgFieldDefNumMaxPower = 20, 
    FITLapMesgFieldDefNumTotalAscent = 21, 
    FITLapMesgFieldDefNumTotalDescent = 22, 
    FITLapMesgFieldDefNumIntensity = 23, 
    FITLapMesgFieldDefNumLapTrigger = 24, 
    FITLapMesgFieldDefNumSport = 25, 
    FITLapMesgFieldDefNumEventGroup = 26, 
    FITLapMesgFieldDefNumNumLengths = 32, 
    FITLapMesgFieldDefNumNormalizedPower = 33, 
    FITLapMesgFieldDefNumLeftRightBalance = 34, 
    FITLapMesgFieldDefNumFirstLengthIndex = 35, 
    FITLapMesgFieldDefNumAvgStrokeDistance = 37, 
    FITLapMesgFieldDefNumSwimStroke = 38, 
    FITLapMesgFieldDefNumSubSport = 39, 
    FITLapMesgFieldDefNumNumActiveLengths = 40, 
    FITLapMesgFieldDefNumTotalWork = 41, 
    FITLapMesgFieldDefNumAvgAltitude = 42, 
    FITLapMesgFieldDefNumMaxAltitude = 43, 
    FITLapMesgFieldDefNumGpsAccuracy = 44, 
    FITLapMesgFieldDefNumAvgGrade = 45, 
    FITLapMesgFieldDefNumAvgPosGrade = 46, 
    FITLapMesgFieldDefNumAvgNegGrade = 47, 
    FITLapMesgFieldDefNumMaxPosGrade = 48, 
    FITLapMesgFieldDefNumMaxNegGrade = 49, 
    FITLapMesgFieldDefNumAvgTemperature = 50, 
    FITLapMesgFieldDefNumMaxTemperature = 51, 
    FITLapMesgFieldDefNumTotalMovingTime = 52, 
    FITLapMesgFieldDefNumAvgPosVerticalSpeed = 53, 
    FITLapMesgFieldDefNumAvgNegVerticalSpeed = 54, 
    FITLapMesgFieldDefNumMaxPosVerticalSpeed = 55, 
    FITLapMesgFieldDefNumMaxNegVerticalSpeed = 56, 
    FITLapMesgFieldDefNumTimeInHrZone = 57, 
    FITLapMesgFieldDefNumTimeInSpeedZone = 58, 
    FITLapMesgFieldDefNumTimeInCadenceZone = 59, 
    FITLapMesgFieldDefNumTimeInPowerZone = 60, 
    FITLapMesgFieldDefNumRepetitionNum = 61, 
    FITLapMesgFieldDefNumMinAltitude = 62, 
    FITLapMesgFieldDefNumMinHeartRate = 63, 
    FITLapMesgFieldDefNumWktStepIndex = 71, 
    FITLapMesgFieldDefNumOpponentScore = 74, 
    FITLapMesgFieldDefNumStrokeCount = 75, 
    FITLapMesgFieldDefNumZoneCount = 76, 
    FITLapMesgFieldDefNumAvgVerticalOscillation = 77, 
    FITLapMesgFieldDefNumAvgStanceTimePercent = 78, 
    FITLapMesgFieldDefNumAvgStanceTime = 79, 
    FITLapMesgFieldDefNumAvgFractionalCadence = 80, 
    FITLapMesgFieldDefNumMaxFractionalCadence = 81, 
    FITLapMesgFieldDefNumTotalFractionalCycles = 82, 
    FITLapMesgFieldDefNumPlayerScore = 83, 
    FITLapMesgFieldDefNumAvgTotalHemoglobinConc = 84, 
    FITLapMesgFieldDefNumMinTotalHemoglobinConc = 85, 
    FITLapMesgFieldDefNumMaxTotalHemoglobinConc = 86, 
    FITLapMesgFieldDefNumAvgSaturatedHemoglobinPercent = 87, 
    FITLapMesgFieldDefNumMinSaturatedHemoglobinPercent = 88, 
    FITLapMesgFieldDefNumMaxSaturatedHemoglobinPercent = 89, 
    FITLapMesgFieldDefNumAvgLeftTorqueEffectiveness = 91, 
    FITLapMesgFieldDefNumAvgRightTorqueEffectiveness = 92, 
    FITLapMesgFieldDefNumAvgLeftPedalSmoothness = 93, 
    FITLapMesgFieldDefNumAvgRightPedalSmoothness = 94, 
    FITLapMesgFieldDefNumAvgCombinedPedalSmoothness = 95, 
    FITLapMesgFieldDefNumTimeStanding = 98, 
    FITLapMesgFieldDefNumStandCount = 99, 
    FITLapMesgFieldDefNumAvgLeftPco = 100, 
    FITLapMesgFieldDefNumAvgRightPco = 101, 
    FITLapMesgFieldDefNumAvgLeftPowerPhase = 102, 
    FITLapMesgFieldDefNumAvgLeftPowerPhasePeak = 103, 
    FITLapMesgFieldDefNumAvgRightPowerPhase = 104, 
    FITLapMesgFieldDefNumAvgRightPowerPhasePeak = 105, 
    FITLapMesgFieldDefNumAvgPowerPosition = 106, 
    FITLapMesgFieldDefNumMaxPowerPosition = 107, 
    FITLapMesgFieldDefNumAvgCadencePosition = 108, 
    FITLapMesgFieldDefNumMaxCadencePosition = 109, 
    FITLapMesgFieldDefNumEnhancedAvgSpeed = 110, 
    FITLapMesgFieldDefNumEnhancedMaxSpeed = 111, 
    FITLapMesgFieldDefNumEnhancedAvgAltitude = 112, 
    FITLapMesgFieldDefNumEnhancedMinAltitude = 113, 
    FITLapMesgFieldDefNumEnhancedMaxAltitude = 114, 
    FITLapMesgFieldDefNumAvgLevMotorPower = 115, 
    FITLapMesgFieldDefNumMaxLevMotorPower = 116, 
    FITLapMesgFieldDefNumLevBatteryConsumption = 117, 
    FITLapMesgFieldDefNumAvgVerticalRatio = 118, 
    FITLapMesgFieldDefNumAvgStanceTimeBalance = 119, 
    FITLapMesgFieldDefNumAvgStepLength = 120, 
    FITLapMesgFieldDefNumAvgVam = 121, 
    FITLapMesgFieldDefNumEnhancedAvgRespirationRate = 136, 
    FITLapMesgFieldDefNumEnhancedMaxRespirationRate = 137, 
    FITLapMesgFieldDefNumAvgRespirationRate = 147, 
    FITLapMesgFieldDefNumMaxRespirationRate = 148, 
    FITLapMesgFieldDefNumTotalGrit = 149, 
    FITLapMesgFieldDefNumTotalFlow = 150, 
    FITLapMesgFieldDefNumJumpCount = 151, 
    FITLapMesgFieldDefNumAvgGrit = 153, 
    FITLapMesgFieldDefNumAvgFlow = 154, 
    FITLapMesgFieldDefNumTotalFractionalAscent = 156, 
    FITLapMesgFieldDefNumTotalFractionalDescent = 157, 
    FITLapMesgFieldDefNumAvgCoreTemperature = 158, 
    FITLapMesgFieldDefNumMinCoreTemperature = 159, 
    FITLapMesgFieldDefNumMaxCoreTemperature = 160, 
} FITLapMesgFieldDefNum;

typedef enum FITLapMesgTotalCyclesField : uint8_t {
    FITLapMesgTotalCyclesFieldTotalStridesSubField,
    FITLapMesgTotalCyclesFieldTotalStrokesSubField,
} FITLapMesgTotalCyclesField;

typedef enum FITLapMesgAvgCadenceField : uint8_t {
    FITLapMesgAvgCadenceFieldAvgRunningCadenceSubField,
} FITLapMesgAvgCadenceField;

typedef enum FITLapMesgMaxCadenceField : uint8_t {
    FITLapMesgMaxCadenceFieldMaxRunningCadenceSubField,
} FITLapMesgMaxCadenceField;

// LengthMesg Field Definition Numbers
typedef enum FITLengthMesgFieldDefNum : uint8_t {
    FITLengthMesgFieldDefNumMessageIndex = 254, 
    FITLengthMesgFieldDefNumTimestamp = 253, 
    FITLengthMesgFieldDefNumEvent = 0, 
    FITLengthMesgFieldDefNumEventType = 1, 
    FITLengthMesgFieldDefNumStartTime = 2, 
    FITLengthMesgFieldDefNumTotalElapsedTime = 3, 
    FITLengthMesgFieldDefNumTotalTimerTime = 4, 
    FITLengthMesgFieldDefNumTotalStrokes = 5, 
    FITLengthMesgFieldDefNumAvgSpeed = 6, 
    FITLengthMesgFieldDefNumSwimStroke = 7, 
    FITLengthMesgFieldDefNumAvgSwimmingCadence = 9, 
    FITLengthMesgFieldDefNumEventGroup = 10, 
    FITLengthMesgFieldDefNumTotalCalories = 11, 
    FITLengthMesgFieldDefNumLengthType = 12, 
    FITLengthMesgFieldDefNumPlayerScore = 18, 
    FITLengthMesgFieldDefNumOpponentScore = 19, 
    FITLengthMesgFieldDefNumStrokeCount = 20, 
    FITLengthMesgFieldDefNumZoneCount = 21, 
    FITLengthMesgFieldDefNumEnhancedAvgRespirationRate = 22, 
    FITLengthMesgFieldDefNumEnhancedMaxRespirationRate = 23, 
    FITLengthMesgFieldDefNumAvgRespirationRate = 24, 
    FITLengthMesgFieldDefNumMaxRespirationRate = 25, 
} FITLengthMesgFieldDefNum;

// RecordMesg Field Definition Numbers
typedef enum FITRecordMesgFieldDefNum : uint8_t {
    FITRecordMesgFieldDefNumTimestamp = 253, 
    FITRecordMesgFieldDefNumPositionLat = 0, 
    FITRecordMesgFieldDefNumPositionLong = 1, 
    FITRecordMesgFieldDefNumAltitude = 2, 
    FITRecordMesgFieldDefNumHeartRate = 3, 
    FITRecordMesgFieldDefNumCadence = 4, 
    FITRecordMesgFieldDefNumDistance = 5, 
    FITRecordMesgFieldDefNumSpeed = 6, 
    FITRecordMesgFieldDefNumPower = 7, 
    FITRecordMesgFieldDefNumCompressedSpeedDistance = 8, 
    FITRecordMesgFieldDefNumGrade = 9, 
    FITRecordMesgFieldDefNumResistance = 10, 
    FITRecordMesgFieldDefNumTimeFromCourse = 11, 
    FITRecordMesgFieldDefNumCycleLength = 12, 
    FITRecordMesgFieldDefNumTemperature = 13, 
    FITRecordMesgFieldDefNumSpeed1s = 17, 
    FITRecordMesgFieldDefNumCycles = 18, 
    FITRecordMesgFieldDefNumTotalCycles = 19, 
    FITRecordMesgFieldDefNumCompressedAccumulatedPower = 28, 
    FITRecordMesgFieldDefNumAccumulatedPower = 29, 
    FITRecordMesgFieldDefNumLeftRightBalance = 30, 
    FITRecordMesgFieldDefNumGpsAccuracy = 31, 
    FITRecordMesgFieldDefNumVerticalSpeed = 32, 
    FITRecordMesgFieldDefNumCalories = 33, 
    FITRecordMesgFieldDefNumVerticalOscillation = 39, 
    FITRecordMesgFieldDefNumStanceTimePercent = 40, 
    FITRecordMesgFieldDefNumStanceTime = 41, 
    FITRecordMesgFieldDefNumActivityType = 42, 
    FITRecordMesgFieldDefNumLeftTorqueEffectiveness = 43, 
    FITRecordMesgFieldDefNumRightTorqueEffectiveness = 44, 
    FITRecordMesgFieldDefNumLeftPedalSmoothness = 45, 
    FITRecordMesgFieldDefNumRightPedalSmoothness = 46, 
    FITRecordMesgFieldDefNumCombinedPedalSmoothness = 47, 
    FITRecordMesgFieldDefNumTime128 = 48, 
    FITRecordMesgFieldDefNumStrokeType = 49, 
    FITRecordMesgFieldDefNumZone = 50, 
    FITRecordMesgFieldDefNumBallSpeed = 51, 
    FITRecordMesgFieldDefNumCadence256 = 52, 
    FITRecordMesgFieldDefNumFractionalCadence = 53, 
    FITRecordMesgFieldDefNumTotalHemoglobinConc = 54, 
    FITRecordMesgFieldDefNumTotalHemoglobinConcMin = 55, 
    FITRecordMesgFieldDefNumTotalHemoglobinConcMax = 56, 
    FITRecordMesgFieldDefNumSaturatedHemoglobinPercent = 57, 
    FITRecordMesgFieldDefNumSaturatedHemoglobinPercentMin = 58, 
    FITRecordMesgFieldDefNumSaturatedHemoglobinPercentMax = 59, 
    FITRecordMesgFieldDefNumDeviceIndex = 62, 
    FITRecordMesgFieldDefNumLeftPco = 67, 
    FITRecordMesgFieldDefNumRightPco = 68, 
    FITRecordMesgFieldDefNumLeftPowerPhase = 69, 
    FITRecordMesgFieldDefNumLeftPowerPhasePeak = 70, 
    FITRecordMesgFieldDefNumRightPowerPhase = 71, 
    FITRecordMesgFieldDefNumRightPowerPhasePeak = 72, 
    FITRecordMesgFieldDefNumEnhancedSpeed = 73, 
    FITRecordMesgFieldDefNumEnhancedAltitude = 78, 
    FITRecordMesgFieldDefNumBatterySoc = 81, 
    FITRecordMesgFieldDefNumMotorPower = 82, 
    FITRecordMesgFieldDefNumVerticalRatio = 83, 
    FITRecordMesgFieldDefNumStanceTimeBalance = 84, 
    FITRecordMesgFieldDefNumStepLength = 85, 
    FITRecordMesgFieldDefNumAbsolutePressure = 91, 
    FITRecordMesgFieldDefNumDepth = 92, 
    FITRecordMesgFieldDefNumNextStopDepth = 93, 
    FITRecordMesgFieldDefNumNextStopTime = 94, 
    FITRecordMesgFieldDefNumTimeToSurface = 95, 
    FITRecordMesgFieldDefNumNdlTime = 96, 
    FITRecordMesgFieldDefNumCnsLoad = 97, 
    FITRecordMesgFieldDefNumN2Load = 98, 
    FITRecordMesgFieldDefNumRespirationRate = 99, 
    FITRecordMesgFieldDefNumEnhancedRespirationRate = 108, 
    FITRecordMesgFieldDefNumGrit = 114, 
    FITRecordMesgFieldDefNumFlow = 115, 
    FITRecordMesgFieldDefNumEbikeTravelRange = 117, 
    FITRecordMesgFieldDefNumEbikeBatteryLevel = 118, 
    FITRecordMesgFieldDefNumEbikeAssistMode = 119, 
    FITRecordMesgFieldDefNumEbikeAssistLevelPercent = 120, 
    FITRecordMesgFieldDefNumCoreTemperature = 139, 
} FITRecordMesgFieldDefNum;

// EventMesg Field Definition Numbers
typedef enum FITEventMesgFieldDefNum : uint8_t {
    FITEventMesgFieldDefNumTimestamp = 253, 
    FITEventMesgFieldDefNumEvent = 0, 
    FITEventMesgFieldDefNumEventType = 1, 
    FITEventMesgFieldDefNumData16 = 2, 
    FITEventMesgFieldDefNumData = 3, 
    FITEventMesgFieldDefNumEventGroup = 4, 
    FITEventMesgFieldDefNumScore = 7, 
    FITEventMesgFieldDefNumOpponentScore = 8, 
    FITEventMesgFieldDefNumFrontGearNum = 9, 
    FITEventMesgFieldDefNumFrontGear = 10, 
    FITEventMesgFieldDefNumRearGearNum = 11, 
    FITEventMesgFieldDefNumRearGear = 12, 
    FITEventMesgFieldDefNumDeviceIndex = 13, 
    FITEventMesgFieldDefNumRadarThreatLevelMax = 21, 
    FITEventMesgFieldDefNumRadarThreatCount = 22, 
    FITEventMesgFieldDefNumRadarThreatAvgApproachSpeed = 23, 
    FITEventMesgFieldDefNumRadarThreatMaxApproachSpeed = 24, 
} FITEventMesgFieldDefNum;

typedef enum FITEventMesgDataField : uint8_t {
    FITEventMesgDataFieldTimerTriggerSubField,
    FITEventMesgDataFieldCoursePointIndexSubField,
    FITEventMesgDataFieldBatteryLevelSubField,
    FITEventMesgDataFieldVirtualPartnerSpeedSubField,
    FITEventMesgDataFieldHrHighAlertSubField,
    FITEventMesgDataFieldHrLowAlertSubField,
    FITEventMesgDataFieldSpeedHighAlertSubField,
    FITEventMesgDataFieldSpeedLowAlertSubField,
    FITEventMesgDataFieldCadHighAlertSubField,
    FITEventMesgDataFieldCadLowAlertSubField,
    FITEventMesgDataFieldPowerHighAlertSubField,
    FITEventMesgDataFieldPowerLowAlertSubField,
    FITEventMesgDataFieldTimeDurationAlertSubField,
    FITEventMesgDataFieldDistanceDurationAlertSubField,
    FITEventMesgDataFieldCalorieDurationAlertSubField,
    FITEventMesgDataFieldFitnessEquipmentStateSubField,
    FITEventMesgDataFieldSportPointSubField,
    FITEventMesgDataFieldGearChangeDataSubField,
    FITEventMesgDataFieldRiderPositionSubField,
    FITEventMesgDataFieldCommTimeoutSubField,
    FITEventMesgDataFieldRadarThreatAlertSubField,
} FITEventMesgDataField;

// DeviceInfoMesg Field Definition Numbers
typedef enum FITDeviceInfoMesgFieldDefNum : uint8_t {
    FITDeviceInfoMesgFieldDefNumTimestamp = 253, 
    FITDeviceInfoMesgFieldDefNumDeviceIndex = 0, 
    FITDeviceInfoMesgFieldDefNumDeviceType = 1, 
    FITDeviceInfoMesgFieldDefNumManufacturer = 2, 
    FITDeviceInfoMesgFieldDefNumSerialNumber = 3, 
    FITDeviceInfoMesgFieldDefNumProduct = 4, 
    FITDeviceInfoMesgFieldDefNumSoftwareVersion = 5, 
    FITDeviceInfoMesgFieldDefNumHardwareVersion = 6, 
    FITDeviceInfoMesgFieldDefNumCumOperatingTime = 7, 
    FITDeviceInfoMesgFieldDefNumBatteryVoltage = 10, 
    FITDeviceInfoMesgFieldDefNumBatteryStatus = 11, 
    FITDeviceInfoMesgFieldDefNumSensorPosition = 18, 
    FITDeviceInfoMesgFieldDefNumDescriptor = 19, 
    FITDeviceInfoMesgFieldDefNumAntTransmissionType = 20, 
    FITDeviceInfoMesgFieldDefNumAntDeviceNumber = 21, 
    FITDeviceInfoMesgFieldDefNumAntNetwork = 22, 
    FITDeviceInfoMesgFieldDefNumSourceType = 25, 
    FITDeviceInfoMesgFieldDefNumProductName = 27, 
    FITDeviceInfoMesgFieldDefNumBatteryLevel = 32, 
} FITDeviceInfoMesgFieldDefNum;

typedef enum FITDeviceInfoMesgDeviceTypeField : uint8_t {
    FITDeviceInfoMesgDeviceTypeFieldBleDeviceTypeSubField,
    FITDeviceInfoMesgDeviceTypeFieldAntplusDeviceTypeSubField,
    FITDeviceInfoMesgDeviceTypeFieldAntDeviceTypeSubField,
    FITDeviceInfoMesgDeviceTypeFieldLocalDeviceTypeSubField,
} FITDeviceInfoMesgDeviceTypeField;

typedef enum FITDeviceInfoMesgProductField : uint8_t {
    FITDeviceInfoMesgProductFieldFaveroProductSubField,
    FITDeviceInfoMesgProductFieldGarminProductSubField,
} FITDeviceInfoMesgProductField;

// DeviceAuxBatteryInfoMesg Field Definition Numbers
typedef enum FITDeviceAuxBatteryInfoMesgFieldDefNum : uint8_t {
    FITDeviceAuxBatteryInfoMesgFieldDefNumTimestamp = 253, 
    FITDeviceAuxBatteryInfoMesgFieldDefNumDeviceIndex = 0, 
    FITDeviceAuxBatteryInfoMesgFieldDefNumBatteryVoltage = 1, 
    FITDeviceAuxBatteryInfoMesgFieldDefNumBatteryStatus = 2, 
    FITDeviceAuxBatteryInfoMesgFieldDefNumBatteryIdentifier = 3, 
} FITDeviceAuxBatteryInfoMesgFieldDefNum;

// TrainingFileMesg Field Definition Numbers
typedef enum FITTrainingFileMesgFieldDefNum : uint8_t {
    FITTrainingFileMesgFieldDefNumTimestamp = 253, 
    FITTrainingFileMesgFieldDefNumType = 0, 
    FITTrainingFileMesgFieldDefNumManufacturer = 1, 
    FITTrainingFileMesgFieldDefNumProduct = 2, 
    FITTrainingFileMesgFieldDefNumSerialNumber = 3, 
    FITTrainingFileMesgFieldDefNumTimeCreated = 4, 
} FITTrainingFileMesgFieldDefNum;

typedef enum FITTrainingFileMesgProductField : uint8_t {
    FITTrainingFileMesgProductFieldFaveroProductSubField,
    FITTrainingFileMesgProductFieldGarminProductSubField,
} FITTrainingFileMesgProductField;

// WeatherConditionsMesg Field Definition Numbers
typedef enum FITWeatherConditionsMesgFieldDefNum : uint8_t {
    FITWeatherConditionsMesgFieldDefNumTimestamp = 253, 
    FITWeatherConditionsMesgFieldDefNumWeatherReport = 0, 
    FITWeatherConditionsMesgFieldDefNumTemperature = 1, 
    FITWeatherConditionsMesgFieldDefNumCondition = 2, 
    FITWeatherConditionsMesgFieldDefNumWindDirection = 3, 
    FITWeatherConditionsMesgFieldDefNumWindSpeed = 4, 
    FITWeatherConditionsMesgFieldDefNumPrecipitationProbability = 5, 
    FITWeatherConditionsMesgFieldDefNumTemperatureFeelsLike = 6, 
    FITWeatherConditionsMesgFieldDefNumRelativeHumidity = 7, 
    FITWeatherConditionsMesgFieldDefNumLocation = 8, 
    FITWeatherConditionsMesgFieldDefNumObservedAtTime = 9, 
    FITWeatherConditionsMesgFieldDefNumObservedLocationLat = 10, 
    FITWeatherConditionsMesgFieldDefNumObservedLocationLong = 11, 
    FITWeatherConditionsMesgFieldDefNumDayOfWeek = 12, 
    FITWeatherConditionsMesgFieldDefNumHighTemperature = 13, 
    FITWeatherConditionsMesgFieldDefNumLowTemperature = 14, 
} FITWeatherConditionsMesgFieldDefNum;

// WeatherAlertMesg Field Definition Numbers
typedef enum FITWeatherAlertMesgFieldDefNum : uint8_t {
    FITWeatherAlertMesgFieldDefNumTimestamp = 253, 
    FITWeatherAlertMesgFieldDefNumReportId = 0, 
    FITWeatherAlertMesgFieldDefNumIssueTime = 1, 
    FITWeatherAlertMesgFieldDefNumExpireTime = 2, 
    FITWeatherAlertMesgFieldDefNumSeverity = 3, 
    FITWeatherAlertMesgFieldDefNumType = 4, 
} FITWeatherAlertMesgFieldDefNum;

// GpsMetadataMesg Field Definition Numbers
typedef enum FITGpsMetadataMesgFieldDefNum : uint8_t {
    FITGpsMetadataMesgFieldDefNumTimestamp = 253, 
    FITGpsMetadataMesgFieldDefNumTimestampMs = 0, 
    FITGpsMetadataMesgFieldDefNumPositionLat = 1, 
    FITGpsMetadataMesgFieldDefNumPositionLong = 2, 
    FITGpsMetadataMesgFieldDefNumEnhancedAltitude = 3, 
    FITGpsMetadataMesgFieldDefNumEnhancedSpeed = 4, 
    FITGpsMetadataMesgFieldDefNumHeading = 5, 
    FITGpsMetadataMesgFieldDefNumUtcTimestamp = 6, 
    FITGpsMetadataMesgFieldDefNumVelocity = 7, 
} FITGpsMetadataMesgFieldDefNum;

// CameraEventMesg Field Definition Numbers
typedef enum FITCameraEventMesgFieldDefNum : uint8_t {
    FITCameraEventMesgFieldDefNumTimestamp = 253, 
    FITCameraEventMesgFieldDefNumTimestampMs = 0, 
    FITCameraEventMesgFieldDefNumCameraEventType = 1, 
    FITCameraEventMesgFieldDefNumCameraFileUuid = 2, 
    FITCameraEventMesgFieldDefNumCameraOrientation = 3, 
} FITCameraEventMesgFieldDefNum;

// GyroscopeDataMesg Field Definition Numbers
typedef enum FITGyroscopeDataMesgFieldDefNum : uint8_t {
    FITGyroscopeDataMesgFieldDefNumTimestamp = 253, 
    FITGyroscopeDataMesgFieldDefNumTimestampMs = 0, 
    FITGyroscopeDataMesgFieldDefNumSampleTimeOffset = 1, 
    FITGyroscopeDataMesgFieldDefNumGyroX = 2, 
    FITGyroscopeDataMesgFieldDefNumGyroY = 3, 
    FITGyroscopeDataMesgFieldDefNumGyroZ = 4, 
    FITGyroscopeDataMesgFieldDefNumCalibratedGyroX = 5, 
    FITGyroscopeDataMesgFieldDefNumCalibratedGyroY = 6, 
    FITGyroscopeDataMesgFieldDefNumCalibratedGyroZ = 7, 
} FITGyroscopeDataMesgFieldDefNum;

// AccelerometerDataMesg Field Definition Numbers
typedef enum FITAccelerometerDataMesgFieldDefNum : uint8_t {
    FITAccelerometerDataMesgFieldDefNumTimestamp = 253, 
    FITAccelerometerDataMesgFieldDefNumTimestampMs = 0, 
    FITAccelerometerDataMesgFieldDefNumSampleTimeOffset = 1, 
    FITAccelerometerDataMesgFieldDefNumAccelX = 2, 
    FITAccelerometerDataMesgFieldDefNumAccelY = 3, 
    FITAccelerometerDataMesgFieldDefNumAccelZ = 4, 
    FITAccelerometerDataMesgFieldDefNumCalibratedAccelX = 5, 
    FITAccelerometerDataMesgFieldDefNumCalibratedAccelY = 6, 
    FITAccelerometerDataMesgFieldDefNumCalibratedAccelZ = 7, 
    FITAccelerometerDataMesgFieldDefNumCompressedCalibratedAccelX = 8, 
    FITAccelerometerDataMesgFieldDefNumCompressedCalibratedAccelY = 9, 
    FITAccelerometerDataMesgFieldDefNumCompressedCalibratedAccelZ = 10, 
} FITAccelerometerDataMesgFieldDefNum;

// MagnetometerDataMesg Field Definition Numbers
typedef enum FITMagnetometerDataMesgFieldDefNum : uint8_t {
    FITMagnetometerDataMesgFieldDefNumTimestamp = 253, 
    FITMagnetometerDataMesgFieldDefNumTimestampMs = 0, 
    FITMagnetometerDataMesgFieldDefNumSampleTimeOffset = 1, 
    FITMagnetometerDataMesgFieldDefNumMagX = 2, 
    FITMagnetometerDataMesgFieldDefNumMagY = 3, 
    FITMagnetometerDataMesgFieldDefNumMagZ = 4, 
    FITMagnetometerDataMesgFieldDefNumCalibratedMagX = 5, 
    FITMagnetometerDataMesgFieldDefNumCalibratedMagY = 6, 
    FITMagnetometerDataMesgFieldDefNumCalibratedMagZ = 7, 
} FITMagnetometerDataMesgFieldDefNum;

// BarometerDataMesg Field Definition Numbers
typedef enum FITBarometerDataMesgFieldDefNum : uint8_t {
    FITBarometerDataMesgFieldDefNumTimestamp = 253, 
    FITBarometerDataMesgFieldDefNumTimestampMs = 0, 
    FITBarometerDataMesgFieldDefNumSampleTimeOffset = 1, 
    FITBarometerDataMesgFieldDefNumBaroPres = 2, 
} FITBarometerDataMesgFieldDefNum;

// ThreeDSensorCalibrationMesg Field Definition Numbers
typedef enum FITThreeDSensorCalibrationMesgFieldDefNum : uint8_t {
    FITThreeDSensorCalibrationMesgFieldDefNumTimestamp = 253, 
    FITThreeDSensorCalibrationMesgFieldDefNumSensorType = 0, 
    FITThreeDSensorCalibrationMesgFieldDefNumCalibrationFactor = 1, 
    FITThreeDSensorCalibrationMesgFieldDefNumCalibrationDivisor = 2, 
    FITThreeDSensorCalibrationMesgFieldDefNumLevelShift = 3, 
    FITThreeDSensorCalibrationMesgFieldDefNumOffsetCal = 4, 
    FITThreeDSensorCalibrationMesgFieldDefNumOrientationMatrix = 5, 
} FITThreeDSensorCalibrationMesgFieldDefNum;

typedef enum FITThreeDSensorCalibrationMesgCalibrationFactorField : uint8_t {
    FITThreeDSensorCalibrationMesgCalibrationFactorFieldAccelCalFactorSubField,
    FITThreeDSensorCalibrationMesgCalibrationFactorFieldGyroCalFactorSubField,
} FITThreeDSensorCalibrationMesgCalibrationFactorField;

// OneDSensorCalibrationMesg Field Definition Numbers
typedef enum FITOneDSensorCalibrationMesgFieldDefNum : uint8_t {
    FITOneDSensorCalibrationMesgFieldDefNumTimestamp = 253, 
    FITOneDSensorCalibrationMesgFieldDefNumSensorType = 0, 
    FITOneDSensorCalibrationMesgFieldDefNumCalibrationFactor = 1, 
    FITOneDSensorCalibrationMesgFieldDefNumCalibrationDivisor = 2, 
    FITOneDSensorCalibrationMesgFieldDefNumLevelShift = 3, 
    FITOneDSensorCalibrationMesgFieldDefNumOffsetCal = 4, 
} FITOneDSensorCalibrationMesgFieldDefNum;

typedef enum FITOneDSensorCalibrationMesgCalibrationFactorField : uint8_t {
    FITOneDSensorCalibrationMesgCalibrationFactorFieldBaroCalFactorSubField,
} FITOneDSensorCalibrationMesgCalibrationFactorField;

// VideoFrameMesg Field Definition Numbers
typedef enum FITVideoFrameMesgFieldDefNum : uint8_t {
    FITVideoFrameMesgFieldDefNumTimestamp = 253, 
    FITVideoFrameMesgFieldDefNumTimestampMs = 0, 
    FITVideoFrameMesgFieldDefNumFrameNumber = 1, 
} FITVideoFrameMesgFieldDefNum;

// ObdiiDataMesg Field Definition Numbers
typedef enum FITObdiiDataMesgFieldDefNum : uint8_t {
    FITObdiiDataMesgFieldDefNumTimestamp = 253, 
    FITObdiiDataMesgFieldDefNumTimestampMs = 0, 
    FITObdiiDataMesgFieldDefNumTimeOffset = 1, 
    FITObdiiDataMesgFieldDefNumPid = 2, 
    FITObdiiDataMesgFieldDefNumRawData = 3, 
    FITObdiiDataMesgFieldDefNumPidDataSize = 4, 
    FITObdiiDataMesgFieldDefNumSystemTime = 5, 
    FITObdiiDataMesgFieldDefNumStartTimestamp = 6, 
    FITObdiiDataMesgFieldDefNumStartTimestampMs = 7, 
} FITObdiiDataMesgFieldDefNum;

// NmeaSentenceMesg Field Definition Numbers
typedef enum FITNmeaSentenceMesgFieldDefNum : uint8_t {
    FITNmeaSentenceMesgFieldDefNumTimestamp = 253, 
    FITNmeaSentenceMesgFieldDefNumTimestampMs = 0, 
    FITNmeaSentenceMesgFieldDefNumSentence = 1, 
} FITNmeaSentenceMesgFieldDefNum;

// AviationAttitudeMesg Field Definition Numbers
typedef enum FITAviationAttitudeMesgFieldDefNum : uint8_t {
    FITAviationAttitudeMesgFieldDefNumTimestamp = 253, 
    FITAviationAttitudeMesgFieldDefNumTimestampMs = 0, 
    FITAviationAttitudeMesgFieldDefNumSystemTime = 1, 
    FITAviationAttitudeMesgFieldDefNumPitch = 2, 
    FITAviationAttitudeMesgFieldDefNumRoll = 3, 
    FITAviationAttitudeMesgFieldDefNumAccelLateral = 4, 
    FITAviationAttitudeMesgFieldDefNumAccelNormal = 5, 
    FITAviationAttitudeMesgFieldDefNumTurnRate = 6, 
    FITAviationAttitudeMesgFieldDefNumStage = 7, 
    FITAviationAttitudeMesgFieldDefNumAttitudeStageComplete = 8, 
    FITAviationAttitudeMesgFieldDefNumTrack = 9, 
    FITAviationAttitudeMesgFieldDefNumValidity = 10, 
} FITAviationAttitudeMesgFieldDefNum;

// VideoMesg Field Definition Numbers
typedef enum FITVideoMesgFieldDefNum : uint8_t {
    FITVideoMesgFieldDefNumUrl = 0, 
    FITVideoMesgFieldDefNumHostingProvider = 1, 
    FITVideoMesgFieldDefNumDuration = 2, 
} FITVideoMesgFieldDefNum;

// VideoTitleMesg Field Definition Numbers
typedef enum FITVideoTitleMesgFieldDefNum : uint8_t {
    FITVideoTitleMesgFieldDefNumMessageIndex = 254, 
    FITVideoTitleMesgFieldDefNumMessageCount = 0, 
    FITVideoTitleMesgFieldDefNumText = 1, 
} FITVideoTitleMesgFieldDefNum;

// VideoDescriptionMesg Field Definition Numbers
typedef enum FITVideoDescriptionMesgFieldDefNum : uint8_t {
    FITVideoDescriptionMesgFieldDefNumMessageIndex = 254, 
    FITVideoDescriptionMesgFieldDefNumMessageCount = 0, 
    FITVideoDescriptionMesgFieldDefNumText = 1, 
} FITVideoDescriptionMesgFieldDefNum;

// VideoClipMesg Field Definition Numbers
typedef enum FITVideoClipMesgFieldDefNum : uint8_t {
    FITVideoClipMesgFieldDefNumClipNumber = 0, 
    FITVideoClipMesgFieldDefNumStartTimestamp = 1, 
    FITVideoClipMesgFieldDefNumStartTimestampMs = 2, 
    FITVideoClipMesgFieldDefNumEndTimestamp = 3, 
    FITVideoClipMesgFieldDefNumEndTimestampMs = 4, 
    FITVideoClipMesgFieldDefNumClipStart = 6, 
    FITVideoClipMesgFieldDefNumClipEnd = 7, 
} FITVideoClipMesgFieldDefNum;

// SetMesg Field Definition Numbers
typedef enum FITSetMesgFieldDefNum : uint8_t {
    FITSetMesgFieldDefNumTimestamp = 254, 
    FITSetMesgFieldDefNumDuration = 0, 
    FITSetMesgFieldDefNumRepetitions = 3, 
    FITSetMesgFieldDefNumWeight = 4, 
    FITSetMesgFieldDefNumSetType = 5, 
    FITSetMesgFieldDefNumStartTime = 6, 
    FITSetMesgFieldDefNumCategory = 7, 
    FITSetMesgFieldDefNumCategorySubtype = 8, 
    FITSetMesgFieldDefNumWeightDisplayUnit = 9, 
    FITSetMesgFieldDefNumMessageIndex = 10, 
    FITSetMesgFieldDefNumWktStepIndex = 11, 
} FITSetMesgFieldDefNum;

// JumpMesg Field Definition Numbers
typedef enum FITJumpMesgFieldDefNum : uint8_t {
    FITJumpMesgFieldDefNumTimestamp = 253, 
    FITJumpMesgFieldDefNumDistance = 0, 
    FITJumpMesgFieldDefNumHeight = 1, 
    FITJumpMesgFieldDefNumRotations = 2, 
    FITJumpMesgFieldDefNumHangTime = 3, 
    FITJumpMesgFieldDefNumScore = 4, 
    FITJumpMesgFieldDefNumPositionLat = 5, 
    FITJumpMesgFieldDefNumPositionLong = 6, 
    FITJumpMesgFieldDefNumSpeed = 7, 
    FITJumpMesgFieldDefNumEnhancedSpeed = 8, 
} FITJumpMesgFieldDefNum;

// SplitMesg Field Definition Numbers
typedef enum FITSplitMesgFieldDefNum : uint8_t {
    FITSplitMesgFieldDefNumSplitType = 0, 
    FITSplitMesgFieldDefNumTotalElapsedTime = 1, 
    FITSplitMesgFieldDefNumTotalTimerTime = 2, 
    FITSplitMesgFieldDefNumTotalDistance = 3, 
    FITSplitMesgFieldDefNumStartTime = 9, 
} FITSplitMesgFieldDefNum;

// ClimbProMesg Field Definition Numbers
typedef enum FITClimbProMesgFieldDefNum : uint8_t {
    FITClimbProMesgFieldDefNumTimestamp = 253, 
    FITClimbProMesgFieldDefNumPositionLat = 0, 
    FITClimbProMesgFieldDefNumPositionLong = 1, 
    FITClimbProMesgFieldDefNumClimbProEvent = 2, 
    FITClimbProMesgFieldDefNumClimbNumber = 3, 
    FITClimbProMesgFieldDefNumClimbCategory = 4, 
    FITClimbProMesgFieldDefNumCurrentDist = 5, 
} FITClimbProMesgFieldDefNum;

// FieldDescriptionMesg Field Definition Numbers
typedef enum FITFieldDescriptionMesgFieldDefNum : uint8_t {
    FITFieldDescriptionMesgFieldDefNumDeveloperDataIndex = 0, 
    FITFieldDescriptionMesgFieldDefNumFieldDefinitionNumber = 1, 
    FITFieldDescriptionMesgFieldDefNumFitBaseTypeId = 2, 
    FITFieldDescriptionMesgFieldDefNumFieldName = 3, 
    FITFieldDescriptionMesgFieldDefNumArray = 4, 
    FITFieldDescriptionMesgFieldDefNumComponents = 5, 
    FITFieldDescriptionMesgFieldDefNumScale = 6, 
    FITFieldDescriptionMesgFieldDefNumOffset = 7, 
    FITFieldDescriptionMesgFieldDefNumUnits = 8, 
    FITFieldDescriptionMesgFieldDefNumBits = 9, 
    FITFieldDescriptionMesgFieldDefNumAccumulate = 10, 
    FITFieldDescriptionMesgFieldDefNumFitBaseUnitId = 13, 
    FITFieldDescriptionMesgFieldDefNumNativeMesgNum = 14, 
    FITFieldDescriptionMesgFieldDefNumNativeFieldNum = 15, 
} FITFieldDescriptionMesgFieldDefNum;

// DeveloperDataIdMesg Field Definition Numbers
typedef enum FITDeveloperDataIdMesgFieldDefNum : uint8_t {
    FITDeveloperDataIdMesgFieldDefNumDeveloperId = 0, 
    FITDeveloperDataIdMesgFieldDefNumApplicationId = 1, 
    FITDeveloperDataIdMesgFieldDefNumManufacturerId = 2, 
    FITDeveloperDataIdMesgFieldDefNumDeveloperDataIndex = 3, 
    FITDeveloperDataIdMesgFieldDefNumApplicationVersion = 4, 
} FITDeveloperDataIdMesgFieldDefNum;

// CourseMesg Field Definition Numbers
typedef enum FITCourseMesgFieldDefNum : uint8_t {
    FITCourseMesgFieldDefNumSport = 4, 
    FITCourseMesgFieldDefNumName = 5, 
    FITCourseMesgFieldDefNumCapabilities = 6, 
    FITCourseMesgFieldDefNumSubSport = 7, 
} FITCourseMesgFieldDefNum;

// CoursePointMesg Field Definition Numbers
typedef enum FITCoursePointMesgFieldDefNum : uint8_t {
    FITCoursePointMesgFieldDefNumMessageIndex = 254, 
    FITCoursePointMesgFieldDefNumTimestamp = 1, 
    FITCoursePointMesgFieldDefNumPositionLat = 2, 
    FITCoursePointMesgFieldDefNumPositionLong = 3, 
    FITCoursePointMesgFieldDefNumDistance = 4, 
    FITCoursePointMesgFieldDefNumType = 5, 
    FITCoursePointMesgFieldDefNumName = 6, 
    FITCoursePointMesgFieldDefNumFavorite = 8, 
} FITCoursePointMesgFieldDefNum;

// SegmentIdMesg Field Definition Numbers
typedef enum FITSegmentIdMesgFieldDefNum : uint8_t {
    FITSegmentIdMesgFieldDefNumName = 0, 
    FITSegmentIdMesgFieldDefNumUuid = 1, 
    FITSegmentIdMesgFieldDefNumSport = 2, 
    FITSegmentIdMesgFieldDefNumEnabled = 3, 
    FITSegmentIdMesgFieldDefNumUserProfilePrimaryKey = 4, 
    FITSegmentIdMesgFieldDefNumDeviceId = 5, 
    FITSegmentIdMesgFieldDefNumDefaultRaceLeader = 6, 
    FITSegmentIdMesgFieldDefNumDeleteStatus = 7, 
    FITSegmentIdMesgFieldDefNumSelectionType = 8, 
} FITSegmentIdMesgFieldDefNum;

// SegmentLeaderboardEntryMesg Field Definition Numbers
typedef enum FITSegmentLeaderboardEntryMesgFieldDefNum : uint8_t {
    FITSegmentLeaderboardEntryMesgFieldDefNumMessageIndex = 254, 
    FITSegmentLeaderboardEntryMesgFieldDefNumName = 0, 
    FITSegmentLeaderboardEntryMesgFieldDefNumType = 1, 
    FITSegmentLeaderboardEntryMesgFieldDefNumGroupPrimaryKey = 2, 
    FITSegmentLeaderboardEntryMesgFieldDefNumActivityId = 3, 
    FITSegmentLeaderboardEntryMesgFieldDefNumSegmentTime = 4, 
    FITSegmentLeaderboardEntryMesgFieldDefNumActivityIdString = 5, 
} FITSegmentLeaderboardEntryMesgFieldDefNum;

// SegmentPointMesg Field Definition Numbers
typedef enum FITSegmentPointMesgFieldDefNum : uint8_t {
    FITSegmentPointMesgFieldDefNumMessageIndex = 254, 
    FITSegmentPointMesgFieldDefNumPositionLat = 1, 
    FITSegmentPointMesgFieldDefNumPositionLong = 2, 
    FITSegmentPointMesgFieldDefNumDistance = 3, 
    FITSegmentPointMesgFieldDefNumAltitude = 4, 
    FITSegmentPointMesgFieldDefNumLeaderTime = 5, 
    FITSegmentPointMesgFieldDefNumEnhancedAltitude = 6, 
} FITSegmentPointMesgFieldDefNum;

// SegmentLapMesg Field Definition Numbers
typedef enum FITSegmentLapMesgFieldDefNum : uint8_t {
    FITSegmentLapMesgFieldDefNumMessageIndex = 254, 
    FITSegmentLapMesgFieldDefNumTimestamp = 253, 
    FITSegmentLapMesgFieldDefNumEvent = 0, 
    FITSegmentLapMesgFieldDefNumEventType = 1, 
    FITSegmentLapMesgFieldDefNumStartTime = 2, 
    FITSegmentLapMesgFieldDefNumStartPositionLat = 3, 
    FITSegmentLapMesgFieldDefNumStartPositionLong = 4, 
    FITSegmentLapMesgFieldDefNumEndPositionLat = 5, 
    FITSegmentLapMesgFieldDefNumEndPositionLong = 6, 
    FITSegmentLapMesgFieldDefNumTotalElapsedTime = 7, 
    FITSegmentLapMesgFieldDefNumTotalTimerTime = 8, 
    FITSegmentLapMesgFieldDefNumTotalDistance = 9, 
    FITSegmentLapMesgFieldDefNumTotalCycles = 10, 
    FITSegmentLapMesgFieldDefNumTotalCalories = 11, 
    FITSegmentLapMesgFieldDefNumTotalFatCalories = 12, 
    FITSegmentLapMesgFieldDefNumAvgSpeed = 13, 
    FITSegmentLapMesgFieldDefNumMaxSpeed = 14, 
    FITSegmentLapMesgFieldDefNumAvgHeartRate = 15, 
    FITSegmentLapMesgFieldDefNumMaxHeartRate = 16, 
    FITSegmentLapMesgFieldDefNumAvgCadence = 17, 
    FITSegmentLapMesgFieldDefNumMaxCadence = 18, 
    FITSegmentLapMesgFieldDefNumAvgPower = 19, 
    FITSegmentLapMesgFieldDefNumMaxPower = 20, 
    FITSegmentLapMesgFieldDefNumTotalAscent = 21, 
    FITSegmentLapMesgFieldDefNumTotalDescent = 22, 
    FITSegmentLapMesgFieldDefNumSport = 23, 
    FITSegmentLapMesgFieldDefNumEventGroup = 24, 
    FITSegmentLapMesgFieldDefNumNecLat = 25, 
    FITSegmentLapMesgFieldDefNumNecLong = 26, 
    FITSegmentLapMesgFieldDefNumSwcLat = 27, 
    FITSegmentLapMesgFieldDefNumSwcLong = 28, 
    FITSegmentLapMesgFieldDefNumName = 29, 
    FITSegmentLapMesgFieldDefNumNormalizedPower = 30, 
    FITSegmentLapMesgFieldDefNumLeftRightBalance = 31, 
    FITSegmentLapMesgFieldDefNumSubSport = 32, 
    FITSegmentLapMesgFieldDefNumTotalWork = 33, 
    FITSegmentLapMesgFieldDefNumAvgAltitude = 34, 
    FITSegmentLapMesgFieldDefNumMaxAltitude = 35, 
    FITSegmentLapMesgFieldDefNumGpsAccuracy = 36, 
    FITSegmentLapMesgFieldDefNumAvgGrade = 37, 
    FITSegmentLapMesgFieldDefNumAvgPosGrade = 38, 
    FITSegmentLapMesgFieldDefNumAvgNegGrade = 39, 
    FITSegmentLapMesgFieldDefNumMaxPosGrade = 40, 
    FITSegmentLapMesgFieldDefNumMaxNegGrade = 41, 
    FITSegmentLapMesgFieldDefNumAvgTemperature = 42, 
    FITSegmentLapMesgFieldDefNumMaxTemperature = 43, 
    FITSegmentLapMesgFieldDefNumTotalMovingTime = 44, 
    FITSegmentLapMesgFieldDefNumAvgPosVerticalSpeed = 45, 
    FITSegmentLapMesgFieldDefNumAvgNegVerticalSpeed = 46, 
    FITSegmentLapMesgFieldDefNumMaxPosVerticalSpeed = 47, 
    FITSegmentLapMesgFieldDefNumMaxNegVerticalSpeed = 48, 
    FITSegmentLapMesgFieldDefNumTimeInHrZone = 49, 
    FITSegmentLapMesgFieldDefNumTimeInSpeedZone = 50, 
    FITSegmentLapMesgFieldDefNumTimeInCadenceZone = 51, 
    FITSegmentLapMesgFieldDefNumTimeInPowerZone = 52, 
    FITSegmentLapMesgFieldDefNumRepetitionNum = 53, 
    FITSegmentLapMesgFieldDefNumMinAltitude = 54, 
    FITSegmentLapMesgFieldDefNumMinHeartRate = 55, 
    FITSegmentLapMesgFieldDefNumActiveTime = 56, 
    FITSegmentLapMesgFieldDefNumWktStepIndex = 57, 
    FITSegmentLapMesgFieldDefNumSportEvent = 58, 
    FITSegmentLapMesgFieldDefNumAvgLeftTorqueEffectiveness = 59, 
    FITSegmentLapMesgFieldDefNumAvgRightTorqueEffectiveness = 60, 
    FITSegmentLapMesgFieldDefNumAvgLeftPedalSmoothness = 61, 
    FITSegmentLapMesgFieldDefNumAvgRightPedalSmoothness = 62, 
    FITSegmentLapMesgFieldDefNumAvgCombinedPedalSmoothness = 63, 
    FITSegmentLapMesgFieldDefNumStatus = 64, 
    FITSegmentLapMesgFieldDefNumUuid = 65, 
    FITSegmentLapMesgFieldDefNumAvgFractionalCadence = 66, 
    FITSegmentLapMesgFieldDefNumMaxFractionalCadence = 67, 
    FITSegmentLapMesgFieldDefNumTotalFractionalCycles = 68, 
    FITSegmentLapMesgFieldDefNumFrontGearShiftCount = 69, 
    FITSegmentLapMesgFieldDefNumRearGearShiftCount = 70, 
    FITSegmentLapMesgFieldDefNumTimeStanding = 71, 
    FITSegmentLapMesgFieldDefNumStandCount = 72, 
    FITSegmentLapMesgFieldDefNumAvgLeftPco = 73, 
    FITSegmentLapMesgFieldDefNumAvgRightPco = 74, 
    FITSegmentLapMesgFieldDefNumAvgLeftPowerPhase = 75, 
    FITSegmentLapMesgFieldDefNumAvgLeftPowerPhasePeak = 76, 
    FITSegmentLapMesgFieldDefNumAvgRightPowerPhase = 77, 
    FITSegmentLapMesgFieldDefNumAvgRightPowerPhasePeak = 78, 
    FITSegmentLapMesgFieldDefNumAvgPowerPosition = 79, 
    FITSegmentLapMesgFieldDefNumMaxPowerPosition = 80, 
    FITSegmentLapMesgFieldDefNumAvgCadencePosition = 81, 
    FITSegmentLapMesgFieldDefNumMaxCadencePosition = 82, 
    FITSegmentLapMesgFieldDefNumManufacturer = 83, 
    FITSegmentLapMesgFieldDefNumTotalGrit = 84, 
    FITSegmentLapMesgFieldDefNumTotalFlow = 85, 
    FITSegmentLapMesgFieldDefNumAvgGrit = 86, 
    FITSegmentLapMesgFieldDefNumAvgFlow = 87, 
    FITSegmentLapMesgFieldDefNumTotalFractionalAscent = 89, 
    FITSegmentLapMesgFieldDefNumTotalFractionalDescent = 90, 
    FITSegmentLapMesgFieldDefNumEnhancedAvgAltitude = 91, 
    FITSegmentLapMesgFieldDefNumEnhancedMaxAltitude = 92, 
    FITSegmentLapMesgFieldDefNumEnhancedMinAltitude = 93, 
} FITSegmentLapMesgFieldDefNum;

typedef enum FITSegmentLapMesgTotalCyclesField : uint8_t {
    FITSegmentLapMesgTotalCyclesFieldTotalStrokesSubField,
} FITSegmentLapMesgTotalCyclesField;

// SegmentFileMesg Field Definition Numbers
typedef enum FITSegmentFileMesgFieldDefNum : uint8_t {
    FITSegmentFileMesgFieldDefNumMessageIndex = 254, 
    FITSegmentFileMesgFieldDefNumFileUuid = 1, 
    FITSegmentFileMesgFieldDefNumEnabled = 3, 
    FITSegmentFileMesgFieldDefNumUserProfilePrimaryKey = 4, 
    FITSegmentFileMesgFieldDefNumLeaderType = 7, 
    FITSegmentFileMesgFieldDefNumLeaderGroupPrimaryKey = 8, 
    FITSegmentFileMesgFieldDefNumLeaderActivityId = 9, 
    FITSegmentFileMesgFieldDefNumLeaderActivityIdString = 10, 
    FITSegmentFileMesgFieldDefNumDefaultRaceLeader = 11, 
} FITSegmentFileMesgFieldDefNum;

// WorkoutMesg Field Definition Numbers
typedef enum FITWorkoutMesgFieldDefNum : uint8_t {
    FITWorkoutMesgFieldDefNumSport = 4, 
    FITWorkoutMesgFieldDefNumCapabilities = 5, 
    FITWorkoutMesgFieldDefNumNumValidSteps = 6, 
    FITWorkoutMesgFieldDefNumWktName = 8, 
    FITWorkoutMesgFieldDefNumSubSport = 11, 
    FITWorkoutMesgFieldDefNumPoolLength = 14, 
    FITWorkoutMesgFieldDefNumPoolLengthUnit = 15, 
} FITWorkoutMesgFieldDefNum;

// WorkoutSessionMesg Field Definition Numbers
typedef enum FITWorkoutSessionMesgFieldDefNum : uint8_t {
    FITWorkoutSessionMesgFieldDefNumMessageIndex = 254, 
    FITWorkoutSessionMesgFieldDefNumSport = 0, 
    FITWorkoutSessionMesgFieldDefNumSubSport = 1, 
    FITWorkoutSessionMesgFieldDefNumNumValidSteps = 2, 
    FITWorkoutSessionMesgFieldDefNumFirstStepIndex = 3, 
    FITWorkoutSessionMesgFieldDefNumPoolLength = 4, 
    FITWorkoutSessionMesgFieldDefNumPoolLengthUnit = 5, 
} FITWorkoutSessionMesgFieldDefNum;

// WorkoutStepMesg Field Definition Numbers
typedef enum FITWorkoutStepMesgFieldDefNum : uint8_t {
    FITWorkoutStepMesgFieldDefNumMessageIndex = 254, 
    FITWorkoutStepMesgFieldDefNumWktStepName = 0, 
    FITWorkoutStepMesgFieldDefNumDurationType = 1, 
    FITWorkoutStepMesgFieldDefNumDurationValue = 2, 
    FITWorkoutStepMesgFieldDefNumTargetType = 3, 
    FITWorkoutStepMesgFieldDefNumTargetValue = 4, 
    FITWorkoutStepMesgFieldDefNumCustomTargetValueLow = 5, 
    FITWorkoutStepMesgFieldDefNumCustomTargetValueHigh = 6, 
    FITWorkoutStepMesgFieldDefNumIntensity = 7, 
    FITWorkoutStepMesgFieldDefNumNotes = 8, 
    FITWorkoutStepMesgFieldDefNumEquipment = 9, 
    FITWorkoutStepMesgFieldDefNumExerciseCategory = 10, 
    FITWorkoutStepMesgFieldDefNumExerciseName = 11, 
    FITWorkoutStepMesgFieldDefNumExerciseWeight = 12, 
    FITWorkoutStepMesgFieldDefNumWeightDisplayUnit = 13, 
    FITWorkoutStepMesgFieldDefNumSecondaryTargetType = 19, 
    FITWorkoutStepMesgFieldDefNumSecondaryTargetValue = 20, 
    FITWorkoutStepMesgFieldDefNumSecondaryCustomTargetValueLow = 21, 
    FITWorkoutStepMesgFieldDefNumSecondaryCustomTargetValueHigh = 22, 
} FITWorkoutStepMesgFieldDefNum;

typedef enum FITWorkoutStepMesgDurationValueField : uint8_t {
    FITWorkoutStepMesgDurationValueFieldDurationTimeSubField,
    FITWorkoutStepMesgDurationValueFieldDurationDistanceSubField,
    FITWorkoutStepMesgDurationValueFieldDurationHrSubField,
    FITWorkoutStepMesgDurationValueFieldDurationCaloriesSubField,
    FITWorkoutStepMesgDurationValueFieldDurationStepSubField,
    FITWorkoutStepMesgDurationValueFieldDurationPowerSubField,
    FITWorkoutStepMesgDurationValueFieldDurationRepsSubField,
} FITWorkoutStepMesgDurationValueField;

typedef enum FITWorkoutStepMesgTargetValueField : uint8_t {
    FITWorkoutStepMesgTargetValueFieldTargetSpeedZoneSubField,
    FITWorkoutStepMesgTargetValueFieldTargetHrZoneSubField,
    FITWorkoutStepMesgTargetValueFieldTargetCadenceZoneSubField,
    FITWorkoutStepMesgTargetValueFieldTargetPowerZoneSubField,
    FITWorkoutStepMesgTargetValueFieldRepeatStepsSubField,
    FITWorkoutStepMesgTargetValueFieldRepeatTimeSubField,
    FITWorkoutStepMesgTargetValueFieldRepeatDistanceSubField,
    FITWorkoutStepMesgTargetValueFieldRepeatCaloriesSubField,
    FITWorkoutStepMesgTargetValueFieldRepeatHrSubField,
    FITWorkoutStepMesgTargetValueFieldRepeatPowerSubField,
    FITWorkoutStepMesgTargetValueFieldTargetStrokeTypeSubField,
} FITWorkoutStepMesgTargetValueField;

typedef enum FITWorkoutStepMesgCustomTargetValueLowField : uint8_t {
    FITWorkoutStepMesgCustomTargetValueLowFieldCustomTargetSpeedLowSubField,
    FITWorkoutStepMesgCustomTargetValueLowFieldCustomTargetHeartRateLowSubField,
    FITWorkoutStepMesgCustomTargetValueLowFieldCustomTargetCadenceLowSubField,
    FITWorkoutStepMesgCustomTargetValueLowFieldCustomTargetPowerLowSubField,
} FITWorkoutStepMesgCustomTargetValueLowField;

typedef enum FITWorkoutStepMesgCustomTargetValueHighField : uint8_t {
    FITWorkoutStepMesgCustomTargetValueHighFieldCustomTargetSpeedHighSubField,
    FITWorkoutStepMesgCustomTargetValueHighFieldCustomTargetHeartRateHighSubField,
    FITWorkoutStepMesgCustomTargetValueHighFieldCustomTargetCadenceHighSubField,
    FITWorkoutStepMesgCustomTargetValueHighFieldCustomTargetPowerHighSubField,
} FITWorkoutStepMesgCustomTargetValueHighField;

typedef enum FITWorkoutStepMesgSecondaryTargetValueField : uint8_t {
    FITWorkoutStepMesgSecondaryTargetValueFieldSecondaryTargetSpeedZoneSubField,
    FITWorkoutStepMesgSecondaryTargetValueFieldSecondaryTargetHrZoneSubField,
    FITWorkoutStepMesgSecondaryTargetValueFieldSecondaryTargetCadenceZoneSubField,
    FITWorkoutStepMesgSecondaryTargetValueFieldSecondaryTargetPowerZoneSubField,
    FITWorkoutStepMesgSecondaryTargetValueFieldSecondaryTargetStrokeTypeSubField,
} FITWorkoutStepMesgSecondaryTargetValueField;

typedef enum FITWorkoutStepMesgSecondaryCustomTargetValueLowField : uint8_t {
    FITWorkoutStepMesgSecondaryCustomTargetValueLowFieldSecondaryCustomTargetSpeedLowSubField,
    FITWorkoutStepMesgSecondaryCustomTargetValueLowFieldSecondaryCustomTargetHeartRateLowSubField,
    FITWorkoutStepMesgSecondaryCustomTargetValueLowFieldSecondaryCustomTargetCadenceLowSubField,
    FITWorkoutStepMesgSecondaryCustomTargetValueLowFieldSecondaryCustomTargetPowerLowSubField,
} FITWorkoutStepMesgSecondaryCustomTargetValueLowField;

typedef enum FITWorkoutStepMesgSecondaryCustomTargetValueHighField : uint8_t {
    FITWorkoutStepMesgSecondaryCustomTargetValueHighFieldSecondaryCustomTargetSpeedHighSubField,
    FITWorkoutStepMesgSecondaryCustomTargetValueHighFieldSecondaryCustomTargetHeartRateHighSubField,
    FITWorkoutStepMesgSecondaryCustomTargetValueHighFieldSecondaryCustomTargetCadenceHighSubField,
    FITWorkoutStepMesgSecondaryCustomTargetValueHighFieldSecondaryCustomTargetPowerHighSubField,
} FITWorkoutStepMesgSecondaryCustomTargetValueHighField;

// ExerciseTitleMesg Field Definition Numbers
typedef enum FITExerciseTitleMesgFieldDefNum : uint8_t {
    FITExerciseTitleMesgFieldDefNumMessageIndex = 254, 
    FITExerciseTitleMesgFieldDefNumExerciseCategory = 0, 
    FITExerciseTitleMesgFieldDefNumExerciseName = 1, 
    FITExerciseTitleMesgFieldDefNumWktStepName = 2, 
} FITExerciseTitleMesgFieldDefNum;

// ScheduleMesg Field Definition Numbers
typedef enum FITScheduleMesgFieldDefNum : uint8_t {
    FITScheduleMesgFieldDefNumManufacturer = 0, 
    FITScheduleMesgFieldDefNumProduct = 1, 
    FITScheduleMesgFieldDefNumSerialNumber = 2, 
    FITScheduleMesgFieldDefNumTimeCreated = 3, 
    FITScheduleMesgFieldDefNumCompleted = 4, 
    FITScheduleMesgFieldDefNumType = 5, 
    FITScheduleMesgFieldDefNumScheduledTime = 6, 
} FITScheduleMesgFieldDefNum;

typedef enum FITScheduleMesgProductField : uint8_t {
    FITScheduleMesgProductFieldFaveroProductSubField,
    FITScheduleMesgProductFieldGarminProductSubField,
} FITScheduleMesgProductField;

// TotalsMesg Field Definition Numbers
typedef enum FITTotalsMesgFieldDefNum : uint8_t {
    FITTotalsMesgFieldDefNumMessageIndex = 254, 
    FITTotalsMesgFieldDefNumTimestamp = 253, 
    FITTotalsMesgFieldDefNumTimerTime = 0, 
    FITTotalsMesgFieldDefNumDistance = 1, 
    FITTotalsMesgFieldDefNumCalories = 2, 
    FITTotalsMesgFieldDefNumSport = 3, 
    FITTotalsMesgFieldDefNumElapsedTime = 4, 
    FITTotalsMesgFieldDefNumSessions = 5, 
    FITTotalsMesgFieldDefNumActiveTime = 6, 
    FITTotalsMesgFieldDefNumSportIndex = 9, 
} FITTotalsMesgFieldDefNum;

// WeightScaleMesg Field Definition Numbers
typedef enum FITWeightScaleMesgFieldDefNum : uint8_t {
    FITWeightScaleMesgFieldDefNumTimestamp = 253, 
    FITWeightScaleMesgFieldDefNumWeight = 0, 
    FITWeightScaleMesgFieldDefNumPercentFat = 1, 
    FITWeightScaleMesgFieldDefNumPercentHydration = 2, 
    FITWeightScaleMesgFieldDefNumVisceralFatMass = 3, 
    FITWeightScaleMesgFieldDefNumBoneMass = 4, 
    FITWeightScaleMesgFieldDefNumMuscleMass = 5, 
    FITWeightScaleMesgFieldDefNumBasalMet = 7, 
    FITWeightScaleMesgFieldDefNumPhysiqueRating = 8, 
    FITWeightScaleMesgFieldDefNumActiveMet = 9, 
    FITWeightScaleMesgFieldDefNumMetabolicAge = 10, 
    FITWeightScaleMesgFieldDefNumVisceralFatRating = 11, 
    FITWeightScaleMesgFieldDefNumUserProfileIndex = 12, 
} FITWeightScaleMesgFieldDefNum;

// BloodPressureMesg Field Definition Numbers
typedef enum FITBloodPressureMesgFieldDefNum : uint8_t {
    FITBloodPressureMesgFieldDefNumTimestamp = 253, 
    FITBloodPressureMesgFieldDefNumSystolicPressure = 0, 
    FITBloodPressureMesgFieldDefNumDiastolicPressure = 1, 
    FITBloodPressureMesgFieldDefNumMeanArterialPressure = 2, 
    FITBloodPressureMesgFieldDefNumMap3SampleMean = 3, 
    FITBloodPressureMesgFieldDefNumMapMorningValues = 4, 
    FITBloodPressureMesgFieldDefNumMapEveningValues = 5, 
    FITBloodPressureMesgFieldDefNumHeartRate = 6, 
    FITBloodPressureMesgFieldDefNumHeartRateType = 7, 
    FITBloodPressureMesgFieldDefNumStatus = 8, 
    FITBloodPressureMesgFieldDefNumUserProfileIndex = 9, 
} FITBloodPressureMesgFieldDefNum;

// MonitoringInfoMesg Field Definition Numbers
typedef enum FITMonitoringInfoMesgFieldDefNum : uint8_t {
    FITMonitoringInfoMesgFieldDefNumTimestamp = 253, 
    FITMonitoringInfoMesgFieldDefNumLocalTimestamp = 0, 
    FITMonitoringInfoMesgFieldDefNumActivityType = 1, 
    FITMonitoringInfoMesgFieldDefNumCyclesToDistance = 3, 
    FITMonitoringInfoMesgFieldDefNumCyclesToCalories = 4, 
    FITMonitoringInfoMesgFieldDefNumRestingMetabolicRate = 5, 
} FITMonitoringInfoMesgFieldDefNum;

// MonitoringMesg Field Definition Numbers
typedef enum FITMonitoringMesgFieldDefNum : uint8_t {
    FITMonitoringMesgFieldDefNumTimestamp = 253, 
    FITMonitoringMesgFieldDefNumDeviceIndex = 0, 
    FITMonitoringMesgFieldDefNumCalories = 1, 
    FITMonitoringMesgFieldDefNumDistance = 2, 
    FITMonitoringMesgFieldDefNumCycles = 3, 
    FITMonitoringMesgFieldDefNumActiveTime = 4, 
    FITMonitoringMesgFieldDefNumActivityType = 5, 
    FITMonitoringMesgFieldDefNumActivitySubtype = 6, 
    FITMonitoringMesgFieldDefNumActivityLevel = 7, 
    FITMonitoringMesgFieldDefNumDistance16 = 8, 
    FITMonitoringMesgFieldDefNumCycles16 = 9, 
    FITMonitoringMesgFieldDefNumActiveTime16 = 10, 
    FITMonitoringMesgFieldDefNumLocalTimestamp = 11, 
    FITMonitoringMesgFieldDefNumTemperature = 12, 
    FITMonitoringMesgFieldDefNumTemperatureMin = 14, 
    FITMonitoringMesgFieldDefNumTemperatureMax = 15, 
    FITMonitoringMesgFieldDefNumActivityTime = 16, 
    FITMonitoringMesgFieldDefNumActiveCalories = 19, 
    FITMonitoringMesgFieldDefNumCurrentActivityTypeIntensity = 24, 
    FITMonitoringMesgFieldDefNumTimestampMin8 = 25, 
    FITMonitoringMesgFieldDefNumTimestamp16 = 26, 
    FITMonitoringMesgFieldDefNumHeartRate = 27, 
    FITMonitoringMesgFieldDefNumIntensity = 28, 
    FITMonitoringMesgFieldDefNumDurationMin = 29, 
    FITMonitoringMesgFieldDefNumDuration = 30, 
    FITMonitoringMesgFieldDefNumAscent = 31, 
    FITMonitoringMesgFieldDefNumDescent = 32, 
    FITMonitoringMesgFieldDefNumModerateActivityMinutes = 33, 
    FITMonitoringMesgFieldDefNumVigorousActivityMinutes = 34, 
} FITMonitoringMesgFieldDefNum;

typedef enum FITMonitoringMesgCyclesField : uint8_t {
    FITMonitoringMesgCyclesFieldStepsSubField,
    FITMonitoringMesgCyclesFieldStrokesSubField,
} FITMonitoringMesgCyclesField;

// HrMesg Field Definition Numbers
typedef enum FITHrMesgFieldDefNum : uint8_t {
    FITHrMesgFieldDefNumTimestamp = 253, 
    FITHrMesgFieldDefNumFractionalTimestamp = 0, 
    FITHrMesgFieldDefNumTime256 = 1, 
    FITHrMesgFieldDefNumFilteredBpm = 6, 
    FITHrMesgFieldDefNumEventTimestamp = 9, 
    FITHrMesgFieldDefNumEventTimestamp12 = 10, 
} FITHrMesgFieldDefNum;

// StressLevelMesg Field Definition Numbers
typedef enum FITStressLevelMesgFieldDefNum : uint8_t {
    FITStressLevelMesgFieldDefNumStressLevelValue = 0, 
    FITStressLevelMesgFieldDefNumStressLevelTime = 1, 
} FITStressLevelMesgFieldDefNum;

// MemoGlobMesg Field Definition Numbers
typedef enum FITMemoGlobMesgFieldDefNum : uint8_t {
    FITMemoGlobMesgFieldDefNumPartIndex = 250, 
    FITMemoGlobMesgFieldDefNumMemo = 0, 
    FITMemoGlobMesgFieldDefNumMesgNum = 1, 
    FITMemoGlobMesgFieldDefNumParentIndex = 2, 
    FITMemoGlobMesgFieldDefNumFieldNum = 3, 
    FITMemoGlobMesgFieldDefNumData = 4, 
} FITMemoGlobMesgFieldDefNum;

// AntChannelIdMesg Field Definition Numbers
typedef enum FITAntChannelIdMesgFieldDefNum : uint8_t {
    FITAntChannelIdMesgFieldDefNumChannelNumber = 0, 
    FITAntChannelIdMesgFieldDefNumDeviceType = 1, 
    FITAntChannelIdMesgFieldDefNumDeviceNumber = 2, 
    FITAntChannelIdMesgFieldDefNumTransmissionType = 3, 
    FITAntChannelIdMesgFieldDefNumDeviceIndex = 4, 
} FITAntChannelIdMesgFieldDefNum;

// AntRxMesg Field Definition Numbers
typedef enum FITAntRxMesgFieldDefNum : uint8_t {
    FITAntRxMesgFieldDefNumTimestamp = 253, 
    FITAntRxMesgFieldDefNumFractionalTimestamp = 0, 
    FITAntRxMesgFieldDefNumMesgId = 1, 
    FITAntRxMesgFieldDefNumMesgData = 2, 
    FITAntRxMesgFieldDefNumChannelNumber = 3, 
    FITAntRxMesgFieldDefNumData = 4, 
} FITAntRxMesgFieldDefNum;

// AntTxMesg Field Definition Numbers
typedef enum FITAntTxMesgFieldDefNum : uint8_t {
    FITAntTxMesgFieldDefNumTimestamp = 253, 
    FITAntTxMesgFieldDefNumFractionalTimestamp = 0, 
    FITAntTxMesgFieldDefNumMesgId = 1, 
    FITAntTxMesgFieldDefNumMesgData = 2, 
    FITAntTxMesgFieldDefNumChannelNumber = 3, 
    FITAntTxMesgFieldDefNumData = 4, 
} FITAntTxMesgFieldDefNum;

// ExdScreenConfigurationMesg Field Definition Numbers
typedef enum FITExdScreenConfigurationMesgFieldDefNum : uint8_t {
    FITExdScreenConfigurationMesgFieldDefNumScreenIndex = 0, 
    FITExdScreenConfigurationMesgFieldDefNumFieldCount = 1, 
    FITExdScreenConfigurationMesgFieldDefNumLayout = 2, 
    FITExdScreenConfigurationMesgFieldDefNumScreenEnabled = 3, 
} FITExdScreenConfigurationMesgFieldDefNum;

// ExdDataFieldConfigurationMesg Field Definition Numbers
typedef enum FITExdDataFieldConfigurationMesgFieldDefNum : uint8_t {
    FITExdDataFieldConfigurationMesgFieldDefNumScreenIndex = 0, 
    FITExdDataFieldConfigurationMesgFieldDefNumConceptField = 1, 
    FITExdDataFieldConfigurationMesgFieldDefNumFieldId = 2, 
    FITExdDataFieldConfigurationMesgFieldDefNumConceptCount = 3, 
    FITExdDataFieldConfigurationMesgFieldDefNumDisplayType = 4, 
    FITExdDataFieldConfigurationMesgFieldDefNumTitle = 5, 
} FITExdDataFieldConfigurationMesgFieldDefNum;

// ExdDataConceptConfigurationMesg Field Definition Numbers
typedef enum FITExdDataConceptConfigurationMesgFieldDefNum : uint8_t {
    FITExdDataConceptConfigurationMesgFieldDefNumScreenIndex = 0, 
    FITExdDataConceptConfigurationMesgFieldDefNumConceptField = 1, 
    FITExdDataConceptConfigurationMesgFieldDefNumFieldId = 2, 
    FITExdDataConceptConfigurationMesgFieldDefNumConceptIndex = 3, 
    FITExdDataConceptConfigurationMesgFieldDefNumDataPage = 4, 
    FITExdDataConceptConfigurationMesgFieldDefNumConceptKey = 5, 
    FITExdDataConceptConfigurationMesgFieldDefNumScaling = 6, 
    FITExdDataConceptConfigurationMesgFieldDefNumDataUnits = 8, 
    FITExdDataConceptConfigurationMesgFieldDefNumQualifier = 9, 
    FITExdDataConceptConfigurationMesgFieldDefNumDescriptor = 10, 
    FITExdDataConceptConfigurationMesgFieldDefNumIsSigned = 11, 
} FITExdDataConceptConfigurationMesgFieldDefNum;

// DiveSummaryMesg Field Definition Numbers
typedef enum FITDiveSummaryMesgFieldDefNum : uint8_t {
    FITDiveSummaryMesgFieldDefNumTimestamp = 253, 
    FITDiveSummaryMesgFieldDefNumReferenceMesg = 0, 
    FITDiveSummaryMesgFieldDefNumReferenceIndex = 1, 
    FITDiveSummaryMesgFieldDefNumAvgDepth = 2, 
    FITDiveSummaryMesgFieldDefNumMaxDepth = 3, 
    FITDiveSummaryMesgFieldDefNumSurfaceInterval = 4, 
    FITDiveSummaryMesgFieldDefNumStartCns = 5, 
    FITDiveSummaryMesgFieldDefNumEndCns = 6, 
    FITDiveSummaryMesgFieldDefNumStartN2 = 7, 
    FITDiveSummaryMesgFieldDefNumEndN2 = 8, 
    FITDiveSummaryMesgFieldDefNumO2Toxicity = 9, 
    FITDiveSummaryMesgFieldDefNumDiveNumber = 10, 
    FITDiveSummaryMesgFieldDefNumBottomTime = 11, 
    FITDiveSummaryMesgFieldDefNumAvgAscentRate = 17, 
    FITDiveSummaryMesgFieldDefNumAvgDescentRate = 22, 
    FITDiveSummaryMesgFieldDefNumMaxAscentRate = 23, 
    FITDiveSummaryMesgFieldDefNumMaxDescentRate = 24, 
    FITDiveSummaryMesgFieldDefNumHangTime = 25, 
} FITDiveSummaryMesgFieldDefNum;

// HrvMesg Field Definition Numbers
typedef enum FITHrvMesgFieldDefNum : uint8_t {
    FITHrvMesgFieldDefNumTime = 0, 
} FITHrvMesgFieldDefNum;

